# -*- coding: utf-8 -*-
# getlist.py

import urllib,urllib2,re,xbmcplugin,xbmcgui,subprocess,sys,os,os.path,xbmcaddon,md5,hashlib,xbmc   
import json
import time
import urlparse
from xbmcswift2 import Plugin
plugin = Plugin()
try:
    from MFSearchKeyboard import Keyboard
except:
    from xbmc import Keyboard
    pass
import itvi_play
__addonid__ = "plugin.video.mfalbum"
__addon__ = xbmcaddon.Addon(id=__addonid__)
RESOURCES_PATH = os.path.join(__addon__.getAddonInfo('path'), 'media', )
more = os.path.join(RESOURCES_PATH,'more.png')
recommended = os.path.join(RESOURCES_PATH,'recommended.png')
recommendedbg = os.path.join(RESOURCES_PATH,'recommendedbg.png')
paging = os.path.join(RESOURCES_PATH,'paging.png')
other = os.path.join(RESOURCES_PATH,'other.png')
search_icon = os.path.join(RESOURCES_PATH,'search_icon.png')

def GetHttpData(url):
    #UserAgent = ''
    req = urllib2.Request(url)
    #req.add_header('User-Agent', UserAgent)
    response = urllib2.urlopen(req)
    httpdata = response.read()
    if response.headers.get('content-encoding', None) == 'gzip':
        httpdata = gzip.GzipFile(fileobj=StringIO.StringIO(httpdata)).read()
    response.close()
    match = re.compile('encodingt=(.+?)"').findall(httpdata)
    if len(match)<=0:
        match = re.compile('meta charset="(.+?)"').findall(httpdata)
    if len(match)>0:
        charset = match[0].lower()
        if (charset != 'utf-8') and (charset != 'utf8'):
            httpdata = unicode(httpdata, charset).encode('utf8')
    return httpdata

def getAlbums(album_id='mfalbum'):
    url = 'http://files.cube.morefun.tv/mfalbums/mfalbums_v1_0/albums-%s.json' %album_id
    try:
        data = GetHttpData(url)
        albums = json.JSONDecoder().decode(data)
        for album in albums:
            is_active = album['is_active'] if 'is_active' in album else 1
            if not is_active:
                continue
                
            str_valid_start = album['valid_start'].encode("utf-8") if 'valid_start' in album and album['valid_start'] else ''
            str_valid_end = album['valid_end'].encode("utf-8") if 'valid_end' in album and album['valid_end'] else ''
            try:
                valid_start = time.mktime(time.strptime(str_valid_start, '%Y-%m-%d %H:%M'))
            except:
                valid_start = 0
            try:
                valid_end = time.mktime(time.strptime(str_valid_end, '%Y-%m-%d %H:%M'))
            except:
                valid_end = 0
            now = time.time()
            valid = True
            if valid_start and now < valid_start:
                valid = False
            if valid_end and now > valid_start:
                valid = False
            if not valid:
                continue
            
            id = album['id'].encode("utf-8") if 'id' in album and album['id'] else ''
            name = album['name'].encode("utf-8") if 'name' in album and album['name'] else ''
            thumb = album['thumb'].encode("utf-8") if 'thumb' in album and album['thumb'] else ''
            view_mode = album['view_mode'].encode("utf-8") if 'view_mode' in album and album['view_mode'] else ''
            
            listitem=xbmcgui.ListItem(name,thumbnailImage=thumb)
            url=sys.argv[0]+"?mode=4&albumid="+urllib.quote_plus(id)+"&view_mode="+urllib.quote_plus(view_mode)+"&page=1"
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    except Exception, e:
        pass

def getSubAlbumAndResources(album_id, view_mode='', page = 1):
    getAlbums(album_id)
    getResources(album_id, view_mode, page)

def getResources(album_id, view_mode='', page = 1):
    log_string = 'func=action&pos=to%s&act=in' %album_id
    xbmc.executebuiltin('FeedbackLog(%s,2)' %log_string)
    url = 'http://files.cube.morefun.tv/mfalbums/mfalbums_v1_0/resources-%s-%d.json' %(album_id,page)
    data = GetHttpData(url)
    res_data = json.JSONDecoder().decode(data)
    total_pages = res_data['total_pages'] if 'total_pages' in res_data and res_data['total_pages'] else 0
    album_bg_image = res_data['album_bg_image'].encode("utf-8") if 'album_bg_image' in res_data and res_data['album_bg_image'] else ''
    album_name = res_data['album_name'].encode("utf-8") if 'album_name' in res_data and res_data['album_name'] else ''
    resources = res_data['resources'] if 'resources' in res_data and res_data['resources'] else []
    for resource in resources:
        id = resource['id'].encode("utf-8") if 'id' in resource and resource['id'] else ''
        url = resource['url'].encode("utf-8") if 'url' in resource and resource['url'] else ''
        if not id and not url:
            continue
        type = ''
        if not id and url:
            type = 'baiduyun'
        elif id:
            for i in range(0,len(id)):
                if id[i].isdigit():
                    type = id[0:i]
                    id = id[i:]
                    break
        category_id = resource['category_id'].encode("utf-8") if 'category_id' in resource and resource['category_id'] else ''
        name = resource['name'].encode("utf-8") if 'name' in resource and resource['name'] else ''
        thumb = resource['thumb'].encode("utf-8") if 'thumb' in resource and resource['thumb'] else ''
        description = resource['description'].encode("utf-8") if 'description' in resource and resource['description'] else ''
        description2 = resource['description2'].encode("utf-8") if 'description2' in resource and resource['description2'] else ''
        doubanscore = resource['doubanscore'].encode("utf-8") if 'doubanscore' in resource and resource['doubanscore'] else ''
        recommend = resource['recommend'].encode("utf-8") if 'recommend' in resource and resource['recommend'] else ''
        tag = resource['tag'].encode("utf-8") if 'tag' in resource and resource['tag'] else ''
        
        listitem=xbmcgui.ListItem(name,thumbnailImage=thumb)
        listitem.setProperty('description',str(description))
        listitem.setProperty('description2',str(description2))
        listitem.setProperty('doubanscore',str(doubanscore))
        listitem.setProperty('recommend',str(recommend))
        listitem.setProperty('tag',str(tag))
        u=sys.argv[0]+"?mode=2&resid="+urllib.quote_plus(str(id))+"&type="+urllib.quote_plus(type)+"&thumbnail="+urllib.quote_plus(thumb)+'&need_type='+urllib.quote_plus('source')
        if type == 'js':
            if category_id == '4': category_id = '3'
            if category_id == '14': category_id = '4'
            url = 'http://v.duba.com/detail/%s.html' %id
            u = 'plugin://plugin.video.mfvod/?mode=2&url='+urllib.quote_plus(url)+'&name='+urllib.quote_plus(name)+'&thumbnail='+urllib.quote_plus(thumb)+'&category_id='+urllib.quote_plus(category_id)+'&need_type='+urllib.quote_plus('source')
        elif type == 'baiduyun':
            # result = urlparse.urlparse(url)
            # query = urlparse.parse_qs(result.query)
            # baiduyun_album_id = query['album_id'][0].strip() if 'album_id' in query else ''
            # baiduyun_uk = query['uk'][0].strip() if 'uk' in query else ''
            # baiduyun_album_url = 'http://yun.baidu.com/share/home?uk=%s&view=album' %baiduyun_uk
            # playpath = "plugin://plugin.video.mfyun/get_album_detail_list/" + urllib.quote_plus(baiduyun_album_id) + '/' + urllib.quote_plus(baiduyun_album_url) + '/' + urllib.quote_plus(thumb) + '/'
            # u = "plugin://plugin.video.mfyun/?mode=11&playname="+urllib.quote_plus(name)+ "&playpath="+urllib.quote_plus(str(playpath))
            if itvi_play.compare_client_version(xbmc.getInfoLabel('client.version'), '1.1.0')>=0:
                u = "mfscript://script.module.itvifav/?mode=click&url="+urllib.quote_plus(url)+ "&title="+urllib.quote_plus(name)+ "&thumb="+urllib.quote_plus(thumb)
            else:
                u = "plugin://script.module.itvifav/?mode=click&url="+urllib.quote_plus(url)+ "&title="+urllib.quote_plus(name)+ "&thumb="+urllib.quote_plus(thumb)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    if total_pages > page:
        listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(page) + '/' +str(total_pages) +'[/COLOR]',thumbnailImage=more)
        listitem.setProperty('next','true')
        u=sys.argv[0] + '?mode=4&mfcachetype=dir_cache_always'+'&albumid='+urllib.quote_plus(album_id)+'&page='+str(page+1)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    # xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunalbum')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb' if not view_mode else view_mode)
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', album_name)
    xbmcplugin.setProperty(int(sys.argv[1]), 'image', album_bg_image)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildRoot():
    # get albums manually edited
    getAlbums()
    
    # get albums edited in cms
    url = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/apps/648/subapps?subapp_id="+"&page_size=54&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    subappNamelist = []
    subappIdlist = []
    subappThumbnaillist = []
    subappImageUrllist = []
    try:
        data = GetHttpData(url)
        data1 = json.JSONDecoder().decode(data)
        item = data1["data"]
        items = item["items"]
        if items != None:
            for j in items:
                subappName = j["subappName"] if "subappName" in j else ''
                if subappName != None:
                    subappName = j["subappName"].encode("utf-8")
                else:
                    subappName = ""
                subappNamelist.append(subappName)
                subappId = j["subappId"] if "subappId" in j else ''
                subappIdlist.append(str(subappId))
                if j["subappThumbnail"]:
                    subappThumbnail = j["subappThumbnail"].encode("utf-8")
                else:
                    subappThumbnail = os.path.join(RESOURCES_PATH,'thumb.png')
                subappThumbnaillist.append(subappThumbnail)
                if j["subappImageUrl"]:
                    subappImageUrl = j["subappImageUrl"].encode("utf-8").split(',')[0]
                else:
                    subappImageUrl = os.path.join(RESOURCES_PATH,'ContentPanel.png')
                subappImageUrllist.append(subappImageUrl)
        # listitem=xbmcgui.ListItem('猫范推荐',thumbnailImage=recommended)
        # url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&albumname="+urllib.quote_plus('猫范推荐')+"&subappimagebg="+urllib.quote_plus(recommendedbg)+"&app_id="+urllib.quote_plus('527')+"&category_id="+urllib.quote_plus('')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('100')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&view_mode="+urllib.quote_plus('morefunthumb')
        # xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
        for i in range(0, len(items)):
            listitem=xbmcgui.ListItem(subappNamelist[i],thumbnailImage=subappThumbnaillist[i])
            url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&albumname="+urllib.quote_plus(subappNamelist[i])+"&subappimagebg="+urllib.quote_plus(subappImageUrllist[i])+"&app_id="+urllib.quote_plus(subappIdlist[i])+"&category_id="+urllib.quote_plus('')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('100')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&bg_num="+urllib.quote_plus('1')+"&view_mode="+urllib.quote_plus('morefunthumb')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    except Exception, e:
        pass
    
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildLists(app_id,category_id,area_id,url,page,style_id,released_on_from,released_on_to,albumname,subappimagebg):
    log_string = 'func=action&pos=to%s&act=in' %str(app_id)
    xbmc.executebuiltin('FeedbackLog(%s,2)' %log_string)
    url1 = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources?app_id="+ str(app_id) +"&category_id=" + str(category_id) + "&area_id="+str(area_id)+"&style_id=" + str(style_id) +"&released_on_from="+released_on_from+"&released_on_to="+released_on_to+"&page_no="+str(page)+"&page_size=54&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    #appidimage = os.path.join(RESOURCES_PATH,app_id+'.png')
    xbmcplugin.setProperty(int(sys.argv[1]), 'image', subappimagebg)
    app_id = ""
    p1 = GetHttpData(url1)
    data = json.JSONDecoder().decode(p1)
    newses = data["data"]
    if newses != None:
        newses1 = newses["items"]
        maxpage = newses["totalPages"]
        #if page > 1:
            #listitem=xbmcgui.ListItem('[COLOR FF004AFF]上一页  ' + str(page)+ '/' +str(maxpage) +'[/COLOR]',thumbnailImage=paging)
            #listitem.setProperty('previous','true')
            #u=sys.argv[0] + '?mode=1&mfcachetype=dir_cache_always&page='+str(page-1) +'&app_id='+urllib.quote_plus(str(app_id))+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&url=' + urllib.quote_plus(url1)+"&view_mode="+urllib.quote_plus('morefunthumb')
            #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
        for i in newses1:
            name = i["title"] if "title" in i else ''
            if name != None:
                name = i["title"].encode("utf-8")
            else:
                name = ""
            resid = i["id"] if "id" in i else ''
            resappepisodes = i["resAppEpisodes"] if "resAppEpisodes" in i else ''
            url = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/"+str(resid)+"?page_size=50&app_id=&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
            thumbnail = i["thumbnail"] if "thumbnail" in i else ''
            if thumbnail != None:
                thumbnail = i["thumbnail"].encode("utf-8")
            else:
                thumbnail = ""
            listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
            listitem.setProperty('resappepisodes',str(resappepisodes))
            u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url) +'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+"&resappepisodes="+urllib.quote_plus(str(resappepisodes))+"&thumbnail="+urllib.quote_plus(thumbnail)+"&view_mode="+urllib.quote_plus('morefunalbum')+'&need_type='+urllib.quote_plus('source')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(newses1))
        if int(maxpage) > page:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(page) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=more)
            listitem.setProperty('next','true')
            u=sys.argv[0] + '?mode=1&mfcachetype=dir_cache_always&page='+str(page+1) +'&app_id='+urllib.quote_plus(str(app_id))+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&url=' + urllib.quote_plus(url1)+"&view_mode="+urllib.quote_plus('morefunalbum')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunalbum')
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', albumname)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildNextLists(url,app_id,resid,page,resappepisodes,thumbnail):
    styleurl = xbmc.getInfoLabel("AppServer.IP") + "/cube/api/resources/"+str(resid)+"?page_size=100&app_id=" + str(app_id) +"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    stylelist = GetHttpData(styleurl)
    styledata = json.JSONDecoder().decode(stylelist)
    styleurls = styledata["data"] if "data" in styledata else ''
    appidlist = styleurls["appId"] if "appId" in styleurls else ''
    sourceNamelist = styleurls["sourceName"].encode("utf-8")
    if appidlist != None:
        appidlist = styleurls["appId"]
    else:
        episodes = styleurls["episodes"]
        if len(episodes) > 0:
            episodeslist = episodes[0]
            appidlist = episodeslist["appId"] if "appId" in episodeslist else ''
    applist = str(appidlist).split(",")
    sourcelist = sourceNamelist.split(",")
    if app_id =="":
        app_id = applist[0]
    newappidlist = ';'
    newappnamelist = ';'
    for id in applist:
        newappidlist = newappidlist + id + ';'
    for name in sourcelist:
        newappnamelist = newappnamelist + name + ';'
    title = styleurls["title"] if "title" in styleurls else ''
    if title != None:
        title = styleurls["title"].encode("utf-8")
    else:
        title = ""
    areaname = styleurls["areaName"] if "areaName" in styleurls else ''
    if areaname != None:
        areaname = styleurls["areaName"].encode("utf-8")
    else:
        areaname = ""
    stylename = styleurls["styleName"] if "styleName" in styleurls else ''
    if stylename != None:
        stylename = styleurls["styleName"].encode("utf-8")
    else:
        stylename = ""
    year = str(styleurls["releasedOn"]).split("-")[0] if "releasedOn" in styleurls else ''
    actors = styleurls["actors"] if "actors" in styleurls else ''
    if actors != None:
        actors = styleurls["actors"].encode("utf-8")
    else:
        actors = ""
    description = styleurls["description"] if "description" in styleurls else ''
    if description != None:
        description = styleurls["description"].encode("utf-8")
    else:
        description = ""
    episodesCount = str(styleurls["episodesCount"]) if "episodesCount" in styleurls else ''
    url = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/"+str(resid)+"/episodes?"+"page_size=100&app_id="+str(app_id)+"&page_no="+str(page)+"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    mylist = GetHttpData(url)
    data1 = json.JSONDecoder().decode(mylist)
    urls = data1["data"]
    urls1 = urls["items"]
    maxpage = urls["totalPages"]
    #if page > 1:
        #listitem=xbmcgui.ListItem('[COLOR FF004AFF]上一页  ' + str(page)+ '/' +str(maxpage) +'[/COLOR]')
        #u=sys.argv[0] + '?mode=2&mfcachetype=dir_cache_always&page='+str(page-1) +'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+ '&url=' + urllib.quote_plus(url)
        #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    for j in urls1:
        item_id = j["id"] if "id" in j else ''
        name = j["title"] if "title" in j else ''
        if name != None:
            name = j["title"].encode("utf-8")
        else:
            name = ""
        play_url = j["playUrl"] if "playUrl" in j else ''
        if play_url != None:
            play_url = j["playUrl"].encode("utf-8")
        else:
            play_url = ""
        appspidername = j["appSpiderName"] if "appSpiderName" in j else ''
        if appspidername != None:
            appspidername = j["appSpiderName"].encode("utf-8")
        else:
            appspidername = ""
        listitem=xbmcgui.ListItem(name)
        listitem.setProperty('name',name)
        listitem.setProperty('playurl',play_url)
        #listitem.setProperty('appidlist',newappidlist)
        #listitem.setProperty('maxpage',str(maxpage))
        url=sys.argv[0] + '?mode=3&mfcachetype=dir_cache_always&url=' + urllib.quote_plus(play_url)+ '&item_id=' + str(item_id)+'&app_id='+urllib.quote_plus(str(app_id))+'&appspidername='+urllib.quote_plus(appspidername)+'&name='+urllib.quote_plus(name)+'&resourceTitle='+urllib.quote_plus(title)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&view_mode="+urllib.quote_plus('morefunlist')
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, False)
    #if int(maxpage) > page:
        #listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(page) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=more)
        #listitem.setProperty('appidlist',appidlist)
        #u=sys.argv[0] + '?mode=2&mfcachetype=dir_cache_always&page='+str(page+1) +'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+ '&url=' + urllib.quote_plus(url)+"&view_mode="+urllib.quote_plus('morefunlist')
        #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    #if not int(maxpage) == 1:
        #listitem=xbmcgui.ListItem('[COLOR FF004AFF]选择页数[/COLOR]',thumbnailImage=paging)
        #listitem.setProperty('appidlist',appidlist)
        #u=sys.argv[0] + '?mode=7&maxpage='+str(maxpage) +'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+ '&url=' + urllib.quote_plus(url)+"&view_mode="+urllib.quote_plus('morefunlist')
        #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunlist')
    xbmcplugin.setProperty(int(sys.argv[1]), 'title', title)
    xbmcplugin.setProperty(int(sys.argv[1]), 'areaname', areaname)
    xbmcplugin.setProperty(int(sys.argv[1]), 'stylename', stylename)
    xbmcplugin.setProperty(int(sys.argv[1]), 'year', year)
    xbmcplugin.setProperty(int(sys.argv[1]), 'actors', actors)
    xbmcplugin.setProperty(int(sys.argv[1]), 'description', description)
    xbmcplugin.setProperty(int(sys.argv[1]), 'appidlist', newappidlist)
    xbmcplugin.setProperty(int(sys.argv[1]), 'appnamelist', newappnamelist)
    xbmcplugin.setProperty(int(sys.argv[1]), 'app_id', app_id)
    xbmcplugin.setProperty(int(sys.argv[1]), 'resappepisodes', resappepisodes)
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumbnail', thumbnail)
    xbmcplugin.setProperty(int(sys.argv[1]), 'maxpage', str(maxpage))
    
    xbmcplugin.setProperty(int(sys.argv[1]), 'itemId', 'morefun'+str(resid))
    xbmcplugin.setProperty(int(sys.argv[1]), 'itemType', 'morefun')
    favouriteUrl = sys.argv[0]+"?fromtype=favourite&app_id=&resid="+urllib.quote_plus(str(resid))+"&page=&resappepisodes="+urllib.quote_plus(resappepisodes)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&need_type='+urllib.quote_plus('source')
    xbmcplugin.setProperty(int(sys.argv[1]), 'url', favouriteUrl)
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumb', thumbnail)
    xbmcplugin.setProperty(int(sys.argv[1]), 'playable', 'false')
    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))
    xbmcplugin.setProperty(int(sys.argv[1]), 'updateUrl', updateUrl)
    xbmcplugin.setProperty(int(sys.argv[1]), 'episodesNum', episodesCount)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))
        
def playVideo(url):
    mylist = GetHttpData(url)
    foobars = re.compile('<m3u8>(.*?)</m3u8>', re.DOTALL).findall(mylist)
    playlist = xbmc.PlayList(1)
    playlist.clear()
    for i in range(0,len(foobars)):
        title =" 第"+str(i+1)+"/"+str(len(foobars))+"节"
        listitem=xbmcgui.ListItem(title)
        listitem.setInfo(type="Video",infoLabels={"Title":title})
        playlist.add(foobars[i], listitem)
    xbmc.Player().play(playlist)

def selectpage(url,app_id,resid,maxpage,resappepisodes,thumbnail):
    maxpages = []
    for i in range(1, maxpage+1):
        maxpages.append(str(i))
    dialog = xbmcgui.Dialog()
    sel = dialog.select('选择页数', maxpages)
    if sel != -1:
        page=maxpages[sel]
        buildNextLists(url,app_id,resid,int(page),resappepisodes,thumbnail)
        

def searchkey(category_id):
    keyword = ""
    type = ""
    kb = Keyboard('','请输入搜索内容',keyword,type)
    kb.doModal()
    if (kb.isConfirmed()):
        keyword = kb.getText()
        if keyword !='':
            searchpage = 1
            searchlist(keyword,category_id,searchpage)
        else:
            xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
            xbmcplugin.endOfDirectory(int(sys.argv[1]))
    else:
        xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
def searchlist(keyword,category_id,searchpage):
    search_path = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/search/"+keyword+"?page_size=54"+"&page_no="+str(searchpage)+"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1383555354&security_code=ce30ea919afcc8cf731b5edf8f91ee6c&session_id=dltianwei&category_id="+str(category_id)
    search_path = eval(repr(search_path).replace("\\x","%"))
    p1 = GetHttpData(search_path)
    data = json.JSONDecoder().decode(p1)
    newses = data["data"]
    app_id = ''
    area_id = ''
    style_id = ''
    if newses != None:
        newses1 = newses["items"]
        maxpage = newses["totalPages"]
        #if page > 1:
            #listitem=xbmcgui.ListItem('[COLOR FF004AFF]上一页  ' + str(page)+ '/' +str(maxpage) +'[/COLOR]',thumbnailImage=paging)
            #listitem.setProperty('previous','true')
            #u=sys.argv[0] + '?mode=1&mfcachetype=dir_cache_always&page='+str(page-1) +'&app_id='+urllib.quote_plus(str(app_id))+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&url=' + urllib.quote_plus(url1)+"&view_mode="+urllib.quote_plus('morefunthumb')
            #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
        for i in newses1:
            name = i["title"] if "title" in j else ''
            if name != None:
                name = i["title"].encode("utf-8")
            else:
                name = ""
            resid = i["id"] if "id" in j else ''
            resappepisodes = i["resAppEpisodes"] if "resappepisodes" in j else ''
            url = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/"+str(resid)+"?page_size=50&app_id=&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
            thumbnail = i["thumbnail"] if "thumbnail" in j else ''
            if thumbnail != None:
                thumbnail = i["thumbnail"].encode("utf-8")
            else:
                thumbnail = ""
            listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
            #listitem.setProperty('resappepisodes',str(resappepisodes))
            u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url) +'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+"&resappepisodes="+urllib.quote_plus(str(resappepisodes))+"&thumbnail="+urllib.quote_plus(thumbnail)+"&view_mode="+urllib.quote_plus('morefunthumb')+'&need_type='+urllib.quote_plus('source')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(newses1))
        if int(maxpage) > searchpage:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(searchpage) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=more)
            listitem.setProperty('next','true')
            u=sys.argv[0] + '?mode=9&mfcachetype=dir_cache_always&searchpage='+str(searchpage+1) +'&app_id='+urllib.quote_plus('0')+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&keyword=' + urllib.quote_plus(keyword)+"&view_mode="+urllib.quote_plus('morefunthumb')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
        #elif maxpage == 0:
            #listitem=xbmcgui.ListItem('[COLOR FF004AFF]无数据  [/COLOR]',thumbnailImage="")
            #u=sys.argv[0] + '?mode=9&searchpage=' + str(searchpage)+"&view_mode="+urllib.quote_plus('morefunthumb')
            #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getsources(appidlist,appnamelist):
    appidlist = appidlist.strip(';')
    appidlist = appidlist.split(";")
    sourcelist = []
    if appnamelist=='':
        for id in appidlist:
            for i in sources:
                if id == i[1]:
                    sourcelist.append({'source': i[2], 'sourceid': id})
        for j in sourcelist:
            listitem=xbmcgui.ListItem(j["source"],thumbnailImage="")
            listitem.setProperty('app_id', j["sourceid"])
            url= ''
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
    else:
        appnamelist = appnamelist.strip(';')
        appnamelist = appnamelist.split(';')
        for i in range(len(appidlist)):
            sourcelist.append({'source': appnamelist[i], 'sourceid': appidlist[i]})
        for j in sourcelist:
            listitem=xbmcgui.ListItem(j["source"],thumbnailImage="")
            listitem.setProperty('app_id', j["sourceid"])
            url= ''
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
        xbmcplugin.endOfDirectory(int(sys.argv[1]))

def performChange(app_id,category_id,url):
    typeid = [1,2,3,5,6]
    typename = ["喜剧","动作","惊悚","科幻","爱情"]
    dialog = xbmcgui.Dialog()
    sel = dialog.select('选择分类', typename)
    page = 1
    if sel != -1:
        style_id=typeid[sel]
        buildLists(app_id,category_id,area_id,url,page,style_id)

def setres(url,resid,resappepisodes,thumbnail):
    mylist = GetHttpData(url)
    data1 = json.JSONDecoder().decode(mylist)
    urls = data1["data"]
    appid = urls["appId"]
    appname = urls["appName"]
    if appname != None:
        appname = urls["appName"].encode("utf-8")
    else:
        appname = ""
    applist = appid.split(",")
    appnamelist = appname.split(",")
    page = 1
    if len(applist) > 1:
        dialog = xbmcgui.Dialog()
        sel = dialog.select('选择数据源', appnamelist)
        if sel != -1:
            app_id=applist[sel]
            buildNextLists(url,app_id,resid,page,resappepisodes,thumbnail)
    else:
        app_id=applist[0]
        buildNextLists(url,app_id,resid,page,resappepisodes,thumbnail)
    
def setarea():
    listitem=xbmcgui.ListItem('大陆')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('大陆')+"&area_id="+urllib.quote_plus('2')+"&view_mode="+urllib.quote_plus('morefunthumb')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('港台')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('港台')+"&area_id="+urllib.quote_plus('1,9,18')+"&view_mode="+urllib.quote_plus('morefunthumb')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('日韩')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('日韩')+"&area_id="+urllib.quote_plus('3,6,17')+"&view_mode="+urllib.quote_plus('morefunthumb')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('欧美')
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('欧美')+"&area_id="+urllib.quote_plus('4,16,50')+"&view_mode="+urllib.quote_plus('morefunthumb')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getareas():
    listitem=xbmcgui.ListItem('全部',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('全部')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('日本',thumbnailImage=japan)
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('日本')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('3')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('内地',thumbnailImage=china)
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('内地')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('2')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('美国',thumbnailImage=usa)
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('美国')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('4')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('韩国',thumbnailImage=korea)
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('韩国')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('6')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('其他',thumbnailImage=other)
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('其他')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('1000')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getstyles():
    listitem=xbmcgui.ListItem('全部',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('全部')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('搞笑',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('搞笑')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('22')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('剧情',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('剧情')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('8')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('冒险',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('冒险')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('10')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('魔幻',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('魔幻')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('120')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('励志',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('励志')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('123')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('体育',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('体育')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('129')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('益智',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('益智')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('36')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('童话',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('童话')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('122')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('真人',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('真人')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('119')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('动作',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('动作')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('2')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('推理',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('推理')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('113')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('亲子',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('亲子')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('121')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('怀旧',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('怀旧')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('156')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('其他',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('其他')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('1000')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getyears():
    listitem=xbmcgui.ListItem('全部',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('全部')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('2013',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('2013')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('2013')+"&released_on_to="+urllib.quote_plus('2014')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('2012',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('2012')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('2012')+"&released_on_to="+urllib.quote_plus('2013')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('2011',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('2011')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('2011')+"&released_on_to="+urllib.quote_plus('2012')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('2010',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('2010')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('2010')+"&released_on_to="+urllib.quote_plus('2011')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('2009',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('2009')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('2009')+"&released_on_to="+urllib.quote_plus('2010')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('2008',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('2008')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('2008')+"&released_on_to="+urllib.quote_plus('2009')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('2007',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('2007')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('2007')+"&released_on_to="+urllib.quote_plus('2008')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('更早',thumbnailImage="")
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('更早')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('2007')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def display_for_history(params):
    app_id = urllib.unquote_plus(params['app_id']) if 'app_id' in params else ''
    resid = urllib.unquote_plus(params['resid']) if 'resid' in params else ''
    page = urllib.unquote_plus(params['page']) if 'page' in params else ''
    resappepisodes = urllib.unquote_plus(params['resappepisodes']) if 'resappepisodes' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    buildNextLists('',app_id,resid,page,resappepisodes,thumbnail)

def display_for_favourite(params):
    display_for_history(params)

def update_favourite(params):
    resid = urllib.unquote_plus(params['resid']) if 'resid' in params else ''
    url = xbmc.getInfoLabel("AppServer.IP") + "/cube/api/resources/"+str(resid)+"?client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    result = GetHttpData(url)
    res = json.JSONDecoder().decode(result)
    data = res["data"] if 'data' in res else None
    if data:
        title = data["title"] if 'title' in data else ''
        if title != None:
            title = data["title"].encode("utf-8")
        else:
            title = ""
        thumbnail = data["thumbnail"] if 'thumbnail' in data else ''
        if thumbnail != None:
            thumbnail = data["thumbnail"].encode("utf-8")
        else:
            thumbnail = ""
        episodesCount = str(data["episodesCount"]) if 'episodesCount' in data else ''
        updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))
        listitem=xbmcgui.ListItem(title)
        listitem.setProperty('title',title)
        listitem.setProperty('thumb',thumbnail)
        listitem.setProperty('episodesNum',episodesCount)
        listitem.setProperty('updateUrl',updateUrl)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), updateUrl, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def get_params(url = ''):
    param = []
    paramstring = sys.argv[2] if url=='' else url
    if len(paramstring) >= 2:
        params = paramstring
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]
    return param    

