# -*- coding: utf-8 -*-
# getlist.py

import urllib,urllib2,re,xbmcplugin,xbmcgui,sys,os,os.path,xbmcaddon,xbmc
from urlparse import urljoin
import json
import gzip
try:
    from cStringIO import StringIO
except ImportError:
    from StringIO import StringIO
from xbmcswift2 import Plugin
plugin = Plugin()
try:
    from MFSearchKeyboard import Keyboard
except:
    from xbmc import Keyboard
    pass



plugin_path = plugin.addon.getAddonInfo('path')
lib_path = os.path.join(plugin_path, 'lib')

import time


__addonid__ = "plugin.video.mfletv"
__addon__ = xbmcaddon.Addon(id=__addonid__)
RESOURCES_PATH = os.path.join(__addon__.getAddonInfo('path'), 'media', )
PAGING_THUMB = os.path.join(RESOURCES_PATH,'paging.png')
MORE_THUMB = os.path.join(RESOURCES_PATH,'more.png')
MOVIE_THUMB = os.path.join(RESOURCES_PATH,'1movie.png')
TV_THUMB = os.path.join(RESOURCES_PATH,'2tv.png')
COMIC_THUMB = os.path.join(RESOURCES_PATH,'3comic.png')
SHOW_THUMB = os.path.join(RESOURCES_PATH,'4show.png')
SELF_THUMB = os.path.join(RESOURCES_PATH,'5self_product.png')
SPORT_THUMB = os.path.join(RESOURCES_PATH,'6sport.png')
FUN_THUMB = os.path.join(RESOURCES_PATH,'7fun.png')
MUSIC_THUMB = os.path.join(RESOURCES_PATH,'8music.png')
STYLE_THUMB = os.path.join(RESOURCES_PATH,'9style.png')
RECODER_THUMB = os.path.join(RESOURCES_PATH,'10recoder.png')
BUSUNESS_THUMB = os.path.join(RESOURCES_PATH,'11business.png')
CAR_THUMB = os.path.join(RESOURCES_PATH,'12car.png')
TRIP_THUMB = os.path.join(RESOURCES_PATH,'13trip.png')



movie_areas = [['全部', '-1'],['内地','50001'],['美国','50071'],['香港','50002'],['英国','50072'],['法国','50075'],['俄罗斯','50102'],['新加坡','50005'],['加拿大','50073'],['台湾','50003'],['韩国','50042'],['泰国','50101'],['印度','50103'],['日本','50041'],['西班牙','50074'],['马来西亚','50004']]
movie_styles = [['全部', '-1'],['剧情','30008'],['喜剧','30009'],['动作','30010'],['恐怖','30012'],['动画','30013'],['警匪','30021'],['武侠','30022'],['战争','30014'],['短片','30154'],['爱情','30011'],['科幻','30020'],['奇幻','30017'],['犯罪','30018'],['冒险','30019'],['灾难','30023'],['伦理','30024'],['传记','30155'],['家庭','30026'],['纪录','30027'],['惊悚','30015'],['历史','30153'],['悬疑','30016'],['歌舞','30025'],['体育','30156']]
movie_years = [['全部', '-1', ''], ['2014', '2014', ''], ['2013', '2013', ''], ['2012', '2012', ''], ['2011', '2011', ''], ['2010', '2010', ''], ['00年代', '00s', ''], ['90年代', '90s', ''], ['更早', '0', '']]

tv_areas = [['全部', '-1'],['内地','50001'],['韩国','50042'],['美国','50071'],['香港','50002'],['台湾','50003'],['泰国','50101'],['英国','50072'],['日本','50041'],['新加坡','50005'],['其他','50005,50074,50073,50102,50004,50103']]
tv_styles = [['全部', '-1'],['剧情','30008'],['伦理','30024'],['喜剧','30009'],['军旅','30317'],['奇幻','30017'],['动作','30010'],['战争','30014'],['武侠','30022'],['犯罪','30018'],['悬疑','30016'],['偶像','30320'],['都市','30039'],['历史','30153'],['灾难','30023'],['古装','30042'],['科幻','30020'],['情景','30044'],['生活','30045'],['情感','30046'],['家庭','30026'],['谍战','30318'],['刑侦','30319'],['经典','31367']]
tv_years = [['全部', '-1', ''], ['2014', '2014', ''], ['2013', '2013', ''], ['2012', '2012', ''], ['2011', '2011', ''], ['2010', '2010', ''], ['00年代', '00s', ''], ['90年代', '90s', ''], ['更早', '0', '']]

comic_areas = [['全部', '-1'],['内地','50001'],['日本','50041'],['美国','50071'],['英国','50072'],['台湾','50003'],['韩国','50042'],['其他','50075,50101,50005,50074,50102,50004,50073,50002']]
comic_styles = [['全部', '-1'],['战斗','30261'],['热血','30050'],['冒险','30019'],['励志','30054'],['英雄','30274'],['后宫','30270'],['百合','30271'],['耽美','30272'],['魔法','30265'],['奇幻','30017'],['搞笑','30057'],['恋爱','30063'],['校园','30088'],['宠物','30282'],['日常','30266'],['童话','30273'],['惊悚','30015'],['竞技','30269'],['都市','30039'],['女性向','30056'],['科幻','30020'],['治愈','30264'],['教育','30278'],['怪物','30055'],['成人','30089'],['轻松','30279'],['神话','30280'],['生活','30045'],['益智','30275'],['机战','30051'],['运动','30052'],['神魔','30059'],['真人','30058'],['魔幻','30354'],['动作','30010'],['LOLI','30062'],['美少女','30053'],['男性向','30060'],['悬疑推理','30061']]
comic_years = [['全部', '-1', ''], ['2014', '2014', ''], ['2013', '2013', ''], ['2012', '2012', ''], ['2011', '2011', ''], ['2010', '2010', ''], ['2009', '2009', ''], ['2008', '2008', ''], ['2007', '2007', ''], ['2006', '2006', ''], ['2005', '2005', ''], ['2004', '2004', ''], ['2003', '2003', ''], ['2002', '2002', ''], ['2001', '2001', ''], ['2000', '2000', ''], ['90年代', '90s', ''], ['更早', '0', '']]

show_areas = [['全部', '-1'],['内地','50001'],['港台','50002,50003'],['日韩','50041,50042'],['美国','50071']]
show_styles = [['全部', '-1'],['情感','30046'],['访谈','30083'],['真人秀','30075'],['搞笑','30057'],['游戏','30070'],['脱口秀','30065'],['选秀','30072'],['生活','30045'],['播报','30082'],['时尚','30167'],['美食','30069'],['纪实','30284'],['文化','30290'],['歌舞','30025'],['曲艺','30291'],['命理','30165'],['其他','30323']]

self_product_styles = [['电视剧', '2'],['综艺','11'],['体育','4'],['音乐','9'],['电影','1']]

sport_styles = [['全部', '-1'],['英超','30222'],['西甲','30223'],['意甲','30224'],['法甲','30295'],['德甲','30365'],['欧冠','30225'],['中超','30227'],['国足','30228'],['亚冠','30367'],['NBA','30232'],['CBA','30230'],['网球','30234'],['台球','30236'],['高尔夫','30294'],['世界杯','30238'],['欧洲杯','30237'],['奥运会','30239'],['中国篮球','30231'],['欧冠篮球','30296'],['篮球其他','30233'],['综合体育','30235'],['国际足球其他','30226'],['国内足球其他','30229']]

fun_areas = [['全部', '-1'],['北京','50006'],['上海','50007'],['广州','50008'],['大陆其他','50009'],['香港','50002'],['台湾','50003'],['日韩','50040'],['欧美','50070'],['东南亚','50104'],['海外其他','50100']]
fun_styles = [['全部', '-1'],['明星资讯','440141'],['电影资讯','440142'],['电视资讯','440143'],['音乐资讯','440144'],['综艺资讯','440145'],['网络热点','440146'],['搞笑猎奇','440147'],['全球娱乐资讯','440150'],['观影调查','440123'],['独家策划','440125'],['独家专访','440126'],['乐视娱乐播报','440122']]

music_areas = [['全部', '-1'],['内地','50001'],['港台','50002,50003'],['欧美','50071,50072,50073,50074,50075,50076,50077,50078,50079,500151'],['日本','50041'],['韩国','50042'],['其他','50100,50101,50102,50103,50104']]
music_styles = [['全部', '-1'],['流行','500241'],['摇滚','500243'],['独立','500242'],['电子','500244'],['嘻哈','500246'],['R&B','500247'],['民谣','500245'],['乡村','500248'],['爵士','500249'],['雷鬼','500251'],['原声','500257'],['拉丁','500252'],['古典','500254'],['布鲁斯','500250'],['新世纪','500253'],['轻音乐','500255'],['世界音乐','500256'],['民族/曲艺','500258'],['其他','500259']]

style_styles = [['全部', '-1']]

recoder_styles = [['全部', '-1'],['自然','30112'],['动物','30113'],['科学','30114'],['地理','30115'],['天文','30116'],['气候','30117'],['战争','30014'],['军事','30119'],['历史','30153'],['考古','30121'],['社会','30122'],['犯罪','30018'],['金融','30124'],['人物','30125'],['艺术','30126'],['人文','30127'],['建筑','30128'],['美食','30069'],['百科','30130'],['环保','30131'],['公开课','100000']]

business_styles = [['全部', '-1'],['市场交易','530001'],['投资理财','530002'],['民生经济','530003'],['品质生活','530004'],['经济管理','530005'],['行业经济','530006']]

car_styles = [['全部', '-1'],['自制','490178'],['版权','490490179'],['分享','490180'],['资源','490181'],['其他','490182'],['驭乐汇','492171'],['斗秀场','492172'],['炫大牌','492173'],['媒体分享','492174'],['网友分享','492175'],['新闻发布','492176'],['针锋相对','492177'],['海外合作','492170']]

trip_styles = [['全部', '-1'],['古城','540001'],['邮轮','540002'],['滑雪','540003'],['蜜月','540004'],['SPA','540005'],['酒店','540006'],['格调','540007'],['节庆','540008'],['家庭','540009'],['赏花','540010'],['空中','540012'],['海岛','540013'],['潜水','540014'],['美食','540015'],['探险','540016'],['都市','540017'],['登山','540018'],['自驾','540019'],['徒步','540020'],['运动','540021'],['购物','540022'],['夜生活','540011']]

void_years = []

void_areas = []

HOST = 'http://list.letv.com/listn/'


def GetHttpData(url):
    req = urllib2.Request(url)
    response = urllib2.urlopen(req)
    httpdata = response.read()
    if response.headers.get('content-encoding', None) == 'gzip':
        httpdata = gzip.GzipFile(fileobj=StringIO.StringIO(httpdata)).read()
    response.close()
    match = re.compile('encodingt=(.+?)"').findall(httpdata)
    if len(match)<=0:
        match = re.compile('meta charset="(.+?)"').findall(httpdata)
    if len(match)>0:
        charset = match[0].lower()
        if (charset != 'utf-8') and (charset != 'utf8'):
            httpdata = unicode(httpdata, charset).encode('utf8')
    return httpdata

def fetch_url(url, data=None, headers={}, timeout=None, proxies=None):
    headers.setdefault(
        'User-Agent', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1872.0 Safari/537.36')  # noqa
    headers.setdefault('Accept-Encoding', 'gzip,deflate')
    if data and isinstance(data, dict):
        data = urlencode(data)
    req = urllib2.Request(url, data, headers)
    http_proxy = None
    if proxies or http_proxy:
        if not proxies:
            if isinstance(http_proxy, basestring):
                proxies = {'http': http_proxy, 'https': http_proxy}
            else:
                proxies = http_proxy
        proxy_handler = urllib2.ProxyHandler(proxies)
        opener = urllib2.build_opener(proxy_handler)
        r = opener.open(req, timeout=timeout)
    else:
        r = urllib2.urlopen(req, timeout=timeout)
    content = r.read()
    if r.headers.get('content-encoding') == 'gzip':
        content = gzip.GzipFile(fileobj=StringIO(content), mode='rb').read()
    return content

def buildRoot():
    listitem=xbmcgui.ListItem('电影',thumbnailImage=MOVIE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('电影')+"&category_id="+urllib.quote_plus('c1')+"&area_id="+urllib.quote_plus('-1')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('-1')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('movie')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('电视剧',thumbnailImage=TV_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('电视剧')+"&category_id="+urllib.quote_plus('c2')+"&area_id="+urllib.quote_plus('-1')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('-1')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('tv')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('动漫',thumbnailImage=COMIC_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('动漫')+"&category_id="+urllib.quote_plus('c5')+"&area_id="+urllib.quote_plus('-1')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('-1')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('comic')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('综艺',thumbnailImage=SHOW_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('综艺')+"&category_id="+urllib.quote_plus('c11')+"&area_id="+urllib.quote_plus('-1')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('show')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('体育',thumbnailImage=SPORT_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('体育')+"&category_id="+urllib.quote_plus('c4')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('sport')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('娱乐',thumbnailImage=FUN_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('娱乐')+"&category_id="+urllib.quote_plus('c3')+"&area_id="+urllib.quote_plus('-1')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('fun')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('音乐',thumbnailImage=MUSIC_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('音乐')+"&category_id="+urllib.quote_plus('c9')+"&area_id="+urllib.quote_plus('-1')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('music')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('风尚',thumbnailImage=STYLE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('风尚')+"&category_id="+urllib.quote_plus('c20')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('style')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('纪录片',thumbnailImage=RECODER_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('纪录片')+"&category_id="+urllib.quote_plus('c16')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('recoder')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('财经',thumbnailImage=BUSUNESS_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('财经')+"&category_id="+urllib.quote_plus('c22')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('business')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('汽车',thumbnailImage=CAR_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('汽车')+"&category_id="+urllib.quote_plus('c14')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('car')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('旅游',thumbnailImage=TRIP_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('旅游')+"&category_id="+urllib.quote_plus('c23')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('trip')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('自制',thumbnailImage=SELF_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('自制')+"&category_id="+urllib.quote_plus('cs')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('2')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('self_product')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildLists(category_id,page,area_id,style_id,released_on_from,released_on_to,medianame):
    if category_id =='c1':
        url = HOST + str(category_id) + '_t' + str(style_id) + '_a' + str(area_id) + '_y' + str(released_on_from) + '_s1_lg-1_ph1_md_o9_d1_p' + str(page) + '.html'
    elif category_id =='c2':
        url = HOST + str(category_id) + '_t' + str(style_id) + '_a' + str(area_id) + '_y' + str(released_on_from) + '_s1_md_o51_d1_p' + str(page) + '.html'
    elif category_id =='c5':
        url = HOST + str(category_id) + '_t' + str(style_id) + '_a' + str(area_id) + '_y' + str(released_on_from) + '_vt-1_f-1_s1_lg-1_st-1_md_o9_d1_p' + str(page) + '.html'
    elif category_id =='c11':
        url = HOST + str(category_id) + '_t' + str(style_id) + '_a' + str(area_id) + '_s3_tv-1_md_o9_d1_p' + str(page) + '.html'
    elif category_id =='cs':
        url = HOST + str(category_id) + str(style_id) + '_o9_p' + str(page) + '.html'
    elif category_id =='c4':
        url = HOST + str(category_id) + '_t' + str(style_id) + '_vt-1_md_o1_d2_p' + str(page) + '.html'
    elif category_id =='c3':
        url = HOST + str(category_id) + '_a' + str(area_id) + '_vt' + str(style_id) + '_md_o9_d2_p' + str(page) + '.html'
    elif category_id =='c9':
        url = HOST + str(category_id) + '_t' + str(style_id) + '_a' + str(area_id) + '_vt-1_sp-1_st-1_md_o17_d2_p' + str(page) + '.html'
    elif category_id =='c20':
        url = HOST + str(category_id) + '_t' + str(style_id) + '_md_o1_d2_p' + str(page) + '.html'
    elif category_id =='c16':
        url = HOST + str(category_id) + '_t' + str(style_id) + '_md_o1_d2_p' + str(page) + '.html'
    elif category_id =='c22':
        url = HOST + str(category_id) + '_t' + str(style_id) + '_vt-1_md_o3_d2_p' + str(page) + '.html'
    elif category_id =='c14':
        url = HOST + str(category_id) + '_t' + str(style_id) + '_vt-1_md_o1_d2_p' + str(page) + '.html'
    elif category_id =='c23':
        url = HOST + str(category_id) + '_t' + str(style_id) + '_vt-1_st-1_md_o1_d2_p' + str(page) + '.html'
    
    items,maxpage = get_video_list_from_url(url)
    
    for i in items:
        name = i["title"].encode("utf-8")
        resappepisodes = i["resAppEpisodes"]
        url = i["url"]
        thumbnail = i["thumbnail"].encode("utf-8")
        listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
        if category_id == "c2" or category_id == 'cs' or category_id == 'c5' or category_id == 'c11':
            listitem.setProperty('v360resappepisodes',resappepisodes)
        u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&category_id='+urllib.quote_plus(category_id)+'&resappepisodes='+urllib.quote_plus(str(resappepisodes))+ '&medianame='+urllib.quote_plus(medianame)+'&style_id=' + urllib.quote_plus(style_id)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(items))
    if int(maxpage) > int(page):
        listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多 ' + str(page) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
        u=sys.argv[0] + '?mode=1&page='+str(page+1) +'&category_id='+urllib.quote_plus(category_id)+'&area_id='+urllib.quote_plus(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&released_on_from=' + urllib.quote_plus(released_on_from)+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb2')
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', medianame)
    if category_id == 'c1' or category_id == 'c2' or category_id == 'c5' or category_id == 'c11':
        xbmcplugin.setProperty(int(sys.argv[1]),'search_show','able')
    else:
        xbmcplugin.setProperty(int(sys.argv[1]),'search_show','unable')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def get_video_list_from_url(url):
    items = []
    maxpage = '0'
    content = fetch_url(url)
    _RE1 = re.compile(r'<div class="list_seo">([\s\S]*?)<div class="list_cnt">[\s\S]*?')
    _RE2 = re.compile(r'<dl class="dl_list">([\s\S]*?)</dl>[\s\S]*?')
    _RE3 = re.compile(
                    r'<dt class="hd_pic">[\s\S]*?<a href="([\s\S]*?)"[\s\S]*?'
                    'img src="([\s\S]*?)"[\s\S]*?'
                    'alt="([\s\S]*?)"[\s\S]*?'
                    )
    _RE_resAppEpisodes = re.compile(r'<span class="number_txt">([\s\S]*?)</span>[\s\S]*?')
    if _RE1.search(content):
        match = _RE1.search(content)
        datapag = match.groups()[0]
        for match in _RE2.finditer(str(datapag)):
            datapag1 = match.groups()[0]
            for match in _RE3.finditer(str(datapag1)):
                detail_url, imgurl, title = match.groups()
            if _RE_resAppEpisodes.search(str(datapag1)):
                match = _RE_resAppEpisodes.search(str(datapag1))
                episodes_num = match.groups()[0]
                episodes_num = episodes_num.split('/')[0]
                episodes_num = episodes_num.replace('最新：','')
            else:
                episodes_num = ''
            items.append({
                'title': title,
                'url': detail_url,
                'thumbnail': imgurl,
                'resAppEpisodes':episodes_num
            })
        
        page_list = []
        _RE_PAGE = re.compile(r'<div class="next-group">([\s\S]*?)</div>[\s\S]*?')
        _RE_PAGE1 = re.compile(r'<div class="next-page">([\s\S]*?)</div>[\s\S]*?')
        _RE_PAGE2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
        if _RE_PAGE.search(content):
            match = _RE_PAGE.search(content)
            datapag =match.groups()[0]
            for match in _RE_PAGE2.finditer(str(datapag)):
                match_page = match.groups('')[0]
                page_list.append(match_page)
            maxpage = page_list[-1]
            maxpage = maxpage.split('-')[-1]
        elif _RE_PAGE1.search(content):
            match = _RE_PAGE1.search(content)
            datapag =match.groups()[0]
            for match in _RE_PAGE2.finditer(str(datapag)):
                match_page = match.groups('')[0]
                page_list.append(match_page)
            maxpage = page_list[-2]
        else:
            maxpage= 1

    return items,maxpage

def buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame,style_id):
    resid = ""
    app_id = '42'
    more_url = url
    appspidername = 'ls'
    content = fetch_url(url)
    if page == "":
        page = "1"
    
    if category_id == "c1":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_movie_from_url(content)
    elif category_id == "c2":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_tv_from_url(content)
    elif category_id == "c5":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_comic_from_url(content)
    elif category_id == "c11":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_show_from_url(content)
    elif category_id == "cs":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_self_from_url(content,style_id)
    elif category_id == "c4":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_sport_from_url(content)
    elif category_id == "c3":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_fun_from_url(content)
    elif category_id == "c9":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_music_from_url(content)
    elif category_id == "c20":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_style_from_url(content)
    elif category_id == "c16":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_recoder_from_url(content)
    elif category_id == "c22":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_business_from_url(content)
    elif category_id == "c14":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_car_from_url(content)
    elif category_id == "c23":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_trip_from_url(content)

    episodesCount = resappepisodes_mf

    if category_id == "c2":
        items,video_maxpage = get_tv_juji_list(content,page)
    elif category_id == 'cs':
        items,video_maxpage = get_self_juji_list(url,name,content,page,style_id)
    elif category_id == "c5":
        items,video_maxpage = get_comic_juji_list(content,page)
    elif category_id == "c11":
        items,video_maxpage = get_show_juji_list(url,page)
    else:
        items,video_maxpage = get_video_juji_list(url,name)

    for j in items:
        title = j["title"]
        play_url = j["url"]
        listitem=xbmcgui.ListItem(title)
        listitem.setProperty('name',title)
        listitem.setProperty('playurl',play_url)
        url=sys.argv[0] + '?mode=3&url=' + urllib.quote_plus(play_url)+ '&item_id='+'&app_id='+urllib.quote_plus(str(app_id))+'&appspidername='+urllib.quote_plus(appspidername)+'&name='+urllib.quote_plus(title)+'&resourceTitle='+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&page="+str(page)+'&category_id='+urllib.quote_plus(str(category_id))+"&view_mode="+urllib.quote_plus('morefunlist')
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, False)

    if (int(page) < int(video_maxpage)) and (category_id == "c11" or 11<=int(page)):
        if len(items)>0:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' +'[/COLOR]',thumbnailImage=MORE_THUMB)
            listitem.setProperty('next','true')
            url=sys.argv[0]+'?mode=2&page='+str(int(page)+1) +'&category_id='+str(category_id)+ '&url=' + urllib.quote_plus(more_url)+ '&name=' + urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&resappepisodes="+urllib.quote_plus(resappepisodes)+ '&medianame='+urllib.quote_plus(medianame)
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
        else:
            plugin.notify('没有更多数据', delay=2000)
            return

    resappepisodes = resappepisodes.replace('更新至','').replace('集','').replace('全','')
    if resappepisodes.isdigit():
        if category_id == "c2" or category_id == 'c5':
            maxpage = video_maxpage
            xbmcplugin.setProperty(int(sys.argv[1]), 'maxpage', str(maxpage))

    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunlist')
    xbmcplugin.setProperty(int(sys.argv[1]), 'title', name)
    xbmcplugin.setProperty(int(sys.argv[1]), 'areaname', areaname)
    xbmcplugin.setProperty(int(sys.argv[1]), 'stylename', stylename)
    xbmcplugin.setProperty(int(sys.argv[1]), 'year', year)
    xbmcplugin.setProperty(int(sys.argv[1]), 'actors', actors)
    xbmcplugin.setProperty(int(sys.argv[1]), 'description', description)
    xbmcplugin.setProperty(int(sys.argv[1]), 'resappepisodes', resappepisodes_mf)
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumbnail', thumbnail)

    if resid !="":
        xbmcplugin.setProperty(int(sys.argv[1]), 'itemId', 'ls'+str(resid))
        favouriteUrl = sys.argv[0]+"?fromtype=favourite&app_id=&resid="+urllib.quote_plus(str(resid))+"&page=&resappepisodes="+urllib.quote_plus(resappepisodes)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&category_id="+urllib.quote_plus(category_id)+"&url="+urllib.quote_plus(more_url)+"&title="+urllib.quote_plus(name)+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.setProperty(int(sys.argv[1]), 'url', favouriteUrl)

    xbmcplugin.setProperty(int(sys.argv[1]), 'itemType', 'letv')
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumb', thumbnail)
    xbmcplugin.setProperty(int(sys.argv[1]), 'playable', 'false')
    xbmcplugin.setProperty(int(sys.argv[1]), 'morefuntvsource', "false")

    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))+"&url="+urllib.quote_plus(more_url)+"&category_id="+urllib.quote_plus(category_id)+"&title="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)
    if (category_id == "c2" or category_id == 'c5') and episodesCount != "":
        xbmcplugin.setProperty(int(sys.argv[1]), 'updateUrl', updateUrl)

    xbmcplugin.setProperty(int(sys.argv[1]), 'episodesNum', episodesCount)
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', medianame)

    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def get_detail_movie_from_url(content):
    _RE_resid = re.compile(r'video : {[\s\S]*?vid:([\s\S]*?),[\s\S]*?')
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    
    _RE_year = re.compile(r'年份[\s\S]*?<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_area1 = re.compile(r'<p>地区：([\s\S]*?)</p>[\s\S]*?')
    _RE_area2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    area_iteam ='/'
    if _RE_area1.search(content):
        match = _RE_area1.search(content)
        datapag = match.groups()[0]
        for match in _RE_area2.finditer(str(datapag)):
            area = match.groups()[0]
            area =re.sub('<[\s\S]*?>','',area)
            area =str(area).replace(' ', '').replace('\n', '').replace('\t', '')
            area_iteam = area_iteam + area +'/'
            areaname = area_iteam.strip('/')
    else:
        areaname = ''
    
    _RE_actor1 = re.compile(r'<p>主演：([\s\S]*?)</p>[\s\S]*?')
    _RE_actor2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    actor_iteam ='/'
    if _RE_actor1.search(content):
        match = _RE_actor1.search(content)
        datapag = match.groups()[0]
        for match in _RE_actor2.finditer(str(datapag)):
            actor = match.groups()[0]
            actor =re.sub('<[\s\S]*?>','',actor)
            actor =str(actor).replace(' ', '').replace('\n', '').replace('\t', '')
            actor_iteam = actor_iteam + actor +'/'
            actors = actor_iteam.strip('/')
    else:
        actors = ''
    
    _RE_type1 = re.compile(r'类型：([\s\S]*?)</li>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    type_iteam ='/'
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        datapag = match.groups()[0]
        for match in _RE_type2.finditer(str(datapag)):
            type = match.groups()[0]
            type =re.sub('<[\s\S]*?>','',type)
            type =str(type).replace(' ', '').replace('\n', '').replace('\t', '')
            type_iteam = type_iteam + type +'/'
            stylename = type_iteam.strip('/')
    else:
        stylename = ''
    
    _RE_description = re.compile(r'<li class="Li04"[\s\S]*?>[\s\S]*?内容简介：([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    episodescount = "1"
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_tv_from_url(content):
    _RE_resid = re.compile(r'video:{[\s\S]*?pid:"([\s\S]*?)"[\s\S]*?')
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    
    _RE_episodescount = re.compile(r'<span class="s-t">([\s\S]*?)</span>[\s\S]*?')
    if _RE_episodescount.search(content):
        match = _RE_episodescount.search(content)
        episodescount = match.groups()[0]
        episodescount = str(episodescount).replace(' ', '').replace('\n', '').replace('\t', '').replace('更新至', '').replace('集', '').replace('共', '')
    else:
        episodescount = ''
    
    _RE_actor1 = re.compile(r'<p class="p2">主演：([\s\S]*?)</p>[\s\S]*?')
    _RE_actor2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    actor_iteam ='/'
    if _RE_actor1.search(content):
        match = _RE_actor1.search(content)
        datapag = match.groups()[0]
        for match in _RE_actor2.finditer(str(datapag)):
            actor = match.groups()[0]
            actor =re.sub('<[\s\S]*?>','',actor)
            actor =str(actor).replace(' ', '').replace('\n', '').replace('\t', '')
            actor_iteam = actor_iteam + actor +'/'
            actors = actor_iteam.strip('/')
    else:
        actors = ''
    
    _RE_area1 = re.compile(r'<p class="p3">国家/地区：([\s\S]*?)</p>[\s\S]*?')
    _RE_area2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    area_iteam ='/'
    if _RE_area1.search(content):
        match = _RE_area1.search(content)
        datapag = match.groups()[0]
        for match in _RE_area2.finditer(str(datapag)):
            area = match.groups()[0]
            area =re.sub('<[\s\S]*?>','',area)
            area =str(area).replace(' ', '').replace('\n', '').replace('\t', '')
            area_iteam = area_iteam + area +'/'
            areaname = area_iteam.strip('/')
    else:
        areaname = ''
    
    _RE_year = re.compile(r'<p class="p4">年代：([\s\S]*?)</p>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = re.sub('<[\s\S]*?>','',year)
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_type1 = re.compile(r'<p class="p5">类型：([\s\S]*?)</p>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    type_iteam ='/'
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        datapag = match.groups()[0]
        for match in _RE_type2.finditer(str(datapag)):
            type = match.groups()[0]
            type =re.sub('<[\s\S]*?>','',type)
            type =str(type).replace(' ', '').replace('\n', '').replace('\t', '')
            type_iteam = type_iteam + type +'/'
            stylename = type_iteam.strip('/')
    else:
        stylename = ''
    
    # _RE_description = re.compile(r'<p class="p7">([\s\S]*?)</p>[\s\S]*?')
    # if _RE_description.search(content):
        # match = _RE_description.search(content)
        # description = match.groups()[0]
        # description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    # else:
        # description = ''
    description = ''
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_comic_from_url(content):
    _RE_resid = re.compile(r'video:{[\s\S]*?pid:"([\s\S]*?)"[\s\S]*?')
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    
    _RE_episodescount = re.compile(r'<span class="s-t">([\s\S]*?)</span>[\s\S]*?')
    if _RE_episodescount.search(content):
        match = _RE_episodescount.search(content)
        episodescount = match.groups()[0]
        episodescount = str(episodescount).replace(' ', '').replace('\n', '').replace('\t', '').replace('更新至', '').replace('集', '').replace('共', '')
    else:
        episodescount = ''
    
    _RE_area1 = re.compile(r'<p class="p3">国家/地区：([\s\S]*?)</p>[\s\S]*?')
    _RE_area2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    area_iteam ='/'
    if _RE_area1.search(content):
        match = _RE_area1.search(content)
        datapag = match.groups()[0]
        for match in _RE_area2.finditer(str(datapag)):
            area = match.groups()[0]
            area =re.sub('<[\s\S]*?>','',area)
            area =str(area).replace(' ', '').replace('\n', '').replace('\t', '')
            area_iteam = area_iteam + area +'/'
            areaname = area_iteam.strip('/')
    else:
        areaname = ''
    
    _RE_year = re.compile(r'<p class="p4">年代：([\s\S]*?)</p>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = re.sub('<[\s\S]*?>','',year)
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_type1 = re.compile(r'<p class="p5">类型：([\s\S]*?)</p>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    type_iteam ='/'
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        datapag = match.groups()[0]
        for match in _RE_type2.finditer(str(datapag)):
            type = match.groups()[0]
            type =re.sub('<[\s\S]*?>','',type)
            type =str(type).replace(' ', '').replace('\n', '').replace('\t', '')
            type_iteam = type_iteam + type +'/'
            stylename = type_iteam.strip('/')
    else:
        stylename = ''
    
    # _RE_description = re.compile(r'<p class="p7">([\s\S]*?)</p>[\s\S]*?')
    # if _RE_description.search(content):
        # match = _RE_description.search(content)
        # description = match.groups()[0]
        # description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    # else:
        # description = ''
    
    actors = ''
    description = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_show_from_url(content):
    _RE_resid = re.compile(r'video:{[\s\S]*?pid:"([\s\S]*?)"[\s\S]*?')
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    
    _RE_type1 = re.compile(r'<p>类型：([\s\S]*?)</p>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    type_iteam ='/'
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        datapag = match.groups()[0]
        for match in _RE_type2.finditer(str(datapag)):
            type = match.groups()[0]
            type =re.sub('<[\s\S]*?>','',type)
            type =str(type).replace(' ', '').replace('\n', '').replace('\t', '')
            type_iteam = type_iteam + type +'/'
            stylename = type_iteam.strip('/')
    else:
        stylename = ''
    
    _RE_area1 = re.compile(r'<p class="p3">国家/地区：([\s\S]*?)</p>[\s\S]*?')
    _RE_area2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    area_iteam ='/'
    if _RE_area1.search(content):
        match = _RE_area1.search(content)
        datapag = match.groups()[0]
        for match in _RE_area2.finditer(str(datapag)):
            area = match.groups()[0]
            area =re.sub('<[\s\S]*?>','',area)
            area =str(area).replace(' ', '').replace('\n', '').replace('\t', '')
            area_iteam = area_iteam + area +'/'
            areaname = area_iteam.strip('/')
    else:
        areaname = ''
    
    _RE_actor1 = re.compile(r'<p class="p1">主持人：([\s\S]*?)</p>[\s\S]*?')
    _RE_actor2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    actor_iteam ='/'
    if _RE_actor1.search(content):
        match = _RE_actor1.search(content)
        datapag = match.groups()[0]
        for match in _RE_actor2.finditer(str(datapag)):
            actor = match.groups()[0]
            actor =re.sub('<[\s\S]*?>','',actor)
            actor =str(actor).replace(' ', '').replace('\n', '').replace('\t', '')
            actor_iteam = actor_iteam + actor +'/'
            actors = actor_iteam.strip('/')
    else:
        actors = ''
    
    # _RE_description = re.compile(r'<p class="p7">([\s\S]*?)</p>[\s\S]*?')
    # if _RE_description.search(content):
        # match = _RE_description.search(content)
        # description = match.groups()[0]
        # description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    # else:
        # description = ''
    
    year = ''
    episodescount = ''
    description = ''
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_self_from_url(content,style_id):
    if style_id == '2':
        resid,actors,stylename,areaname,year,description,episodescount = get_detail_tv_from_url(content)
    elif style_id == '4':
        resid,actors,stylename,areaname,year,description,episodescount = get_detail_sport_from_url(content)
    elif style_id == '9':
        resid,actors,stylename,areaname,year,description,episodescount = get_detail_music_from_url(content)
    elif style_id == '1':
        resid,actors,stylename,areaname,year,description,episodescount = get_detail_movie_from_url(content)
    elif style_id == '11':
        _RE_resid = re.compile(r'video : {[\s\S]*?vid:([\s\S]*?),[\s\S]*?')
        for match in _RE_resid.finditer(content):
            resid = match.groups()[0]
            resid = str(resid).replace(' ', '')
        
        _RE_year = re.compile(r'<span>期数[\s\S]*?;([\s\S]*?)<[\s\S]*?')
        if _RE_year.search(content):
            match = _RE_year.search(content)
            year = match.groups()[0]
            year = year[0:-2]
            year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
        else:
            year = ''
        
        _RE_type1 = re.compile(r'<p>类型：([\s\S]*?)</p>[\s\S]*?')
        _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
        type_iteam ='/'
        if _RE_type1.search(content):
            match = _RE_type1.search(content)
            datapag = match.groups()[0]
            for match in _RE_type2.finditer(str(datapag)):
                type = match.groups()[0]
                type =re.sub('<[\s\S]*?>','',type)
                type =str(type).replace(' ', '').replace('\n', '').replace('\t', '')
                type_iteam = type_iteam + type +'/'
                stylename = type_iteam.strip('/')
        else:
            stylename = ''
        
        _RE_actor1 = re.compile(r'<p>主持人：([\s\S]*?)</p>[\s\S]*?')
        _RE_actor2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
        actor_iteam ='/'
        if _RE_actor1.search(content):
            match = _RE_actor1.search(content)
            datapag = match.groups()[0]
            for match in _RE_actor2.finditer(str(datapag)):
                actor = match.groups()[0]
                actor =re.sub('<[\s\S]*?>','',actor)
                actor =str(actor).replace(' ', '').replace('\n', '').replace('\t', '')
                actor_iteam = actor_iteam + actor +'/'
                actors = actor_iteam.strip('/')
        else:
            actors = ''
        
        _RE_description = re.compile(r'<li class="Li04"[\s\S]*?>[\s\S]*?内容简介：([\s\S]*?)<[\s\S]*?')
        if _RE_description.search(content):
            match = _RE_description.search(content)
            description = match.groups()[0]
            description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
        else:
            description = ''
        
        areaname = ''
        episodescount = '1'
        
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_sport_from_url(content):
    _RE_resid = re.compile(r'video : {[\s\S]*?vid:([\s\S]*?),[\s\S]*?')
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    
    _RE_year = re.compile(r'<span>发布时间[\s\S]*?;([\s\S]*?)</a>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = year.split(' ')[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_type1 = re.compile(r'<p>类型：([\s\S]*?)</p>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    type_iteam ='/'
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        datapag = match.groups()[0]
        for match in _RE_type2.finditer(str(datapag)):
            type = match.groups()[0]
            type =re.sub('<[\s\S]*?>','',type)
            type =str(type).replace(' ', '').replace('\n', '').replace('\t', '')
            type_iteam = type_iteam + type +'/'
            stylename = type_iteam.strip('/')
    else:
        stylename = ''
    
    _RE_description = re.compile(r'<li class="Li04"[\s\S]*?>[\s\S]*?内容简介：([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    episodescount = "1"
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_fun_from_url(content):
    _RE_resid = re.compile(r'video : {[\s\S]*?vid:([\s\S]*?),[\s\S]*?')
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    
    _RE_year = re.compile(r'<span>发布时间[\s\S]*?;([\s\S]*?)</a>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = year.split(' ')[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_area1 = re.compile(r'<p>地区：([\s\S]*?)</p>[\s\S]*?')
    _RE_area2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    area_iteam ='/'
    if _RE_area1.search(content):
        match = _RE_area1.search(content)
        datapag = match.groups()[0]
        for match in _RE_area2.finditer(str(datapag)):
            area = match.groups()[0]
            area =re.sub('<[\s\S]*?>','',area)
            area =str(area).replace(' ', '').replace('\n', '').replace('\t', '')
            area_iteam = area_iteam + area +'/'
            areaname = area_iteam.strip('/')
    else:
        areaname = ''
    
    _RE_type1 = re.compile(r'<p>类型：([\s\S]*?)</p>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    type_iteam ='/'
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        datapag = match.groups()[0]
        for match in _RE_type2.finditer(str(datapag)):
            type = match.groups()[0]
            type =re.sub('<[\s\S]*?>','',type)
            type =str(type).replace(' ', '').replace('\n', '').replace('\t', '')
            type_iteam = type_iteam + type +'/'
            stylename = type_iteam.strip('/')
    else:
        stylename = ''
    
    _RE_description = re.compile(r'<li class="Li04"[\s\S]*?>[\s\S]*?内容简介：([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    episodescount = "1"
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_music_from_url(content):
    _RE_resid = re.compile(r'video : {[\s\S]*?vid:([\s\S]*?),[\s\S]*?')
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    
    _RE_year = re.compile(r'<span>年份[\s\S]*?;([\s\S]*?)</a>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        # year = year.split(' ')[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_area1 = re.compile(r'<p>地区：([\s\S]*?)</p>[\s\S]*?')
    _RE_area2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    area_iteam ='/'
    if _RE_area1.search(content):
        match = _RE_area1.search(content)
        datapag = match.groups()[0]
        for match in _RE_area2.finditer(str(datapag)):
            area = match.groups()[0]
            area =re.sub('<[\s\S]*?>','',area)
            area =str(area).replace(' ', '').replace('\n', '').replace('\t', '')
            area_iteam = area_iteam + area +'/'
            areaname = area_iteam.strip('/')
    else:
        areaname = ''
    
    _RE_type1 = re.compile(r'<p>类型：([\s\S]*?)</p>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    type_iteam ='/'
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        datapag = match.groups()[0]
        for match in _RE_type2.finditer(str(datapag)):
            type = match.groups()[0]
            type =re.sub('<[\s\S]*?>','',type)
            type =str(type).replace(' ', '').replace('\n', '').replace('\t', '')
            type_iteam = type_iteam + type +'/'
            stylename = type_iteam.strip('/')
    else:
        stylename = ''
    
    _RE_actor1 = re.compile(r'<p>演唱者：([\s\S]*?)</p>[\s\S]*?')
    _RE_actor2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    actor_iteam ='/'
    if _RE_actor1.search(content):
        match = _RE_actor1.search(content)
        datapag = match.groups()[0]
        for match in _RE_actor2.finditer(str(datapag)):
            actor = match.groups()[0]
            actor =re.sub('<[\s\S]*?>','',actor)
            actor =str(actor).replace(' ', '').replace('\n', '').replace('\t', '')
            actor_iteam = actor_iteam + actor +'/'
            actors = actor_iteam.strip('/')
    else:
        actors = ''
    
    _RE_description = re.compile(r'<li class="Li04"[\s\S]*?>[\s\S]*?内容简介：([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    episodescount = "1"
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_style_from_url(content):
    _RE_resid = re.compile(r'video : {[\s\S]*?vid:([\s\S]*?),[\s\S]*?')
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    
    _RE_year = re.compile(r'<span>年份[\s\S]*?;([\s\S]*?)</a>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        # year = year.split(' ')[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_description = re.compile(r'<li class="Li04"[\s\S]*?>[\s\S]*?内容简介：([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    stylename = ''
    episodescount = '1'
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_recoder_from_url(content):
    _RE_resid = re.compile(r'video : {[\s\S]*?vid:([\s\S]*?),[\s\S]*?')
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    
    _RE_year = re.compile(r'<span>年份[\s\S]*?;([\s\S]*?)</a>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        # year = year.split(' ')[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_type1 = re.compile(r'<p>类型：([\s\S]*?)</p>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    type_iteam ='/'
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        datapag = match.groups()[0]
        for match in _RE_type2.finditer(str(datapag)):
            type = match.groups()[0]
            type =re.sub('<[\s\S]*?>','',type)
            type =str(type).replace(' ', '').replace('\n', '').replace('\t', '')
            type_iteam = type_iteam + type +'/'
            stylename = type_iteam.strip('/')
    else:
        stylename = ''
    
    _RE_description = re.compile(r'<li class="Li04"[\s\S]*?>[\s\S]*?内容简介：([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    episodescount = '1'
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_business_from_url(content):
    _RE_resid = re.compile(r'video : {[\s\S]*?vid:([\s\S]*?),[\s\S]*?')
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    
    _RE_year = re.compile(r'<span>发布时间[\s\S]*?;([\s\S]*?)</a>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = year.split(' ')[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_type1 = re.compile(r'<p>类型：([\s\S]*?)</p>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    type_iteam ='/'
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        datapag = match.groups()[0]
        for match in _RE_type2.finditer(str(datapag)):
            type = match.groups()[0]
            type =re.sub('<[\s\S]*?>','',type)
            type =str(type).replace(' ', '').replace('\n', '').replace('\t', '')
            type_iteam = type_iteam + type +'/'
            stylename = type_iteam.strip('/')
    else:
        stylename = ''
    
    _RE_description = re.compile(r'<li class="Li04"[\s\S]*?>[\s\S]*?内容简介：([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    episodescount = "1"
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_car_from_url(content):
    _RE_resid = re.compile(r'video : {[\s\S]*?vid:([\s\S]*?),[\s\S]*?')
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    
    _RE_year = re.compile(r'<span>发布时间[\s\S]*?;([\s\S]*?)</a>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = year.split(' ')[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_type1 = re.compile(r'<p>类型：([\s\S]*?)</p>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    type_iteam ='/'
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        datapag = match.groups()[0]
        for match in _RE_type2.finditer(str(datapag)):
            type = match.groups()[0]
            type =re.sub('<[\s\S]*?>','',type)
            type =str(type).replace(' ', '').replace('\n', '').replace('\t', '')
            type_iteam = type_iteam + type +'/'
            stylename = type_iteam.strip('/')
    else:
        stylename = ''
    
    _RE_description = re.compile(r'<li class="Li04"[\s\S]*?>[\s\S]*?内容简介：([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    episodescount = "1"
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_trip_from_url(content):
    _RE_resid = re.compile(r'video : {[\s\S]*?vid:([\s\S]*?),[\s\S]*?')
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    
    _RE_year = re.compile(r'<span>发布时间[\s\S]*?;([\s\S]*?)</a>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = year.split(' ')[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''
    
    _RE_type1 = re.compile(r'<p>类型：([\s\S]*?)</p>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    type_iteam ='/'
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        datapag = match.groups()[0]
        for match in _RE_type2.finditer(str(datapag)):
            type = match.groups()[0]
            type =re.sub('<[\s\S]*?>','',type)
            type =str(type).replace(' ', '').replace('\n', '').replace('\t', '')
            type_iteam = type_iteam + type +'/'
            stylename = type_iteam.strip('/')
    else:
        stylename = ''
    
    _RE_description = re.compile(r'<li class="Li04"[\s\S]*?>[\s\S]*?内容简介：([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    episodescount = "1"
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_tv_juji_list(content,index):
    items = []
    maxpage ='1'
    _RE1 = re.compile(r'<div class="d-l"></div>([\s\S]*?)<div class="d-l"></div>[\s\S]*?')
    _RE2 = re.compile(r'<dl class="w120">([\s\S]*?)</dl>[\s\S]*?')
    _RE3 = re.compile(r'<p class="p1">[\s\S]*?<a href="([\s\S]*?)"[\s\S]*?>([\s\S]*?)<[\s\S]*?')
    if _RE1.search(content):
        match = _RE1.search(content)
        datapag =match.groups()[0]
        for match in _RE2.finditer(str(datapag)):
            datapag1 =match.groups()[0]
            for match in _RE3.finditer(str(datapag1)):
                href,title = match.groups()
            items.append({'title': title,'url':href})

    maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,maxpage

def get_self_juji_list(url,name,content,page,style_id):
    if style_id == '2':
        items,maxpage = get_tv_juji_list(content,page)
    else:
        items,maxpage = get_video_juji_list(url,name)
    return items,maxpage

def get_comic_juji_list(content,index):
    items = []
    maxpage ='1'
    _RE1 = re.compile(r'<div class="d-l"></div>([\s\S]*?)<div class="d-l"></div>[\s\S]*?')
    _RE2 = re.compile(r'<dl class="w120">([\s\S]*?)</dl>[\s\S]*?')
    _RE3 = re.compile(r'<p class="p1">[\s\S]*?<a href="([\s\S]*?)"[\s\S]*?>([\s\S]*?)<[\s\S]*?')
    if _RE1.search(content):
        match = _RE1.search(content)
        datapag =match.groups()[0]
        for match in _RE2.finditer(str(datapag)):
            datapag1 =match.groups()[0]
            for match in _RE3.finditer(str(datapag1)):
                href,title = match.groups()
            items.append({'title': title,'url':href})

    maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,maxpage

def get_show_juji_list(url,index):
    items = []
    maxpage ='1'
    pid = url.split('/')[-1].split('.')[0]
    real_url = 'http://api.letv.com/mms/out/album/getVideoList?callback=&p=1&pid=' + str(pid) + '&top=0&max=21'
    content = fetch_url(real_url)
    datapag = json.JSONDecoder().decode(content)
    data = datapag['data']
    if data:
        for item in data:
            if item.has_key('url'):
                url = item['url'].encode("utf-8").strip()
            if item.has_key('title'):
                title = item['title'].encode("utf-8").strip()
            items.append({'title': title,'url':url})
    
    maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,maxpage

def get_video_juji_list(url,name):
    items = []
    items.append({'title': name,'url':url})
    return items,1


def playVideo(url):
    mylist = GetHttpData(url)
    foobars = re.compile('<m3u8>(.*?)</m3u8>', re.DOTALL).findall(mylist)
    playlist = xbmc.PlayList(1)
    playlist.clear()
    for i in range(0,len(foobars)):
        title =" 第"+str(i+1)+"/"+str(len(foobars))+"节"
        listitem=xbmcgui.ListItem(title)
        listitem.setInfo(type="Video",infoLabels={"Title":title})
        playlist.add(foobars[i], listitem)
    xbmc.Player().play(playlist)

def searchkey(category_id):
    keyword = ""
    type = ""
    if category_id == "c1":
        category_mf = "1"
        keyword = "特殊身份,古惑仔,青春如期,小时代,狄仁杰之神都龙王,不二神探,激战,速度与激情"
        type = "电影"
    elif category_id == "c2":
        category_mf = "2"
        keyword = "特种兵之火凤凰,因为爱情有多美,万万没想到,打狗棍,千金归来,法外风云,咱们结婚吧,终极一班3"
        type = "电视剧"
    elif category_id == "c11":
        category_mf = "14"
        keyword = "爸爸去哪儿,快乐大本营,running man,康熙来了,晓说,天天向上,非诚勿扰,我们结婚了"
        type = "综艺"
    elif category_id == "c5":
        category_mf = "4"
        keyword = "灌篮高手,火影忍者,熊出没,奥特曼,名侦探柯南,海贼王,尸兄,我叫mt"
        type = "动漫"
    kb = Keyboard('','请输入搜索内容',keyword,type)
    kb.doModal()
    if (kb.isConfirmed()):
        keyword = kb.getText()
        if keyword !='':
            searchpage = 1
            searchlist(keyword,category_id,category_mf,searchpage)
        else:
            xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
            xbmcplugin.endOfDirectory(int(sys.argv[1]))
    else:
        xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
def searchlist(keyword,category_id,category_mf,searchpage):
    search_path = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/search/"+keyword+"?page_size=54"+"&page_no="+str(searchpage)+"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1383555354&security_code=ce30ea919afcc8cf731b5edf8f91ee6c&session_id=dltianwei&category_id="+str(category_mf)+"&app_id=49"
    search_path = eval(repr(search_path).replace("\\x","%"))
    p1 = GetHttpData(search_path)
    data = json.JSONDecoder().decode(p1)
    newses = data["data"]
    app_id = ''
    area_id = ''
    style_id = ''
    if newses != None:
        newses1 = newses["items"]
        maxpage = newses["totalPages"]
        for i in newses1:
            name = i["title"].encode("utf-8")
            resid = i["id"]
            resappepisodes = i["resAppEpisodes"]
            url = i["channelUrl"]
            thumbnail = i["thumbnail"].encode("utf-8")
            listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
            u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&category_id='+urllib.quote_plus(category_id)+'&resappepisodes='+urllib.quote_plus(str(resappepisodes))
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(newses1))
        if int(maxpage) > searchpage:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(searchpage) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
            listitem.setProperty('next','true')
            u=sys.argv[0] + '?mode=9&mfcachetype=dir_cache_always&searchpage='+str(searchpage+1) +'&app_id='+urllib.quote_plus('0')+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&keyword=' + urllib.quote_plus(keyword)+"&view_mode="+urllib.quote_plus('morefunthumb')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getareas(category, category_id,medianame):
    areas = []
    if category == "movie":
        areas = movie_areas
    elif category == "tv":
        areas = tv_areas
    elif category == "show":
        areas = show_areas
    elif category == "comic":
        areas = comic_areas
    elif category == "fun":
        areas = fun_areas
    elif category == "music":
        areas = music_areas
    else :
        areas = void_areas
    for area in areas:
        listitem=xbmcgui.ListItem(area[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(area[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus(area[1])+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getstyles(category, category_id,medianame):
    styles = []
    if category == "movie":
        styles = movie_styles
    elif category == "tv":
        styles = tv_styles
    elif category == "show":
        styles = show_styles
    elif category == "comic":
        styles = comic_styles
    elif category == "self_product":
        styles = self_product_styles
    elif category == "sport":
        styles = sport_styles
    elif category == "fun":
        styles = fun_styles
    elif category == "music":
        styles = music_styles
    elif category == "style":
        styles = style_styles
    elif category == "recoder":
        styles = recoder_styles
    elif category == "business":
        styles = business_styles
    elif category == "car":
        styles = car_styles
    elif category == "trip":
        styles = trip_styles
    for style in styles:
        listitem=xbmcgui.ListItem(style[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(style[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus(style[1])+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getyears(category,category_id,medianame):
    years = []
    if category == "movie":
        years = movie_years
    elif category == "tv":
        years = tv_years
    elif category == "comic":
        years = comic_years
    else:
        years = void_years
    for year in years:
        listitem=xbmcgui.ListItem(year[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(year[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus(year[1])+"&released_on_to="+urllib.quote_plus(year[2])+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def display_for_history(params):
    app_id = urllib.unquote_plus(params['app_id']) if 'app_id' in params else ''
    category_id = urllib.unquote_plus(params['category_id']) if 'category_id' in params else ''
    url = urllib.unquote_plus(params['url']) if 'url' in params else ''
    name = urllib.unquote_plus(params['title']) if 'title' in params else ''
    if name == "" or name == None:
        name = urllib.unquote_plus(params['name']) if 'name' in params else ''
    page = urllib.unquote_plus(params['page']) if 'page' in params else ''
    resappepisodes = urllib.unquote_plus(params['resappepisodes']) if 'resappepisodes' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    medianame = urllib.unquote_plus(params['medianame']) if 'medianame' in params else ''
    style_id = urllib.unquote_plus(params['style_id']) if 'style_id' in params else ''
    buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame,style_id)

def display_for_favourite(params):
    display_for_history(params)

def update_favourite(params):
    title = urllib.unquote_plus(params['title']) if 'title' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    resid = urllib.unquote_plus(params['resid']) if 'resid' in params else ''
    url = urllib.unquote_plus(params['url']) if 'url' in params else ''
    category_id = urllib.unquote_plus(params['category_id']) if 'category_id' in params else ''
    content = fetch_url(url)
    
    if category_id == "c1":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_movie_from_url(content)
    elif category_id == "c2":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_tv_from_url(content)
    elif category_id == "c5":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_comic_from_url(content)
    elif category_id == "c11":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_show_from_url(content)
    elif category_id == "cs":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_self_from_url(content)
    elif category_id == "c4":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_sport_from_url(content)
    elif category_id == "c3":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_fun_from_url(content)
    elif category_id == "c9":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_music_from_url(content)
    elif category_id == "c20":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_style_from_url(content)
    elif category_id == "c16":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_recoder_from_url(content)
    elif category_id == "c22":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_business_from_url(content)
    elif category_id == "c14":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_car_from_url(content)
    elif category_id == "c23":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_trip_from_url(content)

    episodesCount = resappepisodes_mf
    
    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))+"&url="+urllib.quote_plus(url)+"&category_id="+urllib.quote_plus(category_id)
    listitem=xbmcgui.ListItem(title)
    listitem.setProperty('title',title)
    listitem.setProperty('thumb',thumbnail)
    listitem.setProperty('episodesNum',episodesCount)
    listitem.setProperty('updateUrl',updateUrl)
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), updateUrl, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))


def get_params(url = ''):
    param = []
    paramstring = sys.argv[2] if url=='' else url
    if len(paramstring) >= 2:
        params = paramstring
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]
    return param

 