# -*- coding: utf-8 -*-
# getlist.py

import urllib,urllib2,re,xbmcplugin,xbmcgui,sys,os,os.path,xbmcaddon,xbmc
from urlparse import urljoin
import json
import gzip
try:
    from cStringIO import StringIO
except ImportError:
    from StringIO import StringIO
from xbmcswift2 import Plugin
plugin = Plugin()
try:
    from MFSearchKeyboard import Keyboard
except:
    from xbmc import Keyboard
    pass



plugin_path = plugin.addon.getAddonInfo('path')
lib_path = os.path.join(plugin_path, 'lib')

import time


__addonid__ = "plugin.video.mfsohu"
__addon__ = xbmcaddon.Addon(id=__addonid__)
RESOURCES_PATH = os.path.join(__addon__.getAddonInfo('path'), 'media', )
PAGING_THUMB = os.path.join(RESOURCES_PATH,'paging.png')
MORE_THUMB = os.path.join(RESOURCES_PATH,'more.png')
MOVIE_THUMB = os.path.join(RESOURCES_PATH,'1movie.png')
TV_THUMB = os.path.join(RESOURCES_PATH,'2tv.png')
COMIC_THUMB = os.path.join(RESOURCES_PATH,'3comic.png')
SHOW_THUMB = os.path.join(RESOURCES_PATH,'4show.png')
REC_THUMB = os.path.join(RESOURCES_PATH,'5recoder.png')
MUSIC_THUMB = os.path.join(RESOURCES_PATH,'7music.png')
NEWS_THUMB = os.path.join(RESOURCES_PATH,'8news.png')
FUN_THUMB = os.path.join(RESOURCES_PATH,'9fun.png')
STAR_MODE_THUMB = os.path.join(RESOURCES_PATH,'10star_mode.png')
TRAVEL_THUMB = os.path.join(RESOURCES_PATH,'11travel.png')
E_FRIEND_THUMB = os.path.join(RESOURCES_PATH,'12e_friend.png')


movie_areas = [['全部', ''],['内地','_u5185_u5730'],['香港','_u9999_u6e2f'],['台湾','_u53f0_u6e7e'],['日本','_u65e5_u672c'],['韩国','_u97e9_u56fd'],['美国','_u7f8e_u56fd'],['英国','_u82f1_u56fd'],['法国','_u6cd5_u56fd'],['德国','_u5fb7_u56fd'],['意大利','_u610f_u5927_u5229'],['西班牙','_u897f_u73ed_u7259'],['俄罗斯','_u4fc4_u7f57_u65af'],['加拿大','_u52a0_u62ff_u5927'],['印度','_u5370_u5ea6'],['泰国','_u6cf0_u56fd'],['其他','_u5176_u4ed6']]
movie_styles = [['全部', ''],['爱情','100100'],['战争','100101'],['喜剧','100102'],['科幻','100103'],['恐怖','100104'],['动画','100105'],['动作','100106'],['风月','100107'],['剧情','100108'],['歌舞','100109'],['记录','100110'],['魔幻','100111'],['灾难','100112'],['悬疑','100113'],['传记','100114'],['警匪','100116'],['伦理','100117'],['惊悚','100118'],['谍战','100119'],['历史','100120'],['武侠','100121'],['青春','100122'],['文艺','100123']]

tv_areas = [['全部', ''],['内地','_u5185_u5730'],['港剧','_u6e2f_u5267'],['台剧','_u53f0_u5267'],['美剧','_u7f8e_u5267'],['韩剧','_u97e9_u5267'],['英剧','_u82F1_u5267'],['泰剧','_u6cf0_u5267'],['日剧','_u65e5_u5267'],['其他','_u5176_u4ed6']]
tv_styles = [['全部', ''],['偶像','101100'],['家庭','101101'],['历史','101102'],['年代','101103'],['言情','101104'],['武侠','101105'],['古装','101106'],['都市','101107'],['农村','101108'],['军旅','101109'],['刑侦','101110'],['喜剧','101111'],['悬疑','101112'],['情景','101113'],['传记','101114'],['科幻','101115'],['动画','101116'],['动作','101117'],['真人秀','101118'],['栏目','101119'],['谍战','101120'],['伦理','101121'],['战争','101122'],['神话','101123'],['惊悚','101124'],['剧情','101127']]

comic_areas = [['全部', ''],['大陆','_u5927_u9646'],['日本','_u65e5_u672c'],['美国','_u7f8e_u56fd'],['韩国','_u97e9_u56fd'],['香港','_u9999_u6e2f'],['欧洲','_u6B27_u6D32'],['其他','_u5176_u4ed6']]
comic_styles = [['全部', ''],['历史','115100'],['搞笑','115101'],['战斗','115102'],['冒险','115103'],['魔幻','115104'],['励志','115105'],['益智','115106'],['童话','115107'],['体育','115108'],['神话','115110'],['青春','115111'],['悬疑','115112'],['真人','115113'],['亲子','115114'],['恋爱','115118'],['科幻','115123'],['治愈','115124'],['日常','115125'],['神魔','115126'],['百合','115127'],['耽美','115128'],['校园','115129'],['后宫','115130'],['美少女','115131'],['竞技','115132'],['机战','115133']]

show_areas = [['全部', ''],['内地','_u5185_u5730'],['香港','_u9999_u6e2f'],['台湾','_u53f0_u6e7e'],['欧美','_u6b27_u7f8e'],['日韩','_u65e5_u97e9'],['其他','_u5176_u4ed6']]
show_styles = [['全部', ''],['访谈','106100'],['时尚','106101'],['游戏竞技','106102'],['KTV','106103'],['交友','106104'],['选秀','106105'],['音乐','106106'],['曲艺','106107'],['养生','106109'],['脱口秀','106110'],['歌舞','106111'],['娱乐节目','106112'],['真人秀','106113'],['其他','106108']]

recorder_styles = [['全部', ''],['人物','107100'],['历史','107101'],['自然','107102'],['军事','107103'],['社会','107104'],['幕后','107105'],['财经','107106'],['搜狐视频大视野','107107'],['剧情','107108'],['旅游','107109'],['科技','107110'],['文化','107111']]

music_areas = [['全部', ''],['内地','_u5185_u5730'],['港台','_u6e2f_u53f0'],['欧美','_u6b27_u7f8e'],['日韩','_u65e5_u97e9'],['其他','_u5176_u4ed6']]
music_styles = [['全部', ''],['流行', '1'],['舞曲', '13'],['摇滚', '2'],['R&B', '10'],['说唱', '3'],['电音', '4'],['古典', '5'],['民歌', '6'],['爵士', '7'],['金属', '8'],['乡村', '9'],['民谣', '14'],['独立', '15'],['朋克', '17'],['另类', '18'],['灵魂', '19'],['电影原声', '12'],['轻音乐', '11']]

news_styles = [['全部', ''],['国内','122204'],['国际','122205'],['军事','122101'],['科技','122106'],['财经','122104'],['社会','122102'],['生活','122999']]

fun_styles = [['全部', ''],['明星','112103'],['电影','112100'],['电视','112101'],['音乐','112102'],['戏剧','112202'],['动漫','112201'],['其他','112203']]

star_mode_styles = [['全部', ''],['资讯','130100'],['女装成衣','130101'],['趋势','130102'],['精选','130103'],['彩妆','130104'],['生活','130106'],['广告','130107'],['电视','130108'],['街拍','130111'],['杂志','130112'],['明星','130113'],['派对','130114'],['艺术与设计','130115'],['电影','130116'],['音乐','130117'],['专题','130118'],['时事','130119'],['八卦','130120'],['红毯','130121'],['护肤','130122'],['产品','130123'],['健康','130124'],['高级定制','130125'],['男装成衣','130126']]

travel_styles = [['全部', ''],['自驾游','131100'],['攻略','131101'],['交通住宿','131102'],['旅游资讯','131103'],['国内游','131104'],['境外游','131105'],['自然','131106'],['人文','131107'],['户外','131108'],['美食','131109'],['节庆活动','131110']]

e_friends_styles = [['全部', ''],['原创','124'],['电影','100'],['电视剧','101'],['动漫','115'],['综艺','106'],['科技','127'],['汽车','126'],['体育','125'],['教育','119'],['新闻','122'],['音乐','121'],['游戏','128'],['娱乐','112'],['母婴','132'],['旅游','131'],['综合','120'],['纪录片','107'],['生活','129'],['时尚','130'],['健康','163']]

full_years = [['全部', '', ''], ['2014', '2014', ''], ['2013', '2013', ''], ['2012', '2012', ''], ['2011', '2011', ''], ['2010', '2010', ''], ['00年代', '11', ''], ['90年代', '90', ''], ['80年代', '80', ''], ['更早', '1', '']]

void_years = []

void_areas = []

HOST = 'http://so.tv.sohu.com/'


def GetHttpData(url):
    req = urllib2.Request(url)
    response = urllib2.urlopen(req)
    httpdata = response.read()
    if response.headers.get('content-encoding', None) == 'gzip':
        httpdata = gzip.GzipFile(fileobj=StringIO.StringIO(httpdata)).read()
    response.close()
    match = re.compile('encodingt=(.+?)"').findall(httpdata)
    if len(match)<=0:
        match = re.compile('<meta http-equiv=[\s\S]*?charset=(.+?)"').findall(httpdata)
    if len(match)>0:
        charset = match[0].lower()
        if (charset != 'utf-8') and (charset != 'utf8'):
            httpdata = unicode(httpdata, charset).encode('utf8')
    return httpdata

def fetch_url(url, data=None, headers={}, timeout=None, proxies=None):
    headers.setdefault(
        'User-Agent', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1872.0 Safari/537.36')  # noqa
    headers.setdefault('Accept-Encoding', 'gzip,deflate')
    if data and isinstance(data, dict):
        data = urlencode(data)
    req = urllib2.Request(url, data, headers)
    http_proxy = None
    if proxies or http_proxy:
        if not proxies:
            if isinstance(http_proxy, basestring):
                proxies = {'http': http_proxy, 'https': http_proxy}
            else:
                proxies = http_proxy
        proxy_handler = urllib2.ProxyHandler(proxies)
        opener = urllib2.build_opener(proxy_handler)
        r = opener.open(req, timeout=timeout)
    else:
        r = urllib2.urlopen(req, timeout=timeout)
    content = r.read()
    if r.headers.get('content-encoding') == 'gzip':
        content = gzip.GzipFile(fileobj=StringIO(content), mode='rb').read()
    return content

def buildRoot():
    listitem=xbmcgui.ListItem('电影',thumbnailImage=MOVIE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('电影')+"&category_id="+urllib.quote_plus('100')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('movie')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('电视剧',thumbnailImage=TV_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('电视剧')+"&category_id="+urllib.quote_plus('101')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('tv')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('综艺',thumbnailImage=SHOW_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('综艺')+"&category_id="+urllib.quote_plus('106')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('show')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('动漫',thumbnailImage=COMIC_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('动漫')+"&category_id="+urllib.quote_plus('115')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('comic')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('纪录片',thumbnailImage=REC_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('纪录片')+"&category_id="+urllib.quote_plus('107')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('recorder')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('音乐',thumbnailImage=MUSIC_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('音乐')+"&category_id="+urllib.quote_plus('121')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('music')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('新闻',thumbnailImage=NEWS_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('新闻')+"&category_id="+urllib.quote_plus('122')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('news')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('娱乐',thumbnailImage=FUN_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('娱乐')+"&category_id="+urllib.quote_plus('112')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('fun')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('星尚',thumbnailImage=STAR_MODE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('星尚')+"&category_id="+urllib.quote_plus('130')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('star_mode')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('旅游',thumbnailImage=TRAVEL_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('旅游')+"&category_id="+urllib.quote_plus('131')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('travel')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('网友上传',thumbnailImage=E_FRIEND_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('网友上传')+"&category_id="+urllib.quote_plus('99')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('e_friends')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)

    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildLists(category_id,page,area_id,style_id,released_on_from,released_on_to,medianame):
    url = HOST + 'list_p1' + str(category_id) + '_p2' + str(style_id) + '_p3' + str(area_id) + '_p4' + str(released_on_from) + '_p5_p6_p7_p8_p9_p10' + str(page) + '.html'
    
    if category_id == '100' or category_id == '121' or category_id == '122' or category_id == '112' or category_id == '130' or category_id == '131' or category_id == '99':
        items,maxpage = get_movies_from_url(url)
    else:
        items,maxpage = get_resources_from_url(url,category_id)
    for i in items:
        name = i["title"].encode("utf-8")
        resappepisodes = i["resAppEpisodes"]
        url = i["url"]
        thumbnail = i["thumbnail"].encode("utf-8")
        listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
        if category_id != "100" and category_id != '121' and category_id != '122' and category_id != '112' and category_id != '130' and category_id != '131' and category_id != '99':
            listitem.setProperty('v360resappepisodes',resappepisodes)
        u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&category_id='+urllib.quote_plus(category_id)+'&resappepisodes='+urllib.quote_plus(str(resappepisodes))+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(items))
    if int(maxpage) > int(page):
        listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多 ' + str(page) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
        u=sys.argv[0] + '?mode=1&page='+str(page+1) +'&category_id='+urllib.quote_plus(category_id)+'&area_id='+urllib.quote_plus(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&released_on_from=' + urllib.quote_plus(released_on_from)+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb2')
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', medianame)
    if category_id == '100' or category_id == '101' or category_id == '115' or category_id == '106':
        xbmcplugin.setProperty(int(sys.argv[1]),'search_show','able')
    else:
        xbmcplugin.setProperty(int(sys.argv[1]),'search_show','unable')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def get_movies_from_url(url):
    content = fetch_url(url)
    _RE_iteam = re.compile(r'<li class="clear">([\s\S]*?)</li>[\s\S]*?')
    _RE_detail = re.compile(
        r'<div class="show-pic">[\s\S]*?<[\s\S]*?href="([\s\S]*?)"[\s\S]*?'
        '<img src="([\s\S]*?)"[\s\S]*?'
        'title="([\s\S]*?)" /></a>')
    _RE_VIP = re.compile(r'<em class="pay">[\s\S]*?</em>')
    items = []
    for match in _RE_iteam.finditer(content):
        datapag = match.groups()[0]
        datapag_match = _RE_detail.search(str(datapag))
        detail_url,imgurl, title = datapag_match.groups()
        if _RE_VIP.search(str(datapag)):
            status = 'pay'
        else:
            status = 'free'
        items.append({
            'title': title,
            'url': detail_url,
            'thumbnail': imgurl,
            'resAppEpisodes':'1集全',
            'status':status
        })
        
        
    maxpage = '0'
    _RE_PAGE1 = re.compile(r'<div class="page">([\s\S]*?)</div>[\s\S]*?')
    _RE_PAGE2 = re.compile(r'<div class="num">[\s\S]*<a href="[\s\S]*?">([\s\S]*?)</a>')
    for match in _RE_PAGE1.finditer(content):
        datapag =match.groups()[0]
        match_page = _RE_PAGE2.search(datapag)
        if match_page:
            maxpage = match_page.groups('')[0]
        else:
            maxpage= 1
            
    return items,maxpage

def get_resources_from_url(url,category_id):
    content = fetch_url(url)
    _RE = re.compile(
        r'<div class="show-pic">[\s\S]*?<[\s\S]*?href="([\s\S]*?)"[\s\S]*?'
        '<img src="([\s\S]*?)"[\s\S]*?'
        'title="([\s\S]*?)" /></a>[\s\S]*?'
        '<span></span><i>([\s\S]*?)</i>[\s\S]*?'
        )
    items = []
    for match in _RE.finditer(content):
        detail_url, imgurl, title, episodes_num = match.groups()
        items.append({
            'title': title,
            'url': detail_url,
            'thumbnail': imgurl,
            'resAppEpisodes':episodes_num
        })
        
    maxpage = '0'
    _RE_PAGE1 = re.compile(r'<div class="page">([\s\S]*?)</div>[\s\S]*?')
    _RE_PAGE2 = re.compile(r'<div class="num">[\s\S]*<a href=[\s\S]*?>([\s\S]*?)</a>')
    for match in _RE_PAGE1.finditer(content):
        datapag =match.groups()[0]
        match_page = _RE_PAGE2.search(datapag)
        if match_page:
            maxpage = match_page.groups('')[0]
        else:
            maxpage= 1
            
    return items,maxpage

def buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame):
    content = GetHttpData(url)
    if page == "":
        page = "1"
    more_url = url
    resid = ""
    if category_id == "100":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_dianying_from_url(content)
    elif category_id == "101":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_dianshi_from_url(content)
    elif category_id == "115":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_dongman_from_url(content)
    elif category_id == "106":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_zongyi_from_url(content)
    elif category_id == "107":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_jilupian_from_url(content)
    elif category_id == "121":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_yinyue_from_url(content)
    elif category_id == "122":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_xinwen_from_url(content)
    elif category_id == "112":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_yule_from_url(content)
    elif category_id == "130":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_xingshang_from_url(content)
    elif category_id == "131":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_lvyou_from_url(content)
    elif category_id == "99":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_wangyoushangchuan_from_url(content)
    episodesCount = resappepisodes_mf
    app_id = '25'
    appspidername = 'sh'
    if category_id == "100" or category_id == '121' or category_id == '122' or category_id == '112' or category_id == '130' or category_id == '131' or category_id == '99':
        items,video_maxpage = get_dy_juji_list(url,name)
    elif category_id == "101":
        items,video_maxpage = get_ds_juji_list(url,page)
    elif category_id == "106":
        items,video_maxpage = get_zy_juji_list(url,page)
    elif category_id == "115":
        items,video_maxpage = get_dm_juji_list(url,page)
    elif category_id == "107":
        items,video_maxpage = get_jlp_juji_list(url,page)
    for j in items:
        title = j["title"]
        play_url = j["url"]
        listitem=xbmcgui.ListItem(title)
        listitem.setProperty('name',title)
        listitem.setProperty('playurl',play_url)
        url=sys.argv[0] + '?mode=3&url=' + urllib.quote_plus(play_url)+ '&item_id='+'&app_id='+urllib.quote_plus(str(app_id))+'&appspidername='+urllib.quote_plus(appspidername)+'&name='+urllib.quote_plus(title)+'&resourceTitle='+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&page="+str(page)+'&category_id='+urllib.quote_plus(str(category_id))+"&view_mode="+urllib.quote_plus('morefunlist')
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, False)
    if (int(page) < int(video_maxpage)) and (11<=int(page) or category_id == "107" or category_id == "106"):
        if len(items)>0:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' +'[/COLOR]',thumbnailImage=MORE_THUMB)
            listitem.setProperty('next','true')
            url=sys.argv[0]+'?mode=2&page='+str(int(page)+1) +'&category_id='+str(category_id)+ '&url=' + urllib.quote_plus(more_url)+ '&name=' + urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&resappepisodes="+urllib.quote_plus(resappepisodes)+ '&medianame='+urllib.quote_plus(medianame)
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
        else:
            plugin.notify('没有更多数据', delay=2000)
            return
            
    resappepisodes = resappepisodes.replace('更新至','').replace('集','').replace('共','').replace('集全','')
    if resappepisodes.isdigit():
        if category_id == "101" or category_id == "115":
            maxpage = video_maxpage
            xbmcplugin.setProperty(int(sys.argv[1]), 'maxpage', str(maxpage))
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunlist')
    xbmcplugin.setProperty(int(sys.argv[1]), 'title', name)
    xbmcplugin.setProperty(int(sys.argv[1]), 'areaname', areaname)
    xbmcplugin.setProperty(int(sys.argv[1]), 'stylename', stylename)
    xbmcplugin.setProperty(int(sys.argv[1]), 'year', year)
    xbmcplugin.setProperty(int(sys.argv[1]), 'actors', actors)
    xbmcplugin.setProperty(int(sys.argv[1]), 'description', description)
    xbmcplugin.setProperty(int(sys.argv[1]), 'resappepisodes', resappepisodes_mf)
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumbnail', thumbnail)
    if resid !="":
        xbmcplugin.setProperty(int(sys.argv[1]), 'itemId', 'sh'+str(resid))
        favouriteUrl = sys.argv[0]+"?fromtype=favourite&app_id=&resid="+urllib.quote_plus(str(resid))+"&page=&resappepisodes="+urllib.quote_plus(resappepisodes)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&category_id="+urllib.quote_plus(category_id)+"&url="+urllib.quote_plus(more_url)+"&title="+urllib.quote_plus(name)+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.setProperty(int(sys.argv[1]), 'url', favouriteUrl)
    xbmcplugin.setProperty(int(sys.argv[1]), 'itemType', 'sohu')
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumb', thumbnail)
    xbmcplugin.setProperty(int(sys.argv[1]), 'playable', 'false')
    xbmcplugin.setProperty(int(sys.argv[1]), 'morefuntvsource', "false")
    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))+"&url="+urllib.quote_plus(more_url)+"&category_id="+urllib.quote_plus(category_id)+"&title="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)
    if (category_id == "101" or category_id == "115" or category_id == "107") and episodesCount != "":
        xbmcplugin.setProperty(int(sys.argv[1]), 'updateUrl', updateUrl)
    xbmcplugin.setProperty(int(sys.argv[1]), 'episodesNum', episodesCount)
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', medianame)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
    
def get_detail_dianying_from_url(content):
    _RE = re.compile(r'var pid[\s\S]*?="([\s\S]*?)";[\s\S]*?')
    for match in _RE.finditer(content):
        resid = match.groups()[0]
    _RE_actor = re.compile(r'<ul class="u cfix">[\s\S]*?主演：([\s\S]*?)</li>[\s\S]*?')
    _RE_year = re.compile(r'<li class="h">年份：<[\s\S]*?>([\s\S]*?)</a> </li>[\s\S]*?')
    _RE_area = re.compile(r'产地：([\s\S]*?)</li>[\s\S]*?')
    _RE_type = re.compile(r'<li class="s h">类型：([\s\S]*?)</li>[\s\S]*?')
    _RE_description = re.compile(r'<p class="intro">简介：([\s\S]*?)<[\s\S]*?')
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '/').replace('\n', '').replace('\t', '')
        actors =actors.strip('/')
    else:
        actors = ''
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
    else:
        year = ''
    if _RE_area.search(content):
        match = _RE_area.search(content)
        area = match.groups()[0]
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    episodescount = "1"
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_yinyue_from_url(content):
    _RE = re.compile(r'var pid[\s\S]*?="([\s\S]*?)";[\s\S]*?')
    for match in _RE.finditer(content):
        resid = match.groups()[0]
        
    _RE_actor = re.compile(r'<li>歌手：([\s\S]*?)</li>[\s\S]*?')
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '/').replace('\n', '').replace('\t', '')
        actors =actors.strip('/')
    else:
        actors = ''
        
    _RE_type = re.compile(r'<li class="s">风格：([\s\S]*?)</li>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''
        
    _RE_area = re.compile(r'<li class="s h">产地：([\s\S]*?)</li>[\s\S]*?')
    if _RE_area.search(content):
        match = _RE_area.search(content)
        area = match.groups()[0]
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''
        
    _RE_description = re.compile(r'<p class="intro">简介：([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
        
    episodescount = "1"
    year = ''
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_xinwen_from_url(content):
    _RE = re.compile(r'var pid[\s\S]*?="([\s\S]*?)";[\s\S]*?')
    for match in _RE.finditer(content):
        resid = match.groups()[0]
        
    _RE_year = re.compile(r'<ul class="u cfix">[\s\S]*?<li>发布：([\s\S]*?)</li>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '/').replace('\n', '').replace('\t', '')
        year = year[0:10]
    else:
        year = ''
        
    _RE_type = re.compile(r'<li class="h">类型：([\s\S]*?)</li>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''
        
    _RE_description = re.compile(r'<p class="intro">简介：([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    episodescount = "1"
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_yule_from_url(content):
    _RE = re.compile(r'var pid[\s\S]*?="([\s\S]*?)";[\s\S]*?')
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_year = re.compile(r'<li class="h">发布：([\s\S]*?)</li>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '/').replace('\n', '').replace('\t', '')
        year = year[0:10]
    else:
        year = ''

    _RE_type = re.compile(r'<li class="h">类型：([\s\S]*?)</li>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    _RE_description = re.compile(r'<p class="intro">简介：([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    actors = ''
    areaname = ''
    episodescount = "1"
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_xingshang_from_url(content):
    _RE = re.compile(r'var pid[\s\S]*?="([\s\S]*?)";[\s\S]*?')
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_type = re.compile(r'<div class="crumb">[\s\S]*?</span>([\s\S]*?)<span class="f-song">[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    _RE_description = re.compile(r'<p class="wz">([\s\S]*?)</p>[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    year = ''
    actors = ''
    areaname = ''
    episodescount = "1"

    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_lvyou_from_url(content):
    _RE = re.compile(r'var pid[\s\S]*?="([\s\S]*?)";[\s\S]*?')
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_type = re.compile(r'<div class="crumb">[\s\S]*?</span>([\s\S]*?)<span class="f-song">[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    _RE_description = re.compile(r'<p class="wz">([\s\S]*?)</p>[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    year = ''
    actors = ''
    areaname = ''
    episodescount = "1"

    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_wangyoushangchuan_from_url(content):
    _RE = re.compile(r"var vid = '([\s\S]*?)';[\s\S]*?")
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_type = re.compile(r'<span class="arr-next">[\s\S]*?</span>[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    _RE_description = re.compile(r'<p class="videoDes cfix">简介：([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    year = ''
    actors = ''
    areaname = ''
    episodescount = "1"

    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_dianshi_from_url(content):
    iteam =[]
    _RE1 = re.compile(r'(\d+)')
    _RE = re.compile(r'var pid[\s\S]*?="([\s\S]*?)";[\s\S]*?')
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_episodescount = re.compile(r'<div id="picFocusout" class="area">[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_episodescount.search(content):
        match = _RE_episodescount.search(content)
        episodescount = match.groups()[0]
        for match in _RE1.finditer(str(episodescount)):
            episodescount = match.groups()[0]
            iteam.append(episodescount)
            episodescount=iteam[-1]
    else:
        episodescount = ''

    _RE_actor = re.compile(r'<p>主演：([\s\S]*?)</p>[\s\S]*?')
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        actors = ''

    _RE_description = re.compile(r'<div class="d1">([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    _RE_year = re.compile(r'<p>年份：[\s\S]*?>([\s\S]*?)<[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''

    _RE_type = re.compile(r'<p>类型：([\s\S]*?)</p>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    areaname = ''
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_dongman_from_url(content):
    iteam =[]
    _RE1 = re.compile(r'(\d+)')
    _RE = re.compile(r'var pid[\s\S]*?="([\s\S]*?)";[\s\S]*?')
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_episodescount = re.compile(r'<div id="picFocusout" class="area">[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_episodescount.search(content):
        match = _RE_episodescount.search(content)
        episodescount = match.groups()[0]
        for match in _RE1.finditer(str(episodescount)):
            episodescount = match.groups()[0]
            iteam.append(episodescount)
            episodescount=iteam[-1]
    else:
        episodescount = ''

    _RE_description = re.compile(r'<div class="d1">([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    _RE_year = re.compile(r'<p>年份：[\s\S]*?>([\s\S]*?)<[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''

    _RE_type = re.compile(r'<p>类型：([\s\S]*?)</p>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    actors = ''
    areaname = ''

    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_zongyi_from_url(content):
    _RE = re.compile(r'var pid[\s\S]*?="([\s\S]*?)";[\s\S]*?')
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_actor = re.compile(r'<p>主持人：([\s\S]*?)</p>[\s\S]*?')
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\t', '').replace('\n', '')
    else:
        actors = ''

    _RE_description = re.compile(r'<div class="d1">([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    _RE_area = re.compile(r'<p>地区：([\s\S]*?)</p>[\s\S]*?')
    if _RE_area.search(content):
        match = _RE_area.search(content)
        area = match.groups()[0]
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''

    _RE_type = re.compile(r'<p>类型：([\s\S]*?)</p>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    year = ''
    episodescount = ''
    return resid,actors,stylename,areaname,year,description,episodescount


def get_detail_jilupian_from_url(content):
    iteam =[]
    _RE1 = re.compile(r'(\d+)')
    _RE = re.compile(r'var pid[\s\S]*?="([\s\S]*?)";[\s\S]*?')
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_episodescount = re.compile(r'<div class="d1 clear">([\s\S]*?)</div>[\s\S]*?')
    if _RE_episodescount.search(content):
        match = _RE_episodescount.search(content)
        episodescount = match.groups()[0]
        for match in _RE1.finditer(str(episodescount)):
            episodescount = match.groups()[0]
            iteam.append(episodescount)
            episodescount=iteam[-1]
    else:
        episodescount = ''

    _RE_description = re.compile(r'<div class="d1">([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    _RE_year = re.compile(r'<p>年份：([\s\S]*?)</a>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = str(year).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        year = ''

    _RE_type = re.compile(r'<p>类型：([\s\S]*?)</p>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    actors = ''
    areaname = ''

    return resid,actors,stylename,areaname,year,description,episodescount

def get_dy_juji_list(url,name):
    items = []
    items.append({'title': name,'url':url})
    return items,1

def get_ds_juji_list(url,index):
    ds_maxpage ='1'
    items = []
    content = GetHttpData(url)
    _RE1 = re.compile(r'<a id="getdesc"[\s\S]*?title="剧集从后到前排序"[\s\S]*?<div class="pp similarLists">([\s\S]*?)</div>[\s\S]*?')
    _RE2 = re.compile(r"<li[\s\S]*?href= '([\s\S]*?)'[\s\S]*?href=[\s\S]*?>([\s\S]*?)</a>[\s\S]*?")
    for match in _RE1.finditer(content):
        datapag =match.groups()[0]
        for match in _RE2.finditer(str(datapag)):
            href,title = match.groups()
            items.append({'title': title,'url':href})

    ds_maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if ds_maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,ds_maxpage

def get_dm_juji_list(url,index):
    dm_maxpage ='1'
    items = []
    content = GetHttpData(url)
    _RE1 = re.compile(r'<a id="getdesc"[\s\S]*?title="剧集从后到前排序"[\s\S]*?<div class="pp similarLists">([\s\S]*?)</div>[\s\S]*?')
    _RE2 = re.compile(r"<li[\s\S]*?href= '([\s\S]*?)'[\s\S]*?href=[\s\S]*?>([\s\S]*?)</a>[\s\S]*?")
    for match in _RE1.finditer(content):
        datapag =match.groups()[0]
        for match in _RE2.finditer(str(datapag)):
            href,title = match.groups()
            items.append({'title': title,'url':href})

    dm_maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if dm_maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,dm_maxpage

def get_jlp_juji_list(url,index):
    jlp_maxpage ='1'
    items = []
    content = GetHttpData(url)
    _RE1 = re.compile(r'<a id="getdesc"[\s\S]*?title="剧集从后到前排序"[\s\S]*?<div class="pp similarLists">([\s\S]*?)</div>[\s\S]*?')
    _RE2 = re.compile(r"<li[\s\S]*?href= '([\s\S]*?)'[\s\S]*?href=[\s\S]*?>([\s\S]*?)</a>[\s\S]*?")
    for match in _RE1.finditer(content):
        datapag =match.groups()[0]
        for match in _RE2.finditer(str(datapag)):
            href,title = match.groups()
            items.append({'title': title,'url':href})

    jlp_maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if jlp_maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,jlp_maxpage

def get_zy_juji_list(url,index):
    zx_maxpage ='1'
    items = []
    content = GetHttpData(url)
    _RE1 = re.compile(r'var PLAYLIST_ID="([\s\S]*?)"[\s\S]*?')
    _RE2 = re.compile(r'<li><span>年份：</span></li>([\s\S]*?)</ul>[\s\S]*?')
    _RE3 = re.compile(r'<li>[\s\S]*?>([\s\S]*?)</a></li>')
    for match in _RE1.finditer(content):
        playId = match.groups()[0]
    for match in _RE2.finditer(content):
        datapag = match.groups()[0]
        for match in _RE3.finditer(str(datapag)):
            year = match.groups()[0]
            has_next=True
            pageNum=1
            while has_next:
                real_url = 'http://pl.hd.sohu.com/videolist?playlistid='+playId+'&year='+year+'&month=&pagenum='+str(pageNum)+'&pagesize=16&order=1&callback=zyListBack'
                data = fetch_url(real_url).decode('gbk','ignore').replace('zyListBack(', '').replace(');', '')
                data = json.JSONDecoder().decode(data)
                videos = data['videos']
                if videos:
                    pageNum = pageNum+1
                    for item in videos:
                        if item.has_key('pageUrl'):
                            url = item['pageUrl'].encode("utf-8").strip()
                        if item.has_key('name'):
                            title = item['name'].encode("utf-8").strip()
                        items.append({'title': title,'url':url})
                else:
                    has_next=False
    zx_maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if zx_maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,zx_maxpage 

def playVideo(url):
    mylist = GetHttpData(url)
    foobars = re.compile('<m3u8>(.*?)</m3u8>', re.DOTALL).findall(mylist)
    playlist = xbmc.PlayList(1)
    playlist.clear()
    for i in range(0,len(foobars)):
        title =" 第"+str(i+1)+"/"+str(len(foobars))+"节"
        listitem=xbmcgui.ListItem(title)
        listitem.setInfo(type="Video",infoLabels={"Title":title})
        playlist.add(foobars[i], listitem)
    xbmc.Player().play(playlist)

def searchkey(category_id):
    keyword = ""
    type = ""
    if category_id == "100":
        category_mf = "1"
        keyword = "特殊身份,古惑仔,青春如期,小时代,狄仁杰之神都龙王,不二神探,激战,速度与激情"
        type = "电影"
    elif category_id == "101":
        category_mf = "2"
        keyword = "特种兵之火凤凰,因为爱情有多美,万万没想到,打狗棍,千金归来,法外风云,咱们结婚吧,终极一班3"
        type = "电视剧"
    elif category_id == "106":
        category_mf = "14"
        keyword = "爸爸去哪儿,快乐大本营,running man,康熙来了,晓说,天天向上,非诚勿扰,我们结婚了"
        type = "综艺"
    elif category_id == "115":
        category_mf = "4"
        keyword = "灌篮高手,火影忍者,熊出没,奥特曼,名侦探柯南,海贼王,尸兄,我叫mt"
        type = "动漫"
    kb = Keyboard('','请输入搜索内容',keyword,type)
    kb.doModal()
    if (kb.isConfirmed()):
        keyword = kb.getText()
        if keyword !='':
            searchpage = 1
            searchlist(keyword,category_id,category_mf,searchpage)
        else:
            xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
            xbmcplugin.endOfDirectory(int(sys.argv[1]))
    else:
        xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
def searchlist(keyword,category_id,category_mf,searchpage):
    if category_id == "100":
       app_id ='25'
    elif category_id == "101":
       app_id ='31'
    elif category_id == "106" or category_id == "115":
       app_id ='615'
    search_path = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/search/"+keyword+"?page_size=54"+"&page_no="+str(searchpage)+"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1383555354&security_code=ce30ea919afcc8cf731b5edf8f91ee6c&session_id=dltianwei&category_id="+str(category_mf)+"&app_id="+str(app_id)
    search_path = eval(repr(search_path).replace("\\x","%"))
    p1 = GetHttpData(search_path)
    data = json.JSONDecoder().decode(p1)
    newses = data["data"]
    app_id = ''
    area_id = ''
    style_id = ''
    if newses != None:
        newses1 = newses["items"]
        maxpage = newses["totalPages"]
        for i in newses1:
            name = i["title"].encode("utf-8")
            resid = i["id"]
            resappepisodes = i["resAppEpisodes"]
            url = i["channelUrl"]
            thumbnail = i["thumbnail"].encode("utf-8")
            listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
            u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&category_id='+urllib.quote_plus(category_id)+'&resappepisodes='+urllib.quote_plus(str(resappepisodes))
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(newses1))
        if int(maxpage) > searchpage:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(searchpage) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
            listitem.setProperty('next','true')
            u=sys.argv[0] + '?mode=9&mfcachetype=dir_cache_always&searchpage='+str(searchpage+1) +'&app_id='+urllib.quote_plus('0')+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&keyword=' + urllib.quote_plus(keyword)+"&view_mode="+urllib.quote_plus('morefunthumb')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getareas(category, category_id,medianame):
    areas = []
    if category == "movie":
        areas = movie_areas
    elif category == "tv":
        areas = tv_areas
    elif category == "show":
        areas = show_areas
    elif category == "comic":
        areas = comic_areas
    elif category == "music":
        areas = music_areas
    elif category == "recorder" or category == "news" or category == "fun" or category == "star_mode" or category == "travel" or category == "e_friends":
        areas = void_areas
    for area in areas:
        listitem=xbmcgui.ListItem(area[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(area[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus(area[1])+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getstyles(category, category_id,medianame):
    styles = []
    if category == "movie":
        styles = movie_styles
    elif category == "tv":
        styles = tv_styles
    elif category == "show":
        styles = show_styles
    elif category == "comic":
        styles = comic_styles
    elif category == "recorder":
        styles = recorder_styles
    elif category == "music":
        styles = music_styles
    elif category == "news":
        styles = news_styles
    elif category == "fun":
        styles = fun_styles
    elif category == "star_mode":
        styles = star_mode_styles
    elif category == "travel":
        styles = travel_styles
    elif category == "e_friends":
        styles = e_friends_styles
    for style in styles:
        listitem=xbmcgui.ListItem(style[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(style[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus(style[1])+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getyears(category,category_id,medianame):
    years = []
    if category == "recorder" or category == "show" or category == "news" or category == "fun" or category == "star_mode" or category == "travel" or category == "e_friends":
        years = void_years
    else:
        years = full_years
    for year in years:
        listitem=xbmcgui.ListItem(year[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(year[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus(year[1])+"&released_on_to="+urllib.quote_plus(year[2])+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def display_for_history(params):
    app_id = urllib.unquote_plus(params['app_id']) if 'app_id' in params else ''
    category_id = urllib.unquote_plus(params['category_id']) if 'category_id' in params else ''
    url = urllib.unquote_plus(params['url']) if 'url' in params else ''
    name = urllib.unquote_plus(params['title']) if 'title' in params else ''
    if name == "" or name == None:
        name = urllib.unquote_plus(params['name']) if 'name' in params else ''
    page = urllib.unquote_plus(params['page']) if 'page' in params else ''
    resappepisodes = urllib.unquote_plus(params['resappepisodes']) if 'resappepisodes' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    medianame = urllib.unquote_plus(params['medianame']) if 'medianame' in params else ''
    buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame)

def display_for_favourite(params):
    display_for_history(params)

def update_favourite(params):
    title = urllib.unquote_plus(params['title']) if 'title' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    resid = urllib.unquote_plus(params['resid']) if 'resid' in params else ''
    url = urllib.unquote_plus(params['url']) if 'url' in params else ''
    category_id = urllib.unquote_plus(params['category_id']) if 'category_id' in params else ''
    content = GetHttpData(url)
    if category_id == "100":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_dianying_from_url(content)
    elif category_id == "101":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_dianshi_from_url(content)
    elif category_id == "106":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_zongyi_from_url(url)
    elif category_id == "115":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_dongman_from_url(content)
    elif category_id == "107":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_jilupian_from_url(content)
    elif category_id == "121":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_yinyue_from_url(content)
    elif category_id == "122":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_xinwen_from_url(content)
    elif category_id == "112":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_yule_from_url(content)
    elif category_id == "130":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_xingshang_from_url(content)
    elif category_id == "131":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_lvyou_from_url(content)
    elif category_id == "99":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_wangyoushangchuan_from_url(content)
    episodesCount = resappepisodes_mf

    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))+"&url="+urllib.quote_plus(url)+"&category_id="+urllib.quote_plus(category_id)
    listitem=xbmcgui.ListItem(title)
    listitem.setProperty('title',title)
    listitem.setProperty('thumb',thumbnail)
    listitem.setProperty('episodesNum',episodesCount)
    listitem.setProperty('updateUrl',updateUrl)
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), updateUrl, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))


def get_params(url = ''):
    param = []
    paramstring = sys.argv[2] if url=='' else url
    if len(paramstring) >= 2:
        params = paramstring
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]
    return param

 