# -*- coding: utf-8 -*-
# getlist.py

import urllib,urllib2,re,xbmcplugin,xbmcgui,sys,os,os.path,xbmcaddon,xbmc
from urlparse import urljoin
import json
import gzip
try:
    from cStringIO import StringIO
except ImportError:
    from StringIO import StringIO
from xbmcswift2 import Plugin
plugin = Plugin()
try:
    from MFSearchKeyboard import Keyboard
except:
    from xbmc import Keyboard
    pass



plugin_path = plugin.addon.getAddonInfo('path')
lib_path = os.path.join(plugin_path, 'lib')

import time


__addonid__ = "plugin.video.mftencent"
__addon__ = xbmcaddon.Addon(id=__addonid__)
RESOURCES_PATH = os.path.join(__addon__.getAddonInfo('path'), 'media', )
PAGING_THUMB = os.path.join(RESOURCES_PATH,'paging.png')
MORE_THUMB = os.path.join(RESOURCES_PATH,'more.png')
MOVIE_THUMB = os.path.join(RESOURCES_PATH,'1movie.png')
TV_THUMB = os.path.join(RESOURCES_PATH,'2tv.png')
COMIC_THUMB = os.path.join(RESOURCES_PATH,'3comic.png')
SHOW_THUMB = os.path.join(RESOURCES_PATH,'4show.png')
MV_THUMB = os.path.join(RESOURCES_PATH,'5mv.png')
REC_THUMB = os.path.join(RESOURCES_PATH,'6recoder.png')
CREATION_THUMB = os.path.join(RESOURCES_PATH,'7creation.png')
PAIKE_THUMB = os.path.join(RESOURCES_PATH,'8paike.png')
HOST_THUMB = os.path.join(RESOURCES_PATH,'9hostshare.png')
NEWS_THUMB = os.path.join(RESOURCES_PATH,'10news.png')
FUN_THUMB = os.path.join(RESOURCES_PATH,'11fun.png')
FINANCE_THUMB = os.path.join(RESOURCES_PATH,'12finance.png')
SPORT_THUMB = os.path.join(RESOURCES_PATH,'13sport.png')
EDU_THUMB = os.path.join(RESOURCES_PATH,'14edu.png')
GAMES_THUMB = os.path.join(RESOURCES_PATH,'15games.png')
V_THUMB = os.path.join(RESOURCES_PATH,'16v.png')
LIFE_THUMB = os.path.join(RESOURCES_PATH,'17life.png')
FASHION_THUMB = os.path.join(RESOURCES_PATH,'18fashion.png')
BABY_THUMB = os.path.join(RESOURCES_PATH,'19baby.png')
TRAVEL_THUMB = os.path.join(RESOURCES_PATH,'20travel.png')

movie_areas = [['全部', ''], ['内地', '100024'], ['香港', '100025'], ['台湾', '100026'], ['日本', '100027'], ['韩国', '100028'], ['美国', '100029'], ['印度', '100030'], ['泰国', '100031'], ['欧洲', '100032'], ['其他', '100033']]
movie_styles = [['全部', ''], ['动作', '100061'], ['冒险', '100003'], ['喜剧', '100004'], ['爱情', '100005'], ['战争', '100006'], ['恐怖', '100007'], ['犯罪', '100008'], ['悬疑', '100009'], ['惊悚', '100010'], ['武侠', '100011'], ['科幻', '100012'], ['音乐', '100013'], ['歌舞', '100014'], ['动画', '100015'], ['奇幻', '100016'], ['家庭', '100017'], ['剧情', '100018'], ['伦理', '100019'], ['记录', '100020'], ['历史', '100021'], ['传记', '100022'], ['院线', '100062']]
movie_years = [['全部', '', ''], ['2014', '100034', ''], ['2013-2011', '100035', ''], ['2010-2006', '100036', ''], ['2005-2000', '100037', ''], ['90年代', '100038', ''], ['80年代', '100039', ''], ['其他', '100040', '']]

tv_areas = [['全部', '-1'], ['内地', '0'], ['美国', '8'], ['英国', '1'], ['台湾', '4'], ['韩国', '5'], ['其他', '9999']]
tv_styles = [['全部', '-1'], ['偶像', '1'], ['喜剧', '2'], ['爱情', '3'], ['都市', '4'], ['古装', '5'], ['武侠', '6'], ['历史', '7'], ['警匪', '8'], ['家庭', '9'], ['神话', '10'], ['剧情', '11'], ['悬疑', '12'], ['战争', '13'], ['军事', '14'], ['犯罪', '15'], ['情景', '16'], ['谍战', '17'], ['片花', '18'], ['魔幻', '19'], ['动作', '20'], ['科幻', '21'], ['刑侦', '22'], ['恐怖', '23'], ['网络剧', '24']]
tv_years = [['全部', '-1', ''], ['2014', '2014', ''], ['2013', '2013', ''], ['2012', '2012', ''], ['2011', '2011', ''], ['2010', '2010', ''], ['2009', '2009', ''], ['其他', '9999', '']]

show_styles = [['全部', '-1'], ['综合', '17'], ['访谈', '18'], ['选秀', '19'], ['搞笑', '20'], ['情感', '21'], ['脱口秀', '22'], ['职场', '59'], ['游戏', '23'], ['歌舞', '32'], ['美食', '24'], ['文化', '33'], ['少儿', '68'], ['腾讯出品', '67'], ['纪实', '69'], ['旅游', '25'], ['演唱会', '26'], ['养生', '65'], ['生活', '29'], ['曲艺', '28'], ['欢乐派对', '57'], ['真人秀场', '58'], ['其他', '31']]

comic_areas = [['全部', '-1'], ['内地', '0'], ['日韩', '1'], ['欧美', '2'], ['其他', '3']]
comic_styles = [['全部', '-1'], ['热血', '0'], ['搞笑', '1'], ['少女', '2'], ['魔幻', '3'], ['推理', '4'], ['竞技', '5'], ['益智', '6'], ['经典', '7'], ['剧情', '8'], ['原创', '9'], ['预告片', '10']]

mv_areas = [['全部', '-1'], ['港台', '0'], ['内地', '1'], ['日韩', '2'], ['欧美', '3'], ['其他', '4']]
mv_styles = [['全部', '-1'], ['流行', '1'], ['摇滚', '0'], ['R&B', '2'], ['电子', '3'], ['爵士', '4'], ['说唱', '5']]
mv_years = [['全部', '-1', ''], ['2014', '2014', ''], ['2013', '2013', ''], ['2012', '2012', ''], ['2011', '2011', ''], ['2010', '2010', ''], ['2009', '2009', ''], ['2008', '2008', ''], ['2007', '2007', '']]

recoder_styles = [['全部', '-1'], ['科技', '3'], ['人物', '1'], ['军事', '2'], ['刑侦', '4'], ['探索', '16'], ['自然', '32'], ['社会', '64'], ['历史', '128'], ['文化', '256'], ['地理', '512']]

creation_styles = [['全部', '1'], ['原创', '2'], ['纪录片', '3'], ['电影', '4'], ['电视剧', '5'], ['动漫', '6'], ['广告', '7']]

paike_styles = [['全部', '1'], ['拍客', '2'], ['新闻', '3'], ['自拍', '4']]

hostshare_styles = [['全部', '1'], ['猎奇', '2'], ['搞笑', '3'], ['娱乐', '4'], ['体育', '5'], ['音乐', '6'], ['旅游', '7'], ['科技', '8'], ['汽车', '9'], ['房产', '10'], ['生活', '11'], ['时尚', '12'], ['教育', '13'], ['财经', '14'], ['综艺', '15'], ['其他', '16']]

news_styles = [['全部', 'all'], ['要闻播报', '1'], ['深度评论', '2'], ['新闻脱口秀', '3'], ['社会民生', '4'], ['法制', '5'], ['军事', '6'], ['原创', '7']]

fun_styles = [['全部', 'all'], ['娱闻播报', '1'], ['影视看点', '4'], ['音乐前沿', '8'], ['明星访谈', '16'], ['九分钟电影大赛', '64'], ['原创', '2'], ['曲艺天地', '3']]

finance_styles = [['全部', 'all'], ['财经要闻', '1'], ['深度解读', '2'], ['股票市场', '3'], ['投资理财', '4'], ['财经脱口秀', '5'], ['财富故事', '6'], ['博鳌论坛', '7'], ['达沃斯', '8'], ['原创', '9'], ['华尔街一刻', '10']]

sport_styles = [['全部', 'all'], ['国内足球', '1'], ['国际足球', '2'], ['体育资讯', '8'], ['极限运动', '16'], ['综合', '32'], ['趣闻花边', '64'], ['功夫搏击', '128'], ['NBA', '2048'], ['体育彩票', '9'], ['原创', '4']]

edu_styles = [['全部', '-1'], ['人文', '1'], ['艺术', '2'], ['哲学', '3'], ['金融', '4'], ['历史', '5'], ['医学', '7'], ['农学', '8'], ['其他', '10'], ['文学', '11'], ['原创', '12'], ['经济', '13'], ['管理', '14'], ['心理', '15'], ['政治', '16'], ['法律', '17'], ['考试', '18'], ['外语', '19'], ['技能', '20'], ['生活', '21'], ['自然科学', '6'], ['工程技术', '9']]

games_styles = [['全部', '5'], ['游戏资讯', '501'], ['网络游戏', '502'], ['单机游戏', '503'], ['手机游戏', '504']]

v_styles = [['全部', '-1'], ['历史', '0'], ['经济', '1'], ['生活', '2'], ['百科', '3'], ['互联网', '5'], ['晃眼', '6'], ['媒体下午茶', '7']]

life_styles = [['全部', '2'], ['健康', '21'], ['美食', '22'], ['家居', '23'], ['宠物', '24'], ['潮品', '25'], ['婚恋', '26'], ['收藏', '27'], ['窍门', '28']]

fashion_styles = [['全部', '1'], ['服饰', '11'], ['美容', '12'], ['美体', '13'], ['秀场', '14'], ['大片', '15'], ['男士', '16']]

baby_styles = [['全部', '3'], ['备孕', '301'], ['孕早期', '302'], ['孕中期', '303'], ['孕晚期', '304'], ['分娩', '305'], ['孕期综合', '306'], ['产后', '307'], ['婴儿期', '308'], ['幼儿期', '309'], ['学龄前', '310'], ['综合指导', '311'], ['宝宝秀', '312']]

travel_styles = [['全部', '4'], ['华东', '401'], ['华北', '402'], ['华中', '403'], ['华南', '404'], ['东北', '405'], ['西南', '406'], ['西北', '407'], ['港澳台', '408'], ['亚洲', '409'], ['欧洲', '410'], ['非洲', '411'], ['大洋洲', '412'], ['南美洲', '413'], ['北美洲', '414'], ['南极洲', '415'], ['主题旅行', '416'], ['当季出行', '417'], ['环球视野', '418']]

void_years = []

void_areas = []

HOST = 'http://v.qq.com/'


def GetHttpData(url):
    req = urllib2.Request(url)
    response = urllib2.urlopen(req)
    httpdata = response.read()
    if response.headers.get('content-encoding', None) == 'gzip':
        httpdata = gzip.GzipFile(fileobj=StringIO.StringIO(httpdata)).read()
    response.close()
    match = re.compile('encodingt=(.+?)"').findall(httpdata)
    if len(match)<=0:
        match = re.compile('meta charset="(.+?)"').findall(httpdata)
    if len(match)>0:
        charset = match[0].lower()
        if (charset != 'utf-8') and (charset != 'utf8'):
            httpdata = unicode(httpdata, charset).encode('utf8')
    return httpdata

def fetch_url(url, data=None, headers={}, timeout=None, proxies=None):
    headers.setdefault(
        'User-Agent', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1872.0 Safari/537.36')  # noqa
    headers.setdefault('Accept-Encoding', 'gzip,deflate')
    if data and isinstance(data, dict):
        data = urlencode(data)
    req = urllib2.Request(url, data, headers)
    http_proxy = None
    if proxies or http_proxy:
        if not proxies:
            if isinstance(http_proxy, basestring):
                proxies = {'http': http_proxy, 'https': http_proxy}
            else:
                proxies = http_proxy
        proxy_handler = urllib2.ProxyHandler(proxies)
        opener = urllib2.build_opener(proxy_handler)
        r = opener.open(req, timeout=timeout)
    else:
        r = urllib2.urlopen(req, timeout=timeout)
    content = r.read()
    if r.headers.get('content-encoding') == 'gzip':
        content = gzip.GzipFile(fileobj=StringIO(content), mode='rb').read()
    return content

def buildRoot():
    listitem=xbmcgui.ListItem('电影',thumbnailImage=MOVIE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('电影')+"&category_id="+urllib.quote_plus('movielist')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('movie')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('电视剧',thumbnailImage=TV_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('电视剧')+"&category_id="+urllib.quote_plus('list')+"&area_id="+urllib.quote_plus('-1')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('-1')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('tv')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('综艺',thumbnailImage=SHOW_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('综艺')+"&category_id="+urllib.quote_plus('variety')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('show')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('动漫',thumbnailImage=COMIC_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('动漫')+"&category_id="+urllib.quote_plus('cartlist')+"&area_id="+urllib.quote_plus('-1')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('comic')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('MV',thumbnailImage=MV_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('MV')+"&category_id="+urllib.quote_plus('mvlist')+"&area_id="+urllib.quote_plus('-1')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('-1')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('mv')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('纪录片',thumbnailImage=REC_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('纪录片')+"&category_id="+urllib.quote_plus('docolist')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('recoder')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('原创',thumbnailImage=CREATION_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('原创')+"&category_id="+urllib.quote_plus('dv')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('creation')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('拍客',thumbnailImage=PAIKE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('拍客')+"&category_id="+urllib.quote_plus('paike')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('paike')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('热享',thumbnailImage=HOST_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('热享')+"&category_id="+urllib.quote_plus('hotshare')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('hostshare')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('新闻',thumbnailImage=NEWS_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('新闻')+"&category_id="+urllib.quote_plus('news')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('all')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('news')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('娱乐',thumbnailImage=FUN_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('娱乐')+"&category_id="+urllib.quote_plus('ent')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('all')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('fun')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('财经',thumbnailImage=FINANCE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('财经')+"&category_id="+urllib.quote_plus('finance')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('all')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('finance')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('体育',thumbnailImage=SPORT_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('体育')+"&category_id="+urllib.quote_plus('sports')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('all')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('sport')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('教育',thumbnailImage=EDU_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('教育')+"&category_id="+urllib.quote_plus('edu')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('edu')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('游戏',thumbnailImage=GAMES_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('游戏')+"&category_id="+urllib.quote_plus('games')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('5')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('games')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('微讲堂',thumbnailImage=V_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('微讲堂')+"&category_id="+urllib.quote_plus('v')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('-1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('v')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('生活',thumbnailImage=LIFE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('生活')+"&category_id="+urllib.quote_plus('life')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('2')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('life')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('时尚',thumbnailImage=FASHION_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('时尚')+"&category_id="+urllib.quote_plus('fashion')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('1')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('fashion')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('育儿',thumbnailImage=BABY_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('育儿')+"&category_id="+urllib.quote_plus('baby')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('3')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('baby')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('旅游',thumbnailImage=TRAVEL_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('旅游')+"&category_id="+urllib.quote_plus('travel')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('4')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('travel')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildLists(category_id,page,area_id,style_id,released_on_from,released_on_to,medianame):
    if category_id == 'movielist':
        url = 'http://v.qq.com/movielist/10001/10001-' + str(style_id) + '_10002-' + str(area_id) + '_10003-' + str(released_on_from) + '/10004-100001/1/' + str(page-1) + '/20/0/0.html'
    elif category_id == 'list':
        url = 'http://v.qq.com/list/2_' + str(style_id) + '_' + str(area_id) +'_' + str(released_on_from) + '_1_0_' + str(page-1) + '_20_-1_-1_0.html'
    elif category_id == 'variety':
        url = 'http://v.qq.com/variety/type/list_'+str(style_id)+'_0_'+str(page-1)+'.html'
    elif category_id == 'cartlist':
        url = 'http://v.qq.com/cartlist/'+str(page-1)[-1]+'/3_'+str(style_id)+'_'+str(area_id)+'_-1_-1_1_'+str(page-1)+'_0_20.html'
    elif category_id == 'mvlist':
        url = 'http://v.qq.com/mvlist/'+str(page-1)[-1]+'/22_'+str(style_id)+'_'+str(released_on_from)+'_'+str(area_id)+'_-1_1_'+str(page-1)+'_0_28.html'
    elif category_id == 'docolist':
        url = 'http://v.qq.com/docolist/'+str(page-1)[-1]+'/9_'+str(style_id)+'_1_'+str(page-1)+'_0_24.html'
    elif category_id == 'dv':
        url = 'http://v.qq.com/dv/list/yclist_0_0_'+str(style_id)+'_'+str(page)+'.html'
    elif category_id == 'paike':
        url = 'http://v.qq.com/paike/list/pklist_0_0_'+str(style_id)+'_'+str(page)+'.html'
    elif category_id == 'hotshare':
        url = 'http://v.qq.com/hotshare/list/rxlist_0_0_'+str(style_id)+'_'+str(page)+'.html'
    elif category_id == 'v':
        if style_id == '-1':
            url = 'http://v.qq.com/v/type/list_9_'+str(style_id)+'_1_0_'+str(page)+'.html'
        else:
            url = 'http://v.qq.com/v/type/list_1_'+str(style_id)+'_1_0_'+str(page)+'.html'
    elif category_id == 'edu':
        url = 'http://sns.video.qq.com/fcgi-bin/dlib/dataout_pc?otype=json&auto_id=159&sort=1&itype='+str(style_id)+'&pagenum='+str(page-1)+'&pagesize=16&callback=jQuery19108853143742308021_1398149366004&_=1398149366006'
    elif category_id == 'news' or category_id == 'ent' or category_id == 'finance' or category_id == 'sports':
        url = 'http://v.qq.com/'+str(category_id)+'/latest/' + str(style_id) + '_' + str(page) + '.html'
    else :
        url = 'http://v.qq.com/'+str(category_id)+'/list/' + str(style_id) + '/0/1_' + str(page-1) + '.html'
    
    if category_id == 'variety':
        items,maxpage = get_show_from_url(url)
    elif category_id == 'edu':
        items,maxpage = get_edu_from_url(url)
    elif category_id == 'cartlist':
        items,maxpage = get_comic_from_url(url)
    elif category_id == 'docolist' or category_id == 'news' or category_id == 'ent' or category_id == 'finance' or category_id == 'sports' or category_id == 'v':
        items,maxpage = get_other_1_from_url(url,category_id)
    else:
        items,maxpage = get_other_2_from_url(url,category_id)
    
    for i in items:
        name = i["title"].encode("utf-8")
        resappepisodes = i["resAppEpisodes"]
        url = i["url"]
        thumbnail = i["thumbnail"].encode("utf-8")
        listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
        if category_id == "list" or category_id == "variety" or category_id == "cartlist" or category_id == "news" or category_id == "ent" or category_id == "finance" or category_id == "sports":
            listitem.setProperty('v360resappepisodes',resappepisodes)
        u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&category_id='+urllib.quote_plus(category_id)+'&resappepisodes='+urllib.quote_plus(str(resappepisodes))+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(items))
    
    if int(maxpage) > int(page):
        listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多 ' + str(page) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
        u=sys.argv[0] + '?mode=1&page='+str(page+1) +'&category_id='+urllib.quote_plus(category_id)+'&area_id='+urllib.quote_plus(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&released_on_from=' + urllib.quote_plus(released_on_from)+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb2')
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', medianame)
    if category_id == 'movielist' or category_id == 'list' or category_id == 'variety' or category_id == 'cartlist':
        xbmcplugin.setProperty(int(sys.argv[1]),'search_show','able')
    else:
        xbmcplugin.setProperty(int(sys.argv[1]),'search_show','unable')
    
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def get_show_from_url(url):
    items = []
    content = fetch_url(url)
    _RE = re.compile(
        r'<div class="mod_pic">[\s\S]*?<a href="([\s\S]*?)"[\s\S]*?'
        '<img src="([\s\S]*?)"[\s\S]*?'
        'alt="([\s\S]*?)"[\s\S]*?'
        '<em class="mask_txt">([\s\S]*?)</em>[\s\S]*?')
    for match in _RE.finditer(content):
        detail_url,imgurl, title, episodes_num = match.groups()
        items.append({
            'title': title,
            'url': detail_url,
            'thumbnail': imgurl,
            'resAppEpisodes': episodes_num
        })
    
    maxpage = '0'
    _RE_PAGE1 = re.compile(r'<div class="mod_pagenav" id="pager">([\s\S]*?)</div>[\s\S]*?')
    _RE_PAGE2 = re.compile(r'<p class="mod_pagenav_main">[\s\S]*<a href[\s\S]*?><span>(\d*?)</span></a>[\s\S]*?')
    for match in _RE_PAGE1.finditer(content):
        datapag =match.groups()[0]
        match_page = _RE_PAGE2.search(datapag)
        if match_page:
            maxpage = match_page.groups('')[0]
        else:
            maxpage= 1
            
    return items,maxpage

def get_edu_from_url(url):
    items = []
    content = fetch_url(url)
    data = re.sub(r'jQuery[\s\S]*?\(','',content)
    data = str(data).replace(')','')
    data = json.JSONDecoder().decode(data)
    data_cover = []
    data_cover = data["cover"]
    for i in range(len(data_cover)):
        title = data_cover[i]["c_title"].encode('utf8')
        detail_url = data_cover[i]["playurl"].encode('utf8')
        imgurl = data_cover[i]["c_pic"].encode('utf8')
        items.append({
            'title': title,
            'url': detail_url,
            'thumbnail': imgurl,
            'resAppEpisodes': ''
        })
    
    maxpage = '0'
    data_total = ''
    data_total = data["total"]
    maxpage = int(data_total)/16 + 1 if int(data_total)%16 > 0 else 1
    
    return items,maxpage

def get_comic_from_url(url):
    items = []
    content = fetch_url(url)
    _RE1 = re.compile(r'<div class="mod_video_list poster">([\s\S]*?)</ul>[\s\S]*?')
    _RE2 = re.compile(r'<li>([\s\S]*?)</li>[\s\S]*?')
    _RE3 = re.compile(
        r'<a href="([\s\S]*?)"[\s\S]*?'
        '<img[\s\S]*?src="([\s\S]*?)"[\s\S]*?'
        'alt=""([\s\S]*?)"[\s\S]*?')
    _RE_resAppEpisodes1 = re.compile(r'<span class="mod_version">([\s\S]*?)</span>[\s\S]*?')
    
    if _RE1.search(content):
        match = _RE1.search(content)
        datapag = match.groups()[0]
        for match in _RE2.finditer(str(datapag)):
            datapag1 = match.groups()[0]
            for match in _RE3.finditer(str(datapag1)):
                detail_url, imgurl, title = match.groups()
            if _RE_resAppEpisodes1.search(str(datapag1)):
                match = _RE_resAppEpisodes1.search(str(datapag1))
                episodes_num = match.groups()[0]
            else:
                episodes_num = ''
            items.append({
                'title': title,
                'url': detail_url,
                'thumbnail': imgurl,
                'resAppEpisodes':episodes_num
            })
    
    maxpage = '0'
    _RE_PAGE1 = re.compile(r'<div class="mod_pagenav"([\s\S]*?)</div>[\s\S]*?')
    _RE_PAGE2 = re.compile(r'<p class="mod_pagenav_main">[\s\S]*<a href[\s\S]*?><span>(\d*?)</span></a>[\s\S]*?')
    for match in _RE_PAGE1.finditer(content):
        datapag =match.groups()[0]
        match_page = _RE_PAGE2.search(datapag)
        if match_page:
            maxpage = match_page.groups('')[0]
        else:
            maxpage= 1
            
    return items,maxpage


def get_other_1_from_url(url,category_id):
    items = []
    content = fetch_url(url)
    _RE1 = re.compile(r'<div class="mod_item">([\s\S]*?)</div>[\s\S]*?')
    _RE2 = re.compile(
        r'<a[\s\S]*?href="([\s\S]*?)"[\s\S]*?'
        '<img[\s\S]*?src="([\s\S]*?)"[\s\S]*?'
        'alt="([\s\S]*?)"[\s\S]*?'
        )
    _RE_resAppEpisodes = re.compile(r'<span class="mod_version">([\s\S]*?)</span>[\s\S]*?')
    for match in _RE1.finditer(content):
        datapag = match.groups()[0]
        for match in _RE2.finditer(datapag):
            detail_url,imgurl, title = match.groups()
            if detail_url.split('/')[0]=='':
                detail_url = HOST + str(detail_url)
        if _RE_resAppEpisodes.search(datapag):
            match = _RE_resAppEpisodes.search(datapag)
            episodes_num = match.groups()[0]
        else:
            episodes_num = ''
        items.append({
            'title': title,
            'url': detail_url,
            'thumbnail': imgurl,
            'resAppEpisodes': episodes_num
        })
    
    maxpage = '0'
    _RE_PAGE1 = re.compile(r'<div class="mod_pagenav"([\s\S]*?)</div>[\s\S]*?')
    _RE_PAGE2 = re.compile(r'<p class="mod_pagenav_main">[\s\S]*<a href[\s\S]*?><span>(\d*?)</span></a>[\s\S]*?')
    for match in _RE_PAGE1.finditer(content):
        datapag =match.groups()[0]
        match_page = _RE_PAGE2.search(datapag)
        if match_page:
            maxpage = match_page.groups('')[0]
        else:
            maxpage= 1
            
    return items,maxpage

def get_other_2_from_url(url,category_id):
    items = []
    content = fetch_url(url)
    _RE1 = re.compile(r'<div class="mod_video_list poster">([\s\S]*?)</ul>[\s\S]*?')
    _RE2 = re.compile(r'<li>([\s\S]*?)</li>[\s\S]*?')
    _RE3 = re.compile(
        r'<a href="([\s\S]*?)"[\s\S]*?'
        '<img[\s\S]*?src="([\s\S]*?)"[\s\S]*?'
        'alt="([\s\S]*?)"[\s\S]*?')
    _RE_resAppEpisodes1 = re.compile(r'<em class="mask_txt">([\s\S]*?)</em>[\s\S]*?')
    _RE_resAppEpisodes2 = re.compile(r'<span class="mod_version">([\s\S]*?)</span>[\s\S]*?')
    
    if _RE1.search(content):
        match = _RE1.search(content)
        datapag = match.groups()[0]
        for match in _RE2.finditer(str(datapag)):
            datapag1 = match.groups()[0]
            for match in _RE3.finditer(str(datapag1)):
                detail_url, imgurl, title = match.groups()
            if _RE_resAppEpisodes1.search(str(datapag1)):
                match = _RE_resAppEpisodes1.search(str(datapag1))
                episodes_num = match.groups()[0]
            elif _RE_resAppEpisodes2.search(str(datapag1)):
                match = _RE_resAppEpisodes2.search(str(datapag1))
                episodes_num = match.groups()[0]
            else:
                episodes_num = ''
            items.append({
                'title': title,
                'url': detail_url,
                'thumbnail': imgurl,
                'resAppEpisodes':episodes_num
            })
    
    maxpage = '0'
    _RE_PAGE1 = re.compile(r'<div class="mod_pagenav"([\s\S]*?)</div>[\s\S]*?')
    _RE_PAGE2 = re.compile(r'<p class="mod_pagenav_main">[\s\S]*<a href[\s\S]*?><span>(\d*?)</span></a>[\s\S]*?')
    for match in _RE_PAGE1.finditer(content):
        datapag =match.groups()[0]
        match_page = _RE_PAGE2.search(datapag)
        if match_page:
            maxpage = match_page.groups('')[0]
        else:
            maxpage= 1
            
    return items,maxpage


def buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame):
    resid = ""
    app_id = '54'
    more_url = url
    appspidername = 'qq'
    content = fetch_url(url)
    if page == "":
        page = "1"
    
    if category_id == "movielist":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_movie_from_url(content)
    elif category_id == "list":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_tv_from_url(content)
    elif category_id == "variety":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_show_from_url(content)
    elif category_id == "cartlist":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_comic_from_url(content)
    # elif category_id == "mvlist" or category_id == 'travel':
        # resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_other_3_from_url(url)
    elif category_id == "dv" or category_id == 'paike' or category_id == 'hotshare':
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_other_1_from_url(content)
    else:
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_other_2_from_url(content)

    episodesCount = resappepisodes_mf

    if category_id == "variety":
        items,video_maxpage = get_show_juji_list(content,page)
    elif category_id == "list" or category_id == 'cartlist':
        items,video_maxpage = get_other_1_juji_list(content,page)
    elif category_id == "docolist" or category_id == 'edu' or category_id == 'v':
        items,video_maxpage = get_other_2_juji_list(content,page)
    elif category_id == "news" or category_id == 'ent' or category_id == 'finance' or category_id == 'sports':
        items,video_maxpage = get_other_3_juji_list(content,page)
    else:
        items,video_maxpage = get_other_4_juji_list(url,name)

    for j in items:
        title = j["title"]
        play_url = j["url"]
        listitem=xbmcgui.ListItem(title)
        listitem.setProperty('name',title)
        listitem.setProperty('playurl',play_url)
        url=sys.argv[0] + '?mode=3&url=' + urllib.quote_plus(play_url)+ '&item_id='+'&app_id='+urllib.quote_plus(str(app_id))+'&appspidername='+urllib.quote_plus(appspidername)+'&name='+urllib.quote_plus(title)+'&resourceTitle='+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&page="+str(page)+'&category_id='+urllib.quote_plus(str(category_id))+"&view_mode="+urllib.quote_plus('morefunlist')
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, False)

    if (int(page) < int(video_maxpage)) and (category_id == 'variety' or category_id == 'docolist' or category_id == 'news' or category_id == 'ent' or category_id == 'finance' or category_id == 'sports' or category_id == 'v' or category_id == 'edu' or 11<=int(page)):
        if len(items)>0:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' +'[/COLOR]',thumbnailImage=MORE_THUMB)
            listitem.setProperty('next','true')
            url=sys.argv[0]+'?mode=2&page='+str(int(page)+1) +'&category_id='+str(category_id)+ '&url=' + urllib.quote_plus(more_url)+ '&name=' + urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&resappepisodes="+urllib.quote_plus(resappepisodes)+ '&medianame='+urllib.quote_plus(medianame)
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
        else:
            plugin.notify('没有更多数据', delay=2000)
            return

    resappepisodes = resappepisodes.replace('更新至','').replace('集','').replace('全','').replace('更新至第','')
    if resappepisodes.isdigit():
        if category_id == "list" or category_id == 'cartlist':
            maxpage = video_maxpage
            xbmcplugin.setProperty(int(sys.argv[1]), 'maxpage', str(maxpage))

    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunlist')
    xbmcplugin.setProperty(int(sys.argv[1]), 'title', name)
    xbmcplugin.setProperty(int(sys.argv[1]), 'areaname', areaname)
    xbmcplugin.setProperty(int(sys.argv[1]), 'stylename', stylename)
    xbmcplugin.setProperty(int(sys.argv[1]), 'year', year)
    xbmcplugin.setProperty(int(sys.argv[1]), 'actors', actors)
    xbmcplugin.setProperty(int(sys.argv[1]), 'description', description)
    xbmcplugin.setProperty(int(sys.argv[1]), 'resappepisodes', resappepisodes_mf)
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumbnail', thumbnail)

    if resid !="":
        xbmcplugin.setProperty(int(sys.argv[1]), 'itemId', 'qq'+str(resid))
        favouriteUrl = sys.argv[0]+"?fromtype=favourite&app_id=&resid="+urllib.quote_plus(str(resid))+"&page=&resappepisodes="+urllib.quote_plus(resappepisodes)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&category_id="+urllib.quote_plus(category_id)+"&url="+urllib.quote_plus(more_url)+"&title="+urllib.quote_plus(name)+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.setProperty(int(sys.argv[1]), 'url', favouriteUrl)

    xbmcplugin.setProperty(int(sys.argv[1]), 'itemType', 'tencent')
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumb', thumbnail)
    xbmcplugin.setProperty(int(sys.argv[1]), 'playable', 'false')
    xbmcplugin.setProperty(int(sys.argv[1]), 'morefuntvsource', "false")

    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))+"&url="+urllib.quote_plus(more_url)+"&category_id="+urllib.quote_plus(category_id)+"&title="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)
    if (category_id == "list" or category_id == 'cartlist') and episodesCount != "":
        xbmcplugin.setProperty(int(sys.argv[1]), 'updateUrl', updateUrl)

    xbmcplugin.setProperty(int(sys.argv[1]), 'episodesNum', episodesCount)
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', medianame)

    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def get_detail_movie_from_url(content):
    _RE_resid = re.compile(r'id :"([\s\S]*?)"[\s\S]*?')
    if _RE_resid.search(content):
        match = _RE_resid.search(content)
        resid = match.groups()[0]

    _RE_actor1 = re.compile(r'主演：</span>([\s\S]*?)</div>[\s\S]*?')
    _RE_actor2 = re.compile(r'<a[\s\S]*?><[\s\S]*?>([\s\S]*?)<[\s\S]*?')
    if _RE_actor1.search(content):
        match = _RE_actor1.search(content)
        actors_data = match.groups()[0]
        actors = '/'
        for match in _RE_actor2.finditer(str(actors_data)):
            iteam = match.groups()[0]
            actors = actors + iteam + '/'
        actors = actors.strip('/')
    else:
        actors = ''

    _RE_type1 = re.compile(r'类型：</span>([\s\S]*?)</div>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        type_data = match.groups()[0]
        stylename = '/'
        for match in _RE_type2.finditer(str(type_data)):
            iteam = match.groups()[0]
            stylename = stylename + iteam + '/'
        stylename = stylename.strip('/')
    else:
        stylename = ''
    
    _RE_area1 = re.compile(r'地区：</span>([\s\S]*?)</div>[\s\S]*?')
    _RE_area2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_area1.search(content):
        match = _RE_area1.search(content)
        area_data = match.groups()[0]
        areaname = '/'
        for match in _RE_area2.finditer(str(area_data)):
            iteam = match.groups()[0]
            areaname = areaname + iteam + '/'
        areaname = areaname.strip('/')
    else:
        areaname = ''
    
    _RE_year1 = re.compile(r'年份：</span>([\s\S]*?)</div>[\s\S]*?')
    _RE_year2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_year1.search(content):
        match = _RE_year1.search(content)
        year_data = match.groups()[0]
        year = '/'
        for match in _RE_year2.finditer(str(year_data)):
            iteam = match.groups()[0]
            year = year + iteam + '/'
        year = year.strip('/')
    else:
        year = ''
    
    _RE_description = re.compile(r'简介：</span><[\s\S]*?>([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    episodescount = "1"
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_tv_from_url(content):
    _RE_resid = re.compile(r'id :"([\s\S]*?)"[\s\S]*?')
    if _RE_resid.search(content):
        match = _RE_resid.search(content)
        resid = match.groups()[0]

    _RE_episodescount = re.compile(r'<span class="current_state">([\s\S]*?)</span>[\s\S]*?')
    if _RE_episodescount.search(content):
        match = _RE_episodescount.search(content)
        episodescount = match.groups()[0]
        episodescount = str(episodescount).replace('全', '').replace('集', '').replace('更新至', '')
    else:
        episodescount = ''

    _RE_actor1 = re.compile(r'主演：</span>([\s\S]*?)</div>[\s\S]*?')
    _RE_actor2 = re.compile(r'<a[\s\S]*?><[\s\S]*?>([\s\S]*?)<[\s\S]*?')
    if _RE_actor1.search(content):
        match = _RE_actor1.search(content)
        actors_data = match.groups()[0]
        actors = '/'
        for match in _RE_actor2.finditer(str(actors_data)):
            iteam = match.groups()[0]
            actors = actors + iteam + '/'
        actors = actors.strip('/') 
    else:
        actors = ''

    _RE_type1 = re.compile(r'类型：</span>([\s\S]*?)</div>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        type_data = match.groups()[0]
        stylename = '/'
        for match in _RE_type2.finditer(str(type_data)):
            iteam = match.groups()[0]
            stylename = stylename + iteam + '/'
        stylename = stylename.strip('/')
    else:
        stylename = ''
    
    _RE_area1 = re.compile(r'地区：</span>([\s\S]*?)</div>[\s\S]*?')
    _RE_area2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_area1.search(content):
        match = _RE_area1.search(content)
        area_data = match.groups()[0]
        areaname = '/'
        for match in _RE_area2.finditer(str(area_data)):
            iteam = match.groups()[0]
            areaname = areaname + iteam + '/'
        areaname = areaname.strip('/')
    else:
        areaname = ''
    
    _RE_year1 = re.compile(r'年份：</span>([\s\S]*?)</div>[\s\S]*?')
    _RE_year2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_year1.search(content):
        match = _RE_year1.search(content)
        year_data = match.groups()[0]
        year = '/'
        for match in _RE_year2.finditer(str(year_data)):
            iteam = match.groups()[0]
            year = year + iteam + '/'
        year = year.strip('/')
    else:
        year = ''
    
    _RE_description = re.compile(r'简介：</span><[\s\S]*?>([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_show_from_url(content):
    _RE_resid = re.compile(r'id :"([\s\S]*?)"[\s\S]*?')
    if _RE_resid.search(content):
        match = _RE_resid.search(content)
        resid = match.groups()[0]
    
    _RE_actor1 = re.compile(r'<span class="label">主持人：([\s\S]*?)</p>[\s\S]*?')
    _RE_actor2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)<[\s\S]*?')
    if _RE_actor1.search(content):
        match = _RE_actor1.search(content)
        actors_data = match.groups()[0]
        actors = '/'
        for match in _RE_actor2.finditer(str(actors_data)):
            iteam = match.groups()[0]
            actors = actors + iteam + '/'
        actors = actors.strip('/') 
    else:
        actors = ''

    _RE_type1 = re.compile(r'<span class="label">类型：([\s\S]*?)</p>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        type_data = match.groups()[0]
        stylename = '/'
        for match in _RE_type2.finditer(str(type_data)):
            iteam = match.groups()[0]
            stylename = stylename + iteam + '/'
        stylename = stylename.strip('/')
    else:
        stylename = ''
    
    _RE_description = re.compile(r'<span class="label">简介：</span><[\s\S]*?>([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    year = ''
    areaname = ''
    episodescount = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_comic_from_url(content):
    _RE_resid = re.compile(r'id :"([\s\S]*?)"[\s\S]*?')
    if _RE_resid.search(content):
        match = _RE_resid.search(content)
        resid = match.groups()[0]

    _RE_episodescount = re.compile(r'<span class="current_state">([\s\S]*?)</span>[\s\S]*?')
    if _RE_episodescount.search(content):
        match = _RE_episodescount.search(content)
        episodescount = match.groups()[0]
        episodescount = str(episodescount).replace('全', '').replace('集', '').replace('更新至', '').replace('更新至第', '')
    else:
        episodescount = ''

    _RE_type1 = re.compile(r'类型：</span>([\s\S]*?)</div>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        type_data = match.groups()[0]
        stylename = '/'
        for match in _RE_type2.finditer(str(type_data)):
            iteam = match.groups()[0]
            stylename = stylename + iteam + '/'
        stylename = stylename.strip('/')
    else:
        stylename = ''
    
    _RE_area1 = re.compile(r'地区：</span>([\s\S]*?)</div>[\s\S]*?')
    _RE_area2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_area1.search(content):
        match = _RE_area1.search(content)
        area_data = match.groups()[0]
        areaname = '/'
        for match in _RE_area2.finditer(str(area_data)):
            iteam = match.groups()[0]
            areaname = areaname + iteam + '/'
        areaname = areaname.strip('/')
    else:
        areaname = ''
    
    _RE_year1 = re.compile(r'年份：</span>([\s\S]*?)</div>[\s\S]*?')
    _RE_year2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_year1.search(content):
        match = _RE_year1.search(content)
        year_data = match.groups()[0]
        year = '/'
        for match in _RE_year2.finditer(str(year_data)):
            iteam = match.groups()[0]
            year = year + iteam + '/'
        year = year.strip('/')
    else:
        year = ''
    
    _RE_description = re.compile(r'简介：</span><[\s\S]*?>([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_other_1_from_url(content):
    _RE_resid = re.compile(r'vid:"([\s\S]*?)"[\s\S]*?')
    if _RE_resid.search(content):
        match = _RE_resid.search(content)
        resid = match.groups()[0]

    _RE_year = re.compile(r'<li>上传时间：([\s\S]*?)</li>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year_data = match.groups()[0]
        iteam = []
        iteam = str(year_data).split('-')
        year  = iteam[0]
    else:
        year = ''
    
    _RE_type1 = re.compile(r'<li>分类：([\s\S]*?)</li>[\s\S]*?')
    _RE_type2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    if _RE_type1.search(content):
        match = _RE_type1.search(content)
        type_data = match.groups()[0]
        stylename = '/'
        for match in _RE_type2.finditer(str(type_data)):
            iteam = match.groups()[0]
            stylename = stylename + iteam + '/'
        stylename = stylename.strip('/')
    else:
        stylename = ''
    
    _RE_description = re.compile(r'简介：([\s\S]*?)</p>[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    actors = ''
    areaname = ''
    episodescount = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_other_2_from_url(url):
    iteam = []
    iteam = str(url).split('/')
    resid = iteam[-1]
    iteams=[]
    iteams= str(resid).split('.')
    resid = iteams[0]

    year = ''
    actors = ''
    areaname = ''
    stylename = ''
    description = ''
    episodescount = ''
    
    return resid,actors,stylename,areaname,year,description,episodescount

# def get_detail_other_3_from_url(url):
    # iteam = []
    # iteam = str(url).split('/')
    # resid = iteam[-1]
    # iteams=[]
    # iteams= str(resid).split('.')
    # resid = iteams[0]
    
    # year = ''
    # actors = ''
    # areaname = ''
    # stylename = ''
    # description = ''
    # episodescount = ''
    
    # return resid,actors,stylename,areaname,year,description,episodescount

def get_other_4_juji_list(url,name):
    items = []
    items.append({'title': name,'url':url})
    plugin.log.debug('wwwwwwwwwwwwww'+url)
    return items,1

def get_other_3_juji_list(content,index):
    items = []
    maxpage ='1'
    _RE_url1 = re.compile(r'<div class="mod_time_tablist" role="tablist">([\s\S]*?)<div class="mod_bd" id="period_content">[\s\S]*?')
    _RE_url2 = re.compile(r'<a href="([\s\S]*?)"[\s\S]*?')
    _RE_list1 = re.compile(r'<li class="item">[\s\S]*?<a href="([\s\S]*?)"[\s\S]*?>([\s\S]*?)</a>')
    _RE_list2 = re.compile(r'<li class="item current"[\s\S]*?href="([\s\S]*?)"[\s\S]*?alt="([\s\S]*?)"[\s\S]*?')
    _RE_list3 = re.compile(r'<li class="item"[\s\S]*?href="([\s\S]*?)"[\s\S]*?alt="([\s\S]*?)"[\s\S]*?')
    if _RE_url1.search(content):
        match = _RE_url1.search(content)
        url_data = match.groups()[0]
        for match in _RE_url2.finditer(str(url_data)):
            url = match.groups()[0]
            real_url = 'http://v.qq.com'+str(url)
            url_content = fetch_url(real_url)
            for match in _RE_list1.finditer(url_content):
                href,title = match.groups()
                href = 'http://v.qq.com'+str(href)
                items.append({'title': title,'url':href})
    else:
        if _RE_list2.search(content):
            match = _RE_list2.search(content)
            href,title = match.groups()
            href = 'http://v.qq.com'+str(href)
            items.append({'title': title,'url':href})
        for match in _RE_list3.finditer(content):
            href,title = match.groups()
            href = 'http://v.qq.com'+str(href)
            items.append({'title': title,'url':href})
    
    maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    
    return items,maxpage

def get_other_2_juji_list(content,index):
    items = []
    maxpage ='1'
    _RE1 = re.compile(r'<li class="item current"[\s\S]*?href="([\s\S]*?)"[\s\S]*?alt="([\s\S]*?)"[\s\S]*?')
    _RE2 = re.compile(r'<li class="item"[\s\S]*?href="([\s\S]*?)"[\s\S]*?alt="([\s\S]*?)"[\s\S]*?')
    if _RE1.search(content):
        match = _RE1.search(content)
        href,title = match.groups()
        href = 'http://v.qq.com'+str(href)
        items.append({'title': title,'url':href})
    for match in _RE2.finditer(content):
        href,title = match.groups()
        href = 'http://v.qq.com'+str(href)
        items.append({'title': title,'url':href})
    
    maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    
    return items,maxpage

def get_other_1_juji_list(content,index):
    items = []
    maxpage ='1'
    _RE = re.compile(r'<li><a target="_self"[\s\S]*?href="([\s\S]*?)"[\s\S]*?title="([\s\S]*?)"[\s\S]*?')
    for match in _RE.finditer(content):
        href,title = match.groups()
        href = 'http://v.qq.com'+str(href)
        items.append({'title': title,'url':href})
    
    maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    
    return items,maxpage

def get_show_juji_list(content,index):
    items = []
    maxpage ='1'
    _RE_url1 = re.compile(r'<div class="mod_time_tablist" role="tablist">([\s\S]*?)<div class="mod_bd" id="period_content">[\s\S]*?')
    _RE_url2 = re.compile(r'<a href="([\s\S]*?)"[\s\S]*?')
    _RE_list = re.compile(r'<li class="item">[\s\S]*?<a href="([\s\S]*?)"[\s\S]*?>([\s\S]*?)</a>')
    if _RE_url1.search(content):
        match = _RE_url1.search(content)
        url_data = match.groups()[0]
        for match in _RE_url2.finditer(str(url_data)):
            url = match.groups()[0]
            real_url = 'http://v.qq.com'+str(url)
            url_content = fetch_url(real_url)
            for match in _RE_list.finditer(url_content):
                href,title = match.groups()
                href = 'http://v.qq.com'+str(href)
                items.append({'title': title,'url':href})
    
    maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    
    return items,maxpage


def playVideo(url):
    mylist = GetHttpData(url)
    foobars = re.compile('<m3u8>(.*?)</m3u8>', re.DOTALL).findall(mylist)
    playlist = xbmc.PlayList(1)
    playlist.clear()
    for i in range(0,len(foobars)):
        title =" 第"+str(i+1)+"/"+str(len(foobars))+"节"
        listitem=xbmcgui.ListItem(title)
        listitem.setInfo(type="Video",infoLabels={"Title":title})
        playlist.add(foobars[i], listitem)
    xbmc.Player().play(playlist)

def searchkey(category_id):
    keyword = ""
    type = ""
    if category_id == "movielist":
        category_mf = "1"
        keyword = "特殊身份,古惑仔,青春如期,小时代,狄仁杰之神都龙王,不二神探,激战,速度与激情"
        type = "电影"
    elif category_id == "list":
        category_mf = "2"
        keyword = "特种兵之火凤凰,因为爱情有多美,万万没想到,打狗棍,千金归来,法外风云,咱们结婚吧,终极一班3"
        type = "电视剧"
    elif category_id == "variety":
        category_mf = "14"
        keyword = "爸爸去哪儿,快乐大本营,running man,康熙来了,晓说,天天向上,非诚勿扰,我们结婚了"
        type = "综艺"
    elif category_id == "cartlist":
        category_mf = "4"
        keyword = "灌篮高手,火影忍者,熊出没,奥特曼,名侦探柯南,海贼王,尸兄,我叫mt"
        type = "动漫"
    kb = Keyboard('','请输入搜索内容',keyword,type)
    kb.doModal()
    if (kb.isConfirmed()):
        keyword = kb.getText()
        if keyword !='':
            searchpage = 1
            searchlist(keyword,category_id,category_mf,searchpage)
        else:
            xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
            xbmcplugin.endOfDirectory(int(sys.argv[1]))
    else:
        xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
def searchlist(keyword,category_id,category_mf,searchpage):
    search_path = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/search/"+keyword+"?page_size=54"+"&page_no="+str(searchpage)+"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1383555354&security_code=ce30ea919afcc8cf731b5edf8f91ee6c&session_id=dltianwei&category_id="+str(category_mf)+"&app_id=54"
    search_path = eval(repr(search_path).replace("\\x","%"))
    p1 = GetHttpData(search_path)
    data = json.JSONDecoder().decode(p1)
    newses = data["data"]
    app_id = ''
    area_id = ''
    style_id = ''
    if newses != None:
        newses1 = newses["items"]
        maxpage = newses["totalPages"]
        for i in newses1:
            name = i["title"].encode("utf-8")
            resid = i["id"]
            resappepisodes = i["resAppEpisodes"]
            url = i["channelUrl"]
            thumbnail = i["thumbnail"].encode("utf-8")
            listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
            u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&category_id='+urllib.quote_plus(category_id)+'&resappepisodes='+urllib.quote_plus(str(resappepisodes))
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(newses1))
        if int(maxpage) > searchpage:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(searchpage) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
            listitem.setProperty('next','true')
            u=sys.argv[0] + '?mode=9&mfcachetype=dir_cache_always&searchpage='+str(searchpage+1) +'&app_id='+urllib.quote_plus('0')+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&keyword=' + urllib.quote_plus(keyword)+"&view_mode="+urllib.quote_plus('morefunthumb')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getareas(category, category_id, medianame):
    areas = []
    if category == "movie":
        areas = movie_areas
    elif category == "tv":
        areas = tv_areas
    elif category == "comic":
        areas = comic_areas
    elif category == "mv":
        areas = mv_areas
    else:
        areas = void_areas
    for area in areas:
        listitem=xbmcgui.ListItem(area[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(area[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus(area[1])+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getstyles(category, category_id,medianame):
    styles = []
    if category == "movie":
        styles = movie_styles
    elif category == "tv":
        styles = tv_styles
    elif category == "show":
        styles = show_styles
    elif category == "comic":
        styles = comic_styles
    elif category == "mv":
        styles = mv_styles
    elif category == "recoder":
        styles = recoder_styles
    elif category == "creation":
        styles = creation_styles
    elif category == "paike":
        styles = paike_styles
    elif category == "hostshare":
        styles = hostshare_styles
    elif category == "news":
        styles = news_styles
    elif category == "fun":
        styles = fun_styles
    elif category == "finance":
        styles = finance_styles
    elif category == "sport":
        styles = sport_styles
    elif category == "edu":
        styles = edu_styles
    elif category == "games":
        styles = games_styles
    elif category == "v":
        styles = v_styles
    elif category == "life":
        styles = life_styles
    elif category == "fashion":
        styles = fashion_styles
    elif category == "baby":
        styles = baby_styles
    elif category == "travel":
        styles = travel_styles
    for style in styles:
        listitem=xbmcgui.ListItem(style[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(style[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus(style[1])+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getyears(category,category_id,medianame):
    years = []
    if category == "movie":
        years = movie_years
    elif category == "tv":
        years = tv_years
    elif category == "mv":
        years = mv_years
    else:
        years = void_years
    for year in years:
        listitem=xbmcgui.ListItem(year[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(year[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus(year[1])+"&released_on_to="+urllib.quote_plus(year[2])+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def display_for_history(params):
    app_id = urllib.unquote_plus(params['app_id']) if 'app_id' in params else ''
    category_id = urllib.unquote_plus(params['category_id']) if 'category_id' in params else ''
    url = urllib.unquote_plus(params['url']) if 'url' in params else ''
    name = urllib.unquote_plus(params['title']) if 'title' in params else ''
    if name == "" or name == None:
        name = urllib.unquote_plus(params['name']) if 'name' in params else ''
    page = urllib.unquote_plus(params['page']) if 'page' in params else ''
    resappepisodes = urllib.unquote_plus(params['resappepisodes']) if 'resappepisodes' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    medianame = urllib.unquote_plus(params['medianame']) if 'medianame' in params else ''
    buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame)
    
def display_for_favourite(params):
    display_for_history(params)

def update_favourite(params):
    title = urllib.unquote_plus(params['title']) if 'title' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    resid = urllib.unquote_plus(params['resid']) if 'resid' in params else ''
    url = urllib.unquote_plus(params['url']) if 'url' in params else ''
    category_id = urllib.unquote_plus(params['category_id']) if 'category_id' in params else ''
    content = fetch_url(url)
    
    if category_id == "movielist":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_movie_from_url(content)
    elif category_id == "list":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_tv_from_url(content)
    elif category_id == "variety":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_show_from_url(content)
    elif category_id == "cartlist":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_comic_from_url(content)
    elif category_id == "dv" or category_id == 'paike' or category_id == 'hotshare':
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_other_1_from_url(content)
    else:
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_other_2_from_url(content)
    
    episodesCount = resappepisodes_mf
    
    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))+"&url="+urllib.quote_plus(url)+"&category_id="+urllib.quote_plus(category_id)
    listitem=xbmcgui.ListItem(title)
    listitem.setProperty('title',title)
    listitem.setProperty('thumb',thumbnail)
    listitem.setProperty('episodesNum',episodesCount)
    listitem.setProperty('updateUrl',updateUrl)
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), updateUrl, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))


def get_params(url = ''):
    param = []
    paramstring = sys.argv[2] if url=='' else url
    if len(paramstring) >= 2:
        params = paramstring
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]
    return param

