# -*- coding: utf-8 -*-
# getlist.py

import urllib,urllib2,re,xbmcplugin,xbmcgui,sys,os,os.path,xbmcaddon,xbmc
from urlparse import urljoin
import json
import gzip
try:
    from cStringIO import StringIO
except ImportError:
    from StringIO import StringIO
from xbmcswift2 import Plugin
plugin = Plugin()
try:
    from MFSearchKeyboard import Keyboard
except:
    from xbmc import Keyboard
    pass



plugin_path = plugin.addon.getAddonInfo('path')
lib_path = os.path.join(plugin_path, 'lib')

import time


__addonid__ = "plugin.video.mfvod"
__addon__ = xbmcaddon.Addon(id=__addonid__)
RESOURCES_PATH = os.path.join(__addon__.getAddonInfo('path'), 'media', )
PAGING_THUMB = os.path.join(RESOURCES_PATH,'paging.png')
MORE_THUMB = os.path.join(RESOURCES_PATH,'more.png')
MOVIE_THUMB = os.path.join(RESOURCES_PATH,'movie.png')
TV_THUMB = os.path.join(RESOURCES_PATH,'tv.png')
SHOW_THUMB = os.path.join(RESOURCES_PATH,'show.png')
COMIC_THUMB = os.path.join(RESOURCES_PATH,'comic.png')

IQIYI_THUMB = os.path.join(RESOURCES_PATH,'iqiyi.png')
SOHU_THUMB = os.path.join(RESOURCES_PATH,'sohu.png')
QQ_THUMB = os.path.join(RESOURCES_PATH,'tencent.png')
YOUKU_THUMB = os.path.join(RESOURCES_PATH,'youku.png')
LETV_THUMB = os.path.join(RESOURCES_PATH,'letv.png')
CUP_THUMB = os.path.join(RESOURCES_PATH,'worldcup.png')


movie_areas = [['全部', ''], ['华语', '华语'], ['日本', '日本'], ['美国', '美国'], ['韩国', '韩国'], ['欧洲', '欧洲'], ['印度', '印度'], ['其他', '其他']]

movie_styles = [['全部', ''], ['偶像', '偶像'], ['爱情', '爱情'], ['剧情', '剧情'], ['喜剧', '喜剧'], ['动作', '动作'], ['战争', '战争'], ['武侠', '武侠'], \
['神话', '神话'], ['历史', '历史'], ['警匪', '警匪'], ['悬疑', '悬疑'], ['恐怖', '恐怖'], ['伦理', '伦理'], ['科幻', '科幻'], ['情景', '情景'], ['灾难', '灾难'], ['其他', '其他']]

tv_areas = [['全部', ''], ['大陆', '大陆'], ['香港', '香港'], ['台湾', '台湾'], ['韩国', '韩国'], ['美国', '美国'], ['泰国', '泰国'], ['日本', '日本'], ['其他', '其他']]

tv_styles = [['全部', ''], ['古装', '古装'], ['军旅', '军旅'], ['谍战', '谍战'], ['喜剧', '喜剧'], ['偶像', '偶像'], ['家庭', '家庭'], ['言情', '言情'], \
['历史', '历史'], ['武侠', '武侠'], ['都市', '都市'], ['刑侦', '刑侦'], ['宫廷', '宫廷'], ['悬疑', '悬疑'],['伦理', '伦理'], ['其他', '其他']]

show_areas = [['全部', ''], ['大陆', '大陆'], ['台湾', '台湾'], ['香港', '香港'], ['韩国', '韩国'], ['日本', '日本'], ['美国', '美国'], ['其他', '其他']]

show_styles = [['全部', ''], ['搞笑', '搞笑'], ['访谈', '访谈'], ['相亲', '相亲'], ['游戏', '游戏'], ['时尚', '时尚'], ['情感', '情感'], ['歌舞', '歌舞'], ['曲艺', '曲艺'], \
['生活', '生活'], ['财经', '财经'], ['真人秀', '真人秀'], ['其他', '其他']]

comic_areas = [['全部', ''], ['大陆', '大陆'], ['日本', '日本'], ['美国', '美国'], ['其他', '其他']]

comic_styles = [['全部', ''], ['动作', '动作'], ['搞笑', '搞笑'], ['励志', '励志'], ['益智', '益智'], ['冒险', '冒险'], ['热血', '热血'], ['科幻', '科幻'], \
['机战', '机战'], ['爱情', '爱情'], ['亲子', '亲子'], ['美少女', '美少女'], ['其他', '其他']]

years = [['全部', '', ''], ['2014', '2014', ''], ['2013', '2013', '2014'], ['2012', '2012', '2013'], ['2011', '2011', '2012'], ['2010', '2010', '2011'], \
['2009', '2009', '2010'], ['2008', '2008', '2009'], ['2007', '2007', '2008'], ['2006', '2006', '2007'], ['2005', '2005', '2006'], ['2004', '2004', '2005'], \
['2003', '2003', '2004'], ['2002', '2002', '2003'], ['2001', '2001', '2002'], ['2000', '2000', '2001'], ['更早', 'early', '']]

# sources = [['yk', '232', '优酷'], ['sh', '25', '搜狐'], ['td', '57', '土豆'], ['ls', '42', '乐视'], ['qy', '49', '爱奇艺'], ['fxw', '231', '风行网'], ['qq', '54', '腾讯'], ['sina', '50', '新浪'], ['PPS', '47', 'PPS'], ['dy', '43', '电影网'],['pptv','9999','PPTV']]


HOST = 'http://v.duba.com/'

def GetHttpData(url):
    #UserAgent = ''
    req = urllib2.Request(url)
    #req.add_header('User-Agent', UserAgent)
    response = urllib2.urlopen(req)
    httpdata = response.read()
    if response.headers.get('content-encoding', None) == 'gzip':
        httpdata = gzip.GzipFile(fileobj=StringIO.StringIO(httpdata)).read()
    response.close()
    match = re.compile('encodingt=(.+?)"').findall(httpdata)
    if len(match)<=0:
        match = re.compile('meta charset="(.+?)"').findall(httpdata)
    if len(match)>0:
        charset = match[0].lower()
        if (charset != 'utf-8') and (charset != 'utf8'):
            httpdata = unicode(httpdata, charset).encode('utf8')
    return httpdata

def fetch_url(url, data=None, headers={}, timeout=None, proxies=None):
    headers.setdefault(
        'User-Agent', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.22 (KHTML, like Gecko) Chrome/25.0.1364.84 Safari/537.22')  # noqa
    headers.setdefault('Accept-Encoding', 'gzip,deflate')

    if data and isinstance(data, dict):
        data = urlencode(data)

    req = urllib2.Request(url, data, headers)

    http_proxy = None
    if proxies or http_proxy:
        if not proxies:
            if isinstance(http_proxy, basestring):
                proxies = {'http': http_proxy, 'https': http_proxy}
            else:
                proxies = http_proxy
        proxy_handler = urllib2.ProxyHandler(proxies)
        opener = urllib2.build_opener(proxy_handler)
        r = opener.open(req, timeout=timeout)
    else:
        r = urllib2.urlopen(req, timeout=timeout)

    content = r.read()

    if r.headers.get('content-encoding') == 'gzip':
        content = gzip.GzipFile(fileobj=StringIO(
            content), mode='rb').read()

    return content

def getSourcesFromServer():
    url = 'http://files.cube.morefun.tv/mfalbums/vod-sources.json'
    try:
        data = GetHttpData(url).decode('gbk').encode('utf8')
        vod_srouces = json.JSONDecoder().decode(data)
    except Exception, e:
        vod_srouces = [['yk', '232', '优酷'], ['sh', '25', '搜狐'], ['td', '57', '土豆'], ['ls', '42', '乐视'], ['qy', '49', '爱奇艺'], ['fxw', '231', '风行网'], ['qq', '54', '腾讯'], ['sina', '50', '新浪'], ['PPS', '47', 'PPS'], ['dy', '43', '电影网'],['pptv','9999','PPTV'],['qt','9998','芒果TV']]
    return vod_srouces

def buildRoot():
    listitem=xbmcgui.ListItem('2014巴西世界杯',thumbnailImage=CUP_THUMB)
    url="plugin://plugin.video.mfworldcup"
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('电影',thumbnailImage=MOVIE_THUMB)
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&medianame="+urllib.quote_plus('电影')+"&category_id="+urllib.quote_plus('1')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('movie')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('电视剧',thumbnailImage=TV_THUMB)
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&medianame="+urllib.quote_plus('电视剧')+"&category_id="+urllib.quote_plus('2')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('tv')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('综艺',thumbnailImage=SHOW_THUMB)
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&medianame="+urllib.quote_plus('综艺')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('show')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('动漫',thumbnailImage=COMIC_THUMB)
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&medianame="+urllib.quote_plus('动漫')+"&category_id="+urllib.quote_plus('3')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('comic')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('优酷',thumbnailImage=YOUKU_THUMB)
    url="plugin://plugin.video.mfyouku"
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('搜狐',thumbnailImage=SOHU_THUMB)
    url="plugin://plugin.video.mfsohu"
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('腾讯',thumbnailImage=QQ_THUMB)
    url="plugin://plugin.video.mftencent"
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('乐视',thumbnailImage=LETV_THUMB)
    url="plugin://plugin.video.mfletv"
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('爱奇艺',thumbnailImage=IQIYI_THUMB)
    url="plugin://plugin.video.mfiqiyi"
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb3')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildLists(category_id,page,area_id,style_id,released_on_from,released_on_to,medianame):
    url = HOST + 'category/' + str(category_id) + '-' + str(style_id) + '-' + str(released_on_from) + '--' + str(area_id) + '--' + str(page) + '----.html'
    if category_id == '1':
        items,maxpage = get_movies_from_url(url)
    elif category_id == '2' or category_id == '3':
        items,maxpage = get_resources_from_url(url,category_id)
    elif category_id == '4':
        items,maxpage = get_variety_from_url(url)
    
    for i in items:
        name = i["title"].encode("utf-8")
        #score = i["score"]
        resappepisodes = i["resAppEpisodes"]
        url = i["url"]
        thumbnail = i["thumbnail"].encode("utf-8")
        listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
        if category_id != "1":
            listitem.setProperty('v360resappepisodes',resappepisodes)
        u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&category_id='+urllib.quote_plus(category_id)+'&resappepisodes='+urllib.quote_plus(str(resappepisodes))+'&need_type='+urllib.quote_plus('source')+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(items))
    if int(maxpage) > int(page):
        listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多 ' + str(page) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
        u=sys.argv[0] + '?mode=1&mfcachetype=dir_cache_always&page='+str(page+1) +'&category_id='+urllib.quote_plus(category_id)+'&area_id='+urllib.quote_plus(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&released_on_from=' + urllib.quote_plus(released_on_from)+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    #xbmcplugin.setProperty(int(sys.argv[1]), 'morefuntvsource', "true")
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb2')
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', medianame)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def get_movies_from_url(url):
    content = fetch_url(url)
    _RE = re.compile(
        r'<li class="g-img-mask">\s*<a[\s\S]*?href="(.+?)"[\s\S]*?'
        '<img[\s\S]*?alt="(.+?)"[\s\S]*?'
        'data-original="(.+?)">[\s\S]*?')
    items = []
    for match in _RE.finditer(content):
        detail_url, title, imgurl = match.groups()
        if imgurl[0:8] == '/static/':
            imgurl = urljoin(HOST, imgurl)
        items.append({
            'title': title,
            'url': urljoin(HOST, detail_url),
            'thumbnail': imgurl,
            'resAppEpisodes':'1集全'
        })

    maxpage = '0'
    maxpages = []
    _RE_PAGE1 = re.compile(r'<div class="g-paging">([\s\S]*?)</div>[\s\S]*?')
    _RE_PAGE2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    for match in _RE_PAGE1.finditer(content):
        datapag = match.groups()[0]
        match_page = _RE_PAGE2.search(datapag)
        if match_page:
            for match in _RE_PAGE2.finditer(str(datapag)):
                maxpage_name = match.groups()[0]
                maxpages.append(maxpage_name)
            if maxpages[-1]=='下一页':
                maxpage = maxpages[-2]
            else:
                maxpage = maxpages[-1]
        else:
            maxpage=1
    return items,maxpage

def get_resources_from_url(url,category_id):
    content = fetch_url(url)
    _RE = re.compile(
        r'<li class="g-img-mask">\s*<a[\s\S]*?href="(.+?)"[\s\S]*?'
        '<img[\s\S]*?alt="(.+?)"[\s\S]*?'
        'data-original="(.+?)">[\s\S]*?'
        '<span class="info">(.+?)</span>[\s\S]*?')
    items = []
    for match in _RE.finditer(content):
        detail_url, title, imgurl, episodes_num = match.groups()
        if imgurl[0:8] == '/static/':
            imgurl = urljoin(HOST, imgurl)
        items.append({
            'title': title,
            'url': urljoin(HOST, detail_url),
            'thumbnail': imgurl,
            'resAppEpisodes':episodes_num if category_id != '1' else '1集全'
        })
    maxpage = '0'
    maxpages = []
    _RE_PAGE1 = re.compile(r'<div class="g-paging">([\s\S]*?)</div>[\s\S]*?')
    _RE_PAGE2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    for match in _RE_PAGE1.finditer(content):
        datapag = match.groups()[0]
        match_page = _RE_PAGE2.search(datapag)
        if match_page:
            for match in _RE_PAGE2.finditer(str(datapag)):
                maxpage_name = match.groups()[0]
                maxpages.append(maxpage_name)
            if maxpages[-1]=='下一页':
                maxpage = maxpages[-2]
            else:
                maxpage = maxpages[-1]
        else:
            maxpage=1
    return items,maxpage

def get_variety_from_url(url):    
    content = fetch_url(url)
    _RE = re.compile(
        r'<li class="g-img-mask">\s*<a[\s\S]*?href="(.+?)"[\s\S]*?'
        '<img[\s\S]*?alt="(.+?)"[\s\S]*?'
        'data-original="(.+?)">[\s\S]*?'
        '<span class="info">(.+?)</span>[\s\S]*?')
    items = []
    for match in _RE.finditer(content):
        detail_url, title, imgurl, episodes_num = match.groups()
        if imgurl[0:8] == '/static/':
            imgurl = urljoin(HOST, imgurl)
        items.append({
            'title': title,
            'url': urljoin(HOST, detail_url),
            'thumbnail': imgurl,
            'resAppEpisodes':episodes_num
        })

    maxpage = '0'
    maxpages = []
    _RE_PAGE1 = re.compile(r'<div class="g-paging">([\s\S]*?)</div>[\s\S]*?')
    _RE_PAGE2 = re.compile(r'<a[\s\S]*?>([\s\S]*?)</a>[\s\S]*?')
    for match in _RE_PAGE1.finditer(content):
        datapag = match.groups()[0]
        match_page = _RE_PAGE2.search(datapag)
        if match_page:
            for match in _RE_PAGE2.finditer(str(datapag)):
                maxpage_name = match.groups()[0]
                maxpages.append(maxpage_name)
            if maxpages[-1]=='下一页':
                maxpage = maxpages[-2]
            else:
                maxpage = maxpages[-1]
        else:
            maxpage=1
    return items,maxpage

def buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame):
    content = fetch_url(url)
    if page == "":
        page = "1"
    more_url = url
    resid = ""
    if category_id == "1":
        actors,stylename,areaname,year,description,appidlist,site_list,resid,resappepisodes_mf = get_detail_dianying_from_url(content)
    elif category_id == "2":
        actors,stylename,areaname,year,description,appidlist,site_list,resid,resappepisodes_mf = get_detail_dianshi_from_url(content)
    elif category_id == "3":
        actors,stylename,areaname,year,description,appidlist,site_list,resid,resappepisodes_mf = get_detail_dongman_from_url(content)
    elif category_id == "4":
        actors,stylename,areaname,year,description,appidlist,site_list,resid,resappepisodes_mf = get_detail_zongyi_from_url(content)

    site = ""
    episodesCount = resappepisodes_mf
    applist = appidlist.split(",")
    if applist[0] == "":
        plugin.notify('由于版权问题，暂不支持该数据源', delay=2000, image='DefaultIconInfo.png')
        return
    newappidlist = ';'
    for id in applist:
        newappidlist = newappidlist + id + ';'
    title = name
    sources = getSourcesFromServer()
    if app_id !="":
        for i in sources:
            if app_id == i[1]:
                site = i[0]
        for j in site_list:
            if site == j:
                appspidername = j
    else:
        app_id = applist[0]
        for i in sources:
            if i[1] == app_id:
                appspidername = i[0]
    if category_id == "1":
        items,video_maxpage = get_dy_juji_list(content,appspidername,name)
    elif category_id == "2":
        items,video_maxpage = get_dm_juji_list(content,appspidername,page)
    elif category_id == "3":
        items,video_maxpage = get_dm_juji_list(content,appspidername,page)    
    elif category_id == "4":
        items,video_maxpage = get_zy_juji_list(content,resid,appspidername,page)

    for j in items:
        title = j["title"]
        play_url = j["url"]
        play_url = play_url.replace("?ptag=duba","").replace("#from_kingsoft","")
        listitem=xbmcgui.ListItem(title)
        listitem.setProperty('name',title)
        listitem.setProperty('playurl',play_url)
        url=sys.argv[0] + '?mode=3&mfcachetype=dir_cache_always&url=' + urllib.quote_plus(play_url)+ '&item_id='+'&app_id='+urllib.quote_plus(str(app_id))+'&appspidername='+urllib.quote_plus(appspidername)+'&name='+urllib.quote_plus(title)+'&resourceTitle='+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&page="+str(page)+'&category_id='+urllib.quote_plus(str(category_id))+"&view_mode="+urllib.quote_plus('morefunlist')
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, False)
    if (int(page) < int(video_maxpage)) and (category_id == "4" or 11<=int(page)):
        if len(items)>0:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' +'[/COLOR]',thumbnailImage=MORE_THUMB)
            listitem.setProperty('next','true')
            url=sys.argv[0]+'?mode=2&mfcachetype=dir_cache_always&page='+str(int(page)+1) +'&app_id='+urllib.quote_plus(str(app_id))+'&category_id='+str(category_id)+ '&url=' + urllib.quote_plus(more_url)+ '&name=' + urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&resappepisodes="+urllib.quote_plus(resappepisodes)+'&need_type='+urllib.quote_plus('source')+ '&medianame='+urllib.quote_plus(medianame)
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
            
    resappepisodes = resappepisodes.replace('\n','').replace(' ','').replace('\t','').strip().replace('更新至','').replace('共','').replace('集','').replace('全','')
    # if resappepisodes.isdigit():
    if category_id == "2":
        maxpage = video_maxpage  # old: int(resappepisodes)/100 + 1
        xbmcplugin.setProperty(int(sys.argv[1]), 'maxpage', str(maxpage))
    elif category_id == "3":
        maxpage = video_maxpage
        xbmcplugin.setProperty(int(sys.argv[1]), 'maxpage', str(maxpage))
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunlist')
    xbmcplugin.setProperty(int(sys.argv[1]), 'title', name)
    xbmcplugin.setProperty(int(sys.argv[1]), 'areaname', areaname)
    xbmcplugin.setProperty(int(sys.argv[1]), 'stylename', stylename)
    xbmcplugin.setProperty(int(sys.argv[1]), 'year', year)
    xbmcplugin.setProperty(int(sys.argv[1]), 'actors', actors)
    xbmcplugin.setProperty(int(sys.argv[1]), 'description', description)
    xbmcplugin.setProperty(int(sys.argv[1]), 'appidlist', newappidlist)
    xbmcplugin.setProperty(int(sys.argv[1]), 'app_id', app_id)
    xbmcplugin.setProperty(int(sys.argv[1]), 'resappepisodes', resappepisodes_mf)
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumbnail', thumbnail)
    if resid !="":
        xbmcplugin.setProperty(int(sys.argv[1]), 'itemId', 'v360v'+str(resid))
        favouriteUrl = sys.argv[0]+"?fromtype=favourite&app_id=&resid="+urllib.quote_plus(str(resid))+"&page=&resappepisodes="+urllib.quote_plus(resappepisodes)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&category_id="+urllib.quote_plus(category_id)+"&url="+urllib.quote_plus(more_url)+"&title="+urllib.quote_plus(name)+"&need_type="+urllib.quote_plus('source')+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.setProperty(int(sys.argv[1]), 'url', favouriteUrl)
    xbmcplugin.setProperty(int(sys.argv[1]), 'itemType', 'morefun')
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumb', thumbnail)
    xbmcplugin.setProperty(int(sys.argv[1]), 'playable', 'false')
    xbmcplugin.setProperty(int(sys.argv[1]), 'morefuntvsource', "false")
    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))+"&url="+urllib.quote_plus(more_url)+"&category_id="+urllib.quote_plus(category_id)+"&title="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)
    if (category_id == "2" or category_id == "3") and episodesCount != "":
        xbmcplugin.setProperty(int(sys.argv[1]), 'updateUrl', updateUrl)
    xbmcplugin.setProperty(int(sys.argv[1]), 'episodesNum', episodesCount)
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', medianame)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
    
def get_detail_dianying_from_url(content):
    site_list = []
    _RE = re.compile(
        r'<span class="year">(.+?)</span>[\s\S]*?'
         '<span class="label">导演：</span>(.+?)</a> </li>[\s\S]*?'
          '<div class="theme limit">(.+?)</div>[\s\S]*?'
          '<li> <span class="label">类型：</span>(.+?)</li>[\s\S]*?'
          '<li> <span class="label">地区：</span>(.+?)</li>[\s\S]*?'
         '<div class="long" style="display:none;">(.+?)<span href="#" class="g-unfoldbtn">[\s\S]*?'
        )
    for match in _RE.finditer(content):
        year,director,actors,type,area,description= match.groups()
        year = year.replace("(","").replace(")","")
        director =re.sub('</a>','/',director)
        director =re.sub('<[\s\S]*?>','',director)
        actors =re.sub('</a>','/',actors)
        actors =re.sub('<[\s\S]*?>','',actors)
        stylename =re.sub('<[\s\S]*?>',' ',type)
        areaname =re.sub('<[\s\S]*?>','',area)
    site_list = []
    appidlist = ""
    _RE_sites1 = re.compile(r'<div class="qvod">(.+?)</div>[\s\S]*?')
    _RE_sites2 = re.compile(r'<a class="[\s\S]*?prodd="(.+?)"\s*infoid="(.+?)"[\s\S]*?</a>[\s\S]*?')
    
    for match in _RE_sites1.finditer(content):
        site = match.groups()[0]
        
        for match in _RE_sites2.finditer(str(site)):
            prodd,infoid= match.groups()
            movieid = infoid
            site_list.append(prodd)
    sources = getSourcesFromServer()
    for j in site_list:
        for i in sources:
            if j == i[0]:
                appidlist = appidlist + ',' + i[1]
    appidlist = appidlist.strip(',')
    episodescount = "1"
    return actors,stylename,areaname,year,description,appidlist,site_list,movieid,episodescount


def get_detail_dianshi_from_url(content):
    movieid = ''
    _RE_movieid = re.compile(r'<div class="focus g-mask-play-once">[\s\S]*?infoid="(.+?)"[\s\S]*?')
    match = _RE_movieid.search(content)
    if match:
        movieid = match.groups('')[0]
    _RE = re.compile(
        r'<span class="year">(.+?)</span>[\s\S]*?'
         '<div class="theme limit">(.+?)</div>[\s\S]*?'
         '<p class="theme long"[\s\S]*?>\s*(.+?)\s*<span class[\s\S]*?'
        )
    for match in _RE.finditer(content):
        year,actors,description= match.groups()
        year = year.replace("(","").replace(")","")
        actors =re.sub('</a>','/',actors)
        actors =re.sub('<[\s\S]*?>','',actors)
    episodescount = ""
    _RE_episode1 = re.compile(
                 r'<li>[\s\S]*?<p class="episode">(.+?)</p>[\s\S]*?'
                  )
    _RE_episode2 = re.compile(
                 r'<emclass="g-highlight">(.+?)</em>/\d*</a>?'
                  )
    for match in _RE_episode1.finditer(content):
        episodescount = match.groups()[0]
        episodescount = str(episodescount).replace('共', '').replace('全', '').replace('更新至', '').replace('集', '').replace(' ', '')
        for match in _RE_episode2.finditer(str(episodescount)):
            episodescount = match.groups()[0]
    site_list = []
    appidlist = ""
    _RE_sites = re.compile(r'<h4 class="site"[\s\S]*?prodd="(.+?)">[\s\S]*?')
    for match in _RE_sites.finditer(content):
        site = match.groups()[0]
        site_list.append(site)
    sources = getSourcesFromServer()
    for j in site_list:
        for i in sources:
            if j == i[0]:
                appidlist = appidlist + ',' + i[1]
    appidlist = appidlist.strip(',')
    
    return actors,"","",year,description,appidlist,site_list,movieid,episodescount

def get_detail_dongman_from_url(content):
    start = time.time()
    movieid = ''
    _RE_movieid = re.compile(r'<div class="focus g-mask-play-once">[\s\S]*?infoid="(.+?)"[\s\S]*?')
    match = _RE_movieid.search(content)
    if match:
        movieid = match.groups('')[0]
    
    actors = ""
    director = ""
    areaname = ""
    stylename = ""
    year = ""
    description = ""
    episodescount = ""
    _RE_info = re.compile(
                 r'<ul class="infolist">[\s\S]*?'
                  '<li>[\s\S]*?<p class="episode">[\s\S]*?</p>[\s\S]*?'
                  '<li>[\s\S]*?<a href=[\s\S]*?>(.+?)</a>[\s\S]*?'
                  '<li>[\s\S]*?</span>(.+?)</li>[\s\S]*?'
                  '<li>[\s\S]*?<p class="theme short">(.+?)</p>[\s\S]*?')
    match = _RE_info.search(content)
    if match:
        areaname,stylename,description = match.groups('')
        stylename = re.sub('<[\s\S]*?>','',stylename)
    
    
    _RE_episode1 = re.compile(
                 r'<li>[\s\S]*?<p class="episode">(.+?)</p>[\s\S]*?'
                  )
    _RE_episode2 = re.compile(
                 r'<emclass="g-highlight">(.+?)</em>\d*</a>?'
                  )
    for match in _RE_episode1.finditer(content):
        episodescount = match.groups()[0]
        episodescount = str(episodescount).replace('共', '').replace('全', '').replace('更新至', '').replace('集', '').replace(' ', '')
        for match in _RE_episode2.finditer(str(episodescount)):
            episodescount = match.groups()[0]
    
    
    _RE_year = re.compile(r'<span class="year">(.+?)</span>[\s\S]*?')
    match = _RE_year.search(content)
    if match:
        year = match.groups()[0].replace("(","").replace(")","")
    
    site_list = []
    appidlist = ""
    _RE_sites = re.compile(r'<h4 class="site"[\s\S]*?prodd="(.+?)">[\s\S]*?')
    for match in _RE_sites.finditer(content):
        site = match.groups()[0]
        site_list.append(site)
    sources = getSourcesFromServer()
    for j in site_list:
        for i in sources:
            if j == i[0]:
                appidlist = appidlist + ',' + i[1]
    appidlist = appidlist.strip(',')
    
    end = time.time()
    return actors,stylename,areaname,year,description,appidlist,site_list,movieid,episodescount

def get_detail_zongyi_from_url(content):
    _RE = re.compile(
        r'<li> <span class="label">主持：</span> <div class="theme limit episode">(.+?)</div> </li>[\s\S]*?'
        '<li> <span class="label">地区：</span> <a href="[\s\S]*?">(.+?)</a> </li>[\s\S]*?'
        '<p class="theme long" style="display:none;">([\s\S]*)<span class="g-unfoldbtn">[\s\S]*?'
        )
    for match in _RE.finditer(content):
        emcee,areaname,description = match.groups()
        emcee = re.sub('<[\s\S]*?>',' ',emcee)
        
    site_list = []
    appidlist = ""
    
    _RE_sites1 = re.compile(r'title="[\s\S]*?" class="g-img" href="[\s\S]*?" prodd="[\s\S]*?" infoid="(.+?)" proid="[\s\S]*?" >')
    _RE_sites2 = re.compile(r'class="site" proid="[\s\S]*?" prodd="(.+?)"')   
    
    for info in _RE_sites1.finditer(content):
        infoid = info.groups()[0]
        
    for pro in _RE_sites2.finditer(content):
        prodd = pro.groups()[0]
        site_list.append(prodd)
    sources = getSourcesFromServer()
    for j in site_list:
        for i in sources:
            if j == i[0]:
                appidlist = appidlist + ',' + i[1]
    appidlist = appidlist.strip(',')
    
    episodescount = ""
    actors = emcee
    stylename = ''
    year  = ''
    
    return actors,stylename,areaname,year,description,appidlist,site_list,infoid,episodescount
    
def get_dy_juji_list(content,site_name,name):
    items = []
    _RE = re.compile(
        r'<div class="qvod">\s*([\s\S]*?)\s*</div>'
        )
    RE = re.compile(
        r'<a class="(.+?)" href="(.+?)" prodd="(.+?)" infoid="(.+?)" proid="(.+?)" >[\s\S]*?</a>[\s\S]*?'
        )
    _RE1 = re.compile(
        r'url=([\s\S]*?.html)[\s\S]*?'
        )
    for match in _RE.finditer(content):
        detail = match.groups()[0]
        for match in RE.finditer(str(detail)):
            detailitems = match.groups()
            ico,herf,prodd,infoid,proid = match.groups()
            if prodd == "yk":
                if _RE1.search(str(herf)):
                    match = _RE1.search(str(herf))
                    herf = match.groups()[0]
                    herf = urllib.unquote_plus(herf)
            if prodd == site_name:
                items.append({
                    'title': name,
                    'ico': ico,
                    'url':herf,
                    'prodd': prodd,
                    'infoid': infoid,
                    'proid': proid
                })
    return items,1

def get_ds_juji_list(content,site_name,index):
    _RE1 = re.compile(r'url=([\s\S]*?.html)[\s\S]*?')
    dongman_maxpage = "1"
    appidlist = ""
    reg = re.compile(r'Object\((.+?)\);')
    items = []
    for match in reg.finditer(content):
        webplaypath = match.groups()[0]
        data = json.JSONDecoder().decode(webplaypath)
        for i in range(0,len(data)):
            if data[i]["icon"] == site_name:
                count = data[i]["count"]
                play_list = data[i]["play_list"]
                for j in play_list:
                    playurl = j["playurl"]
                    if site_name == "yk":
                        if _RE1.search(str(playurl)):
                            match = _RE1.search(str(playurl))
                            playurl = match.groups()[0]
                            playurl = urllib.unquote_plus(playurl)
                    title = j["jishu"]
                    items.append({'title': title, 'url': playurl})
                dongman_maxpage = int(count)/100 + 1 if int(count)%100 > 0 else 0
                break
    detailpage = (int(index)-1)*100
    if dongman_maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,dongman_maxpage

def get_dm_juji_list(content,site_name,index):
    _RE1 = re.compile(r'url=([\s\S]*?.html)[\s\S]*?')
    dongman_maxpage = "1"
    appidlist = ""
    reg = re.compile(r'Object\((.+?)\);')
    items = []
    for match in reg.finditer(content):
        webplaypath = match.groups()[0]
        data = json.JSONDecoder().decode(webplaypath)
        for i in range(0,len(data)):
            if data[i]["icon"] == site_name:
                count = data[i]["count"]
                play_list = data[i]["play_list"]
                for j in play_list:
                    playurl = j["playurl"]
                    if site_name == "yk":
                        if _RE1.search(str(playurl)):
                            match = _RE1.search(str(playurl))
                            playurl = match.groups()[0]
                            playurl = urllib.unquote_plus(playurl)
                    title = j["jishu"]
                    items.append({'title': title, 'url': playurl})
                dongman_maxpage = int(count)/100 + 1 if int(count)%100 > 0 else 0
                break
    detailpage = (int(index)-1)*100
    if dongman_maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,dongman_maxpage

def get_zy_juji_list(content,infoid,site_name,page):

    #获取每个源的代码
    _RE_SITE = re.compile(r'<div class="tab-content" prodd="(.+?)" proid="(.+?)"[\s\S]*?(<span class="match g-note">[\s\S]*?</span>[\s\S]*?)(<div class="g-paging" maxpage="[\s\S]*?"> </div>) </div> </div>[\s\S]*?')    
    _RE_YEAR = re.compile(r'<span class="match[\s\S]*?">(.+?)</span>')
    _RE_MAXPAGE = re.compile(r'maxpage="(.+?)"')
    
    #获取每一个源的year,prodd,proid,maxpage 
    ItemInfoList = []
    
    for siteinfo in _RE_SITE.finditer(content):
        prodd,proid,yearStr,maxpageStr = siteinfo.groups()
        
        yearlist = []
        for yearinfo in _RE_YEAR.finditer(yearStr):
            yearlist.append( yearinfo.groups()[0] )
        maxpagelist = []    
        for maxpageinfo in _RE_MAXPAGE.finditer(maxpageStr):
            maxpagelist.append( maxpageinfo.groups()[0] )
        
        ItemInfo = {}    
        ItemInfo["prodd"] = prodd
        ItemInfo["proid"] = proid
        ItemInfo["last"] = yearlist[0]
        
        yearpage = {}
        length = min( len(yearlist),len(maxpagelist) )
        for i in range(0,length):
            yearpage[yearlist[i]] = maxpagelist[i]
        ItemInfo["maxpage"] = yearpage
        
        ItemInfoList.append(ItemInfo)
    
    #查找指定源的proid,最新年份,最大页数
    for item in ItemInfoList:
        if item["prodd"] == site_name:
            proid   = item["proid"]
            year    = item["last"]       
            maxpage = item["maxpage"][year]
            
    return get_zy_json_response(infoid,proid,year,page,site_name), maxpage  

def get_zy_json_response(infoid,proid,year,page,site_name):

    _RE = re.compile(r'class="site" proid="(.+?)" prodd="([\s\S]*?)"')   
    _RE1 = re.compile(r'url=([\s\S]*?.html)[\s\S]*?')
    
    #获取json接口的返回值
    url = 'http://v.duba.com/ajax_getPlaylist.html?id=%s&proid=%s&year=%s&page=%s' %(infoid,proid,year,page)    
    content = fetch_url(url)
    
    #json返回值处理
    data = json.JSONDecoder().decode(content)
    list = data["list"]
    items = []
    for match in list:
        pubDate = match["pubDate"]
        word    = match['word']
        playurl = match["playurl"]
        if site_name == "yk":
            if _RE1.search(str(playurl)):
                match = _RE1.search(str(playurl))
                playurl = match.groups()[0]
                playurl = urllib.unquote_plus(playurl)
        
        if word == 'Array':
            word = ''
        title = pubDate + '    '+ word
        
        items.append({
            'title': title.encode('utf8'),
            'url'  : playurl.encode('utf8')
        })

    return items
  
def playVideo(url):
    mylist = GetHttpData(url)
    foobars = re.compile('<m3u8>(.*?)</m3u8>', re.DOTALL).findall(mylist)
    playlist = xbmc.PlayList(1)
    playlist.clear()
    for i in range(0,len(foobars)):
        title =" 第"+str(i+1)+"/"+str(len(foobars))+"节"
        listitem=xbmcgui.ListItem(title)
        listitem.setInfo(type="Video",infoLabels={"Title":title})
        playlist.add(foobars[i], listitem)
    xbmc.Player().play(playlist)

def searchkey(category_id):
    keyword = ""
    type = ""
    if category_id == "1":
        category_mf = "1"
        keyword = "美国队长,西游记之大闹天宫,北京爱情故事,神偷奶爸,僵尸,恶战,奥林匹斯的陷落,警察故事,私人定制"
        type = "电影"
    elif category_id == "2":
        category_mf = "2"
        keyword = "叛逃,屌丝男士,妻子的秘密,男人四十要出嫁,一仆二主,来自星星的你,别再犹豫,万万没想到"
        type = "电视剧"
    elif category_id == "4":
        category_mf = "14"
        keyword = "中国好歌曲,快乐大本营,笑傲江湖,running man,百变大咖秀,康熙来了,天天向上,晓说"
        type = "综艺"
    elif category_id == "3":
        category_mf = "4"
        keyword = "奥特曼,熊出没,啦啦啦德玛西亚,黑子的篮球,火影忍者,海贼王,名侦探柯南,七龙珠"
        type = "动漫"
    kb = Keyboard('','请输入搜索内容',keyword,type)
    kb.doModal()
    if (kb.isConfirmed()):
        keyword = kb.getText()
        if keyword !='':
            searchpage = 1
            searchlist(keyword,category_id,category_mf,searchpage)
        else:
            xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
            xbmcplugin.endOfDirectory(int(sys.argv[1]))
    else:
        xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
def searchlist(keyword,category_id,category_mf,searchpage):
    search_path = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/search/"+keyword+"?page_size=54"+"&page_no="+str(searchpage)+"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1383555354&security_code=ce30ea919afcc8cf731b5edf8f91ee6c&session_id=dltianwei&category_id="+str(category_mf)+"&app_id=712"
    search_path = eval(repr(search_path).replace("\\x","%"))
    p1 = GetHttpData(search_path)
    data = json.JSONDecoder().decode(p1)
    newses = data["data"]
    app_id = ''
    area_id = ''
    style_id = ''
    if newses != None:
        newses1 = newses["items"]
        maxpage = newses["totalPages"]
        for i in newses1:
            name = i["title"].encode("utf-8") if "title" in i and i["title"] else ""
            resid = i["id"]  if "id" in i and i["id"] else ""
            resappepisodes = i["resAppEpisodes"]  if "resAppEpisodes" in i and i["resAppEpisodes"] else ""
            url = i["channelUrl"]
            thumbnail = i["thumbnail"].encode("utf-8")  if "thumbnail" in i and i["thumbnail"] else ""
            listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
            u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&category_id='+urllib.quote_plus(category_id)+'&resappepisodes='+urllib.quote_plus(str(resappepisodes))+'&need_type='+urllib.quote_plus('source')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(newses1))
        if int(maxpage) > searchpage:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(searchpage) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
            listitem.setProperty('next','true')
            u=sys.argv[0] + '?mode=9&mfcachetype=dir_cache_always&searchpage='+str(searchpage+1) +'&app_id='+urllib.quote_plus('0')+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&keyword=' + urllib.quote_plus(keyword)+"&view_mode="+urllib.quote_plus('morefunthumb')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getareas(category, category_id,medianame):
    areas = []
    if category == "movie":
        areas = movie_areas
    elif category == "tv":
        areas = tv_areas
    elif category == "show":
        areas = show_areas
    elif category == "comic":
        areas = comic_areas
    for area in areas:
        listitem=xbmcgui.ListItem(area[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus(area[0])+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus(area[1])+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getstyles(category, category_id,medianame):
    styles = []
    if category == "movie":
        styles = movie_styles
    elif category == "tv":
        styles = tv_styles
    elif category == "show":
        styles = show_styles
    elif category == "comic":
        styles = comic_styles
    for style in styles:
        listitem=xbmcgui.ListItem(style[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus(style[0])+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus(style[1])+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getsources(appidlist,appnamelist):
    appidlist = appidlist.strip(';')
    appidlist = appidlist.split(";")
    sourcelist = []
    sources = getSourcesFromServer()
    if appnamelist=='':
        for id in appidlist:
            for i in sources:
                if id == i[1]:
                    sourcelist.append({'source': i[2], 'sourceid': id})
        for j in sourcelist:
            listitem=xbmcgui.ListItem(j["source"],thumbnailImage="")
            listitem.setProperty('app_id', j["sourceid"])
            url= ''
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
    else:
        appnamelist = appnamelist.strip(';')
        appnamelist = appnamelist.split(';')
        for i in range(len(appidlist)):
            sourcelist.append({'source': appnamelist[i], 'sourceid': appidlist[i]})
        for j in sourcelist:
            listitem=xbmcgui.ListItem(j["source"],thumbnailImage="")
            listitem.setProperty('app_id', j["sourceid"])
            url= ''
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
        xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getyears(category_id,medianame):
    for year in years:
        listitem=xbmcgui.ListItem(year[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus(year[0])+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus(year[1])+"&released_on_to="+urllib.quote_plus(year[2])+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def display_for_history(params):
    app_id = urllib.unquote_plus(params['app_id']) if 'app_id' in params else ''
    category_id = urllib.unquote_plus(params['category_id']) if 'category_id' in params else ''
    url = urllib.unquote_plus(params['url']) if 'url' in params else ''
    name = urllib.unquote_plus(params['title']) if 'title' in params else ''
    if name == "" or name == None:
        name = urllib.unquote_plus(params['name']) if 'name' in params else ''
    page = urllib.unquote_plus(params['page']) if 'page' in params else ''
    resappepisodes = urllib.unquote_plus(params['resappepisodes']) if 'resappepisodes' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    medianame = urllib.unquote_plus(params['medianame']) if 'medianame' in params else ''
    buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame)
    
def display_for_favourite(params):
    display_for_history(params)

def update_favourite(params):
    title = urllib.unquote_plus(params['title']) if 'title' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    resid = urllib.unquote_plus(params['resid']) if 'resid' in params else ''
    url = urllib.unquote_plus(params['url']) if 'url' in params else ''
    category_id = urllib.unquote_plus(params['category_id']) if 'category_id' in params else ''
    content = fetch_url(url)
    if category_id == "1":
        actors,stylename,areaname,year,description,appidlist,site_list,resid,resappepisodes_mf = get_detail_dianying_from_url(content)
    elif category_id == "2":
        actors,stylename,areaname,year,description,appidlist,site_list,resid,resappepisodes_mf = get_detail_dianshi_from_url(content)
    elif category_id == "4":
        actors,stylename,areaname,year,description,appidlist,site_list,resid,resappepisodes_mf = get_detail_zongyi_from_url(content)
    elif category_id == "3":
        actors,stylename,areaname,year,description,appidlist,site_list,resid,resappepisodes_mf = get_detail_dongman_from_url(content)
    episodesCount = resappepisodes_mf
    
    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))+"&url="+urllib.quote_plus(url)+"&category_id="+urllib.quote_plus(category_id)
    listitem=xbmcgui.ListItem(title)
    listitem.setProperty('title',title)
    listitem.setProperty('thumb',thumbnail)
    listitem.setProperty('episodesNum',episodesCount)
    listitem.setProperty('updateUrl',updateUrl)
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), updateUrl, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))


def get_params(url = ''):
    param = []
    paramstring = sys.argv[2] if url=='' else url
    if len(paramstring) >= 2:
        params = paramstring
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]
    return param    

