# -*- coding: utf-8 -*-
# getlist.py

import urllib,urllib2,re,xbmcplugin,xbmcgui,sys,os,os.path,xbmcaddon,xbmc   
import json
try:
    from MFSearchKeyboard import Keyboard
except:
    from xbmc import Keyboard
    pass
from xbmcswift2 import Plugin
plugin = Plugin()

__addonid__ = "plugin.video.mfvod"
__addon__ = xbmcaddon.Addon(id=__addonid__)
RESOURCES_PATH = os.path.join(__addon__.getAddonInfo('path'), 'media', )
PAGING_THUMB = os.path.join(RESOURCES_PATH,'paging.png')
MORE_THUMB = os.path.join(RESOURCES_PATH,'more.png')
MOVIE_THUMB = os.path.join(RESOURCES_PATH,'movie.png')
TV_THUMB = os.path.join(RESOURCES_PATH,'tv.png')
SHOW_THUMB = os.path.join(RESOURCES_PATH,'show.png')
COMIC_THUMB = os.path.join(RESOURCES_PATH,'comic.png')

movie_areas = [['全部', ''], ['华语', '1,2,9,18,49'], ['美国', '4'], ['韩国', '6'], ['欧洲', '50'], ['其他', '1000']]

movie_styles = [['全部', ''], ['爱情', '6'], ['动作', '2'], ['喜剧', '1'], ['剧情', '8'], ['动画', '13'], ['科幻', '5'], ['战争', '7'], \
['恐怖', '9'], ['风月', '47'], ['歌舞', '149'], ['魔幻', '120'], ['灾难', '153'], ['悬疑', '11'], ['其他', '1000']]

tv_areas = [['全部', ''], ['内地', '2'], ['香港', '1'], ['韩国', '6'], ['美国', '4'], ['其他', '1000']]

tv_styles = [['全部', ''], ['都市', '20'], ['家庭', '24'], ['言情', '21'], ['警匪', '25'], ['古装', '23'], ['武侠', '27'], ['军事', '26'], \
['神话', '29'], ['科幻', '5'], ['悬疑', '11'], ['历史', '14'], ['儿童', '31'], ['农村', '30'], ['其他', '1000']]

show_areas = [['全部', ''], ['内地', '2'], ['港台', '1,9,18'], ['韩国', '6'], ['日本', '3'], ['美国', '4'], ['其他', '1000']]

show_styles = [['全部', ''], ['访谈', '38'], ['选秀', '138'], ['游戏', '39'], ['时尚', '16'], ['音乐', '48'], ['曲艺', '164'], ['交友', '159'], ['其他', '1000']]

comic_areas = [['全部', ''], ['日本', '3'], ['内地', '2'], ['美国', '4'], ['韩国', '6'], ['其他', '1000']]

comic_styles = [['全部', ''], ['搞笑', '22'], ['剧情', '8'], ['冒险', '10'], ['魔幻', '120'], ['励志', '123'], ['体育', '129'], ['益智', '36'], \
['童话', '122'], ['真人', '119'], ['动作', '2'], ['推理', '113'], ['亲子', '121'], ['怀旧', '156'], ['其他', '1000']]

years = [['全部', '', ''], ['2013', '2013', ''], ['2012', '2012', '2013'], ['2011', '2011', '2012'], ['2010', '2010', '2011'], \
['2009', '2009', '2010'], ['2008', '2008', '2009'], ['2007', '2007', '2008'], ['更早', '', '2007']]

def GetHttpData(url):
    #UserAgent = ''
    req = urllib2.Request(url)
    #req.add_header('User-Agent', UserAgent)
    response = urllib2.urlopen(req)
    httpdata = response.read()
    if response.headers.get('content-encoding', None) == 'gzip':
        httpdata = gzip.GzipFile(fileobj=StringIO.StringIO(httpdata)).read()
    response.close()
    match = re.compile('encodingt=(.+?)"').findall(httpdata)
    if len(match)<=0:
        match = re.compile('meta charset="(.+?)"').findall(httpdata)
    if len(match)>0:
        charset = match[0].lower()
        if (charset != 'utf-8') and (charset != 'utf8'):
            httpdata = unicode(httpdata, charset).encode('utf8')
    return httpdata

def buildRoot():
    listitem=xbmcgui.ListItem('电影',thumbnailImage=MOVIE_THUMB)
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('电影')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('1')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('movie')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('电视剧',thumbnailImage=TV_THUMB)
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('电视剧')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('2')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('tv')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('综艺',thumbnailImage=SHOW_THUMB)
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('综艺')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('14')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('show')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('动漫',thumbnailImage=COMIC_THUMB)
    url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus('动漫')+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('comic')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildLists(app_id,category_id,area_id,url,page,style_id,released_on_from,released_on_to):
    url1 = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources?app_id="+ str(app_id) +"&category_id=" + str(category_id) + "&area_id="+str(area_id)+"&style_id=" + str(style_id) +"&released_on_from="+released_on_from+"&released_on_to="+released_on_to+"&page_no="+str(page)+"&page_size=54&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    p1 = GetHttpData(url1)
    data = json.JSONDecoder().decode(p1)
    newses = data["data"]
    if newses != None:
        newses1 = newses["items"]
        maxpage = newses["totalPages"]
        #if page > 1:
            #listitem=xbmcgui.ListItem('[COLOR FF004AFF]上一页  ' + str(page)+ '/' +str(maxpage) +'[/COLOR]',thumbnailImage=PAGING_THUMB)
            #u=sys.argv[0] + '?mode=1&mfcachetype=dir_cache_always&page='+str(page-1) +'&app_id='+urllib.quote_plus(str(app_id))+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&url=' + urllib.quote_plus(url1)+"&view_mode="+urllib.quote_plus('morefunthumb')
            #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
        for i in newses1:
            name = i["title"].encode("utf-8")
            resid = i["id"]
            resappepisodes = i["resAppEpisodes"]
            url = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/"+str(resid)+"?page_size=50&app_id=&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
            thumbnail = i["thumbnail"].encode("utf-8")
            listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
            listitem.setProperty('resappepisodes','')
            u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url) +'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+"&resappepisodes="+urllib.quote_plus(str(resappepisodes))+"&thumbnail="+urllib.quote_plus(thumbnail)+"&view_mode="+urllib.quote_plus('morefunthumb2')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(newses1))
        if int(maxpage) > page:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多 ' + str(page) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
            u=sys.argv[0] + '?mode=1&mfcachetype=dir_cache_always&page='+str(page+1) +'&app_id='+urllib.quote_plus(str(app_id))+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&url=' + urllib.quote_plus(url1)+"&view_mode="+urllib.quote_plus('morefunthumb2')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb2')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildNextLists(url,app_id,resid,page,resappepisodes,thumbnail):
    styleurl = xbmc.getInfoLabel("AppServer.IP") + "/cube/api/resources/"+str(resid)+"?page_size=100&app_id=" + str(app_id) +"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    plugin.log.debug('111111111111111111111'+styleurl)
    stylelist = GetHttpData(styleurl)
    styledata = json.JSONDecoder().decode(stylelist)
    styleurls = styledata["data"]
    appidlist = styleurls["appId"].encode("utf-8")
    applist = appidlist.split(",")
    if app_id =="":
        app_id = applist[0]
    newappidlist = ';'
    for id in applist:
        newappidlist = newappidlist + id + ';'
    title = styleurls["title"].encode("utf-8")
    areaname = styleurls["areaName"].encode("utf-8")
    stylename = styleurls["styleName"].encode("utf-8")
    year = str(styleurls["releasedOn"]).split("-")[0]
    actors = styleurls["actors"].encode("utf-8")
    description = styleurls["description"].encode("utf-8")
    episodesCount = str(styleurls["episodesCount"]) if "episodesCount" in styleurls else ''
    url = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/"+str(resid)+"/episodes?"+"page_size=100&app_id="+str(app_id)+"&page_no="+str(page)+"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    mylist = GetHttpData(url)
    data1 = json.JSONDecoder().decode(mylist)
    urls = data1["data"]
    urls1 = urls["items"]
    maxpage = urls["totalPages"]
    #if page > 1:
        #listitem=xbmcgui.ListItem('[COLOR FF004AFF]上一页  ' + str(page)+ '/' +str(maxpage) +'[/COLOR]')
        #u=sys.argv[0] + '?mode=2&mfcachetype=dir_cache_always&page='+str(page-1) +'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+ '&url=' + urllib.quote_plus(url)
        #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    for j in urls1:
        item_id = j["id"]
        name = j["title"].encode("utf-8")
        play_url = j["playUrl"].encode("utf-8")
        appspidername = j["appSpiderName"].encode("utf-8")
        listitem=xbmcgui.ListItem(name)
        listitem.setProperty('name',name)
        listitem.setProperty('playurl',play_url)
        #listitem.setProperty('appidlist',newappidlist)
        #listitem.setProperty('maxpage',str(maxpage))
        url=sys.argv[0] + '?mode=3&mfcachetype=dir_cache_always&url=' + urllib.quote_plus(play_url)+ '&item_id=' + str(item_id)+'&app_id='+urllib.quote_plus(str(app_id))+'&appspidername='+urllib.quote_plus(appspidername)+'&name='+urllib.quote_plus(name)+'&resourceTitle='+urllib.quote_plus(title)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&view_mode="+urllib.quote_plus('morefunlist')
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, False)
    #if int(maxpage) > page:
        #listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多 ' + str(page) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
        #u=sys.argv[0] + '?mode=2&mfcachetype=dir_cache_always&page='+str(page+1) +'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+ '&url=' + urllib.quote_plus(url)
        #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    #if not int(maxpage) == 1:
        #listitem=xbmcgui.ListItem('[COLOR FF004AFF]选择页数[/COLOR]',thumbnailImage=PAGING_THUMB)
        #u=sys.argv[0] + '?mode=7&maxpage='+str(maxpage) +'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+ '&url=' + urllib.quote_plus(url)
        #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunlist')
    xbmcplugin.setProperty(int(sys.argv[1]), 'title', title)
    xbmcplugin.setProperty(int(sys.argv[1]), 'areaname', areaname)
    xbmcplugin.setProperty(int(sys.argv[1]), 'stylename', stylename)
    xbmcplugin.setProperty(int(sys.argv[1]), 'year', year)
    xbmcplugin.setProperty(int(sys.argv[1]), 'actors', actors)
    xbmcplugin.setProperty(int(sys.argv[1]), 'description', description)
    xbmcplugin.setProperty(int(sys.argv[1]), 'appidlist', newappidlist)
    xbmcplugin.setProperty(int(sys.argv[1]), 'app_id', app_id)
    xbmcplugin.setProperty(int(sys.argv[1]), 'resappepisodes', resappepisodes)
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumbnail', thumbnail)
    xbmcplugin.setProperty(int(sys.argv[1]), 'maxpage', str(maxpage))
    
    xbmcplugin.setProperty(int(sys.argv[1]), 'itemId', 'morefun'+str(resid))
    xbmcplugin.setProperty(int(sys.argv[1]), 'itemType', 'morefun')
    favouriteUrl = sys.argv[0]+"?fromtype=favourite&app_id=&resid="+urllib.quote_plus(str(resid))+"&page=&resappepisodes="+urllib.quote_plus(resappepisodes)+"&thumbnail="+urllib.quote_plus(thumbnail)
    xbmcplugin.setProperty(int(sys.argv[1]), 'url', favouriteUrl)
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumb', thumbnail)
    xbmcplugin.setProperty(int(sys.argv[1]), 'playable', 'false')
    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))
    xbmcplugin.setProperty(int(sys.argv[1]), 'updateUrl', updateUrl)
    xbmcplugin.setProperty(int(sys.argv[1]), 'episodesNum', episodesCount)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))
        
def playVideo(url):
    mylist = GetHttpData(url)
    foobars = re.compile('<m3u8>(.*?)</m3u8>', re.DOTALL).findall(mylist)
    playlist = xbmc.PlayList(1)
    playlist.clear()
    for i in range(0,len(foobars)):
        title =" 第"+str(i+1)+"/"+str(len(foobars))+"节"
        listitem=xbmcgui.ListItem(title)
        listitem.setInfo(type="Video",infoLabels={"Title":title})
        playlist.add(foobars[i], listitem)
    xbmc.Player().play(playlist)

def searchkey(category_id):
    keyword = ""
    type = ""
    if category_id == "1":
        keyword = "特殊身份,古惑仔,青春如期,小时代,狄仁杰之神都龙王,不二神探,激战,速度与激情"
        type = "电影"
    elif category_id == "2":
        keyword = "特种兵之火凤凰,因为爱情有多美,万万没想到,打狗棍,千金归来,法外风云,咱们结婚吧,终极一班3"
        type = "电视剧"
    elif category_id == "14":
        keyword = "爸爸去哪儿,快乐大本营,running man,康熙来了,晓说,天天向上,非诚勿扰,我们结婚了"
        type = "综艺"
    elif category_id == "4":
        keyword = "灌篮高手,火影忍者,熊出没,奥特曼,名侦探柯南,海贼王,尸兄,我叫mt"
        type = "动漫"
    kb = Keyboard('','请输入搜索内容',keyword,type)
    kb.doModal()
    if (kb.isConfirmed()):
        keyword = kb.getText()
        if keyword !='':
            searchpage = 1
            searchlist(keyword,category_id,searchpage)
        else:
            xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
            xbmcplugin.endOfDirectory(int(sys.argv[1]))
    else:
        xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
def searchlist(keyword,category_id,searchpage):
    search_path = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/search/"+keyword+"?page_size=54"+"&page_no="+str(searchpage)+"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1383555354&security_code=ce30ea919afcc8cf731b5edf8f91ee6c&session_id=dltianwei&category_id="+str(category_id)
    search_path = eval(repr(search_path).replace("\\x","%"))
    p1 = GetHttpData(search_path)
    data = json.JSONDecoder().decode(p1)
    newses = data["data"]
    app_id = ''
    area_id = ''
    style_id = ''
    if newses != None:
        newses1 = newses["items"]
        maxpage = newses["totalPages"]
        #if page > 1:
            #listitem=xbmcgui.ListItem('[COLOR FF004AFF]上一页  ' + str(page)+ '/' +str(maxpage) +'[/COLOR]',thumbnailImage=PAGING_THUMB)
            #listitem.setProperty('previous','true')
            #u=sys.argv[0] + '?mode=1&mfcachetype=dir_cache_always&page='+str(page-1) +'&app_id='+urllib.quote_plus(str(app_id))+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&url=' + urllib.quote_plus(url1)+"&view_mode="+urllib.quote_plus('morefunthumb')
            #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
        for i in newses1:
            name = i["title"].encode("utf-8")
            resid = i["id"]
            resappepisodes = i["resAppEpisodes"]
            url = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/"+str(resid)+"?page_size=50&app_id=&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
            thumbnail = i["thumbnail"].encode("utf-8")
            listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
            u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url) +'&app_id='+urllib.quote_plus(str(app_id))+'&resid='+str(resid)+"&resappepisodes="+urllib.quote_plus(str(resappepisodes))+"&thumbnail="+urllib.quote_plus(thumbnail)+"&view_mode="+urllib.quote_plus('morefunthumb')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(newses1))
        if int(maxpage) > searchpage:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(searchpage) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
            listitem.setProperty('next','true')
            u=sys.argv[0] + '?mode=9&mfcachetype=dir_cache_always&searchpage='+str(searchpage+1) +'&app_id='+urllib.quote_plus('0')+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&keyword=' + urllib.quote_plus(keyword)+"&view_mode="+urllib.quote_plus('morefunthumb')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
        #elif maxpage == 0:
            #listitem=xbmcgui.ListItem('[COLOR FF004AFF]无数据  [/COLOR]',thumbnailImage="")
            #u=sys.argv[0] + '?mode=9&searchpage=' + str(searchpage)+"&view_mode="+urllib.quote_plus('morefunthumb')
            #xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getareas(category, category_id):
    areas = []
    if category == "movie":
        areas = movie_areas
    elif category == "tv":
        areas = tv_areas
    elif category == "show":
        areas = show_areas
    elif category == "comic":
        areas = comic_areas
    for area in areas:
        listitem=xbmcgui.ListItem(area[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus(area[0])+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus(area[1])+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1')
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getstyles(category, category_id):
    styles = []
    if category == "movie":
        styles = movie_styles
    elif category == "tv":
        styles = tv_styles
    elif category == "show":
        styles = show_styles
    elif category == "comic":
        styles = comic_styles
    for style in styles:
        listitem=xbmcgui.ListItem(style[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus(style[0])+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus(style[1])+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1')
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getyears(category_id):
    for year in years:
        listitem=xbmcgui.ListItem(year[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&mfcachetype=dir_cache_always&name="+urllib.quote_plus(year[0])+"&app_id="+urllib.quote_plus('0')+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus(year[1])+"&released_on_to="+urllib.quote_plus(year[2])+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1')
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def display_for_history(params):
    app_id = urllib.unquote_plus(params['app_id']) if 'app_id' in params else ''
    resid = urllib.unquote_plus(params['resid']) if 'resid' in params else ''
    page = urllib.unquote_plus(params['page']) if 'page' in params else ''
    resappepisodes = urllib.unquote_plus(params['resappepisodes']) if 'resappepisodes' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    buildNextLists('',app_id,resid,page,resappepisodes,thumbnail)

def display_for_favourite(params):
    display_for_history(params)

def update_favourite(params):
    resid = urllib.unquote_plus(params['resid']) if 'resid' in params else ''
    url = xbmc.getInfoLabel("AppServer.IP") + "/cube/api/resources/"+str(resid)+"?client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1382497021&security_code=53653eb0685cafe019589767103dad2f&session_id=dltianwei"
    result = GetHttpData(url)
    res = json.JSONDecoder().decode(result)
    data = res["data"] if 'data' in res else None
    if data:
        title = data["title"].encode("utf-8") if 'title' in data else ''
        thumbnail = data["thumbnail"].encode("utf-8") if 'thumbnail' in data else ''
        episodesCount = str(data["episodesCount"]) if 'episodesCount' in data else ''
        updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))
        listitem=xbmcgui.ListItem(title)
        listitem.setProperty('title',title)
        listitem.setProperty('thumb',thumbnail)
        listitem.setProperty('episodesNum',episodesCount)
        listitem.setProperty('updateUrl',updateUrl)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), updateUrl, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def get_params(url = ''):
    param = []
    paramstring = sys.argv[2] if url=='' else url
    if len(paramstring) >= 2:
        params = paramstring
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]
    return param    

