# -*- coding: utf-8 -*-
# getlist.py

import urllib,urllib2,re,xbmcplugin,xbmcgui,sys,os,os.path,xbmcaddon,xbmc
from urlparse import urljoin
import json
import gzip
import time
try:
    from cStringIO import StringIO
except ImportError:
    from StringIO import StringIO
from xbmcswift2 import Plugin
plugin = Plugin()
try:
    from MFSearchKeyboard import Keyboard
except:
    from xbmc import Keyboard
    pass

plugin_path = plugin.addon.getAddonInfo('path')
lib_path = os.path.join(plugin_path, 'lib')
__addonid__ = "plugin.video.mfworldcup"
__addon__ = xbmcaddon.Addon(id=__addonid__)
RESOURCES_PATH = os.path.join(__addon__.getAddonInfo('path'), 'media', )
PAGING_THUMB = os.path.join(RESOURCES_PATH,'paging.png')
MORE_THUMB = os.path.join(RESOURCES_PATH,'more.png')
VIDEO_THUMB = os.path.join(RESOURCES_PATH,'6sport.png')


HOST = 'http://2014.youku.com/'

def GetHttpData(url):
    req = urllib2.Request(url)
    response = urllib2.urlopen(req)
    httpdata = response.read()
    if response.headers.get('content-encoding', None) == 'gzip':
        httpdata = gzip.GzipFile(fileobj=StringIO.StringIO(httpdata)).read()
    response.close()
    match = re.compile('encodingt=(.+?)"').findall(httpdata)
    if len(match)<=0:
        match = re.compile('meta charset="(.+?)"').findall(httpdata)
    if len(match)>0:
        charset = match[0].lower()
        if (charset != 'utf-8') and (charset != 'utf8'):
            httpdata = unicode(httpdata, charset).encode('utf8')
    return httpdata

def fetch_url(url, data=None, headers={}, timeout=None, proxies=None):
    headers.setdefault(
        'User-Agent', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1872.0 Safari/537.36')  # noqa
    headers.setdefault('Accept-Encoding', 'gzip,deflate')
    if data and isinstance(data, dict):
        data = urlencode(data)
    req = urllib2.Request(url, data, headers)
    http_proxy = None
    if proxies or http_proxy:
        if not proxies:
            if isinstance(http_proxy, basestring):
                proxies = {'http': http_proxy, 'https': http_proxy}
            else:
                proxies = http_proxy
        proxy_handler = urllib2.ProxyHandler(proxies)
        opener = urllib2.build_opener(proxy_handler)
        r = opener.open(req, timeout=timeout)
    else:
        r = urllib2.urlopen(req, timeout=timeout)
    content = r.read()
    if r.headers.get('content-encoding') == 'gzip':
        content = gzip.GzipFile(fileobj=StringIO(content), mode='rb').read()
    return content

def buildRoot():
    listitem=xbmcgui.ListItem('火爆头条',thumbnailImage=VIDEO_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('火爆头条')+"&category_id="+urllib.quote_plus('1')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('每日进球',thumbnailImage=VIDEO_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('每日进球')+"&category_id="+urllib.quote_plus('2')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('赛事直击',thumbnailImage=VIDEO_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('赛事直击')+"&category_id="+urllib.quote_plus('3')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    listitem=xbmcgui.ListItem('每日话题',thumbnailImage=VIDEO_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('每日话题')+"&category_id="+urllib.quote_plus('4')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'fullwidthlist')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildLists(category_id,page,area_id,style_id,released_on_from,released_on_to,medianame):
    if category_id =='1':
        url = HOST + 'index/highlights/_page102376_'+ str(page) +'_cmodid_102376?from=y1.3-2014-index-5905-11805.102359-102360.0-10'
    elif category_id =='2':
        url = HOST + 'index/goal/_page102384_'+ str(page) +'_cmodid_102384?from=y1.3-2014-index-5905-11805.102361.0-10'
    elif category_id =='3':
        url = HOST + 'index/replay/_page102389_'+ str(page) +'_cmodid_102389?from=y1.3-2014-index-5905-11805.102364-102369.0-10'
    elif category_id =='4':
        url = HOST + 'index/special/_page102421_'+ str(page) +'_cmodid_102421?from=y1.3-2014-index-5905-11805.102364-102365.0-10'
    
    items,maxpage = get_video_list_from_url(url)
    
    for i in items:
        name = i["title"].encode("utf-8")
        resappepisodes = i["resAppEpisodes"]
        url = i["url"]
        thumbnail = i["thumbnail"].encode("utf-8")
        listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
        u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&category_id='+urllib.quote_plus(category_id)+'&resappepisodes='+urllib.quote_plus(str(resappepisodes))+ '&medianame='+urllib.quote_plus(medianame)+'&style_id=' + urllib.quote_plus(style_id)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(items))
    if int(maxpage) > int(page):
        listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多 ' + str(page) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
        u=sys.argv[0] + '?mode=1&page='+str(page+1) +'&category_id='+urllib.quote_plus(category_id)+'&area_id='+urllib.quote_plus(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&released_on_from=' + urllib.quote_plus(released_on_from)+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', medianame)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def get_video_list_from_url(url):
    items = []
    maxpage = '0'
    content = fetch_url(url)
    _RE_data = re.compile(r'<div class="yk-row">([\s\S]*?)<div class="LPageBar">[\s\S]*?')
    _RE = re.compile(
                    r'<div class="v[\s\S]*?" >[\s\S]*?<img src="([\s\S]*?)"[\s\S]*?'
                    'alt="([\s\S]*?)"[\s\S]*?'
                    'href="([\s\S]*?)"[\s\S]*?'
                    )
    if _RE_data.search(content):
        match = _RE_data.search(content)
        datapag = match.groups()[0]
        for match in _RE.finditer(str(datapag)):
            imgurl, title, detail_url= match.groups()
            episodes_num = ''
            items.append({
                'title': title,
                'url': detail_url,
                'thumbnail': imgurl,
                'resAppEpisodes':episodes_num
            })
        
        page_list = []
        _RE_PAGE = re.compile(r'<span class="pages">[\s\S]*<a onclick[\s\S]*?href="([\s\S]*?)"[\s\S]*?')
        if _RE_PAGE.search(content):
            match = _RE_PAGE.search(content)
            data = match.groups()[0]
            maxpage = data.split('_')[2]
        else:
            maxpage= 1
    return items,maxpage

def buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame,style_id):
    resid = ""
    app_id = '232'
    more_url = url
    appspidername = 'yk'
    content = fetch_url(url)
    
    resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_video_from_url(content)
    
    episodesCount = resappepisodes_mf

    items,video_maxpage = get_video_juji_list(url,name)

    for j in items:
        title = j["title"]
        play_url = j["url"]
        listitem=xbmcgui.ListItem(title)
        listitem.setProperty('name',title)
        listitem.setProperty('playurl',play_url)
        url=sys.argv[0] + '?mode=3&url=' + urllib.quote_plus(play_url)+ '&item_id='+'&app_id='+urllib.quote_plus(str(app_id))+'&appspidername='+urllib.quote_plus(appspidername)+'&name='+urllib.quote_plus(title)+'&resourceTitle='+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&page="+str(page)+'&category_id='+urllib.quote_plus(str(category_id))+"&view_mode="+urllib.quote_plus('morefunlist')
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, False)

    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunlist')
    xbmcplugin.setProperty(int(sys.argv[1]), 'title', name)
    xbmcplugin.setProperty(int(sys.argv[1]), 'areaname', areaname)
    xbmcplugin.setProperty(int(sys.argv[1]), 'stylename', stylename)
    xbmcplugin.setProperty(int(sys.argv[1]), 'year', year)
    xbmcplugin.setProperty(int(sys.argv[1]), 'actors', actors)
    xbmcplugin.setProperty(int(sys.argv[1]), 'description', description)
    xbmcplugin.setProperty(int(sys.argv[1]), 'resappepisodes', resappepisodes_mf)
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumbnail', thumbnail)

    if resid !="":
        xbmcplugin.setProperty(int(sys.argv[1]), 'itemId', 'yk'+str(resid))
        favouriteUrl = sys.argv[0]+"?fromtype=favourite&app_id=&resid="+urllib.quote_plus(str(resid))+"&page=&resappepisodes="+urllib.quote_plus(resappepisodes)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&category_id="+urllib.quote_plus(category_id)+"&url="+urllib.quote_plus(more_url)+"&title="+urllib.quote_plus(name)+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.setProperty(int(sys.argv[1]), 'url', favouriteUrl)

    xbmcplugin.setProperty(int(sys.argv[1]), 'itemType', 'youku')
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumb', thumbnail)
    xbmcplugin.setProperty(int(sys.argv[1]), 'playable', 'false')
    xbmcplugin.setProperty(int(sys.argv[1]), 'morefuntvsource', "false")
    xbmcplugin.setProperty(int(sys.argv[1]), 'episodesNum', episodesCount)
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', medianame)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def get_detail_video_from_url(content):
    _RE_resid = re.compile(r"var videoId2= '([\s\S]*?)'")
    for match in _RE_resid.finditer(content):
        resid = match.groups()[0]
        resid = str(resid).replace(' ', '')
    
    _RE_description = re.compile(r'<div class="yk-videoinfo">[\s\S]*?id="text_long"[\s\S]*?>([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    
    year = '2014'
    actors = ''
    areaname = ''
    stylename = '优酷体育'
    episodescount = "1"
    return resid,actors,stylename,areaname,year,description,episodescount

def get_video_juji_list(url,name):
    items = []
    items.append({'title': name,'url':url})
    return items,1

def display_for_history(params):
    app_id = urllib.unquote_plus(params['app_id']) if 'app_id' in params else ''
    category_id = urllib.unquote_plus(params['category_id']) if 'category_id' in params else ''
    url = urllib.unquote_plus(params['url']) if 'url' in params else ''
    name = urllib.unquote_plus(params['title']) if 'title' in params else ''
    if name == "" or name == None:
        name = urllib.unquote_plus(params['name']) if 'name' in params else ''
    page = urllib.unquote_plus(params['page']) if 'page' in params else ''
    resappepisodes = urllib.unquote_plus(params['resappepisodes']) if 'resappepisodes' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    medianame = urllib.unquote_plus(params['medianame']) if 'medianame' in params else ''
    style_id = urllib.unquote_plus(params['style_id']) if 'style_id' in params else ''
    buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame,style_id)

def display_for_favourite(params):
    display_for_history(params)

def get_params(url = ''):
    param = []
    paramstring = sys.argv[2] if url=='' else url
    if len(paramstring) >= 2:
        params = paramstring
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]
    return param