# -*- coding: utf-8 -*-
# getlist.py

import urllib,urllib2,re,xbmcplugin,xbmcgui,sys,os,os.path,xbmcaddon,xbmc
from urlparse import urljoin
import json
import gzip
try:
    from cStringIO import StringIO
except ImportError:
    from StringIO import StringIO
from xbmcswift2 import Plugin
plugin = Plugin()
try:
    from MFSearchKeyboard import Keyboard
except:
    from xbmc import Keyboard
    pass



plugin_path = plugin.addon.getAddonInfo('path')
lib_path = os.path.join(plugin_path, 'lib')

import time


__addonid__ = "plugin.video.mfyouku"
__addon__ = xbmcaddon.Addon(id=__addonid__)
RESOURCES_PATH = os.path.join(__addon__.getAddonInfo('path'), 'media', )
PAGING_THUMB = os.path.join(RESOURCES_PATH,'paging.png')
MORE_THUMB = os.path.join(RESOURCES_PATH,'more.png')
MOVIE_THUMB = os.path.join(RESOURCES_PATH,'1movie.png')
TV_THUMB = os.path.join(RESOURCES_PATH,'2tv.png')
COMIC_THUMB = os.path.join(RESOURCES_PATH,'3comic.png')
SHOW_THUMB = os.path.join(RESOURCES_PATH,'4show.png')
INFO_THUMB = os.path.join(RESOURCES_PATH,'5info.png')
EDU_THUMB = os.path.join(RESOURCES_PATH,'6educate.png')
REC_THUMB = os.path.join(RESOURCES_PATH,'7recoder.png')
MUSIC_THUMB = os.path.join(RESOURCES_PATH,'8music.png')
FUN_THUMB = os.path.join(RESOURCES_PATH,'9fun.png')
SPORT_THUMB = os.path.join(RESOURCES_PATH,'10sport.png')
CAR_THUMB = os.path.join(RESOURCES_PATH,'11car.png')
SCIENCE_THUMB = os.path.join(RESOURCES_PATH,'12science.png')
GAMES_THUMB = os.path.join(RESOURCES_PATH,'13games.png')
LIFE_THUMB = os.path.join(RESOURCES_PATH,'14life.png')
STYLE_THUMB = os.path.join(RESOURCES_PATH,'15style.png')
TRIP_THUMB = os.path.join(RESOURCES_PATH,'16trip.png')
MOM_BABY_THUMB = os.path.join(RESOURCES_PATH,'17mom&baby.png')
JOCK_THUMB = os.path.join(RESOURCES_PATH,'18jock.png')
CREATION_THUMB = os.path.join(RESOURCES_PATH,'19creation.png')
AD_THUMB = os.path.join(RESOURCES_PATH,'20ad.png')

movie_areas = [['全部', ''], ['大陆', '大陆'], ['香港', '香港'], ['台湾', '台湾'], ['韩国', '韩国'], ['美国', '美国'], ['法国', '法国'], ['英国', '英国'], ['德国', '德国'], ['意大利', '意大利'], ['加拿大', '加拿大'], ['印度', '印度'], ['俄罗斯', '俄罗斯'], ['泰国', '泰国'], ['其他', '其他']]
movie_styles = [['全部', ''], ['武侠', '武侠'], ['警匪', '警匪'], ['犯罪', '犯罪'], ['科幻', '科幻'], ['战争', '战争'], ['恐怖', '恐怖'], ['惊悚', '惊悚'], ['纪录片', '纪录片'], ['西部', '西部'], ['戏曲', '戏曲'], ['歌舞', '歌舞'], ['奇幻', '奇幻'], ['冒险', '冒险'], ['悬疑', '悬疑'], ['历史', '历史'], ['动作', '动作'], ['传记', '传记'], ['动画', '动画'], ['儿童', '儿童'], ['喜剧', '喜剧'], ['爱情', '爱情'], ['剧情', '剧情'], ['运动', '运动'], ['短片', '短片'], ['优酷出品', '优酷出品']]

tv_areas = [['全部', ''], ['大陆', '大陆'], ['香港', '香港'], ['台湾', '台湾'], ['韩国', '韩国'], ['美国', '美国'], ['英国', '英国'], ['泰国', '泰国'], ['新加坡', '新加坡']]
tv_styles = [['全部', ''], ['古装', '古装'], ['武侠', '武侠'], ['警匪', '警匪'], ['军事', '军事'], ['神话', '神话'], ['科幻', '科幻'], ['悬疑', '悬疑'], ['历史', '历史'], ['儿童', '儿童'], ['农村', '农村'], ['都市', '都市'], ['家庭', '家庭'], ['搞笑', '搞笑'], ['偶像', '偶像'], ['言情', '言情'], ['时装', '时装'], ['优酷出品', '优酷出品']]

show_areas = [['全部', ''], ['大陆', '大陆'], ['香港', '香港'], ['台湾', '台湾'], ['韩国', '韩国'], ['日本', '日本'], ['美国', '美国'], ['澳大利亚', '澳大利亚']]
show_styles = [['全部', ''], ['优酷出品', '优酷出品'], ['优酷牛人', '优酷牛人'], ['脱口秀', '脱口秀'], ['真人秀', '真人秀'], ['选秀', '选秀'], ['美食', '美食'], ['旅游', '旅游'], ['汽车', '汽车'], ['访谈', '访谈'], ['纪实', '纪实'], ['搞笑', '搞笑'], ['时尚', '时尚'], ['晚会', '晚会'], ['理财', '理财'], ['演唱会', '演唱会'], ['曲艺', '曲艺'], ['益智', '益智'], ['音乐', '音乐'], ['舞蹈', '舞蹈'], ['体育娱乐', '体育娱乐'], ['游戏', '游戏'], ['生活', '生活']]

comic_areas = [['全部', ''], ['大陆', '大陆'], ['日本', '日本'], ['美国', '美国'], ['台湾', '台湾'], ['香港', '香港'], ['韩国', '韩国'], ['英国', '英国'], ['法国', '法国']]
comic_styles = [['全部', ''], ['热血', '热血'], ['格斗', '格斗'], ['恋爱', '恋爱'], ['美少女', '美少女'], ['校园', '校园'], ['搞笑', '搞笑'], ['LOLI', 'LOLI'], ['神魔', '神魔'], ['机战', '机战'], ['科幻', '科幻'], ['真人', '真人'], ['青春', '青春'], ['魔法', '魔法'], ['神话', '神话'], ['冒险', '冒险'], ['运动', '运动'], ['竞技', '竞技'], ['童话', '童话'], ['亲子', '亲子'], ['教育', '教育'], ['励志', '励志'], ['剧情', '剧情'], ['社会', '社会'], ['历史', '历史'], ['战争', '战争']]

info_areas = [['全部', ''],['国内','国内'],['国际','国际']]
info_styles = [['全部', ''],['时政','时政'],['财经','财经'],['社会','社会'],['生活','生活'],['军事','军事'],['科技','科技'],['体育','体育'],['公益','公益']]

edu_styles = [['全部', ''],['文化','文化'],['艺术','艺术'],['理工','理工'],['历史','历史'],['经济','经济'],['政治','政治'],['外语','外语'],['法律','法律'],['哲学','哲学'],['公开课程','公开课'],['心理学科','心理学'],['管理学科','管理学'],['计算机学','计算机'],['名人名嘴','名人名嘴'],['伦理社会','伦理社会'],['职业培训','职业培训'],['家庭教育','家庭教育']]

rec_styles = [['全部', ''],['人物','人物'],['军事','军事'],['历史','历史'],['自然','自然'],['古迹','古迹'],['探险','探险'],['科技','科技'],['文化','文化'],['刑侦','刑侦'],['社会','社会'],['旅游','旅游']]

music_areas = [['全部', ''],['大陆','大陆'],['港台','港台'],['日韩','日韩'],['欧美','欧美'],['其他','其他']]
music_styles = [['全部', ''],['流行','流行'],['摇滚','摇滚'],['舞曲','舞曲'],['电子','电子'],['R&B','R&B'],['HIP-HOP','HIP-HOP'],['乡村','乡村'],['民族','民族'],['民谣','民谣'],['拉丁','拉丁'],['爵士','爵士'],['雷鬼','雷鬼'],['新世纪','新世纪'],['古典','古典'],['音乐剧','音乐剧'],['轻音乐','轻音乐']]

fun_styles = [['全部', ''],['娱乐资讯','2146'],['电视资讯','2077'],['电影资讯','2067'],['音乐资讯','2142'],['颁奖礼','2076'],['戏剧','2312'],['曲艺','2309'],['艺术','2311'],['魔术','2350']]

sport_styles = [['全部', ''],['体育资讯','2121'],['篮球','2086'],['CBA','2114'],['足球','2085'],['英超','2108'],['极限运动','2104'],['跑酷','2103'],['自行车','2102'],['轮滑','2101'],['滑板','2355'],['武术','2099'],['格斗','2095'],['赛车','2362'],['大球运动','2087'],['小球运动','2097'],['网球','2088'],['田径','2093'],['水上项目','2092'],['力量项目','2096'],['冰雪项目','2361'],['射击','2360'],['健身','2359'],['竞技舞蹈','2358'],['技巧','2091'],['棋牌','2357'],['模型','2356'],['其他','2105'],['奥运会','2120'],['欧洲杯','2118']]

car_styles = [['全部', ''],['车讯','263'],['购车','291'],['试驾','277'],['新车','290'],['国产车','276'],['欧洲','304'],['美国','305'],['日韩','303'],['其他地区','306'],['宝马','289'],['通用','293'],['丰田','294'],['福特','295'],['大众','296'],['戴姆勒-克莱斯勒','297'],['现代-起亚','298'],['日产','299'],['标致-雪铁龙','300'],['本田','301'],['雷诺','302'],['养车','292'],['修车','268'],['改装','270'],['装饰','286'],['赛车','2094'],['二手车','275'],['名车','264'],['车女郎','265'],['车广告','266'],['学车','267'],['飙车','269'],['车友会','278'],['摩托车','307'],['F1','2119']]

science_styles = [['全部', ''],['数码','259'],['App','3056'],['游戏机','2340'],['GPS','2339'],['数字家电','2338'],['MP3/MP4','2337'],['DC/DV','2336'],['笔记本','2335'],['手机','2334'],['IT','262'],['平板','3057']]

games_styles = [['全部', ''],['游戏资讯','2222'],['网络游戏','2221'],['游戏音乐','2213'],['电子竞技','2218'],['单机游戏','2219'],['魔兽世界','2230'],['地下城与勇士','2231'],['手机游戏','2352']]

life_styles = [['全部', ''],['休闲','240'],['潮品','3061'],['婚恋','3060'],['女性','2341'],['家居','2327'],['健康','2326'],['理财','248'],['居家','247'],['宠物','244'],['聚会','243'],['美食','242'],['记录','3062']]

style_styles = [['全部', ''],['美容','2319'],['修身','2320'],['服装服饰','2321'],['时尚购物','2322'],['潮人','2323'],['情感星座','2324']]

trip_styles = [['全部', ''],['城市','2342'],['户外运动','2348'],['节庆活动','2347'],['自然景点','2346'],['人文景点','2345'],['游轮岛屿','2344'],['乡村古镇','2343'],['旅游用品','2333'],['交通住宿','2332'],['旅游业界','2331'],['出境游','2330'],['国内游','2329'],['攻略指南','2349']]

mom_baby_styles = [['全部', ''],['育儿','2314'],['宝宝秀','2315'],['妈妈','2316'],['早教','2317'],['怀孕','2318'],['搞笑儿童','237']]

jock_styles = [['全部', ''],['恶搞短片','235'],['搞笑自拍','236'],['搞笑动物','238']]

creation_styles = [['全部', ''],['原创DV','2153'],['自拍作品','2149'],['改编','2151'],['记录','2150']]

full_years = [['全部', '', ''], ['2014', '2014', ''], ['2013', '2013', ''], ['2012', '2012', ''], ['2011', '2011', ''], ['2010', '2010', ''], ['00年代', '2000', ''], ['90年代', '1990', ''], ['80年代', '1980', ''], ['70年代', '1970', ''], ['更早', '-1969', '']]

void_years = []

void_areas = []

void_styles = []

HOST = 'http://www.youku.com/'


def GetHttpData(url):
    req = urllib2.Request(url)
    response = urllib2.urlopen(req)
    httpdata = response.read()
    if response.headers.get('content-encoding', None) == 'gzip':
        httpdata = gzip.GzipFile(fileobj=StringIO.StringIO(httpdata)).read()
    response.close()
    match = re.compile('encodingt=(.+?)"').findall(httpdata)
    if len(match)<=0:
        match = re.compile('meta charset="(.+?)"').findall(httpdata)
    if len(match)>0:
        charset = match[0].lower()
        if (charset != 'utf-8') and (charset != 'utf8'):
            httpdata = unicode(httpdata, charset).encode('utf8')
    return httpdata

def fetch_url(url, data=None, headers={}, timeout=None, proxies=None):
    headers.setdefault(
        'User-Agent', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1872.0 Safari/537.36')  # noqa
    headers.setdefault('Accept-Encoding', 'gzip,deflate')
    if data and isinstance(data, dict):
        data = urlencode(data)
    req = urllib2.Request(url, data, headers)
    http_proxy = None
    if proxies or http_proxy:
        if not proxies:
            if isinstance(http_proxy, basestring):
                proxies = {'http': http_proxy, 'https': http_proxy}
            else:
                proxies = http_proxy
        proxy_handler = urllib2.ProxyHandler(proxies)
        opener = urllib2.build_opener(proxy_handler)
        r = opener.open(req, timeout=timeout)
    else:
        r = urllib2.urlopen(req, timeout=timeout)
    content = r.read()
    if r.headers.get('content-encoding') == 'gzip':
        content = gzip.GzipFile(fileobj=StringIO(content), mode='rb').read()
    return content

def buildRoot():
    listitem=xbmcgui.ListItem('电影',thumbnailImage=MOVIE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('电影')+"&category_id="+urllib.quote_plus('96')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('movie')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('电视剧',thumbnailImage=TV_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('电视剧')+"&category_id="+urllib.quote_plus('97')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('tv')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('综艺',thumbnailImage=SHOW_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('综艺')+"&category_id="+urllib.quote_plus('85')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('show')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('动漫',thumbnailImage=COMIC_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('动漫')+"&category_id="+urllib.quote_plus('100')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('comic')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('资讯',thumbnailImage=INFO_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('资讯')+"&category_id="+urllib.quote_plus('91')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('info')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('教育',thumbnailImage=EDU_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('教育')+"&category_id="+urllib.quote_plus('87')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('education')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('纪录片',thumbnailImage=REC_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('纪录片')+"&category_id="+urllib.quote_plus('84')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('recoder')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('音乐',thumbnailImage=MUSIC_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('音乐')+"&category_id="+urllib.quote_plus('95')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('music')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('娱乐',thumbnailImage=FUN_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('娱乐')+"&category_id="+urllib.quote_plus('86')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('fun')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('体育',thumbnailImage=SPORT_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('体育')+"&category_id="+urllib.quote_plus('98')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('sport')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('汽车',thumbnailImage=CAR_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('汽车')+"&category_id="+urllib.quote_plus('104')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('car')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('科技',thumbnailImage=SCIENCE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('科技')+"&category_id="+urllib.quote_plus('105')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('science')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('游戏',thumbnailImage=GAMES_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('游戏')+"&category_id="+urllib.quote_plus('99')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('games')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('生活',thumbnailImage=LIFE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('生活')+"&category_id="+urllib.quote_plus('103')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('life')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('时尚',thumbnailImage=STYLE_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('时尚')+"&category_id="+urllib.quote_plus('89')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('style')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('旅游',thumbnailImage=TRIP_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('旅游')+"&category_id="+urllib.quote_plus('88')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('trip')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('母婴',thumbnailImage=MOM_BABY_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('母婴')+"&category_id="+urllib.quote_plus('90')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('mom_baby')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('搞笑',thumbnailImage=JOCK_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('搞笑')+"&category_id="+urllib.quote_plus('94')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('jock')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('广告',thumbnailImage=AD_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('广告')+"&category_id="+urllib.quote_plus('102')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('ad')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    listitem=xbmcgui.ListItem('原创',thumbnailImage=CREATION_THUMB)
    url=sys.argv[0]+"?mode=1&medianame="+urllib.quote_plus('原创')+"&category_id="+urllib.quote_plus('92')+"&area_id="+urllib.quote_plus('')+"&style_id="+urllib.quote_plus('')+"&released_on_from="+urllib.quote_plus('')+"&released_on_to="+urllib.quote_plus('')+"&page_size="+urllib.quote_plus('50')+"&type="+urllib.quote_plus('1')+"&page="+urllib.quote_plus('1')+"&need_type="+urllib.quote_plus('creation')
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def buildLists(category_id,page,area_id,style_id,released_on_from,released_on_to,medianame):
    if category_id == '96':
        url = HOST + 'v_olist/c_' + str(category_id) + '_g_' + str(style_id) + '_a_' + str(area_id) + '_r_' + str(released_on_from) + '_p_' + str(page) + '_u_1_pt_1.html'
    elif category_id == '97' or category_id == '100' or category_id == '85' or category_id == '91' or category_id == '87' or category_id == '84' or category_id == '95':
        url = HOST + 'v_olist/c_' + str(category_id) + '_g_' + str(style_id) + '_a_' + str(area_id) + '_r_' + str(released_on_from) + '_p_' + str(page) + '_pt_1.html'
    elif category_id == '86' or category_id == '98' or category_id == '104' or category_id == '105' or category_id == '99' or category_id == '103' or category_id == '89' or category_id == '88' or category_id == '90' or category_id == '94' or category_id == '102':
        url = HOST + 'v_showlist/c' + str(category_id) + 'g' + str(style_id) + 'd1s1p' + str(page) + '.html'
    else :
        url = HOST + 'v_showlist/c' + str(category_id) + 'g' + str(style_id) + 'd4s1p' + str(page) + '.html'
    
    if category_id == '96':
        items,maxpage = get_movies_from_url(url)
    elif category_id == '97' or category_id == '100' or category_id == '85' or category_id == '91' or category_id == '87' or category_id == '84':
        items,maxpage = get_resources_from_url(url,category_id)
    else:
        items,maxpage = get_other_from_url(url)
    for i in items:
        name = i["title"].encode("utf-8")
        resappepisodes = i["resAppEpisodes"]
        url = i["url"]
        thumbnail = i["thumbnail"].encode("utf-8")
        listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
        if category_id == "97" or category_id == "100" or category_id == "85" or category_id == "91" or category_id == "87" or category_id == "84":
            listitem.setProperty('v360resappepisodes',resappepisodes)
        u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&category_id='+urllib.quote_plus(category_id)+'&resappepisodes='+urllib.quote_plus(str(resappepisodes))+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(items))
    if int(maxpage) > int(page):
        listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多 ' + str(page) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
        u=sys.argv[0] + '?mode=1&page='+str(page+1) +'&category_id='+urllib.quote_plus(category_id)+'&area_id='+urllib.quote_plus(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&released_on_from=' + urllib.quote_plus(released_on_from)+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb2')
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', medianame)
    if category_id == '96' or category_id == '97' or category_id == '85' or category_id == '100':
        xbmcplugin.setProperty(int(sys.argv[1]),'search_show','able')
    else:
        xbmcplugin.setProperty(int(sys.argv[1]),'search_show','unable')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def get_movies_from_url(url):
    content = fetch_url(url)
    _RE = re.compile(
        r'<div class="yk-col3">[\s\S]*?<img src="(.+?)"[\s\S]*?'
        'alt="(.+?)"[\s\S]*?'
        '<div class="p-link">[\s\S]*?<a href="(.+?)"[\s\S]*?')
    items = []
    for match in _RE.finditer(content):
        imgurl, title, detail_url = match.groups()
        items.append({
            'title': title,
            'url': detail_url,
            'thumbnail': imgurl,
            'resAppEpisodes':'1集全'
        })
        
    maxpage = '0'
    _RE_PAGE1 = re.compile(r'<div class="yk-pager">([\s\S]*?)</div>[\s\S]*?')
    _RE_PAGE2 = re.compile(r'<ul class="yk-pages">[\s\S]*<li><a href=[\s\S]*?>([\s\S]*?)</a></li>[\s\S]*?')
    for match in _RE_PAGE1.finditer(content):
        datapag =match.groups()[0]
        match_page = _RE_PAGE2.search(datapag)
        if match_page:
            maxpage = match_page.groups('')[0]
        else:
            maxpage= 1
            
    return items,maxpage

def get_resources_from_url(url,category_id):
    content = fetch_url(url)
    _RE = re.compile(
        r'<div class="yk-col3">[\s\S]*?<img[\s\S]*?src="(.+?)"[\s\S]*?'
        'alt="(.+?)"[\s\S]*?'
        '<span class="p-status">(.+?)</span>[\s\S]*?'
        '<a[\s\S]*?href="(.+?)"[\s\S]*?'
        )
    items = []
    for match in _RE.finditer(content):
        imgurl, title, episodes_num, detail_url = match.groups()
        items.append({
            'title': title,
            'url': detail_url,
            'thumbnail': imgurl,
            'resAppEpisodes':episodes_num if category_id != '96' else '1集全'
        })
        
    maxpage = '0'
    _RE_PAGE1 = re.compile(r'<div class="yk-pager">([\s\S]*?)</div>[\s\S]*?')
    _RE_PAGE2 = re.compile(r'<ul class="yk-pages">[\s\S]*<li><a href=[\s\S]*?>([\s\S]*?)</a></li>[\s\S]*?')
    for match in _RE_PAGE1.finditer(content):
        datapag =match.groups()[0]
        match_page = _RE_PAGE2.search(datapag)
        if match_page:
            maxpage = match_page.groups('')[0]
        else:
            maxpage= 1

    return items,maxpage

def get_other_from_url(url):
    content = fetch_url(url)
    _RE = re.compile(
        r'<div class="yk-col4">[\s\S]*?<img[\s\S]*?src="(.+?)"[\s\S]*?'
        'alt="(.+?)"[\s\S]*?'
        '<a[\s\S]*?href="(.+?)"[\s\S]*?')
    items = []
    for match in _RE.finditer(content):
        imgurl, title, detail_url = match.groups()
        items.append({
            'title': title,
            'url': detail_url,
            'thumbnail': imgurl,
            'resAppEpisodes':'1集全'
        })
        
    maxpage = '0'
    _RE_PAGE1 = re.compile(r'<div class="yk-pager">([\s\S]*?)</div>[\s\S]*?')
    _RE_PAGE2 = re.compile(r'<ul class="yk-pages">[\s\S]*<li><a href=[\s\S]*?>([\s\S]*?)</a></li>[\s\S]*?')
    for match in _RE_PAGE1.finditer(content):
        datapag =match.groups()[0]
        match_page = _RE_PAGE2.search(datapag)
        if match_page:
            maxpage = match_page.groups('')[0]
        else:
            maxpage= 1
            
    return items,maxpage

def buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame):
    resid = ""
    more_url = url
    content = fetch_url(url)
    if page == "":
        page = "1"
    
    if category_id == "96":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_dianying_from_url(content)
    elif category_id == "97":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_dianshi_from_url(content)
    elif category_id == "85":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_zongyi_from_url(content)
    elif category_id == "100":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_dongman_from_url(content)
    elif category_id == "91":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_zixun_from_url(content)
    elif category_id == "87":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_jiaoyu_from_url(content)
    elif category_id == "84":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_jilupian_from_url(content)
    elif category_id == "95":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_yinyue_from_url(content)
    elif category_id == "86":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_yule_from_url(content)
    elif category_id == "89":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_shishang_from_url(content)
    elif category_id == "88":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_lvyou_from_url(content)
    elif category_id == "92":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_yuanchuang_from_url(content)
    else:
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_other_from_url(content)
    
    episodesCount = resappepisodes_mf
    app_id = '232'
    appspidername = 'yk'
    
    if category_id == "96":
        items,video_maxpage = get_dy_juji_list(content,name)
    elif category_id == "97":
        items,video_maxpage = get_ds_juji_list(url,page)
    elif category_id == "85":
        items,video_maxpage = get_zy_juji_list(url,page)
    elif category_id == "100":
        items,video_maxpage = get_dm_juji_list(url,page)
    elif category_id == "91":
        items,video_maxpage = get_zx_juji_list(url,page)
    elif category_id == "87":
        items,video_maxpage = get_jy_juji_list(url,page)
    elif category_id == "84":
        items,video_maxpage = get_jlp_juji_list(url,page)
    else:
        items,video_maxpage = get_other_juji_list(url,name)
    
    for j in items:
        title = j["title"]
        play_url = j["url"]
        listitem=xbmcgui.ListItem(title)
        listitem.setProperty('name',title)
        listitem.setProperty('playurl',play_url)
        url=sys.argv[0] + '?mode=3&url=' + urllib.quote_plus(play_url)+ '&item_id='+'&app_id='+urllib.quote_plus(str(app_id))+'&appspidername='+urllib.quote_plus(appspidername)+'&name='+urllib.quote_plus(title)+'&resourceTitle='+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&page="+str(page)+'&category_id='+urllib.quote_plus(str(category_id))+"&view_mode="+urllib.quote_plus('morefunlist')
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, False)
    
    if (int(page) < int(video_maxpage)) and (11<=int(page) or category_id == "85" or category_id == "91" or category_id == "87" or category_id == "84"):
        if len(items)>0:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' +'[/COLOR]',thumbnailImage=MORE_THUMB)
            listitem.setProperty('next','true')
            url=sys.argv[0]+'?mode=2&page='+str(int(page)+1) +'&category_id='+str(category_id)+ '&url=' + urllib.quote_plus(more_url)+ '&name=' + urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&resappepisodes="+urllib.quote_plus(resappepisodes)+ '&medianame='+urllib.quote_plus(medianame)
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
        else:
            plugin.notify('没有更多数据', delay=2000)
            return
            
    resappepisodes = resappepisodes.replace('更新至','').replace('集全','')
    if resappepisodes.isdigit():
        if category_id == "97" or category_id == "100":
            maxpage = video_maxpage
            xbmcplugin.setProperty(int(sys.argv[1]), 'maxpage', str(maxpage))
    
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunlist')
    xbmcplugin.setProperty(int(sys.argv[1]), 'title', name)
    xbmcplugin.setProperty(int(sys.argv[1]), 'areaname', areaname)
    xbmcplugin.setProperty(int(sys.argv[1]), 'stylename', stylename)
    xbmcplugin.setProperty(int(sys.argv[1]), 'year', year)
    xbmcplugin.setProperty(int(sys.argv[1]), 'actors', actors)
    xbmcplugin.setProperty(int(sys.argv[1]), 'description', description)
    xbmcplugin.setProperty(int(sys.argv[1]), 'resappepisodes', resappepisodes_mf)
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumbnail', thumbnail)
    
    if resid !="":
        xbmcplugin.setProperty(int(sys.argv[1]), 'itemId', 'yk'+str(resid))
        favouriteUrl = sys.argv[0]+"?fromtype=favourite&app_id=&resid="+urllib.quote_plus(str(resid))+"&page=&resappepisodes="+urllib.quote_plus(resappepisodes)+"&thumbnail="+urllib.quote_plus(thumbnail)+"&category_id="+urllib.quote_plus(category_id)+"&url="+urllib.quote_plus(more_url)+"&title="+urllib.quote_plus(name)+ '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.setProperty(int(sys.argv[1]), 'url', favouriteUrl)
    
    xbmcplugin.setProperty(int(sys.argv[1]), 'itemType', 'youku')
    xbmcplugin.setProperty(int(sys.argv[1]), 'thumb', thumbnail)
    xbmcplugin.setProperty(int(sys.argv[1]), 'playable', 'false')
    xbmcplugin.setProperty(int(sys.argv[1]), 'morefuntvsource', "false")
    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))+"&url="+urllib.quote_plus(more_url)+"&category_id="+urllib.quote_plus(category_id)+"&title="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)
    if (category_id == "97" or category_id == "100" or category_id == "87" or category_id == "84") and episodesCount != "":
        xbmcplugin.setProperty(int(sys.argv[1]), 'updateUrl', updateUrl)
    xbmcplugin.setProperty(int(sys.argv[1]), 'episodesNum', episodesCount)
    xbmcplugin.setProperty(int(sys.argv[1]), 'SencondFolder', medianame)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
    
def get_detail_dianying_from_url(content):
    _RE = re.compile(r"window.g_config={[\s\S]*?id:'([\s\S]*?)'[\s\S]*?")
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_year = re.compile(r'<span class="name">[\s\S]*?<span class="pub">(.+?)</span>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
    else:
        year = ''

    _RE_area = re.compile(r'<span class="area">\s*?<label>地区:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_area.search(content):
        match = _RE_area.search(content)
        area = match.groups()[0]
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''

    _RE_type = re.compile(r'<span class="type">\s*?<label>类型:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    _RE_actor = re.compile(r'<span class="actor">\s*?<label>主演:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        actors = ''

    _RE_description = re.compile(r'<span class="short" style="display:block;">([\s\S]*?)</span>[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =re.sub('<[\s\S]*?>','',description)
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    episodescount = "1"
    return resid,actors,stylename,areaname,year,description,episodescount


def get_detail_dianshi_from_url(content):
    iteam =[]
    _RE1 = re.compile(r'(\d+)')
    _RE = re.compile(r"window.g_config={[\s\S]*?id:'([\s\S]*?)'[\s\S]*?")
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_year = re.compile(r'<span class="name">[\s\S]*?<span class="pub">(.+?)</span>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
    else:
        year = ''

    _RE_area = re.compile(r'<span class="area">\s*?<label>地区:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_area.search(content):
        match = _RE_area.search(content)
        area = match.groups()[0]
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''

    _RE_type = re.compile(r'<span class="type">\s*?<label>类型:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    _RE_actor = re.compile(r'<span class="actor">\s*?<label>主演:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        actors = ''

    _RE_episodescount = re.compile(r'<div class="basenotice">([\s\S]*?)<[\s\S]*?')
    if _RE_episodescount.search(content):
        match = _RE_episodescount.search(content)
        episodescount = match.groups()[0]
        for match in _RE1.finditer(str(episodescount)):
            episodescount = match.groups()[0]
            iteam.append(episodescount)
            episodescount=iteam[0]
    else:
        episodescount = ''

    _RE_description = re.compile(r'<span class="short" id="show_info_short" style="display: inline;">([\s\S]*?)</span>[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =re.sub('<[\s\S]*?>','',description)
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_zongyi_from_url(content):
    _RE = re.compile(r"window.g_config={[\s\S]*?id:'([\s\S]*?)'[\s\S]*?")
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_area = re.compile(r'<span class="area">\s*?<label>地区:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_area.search(content):
        match = _RE_area.search(content)
        area = match.groups()[0]
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''

    _RE_type = re.compile(r'<span class="type">\s*?<label>类型:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    _RE_actor = re.compile(r'<span class="host">\s*?<label>主持人:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\t', '').replace('\n', '')
    else:
        actors = ''

    _RE_description = re.compile(r'<span class="short" id="show_info_short" style="display: inline;">([\s\S]*?)</span>[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =re.sub('<[\s\S]*?>','',description)
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    year = ''
    episodescount = ''
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_dongman_from_url(content):
    iteam =[]
    _RE1 = re.compile(r'(\d+)')
    _RE = re.compile(r"window.g_config={[\s\S]*?id:'([\s\S]*?)'[\s\S]*?")
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_year = re.compile(r'<span class="name">[\s\S]*?<span class="pub">(.+?)</span>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
    else:
        year = ''

    _RE_area = re.compile(r'<span class="area">\s*?<label>地区:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_area.search(content):
        match = _RE_area.search(content)
        area = match.groups()[0]
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''

    _RE_type = re.compile(r'<span class="type">\s*?<label>类型:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    _RE_episodescount = re.compile(r'<div class="basenotice">([\s\S]*?)<[\s\S]*?')
    if _RE_episodescount.search(content):
        match = _RE_episodescount.search(content)
        episodescount = match.groups()[0]
        for match in _RE1.finditer(str(episodescount)):
            episodescount = match.groups()[0]
            iteam.append(episodescount)
            episodescount=iteam[0]
    else:
        episodescount = ''

    _RE_description = re.compile(r'<span class="short" id="show_info_short" style="display: inline;">([\s\S]*?)</span>[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =re.sub('<[\s\S]*?>','',description)
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    actors = ""

    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_zixun_from_url(content):
    iteam =[]
    _RE1 = re.compile(r'(\d+)')
    _RE = re.compile(r"window.g_config={[\s\S]*?id:'([\s\S]*?)'[\s\S]*?")
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_area = re.compile(r'<span class="area">\s*?<label>地区:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_area.search(content):
        match = _RE_area.search(content)
        area = match.groups()[0]
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''

    _RE_type = re.compile(r'<span class="type">\s*?<label>类型:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    _RE_actor = re.compile(r'<span class="host">\s*?<label>主持人:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\t', '').replace('\n', '')
    else:
        actors = ''

    _RE_episodescount = re.compile(r'<div class="basenotice">([\s\S]*?)<[\s\S]*?')
    if _RE_episodescount.search(content):
        match = _RE_episodescount.search(content)
        episodescount = match.groups()[0]
        for match in _RE1.finditer(str(episodescount)):
            episodescount = match.groups()[0]
            iteam.append(episodescount)
            episodescount=iteam[0]
    else:
        episodescount = ''

    _RE_description = re.compile(r'<span class="short" id="show_info_short" style="display: inline;">([\s\S]*?)</span>[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =re.sub('<[\s\S]*?>','',description)
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    year = ''
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_jilupian_from_url(content):
    iteam =[]
    _RE1 = re.compile(r'(\d+)')
    _RE = re.compile(r"window.g_config={[\s\S]*?id:'([\s\S]*?)'[\s\S]*?")
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_type = re.compile(r'<span class="type">\s*?<label>类型:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    _RE_actor = re.compile(r'<label>主持人:</label>[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\t', '').replace('\n', '')
    else:
        actors = ''

    _RE_episodescount = re.compile(r'<div class="basenotice">([\s\S]*?)<[\s\S]*?')
    if _RE_episodescount.search(content):
        match = _RE_episodescount.search(content)
        episodescount = match.groups()[0]
        for match in _RE1.finditer(str(episodescount)):
            episodescount = match.groups()[0]
            iteam.append(episodescount)
            episodescount=iteam[0]
    else:
        episodescount = ''

    _RE_description = re.compile(r'<span class="short" id="show_info_short" style="display: inline;">([\s\S]*?)</span>[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =re.sub('<[\s\S]*?>','',description)
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    year = ''
    areaname = ''

    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_jiaoyu_from_url(content):
    iteam =[]
    _RE1 = re.compile(r'(\d+)')
    _RE = re.compile(r"window.g_config={[\s\S]*?id:'([\s\S]*?)'[\s\S]*?")
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_area = re.compile(r'<span class="area">\s*?<label>地区:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_area.search(content):
        match = _RE_area.search(content)
        area = match.groups()[0]
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''

    _RE_type = re.compile(r'<span class="type">\s*?<label>类型:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    _RE_actor = re.compile(r'<label>主讲人:</label>([\s\S]*?)</span>[\s\S]*?')
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\t', '').replace('\n', '')
    else:
        actors = ''

    _RE_episodescount = re.compile(r'<div class="basenotice">([\s\S]*?)<[\s\S]*?')
    if _RE_episodescount.search(content):
        match = _RE_episodescount.search(content)
        episodescount = match.groups()[0]
        for match in _RE1.finditer(str(episodescount)):
            episodescount = match.groups()[0]
            iteam.append(episodescount)
            episodescount=iteam[0]
    else:
        episodescount = ''

    _RE_description = re.compile(r'<span class="short" id="show_info_short" style="display: inline;">([\s\S]*?)</span>[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =re.sub('<[\s\S]*?>','',description)
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    year = ''

    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_yinyue_from_url(content):
    _RE = re.compile(r"var videoId2= '([\s\S]*?)'[\s\S]*?")
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_area_type = re.compile(r'<div class="crumbs">[\s\S]*?<span class="arrow"> &gt; </span>([\s\S]*?)<span class="arrow"> &gt; </span>([\s\S]*?)</div>[\s\S]*?')
    if _RE_area_type.search(content):
        match = _RE_area_type.search(content)
        area,type = match.groups()
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''
        stylename = ''

    _RE_year = re.compile(r'<div class="type">[\s\S]*<span class="break">/</span>([\s\S]*?)</div>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
    else:
        year = ''

    _RE_actor = re.compile(r'<div class="show_singer">[\s\S]*?</label>([\s\S]*?)</div>[\s\S]*?')
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        actors = ''

    description = ''
    episodescount = "1"

    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_yule_from_url(content):
    _RE = re.compile(r"var videoId2= '([\s\S]*?)'[\s\S]*?")
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_area = re.compile(r'<li class="show_area">[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')
    if _RE_area.search(content):
        match = _RE_area.search(content)
        area = match.groups()[0]
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''

    _RE_type = re.compile(r'<li class="show_type">[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    _RE_description = re.compile(r'<div class="yk-videoinfo">[\s\S]*?<div class="text" id="text_short">([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    _RE_year = re.compile(r'<span class="pub">([\s\S]*?)</span>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year = year[1:-1]
    else:
        year = ''

    _RE_actor = re.compile(r'<li class="show_director">[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        actors = ''

    episodescount = "1"
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_shishang_from_url(content):
    _RE = re.compile(r"var videoId2= '([\s\S]*?)'[\s\S]*?")
    for match in _RE.finditer(content):
        resid = match.groups()[0]

    _RE_year = re.compile(r'<span class="pub">([\s\S]*?)</span>[\s\S]*?')
    _RE_actor = re.compile(r'<li class="show_director">[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')
    _RE_description = re.compile(r'<div class="yk-videoinfo">[\s\S]*?<div class="text" id="text_short">([\s\S]*?)<[\s\S]*?')
    _RE_area = re.compile(r'<li class="show_area">[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')
    _RE_type = re.compile(r'<li class="show_type">[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')

    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year =year[1:-1]
    else:
        year = ''

    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        actors = ''

    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    if _RE_area.search(content):
        match = _RE_area.search(content)
        area = match.groups()[0]
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''

    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    episodescount = "1"

    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_lvyou_from_url(content):
    _RE = re.compile(r"var videoId2= '([\s\S]*?)'[\s\S]*?")
    for match in _RE.finditer(content):
        resid= match.groups()[0]

    _RE_description = re.compile(r'<div class="yk-videoinfo">[\s\S]*?<div class="text" id="text_short">([\s\S]*?)<[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''

    _RE_year = re.compile(r'<span class="pub">([\s\S]*?)</span>[\s\S]*?')
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year =year[1:-1]
    else:
        year = ''

    _RE_area = re.compile(r'<li class="show_area">[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')
    if _RE_area.search(content):
        match = _RE_area.search(content)
        area = match.groups()[0]
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''

    _RE_type = re.compile(r'<li class="show_type">[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''

    _RE_actor = re.compile(r'<li class="show_director">[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        actors = ''

    episodescount = "1"

    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_yuanchuang_from_url(content):
    _RE = re.compile(r"var videoId2= '([\s\S]*?)'[\s\S]*?")
    for match in _RE.finditer(content):
        resid= match.groups()[0]
    _RE_description = re.compile(r'<div class="yk-videoinfo">[\s\S]*?<div class="text" id="text_short">([\s\S]*?)<[\s\S]*?')
    _RE_year = re.compile(r'<span class="pub">([\s\S]*?)</span>[\s\S]*?')
    _RE_area = re.compile(r'<li class="show_area">[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')
    _RE_type = re.compile(r'<li class="show_type">[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')
    _RE_actor = re.compile(r'<li class="show_actor">[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year =year[1:-1]
    else:
        year = ''
    if _RE_area.search(content):
        match = _RE_area.search(content)
        area = match.groups()[0]
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        actors = ''
    episodescount = "1"
    return resid,actors,stylename,areaname,year,description,episodescount

def get_detail_other_from_url(content):
    _RE = re.compile(r"var videoId2= '([\s\S]*?)'[\s\S]*?")
    for match in _RE.finditer(content):
        resid= match.groups()[0]
    _RE_type = re.compile(r'<div class="crumbs">[\s\S]*<span class="arrow"> &gt; </span>([\s\S]*?)</div>[\s\S]*?')
    _RE_description = re.compile(r'<div class="yk-videoinfo">[\s\S]*?<div class="text" id="text_short">([\s\S]*?)<[\s\S]*?')
    _RE_year = re.compile(r'<span class="pub">([\s\S]*?)</span>[\s\S]*?')
    _RE_area = re.compile(r'<li class="show_area">[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')
    _RE_actor = re.compile(r'<li class="show_actor">[\s\S]*?</span>([\s\S]*?)</li>[\s\S]*?')
    if _RE_type.search(content):
        match = _RE_type.search(content)
        type = match.groups()[0]
        stylename =re.sub('<[\s\S]*?>','',type)
        stylename =str(stylename).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        stylename = ''
    if _RE_description.search(content):
        match = _RE_description.search(content)
        description = match.groups()[0]
        description =str(description).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        description = ''
    if _RE_year.search(content):
        match = _RE_year.search(content)
        year = match.groups()[0]
        year =year[1:-1]
    else:
        year = ''
    if _RE_area.search(content):
        match = _RE_area.search(content)
        area = match.groups()[0]
        areaname =re.sub('<[\s\S]*?>','',area)
        areaname =str(areaname).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        areaname = ''
    if _RE_actor.search(content):
        match = _RE_actor.search(content)
        actors = match.groups()[0]
        actors =re.sub('<[\s\S]*?>','',actors)
        actors =str(actors).replace(' ', '').replace('\n', '').replace('\t', '')
    else:
        actors = ''
    episodescount = "1"
    return resid,actors,stylename,areaname,year,description,episodescount

def get_dy_juji_list(content,name):
    items = []
    _RE1 = re.compile(r'<li class="action">\s*([\s\S]*?)\s*</li>')
    _RE2 = re.compile(r'<a class=[\s\S]*?href="(.+?)"[\s\S]*?')
    for match in _RE1.finditer(content):
        detail = match.groups()[0]
        for match in _RE2.finditer(str(detail)):
            herf = match.groups()[0]
            items.append({'title': name,'url':herf})
    return items,1

def get_ds_juji_list(url,index):
    ds_maxpage ='1'
    items = []
    content = fetch_url(url)
    _RE1 = re.compile(r'<ul id="zySeriesTab">\s*?([\s\S]*?)\s*?</ul>[\s\S]*?')
    _RE2 = re.compile(r'<li data="([\s\S]*?)"[\s\S]*?</li>[\s\S]*?')
    _RE3 = re.compile(r'<a href="(.+?)"[\s\S]*?>(\d*?)</a>[\s\S]*?')
    _RE4 = re.compile(r'<div id="episode">([\s\S]*?)</div>[\s\S]*?')
    _RE5 = re.compile(r'<li><a href="([\s\S]*?)"[\s\S]*?>(\d*?)</a>[\s\S]*?')
    _RE6 = re.compile(r'<em class="ico_preview">')
    if not _RE1.search(content):
        for match in _RE4.finditer(content):
            datapag = match.groups()[0]
            for match in _RE5.finditer(str(datapag)):
                href,title = match.groups()
                title = '第'+title+'集'
                items.append({'title': title,'url':href})
            if _RE6.search(str(datapag)):
                items = items[0:-1]
    else:
        for match in _RE1.finditer(content):
            datapag = match.groups()[0]
            for match in _RE2.finditer(str(datapag)):
                data =match.groups()[0]
                id = url.split('/')[4]
                real_link = 'http://www.youku.com/show_episode/' + id + '?dt=json&divid=reload_' + data
                real_content = fetch_url(real_link)
                for match in _RE3.finditer(real_content):
                    href,title = match.groups()
                    title = '第'+title+'集'
                    items.append({'title': title,'url':href})
                if _RE6.search(str(datapag)):
                    items = items[0:-1]
    
    ds_maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if ds_maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,ds_maxpage

def get_zx_juji_list(url,index):
    zx_maxpage ='1'
    items = []
    content = fetch_url(url)
    _RE1 = re.compile(r'<ul id="zySeriesTab">\s*?([\s\S]*?)\s*?</ul>[\s\S]*?')
    _RE2 = re.compile(r'<div id="episode"><div>([\s\S]*?)</div>')
    _RE3 = re.compile(r'<li class="ititle_w">[\s\S]*?<a[\s\S]*?title="(.+?)" href="(.+?)"[\s\S]*?</a>[\s\S]*?')
    _RE4 = re.compile(r'<li class="ititle">[\s\S]*?<a[\s\S]*?title="(.+?)" href="(.+?)"[\s\S]*?</a>[\s\S]*?')
    _RE5 = re.compile(r'<li data="([\s\S]*?)"[\s\S]*?</li>[\s\S]*?')
    _RE6 = re.compile(r'<ul class="item">\s*?<li class="[\s\S]*?">[\s\S]*?<a[\s\S]*?title="(.+?)" href="(.+?)"[\s\S]*?</a>[\s\S]*?')
    if not _RE1.search(content):
        if _RE2.search(content):
            for match in _RE2.finditer(content):
                datapag1 = match.groups()[0]
            if _RE3.search(str(datapag1)):
                for match in _RE3.finditer(str(datapag1)):
                    title,href= match.groups()
                    items.append({'title': title,'url':href})
            elif _RE4.search(str(datapag1)):
                for match in _RE4.finditer(str(datapag1)):
                    title,href= match.groups()
                    items.append({'title': title,'url':href})
    else:
        for match in _RE1.finditer(content):
            datapag2 = match.groups()[0]
            for match in _RE5.finditer(str(datapag2)):
                data =match.groups()[0]
                id = url.split('/')[4]
                real_link = 'http://www.youku.com/show_episode/' + id + '?dt=json&divid=reload_' + data
                real_content = fetch_url(real_link)
                for match in _RE6.finditer(real_content):
                    title,href = match.groups()
                    items.append({'title': title,'url':href})
    zx_maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if zx_maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,zx_maxpage 


def get_zy_juji_list(url,index):
    zy_maxpage ='1'
    items = []
    content = fetch_url(url)
    _RE1 = re.compile(r'<div class="series_month">([\s\S]*?)</div><!--.bd-->[\s\S]*?')
    _RE2 = re.compile(r'<div class="pgm-tab">([\s\S]*?)</div>[\s\S]*?')
    _RE3 = re.compile(r'<div id="episode"><div>([\s\S]*?)</div>')
    _RE4 = re.compile(r'<li class="ititle_w">[\s\S]*?<a[\s\S]*?title="(.+?)" href="(.+?)"[\s\S]*?</a>[\s\S]*?')
    _RE5 = re.compile(r'<li class="ititle">[\s\S]*?<a[\s\S]*?title="(.+?)" href="(.+?)"[\s\S]*?</a>[\s\S]*?')
    _RE6 = re.compile(r'<ul id="zySeriesTab">\s*?([\s\S]*?)\s*?</ul>[\s\S]*?')
    _RE7 = re.compile(r'<li data="([\s\S]*?)"[\s\S]*?</li>[\s\S]*?')
    _RE8 = re.compile(r'<ul class="item">\s*?<li class="[\s\S]*?">[\s\S]*?<a[\s\S]*?title="(.+?)" href="(.+?)"[\s\S]*?</a>[\s\S]*?')
    for match in _RE1.finditer(content):
        datapag1 = match.groups()[0]
        if not _RE2.search(str(datapag1)):
            for match in _RE3.finditer(str(datapag1)):
                datapag2 = match.groups()[0]
                if _RE4.search(str(datapag2)):
                    for match in _RE4.finditer(str(datapag2)):
                        title,href= match.groups()
                        items.append({'title': title,'url':href})
                elif _RE5.search(str(datapag2)):
                    for match in _RE5.finditer(str(datapag2)):
                        title,href= match.groups()
                        items.append({'title': title,'url':href})
        else:
            for match in _RE6.finditer(str(datapag1)):
                datapag3 = match.groups()[0]
                for match in _RE7.finditer(str(datapag3)):
                    data =match.groups()[0]
                    id = url.split('/')[4]
                    real_link = 'http://www.youku.com/show_episode/' + id + '?dt=json&divid=reload_' + data
                    real_content = fetch_url(real_link)
                    for match in _RE8.finditer(real_content):
                        title,href = match.groups()
                        items.append({'title': title,'url':href})
    zy_maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if zy_maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,zy_maxpage 

def get_jy_juji_list(url,index):
    jy_maxpage ='1'
    items = []
    content = fetch_url(url)
    _RE1 = re.compile(r'<ul id="zySeriesTab">\s*?([\s\S]*?)\s*?</ul>[\s\S]*?')
    _RE2 = re.compile(r'<div id="episode"><div>([\s\S]*?)</div>')
    _RE3 = re.compile(r'<li class="ititle_w">[\s\S]*?<a[\s\S]*?title="(.+?)" href="(.+?)"[\s\S]*?</a>[\s\S]*?')
    _RE4 = re.compile(r'<li class="ititle">[\s\S]*?<a[\s\S]*?title="(.+?)" href="(.+?)"[\s\S]*?</a>[\s\S]*?')
    _RE5 = re.compile(r'<li data="([\s\S]*?)"[\s\S]*?</li>[\s\S]*?')
    _RE6 = re.compile(r'<ul class="item">\s*?<li class="[\s\S]*?">[\s\S]*?<a[\s\S]*?title="(.+?)" href="(.+?)"[\s\S]*?</a>[\s\S]*?')
    if not _RE1.search(content):
        if _RE2.search(content):
            for match in _RE2.finditer(content):
                datapag1 = match.groups()[0]
            if _RE3.search(str(datapag1)):
                for match in _RE3.finditer(str(datapag1)):
                    title,href= match.groups()
                    items.append({'title': title,'url':href})
            elif _RE4.search(str(datapag1)):
                for match in _RE4.finditer(str(datapag1)):
                    title,href= match.groups()
                    items.append({'title': title,'url':href})
    else:
        for match in _RE1.finditer(content):
            datapag2 = match.groups()[0]
            for match in _RE5.finditer(str(datapag2)):
                data =match.groups()[0]
                id = url.split('/')[4]
                real_link = 'http://www.youku.com/show_episode/' + id + '?dt=json&divid=reload_' + data
                real_content = fetch_url(real_link)
                for match in _RE6.finditer(real_content):
                    title,href = match.groups()
                    items.append({'title': title,'url':href})
    jy_maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if jy_maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,jy_maxpage

def get_jlp_juji_list(url,index):
    jlp_maxpage ='1'
    items = []
    content = fetch_url(url)
    _RE1 = re.compile(r'<ul id="zySeriesTab">\s*?([\s\S]*?)\s*?</ul>[\s\S]*?')
    _RE2 = re.compile(r'<div id="episode"><div>([\s\S]*?)</div>')
    _RE3 = re.compile(r'<li class="ititle_w">[\s\S]*?<a[\s\S]*?title="(.+?)" href="(.+?)"[\s\S]*?</a>[\s\S]*?')
    _RE4 = re.compile(r'<li class="ititle">[\s\S]*?<a[\s\S]*?title="(.+?)" href="(.+?)"[\s\S]*?</a>[\s\S]*?')
    _RE5 = re.compile(r'<li data="([\s\S]*?)"[\s\S]*?</li>[\s\S]*?')
    _RE6 = re.compile(r'<ul class="item">\s*?<li class="[\s\S]*?">[\s\S]*?<a[\s\S]*?title="(.+?)" href="(.+?)"[\s\S]*?</a>[\s\S]*?')
    if not _RE1.search(content):
        if _RE2.search(content):
            for match in _RE2.finditer(content):
                datapag1 = match.groups()[0]
            if _RE3.search(str(datapag1)):
                for match in _RE3.finditer(str(datapag1)):
                    title,href= match.groups()
                    items.append({'title': title,'url':href})
            elif _RE4.search(str(datapag1)):
                for match in _RE4.finditer(str(datapag1)):
                    title,href= match.groups()
                    items.append({'title': title,'url':href})
    else:
        for match in _RE1.finditer(content):
            datapag2 = match.groups()[0]
            for match in _RE5.finditer(str(datapag2)):
                data =match.groups()[0]
                id = url.split('/')[4]
                real_link = 'http://www.youku.com/show_episode/' + id + '?dt=json&divid=reload_' + data
                real_content = fetch_url(real_link)
                for match in _RE6.finditer(real_content):
                    title,href = match.groups()
                    items.append({'title': title,'url':href})
    jlp_maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if jlp_maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,jlp_maxpage

def get_dm_juji_list(url,index):
    dm_maxpage ='1'
    items = []
    content = fetch_url(url)
    _RE1 = re.compile(r'<ul id="zySeriesTab">\s*?([\s\S]*?)\s*?</ul>[\s\S]*?')
    _RE2 = re.compile(r'<li data="([\s\S]*?)"[\s\S]*?</li>[\s\S]*?')
    _RE3 = re.compile(r'<a href="(.+?)" title="(.+?)"[\s\S]*?</a>[\s\S]*?')
    _RE4 = re.compile(r'<div id="episode">([\s\S]*?)</div>[\s\S]*?')
    _RE5 = re.compile(r'<li><a href="([\s\S]*?)" title="([\s\S]*?)"[\s\S]*?</li>')
    if not _RE1.search(content):
        for match in _RE4.finditer(content):
            datapag = match.groups()[0]
            for match in _RE5.finditer(str(datapag)):
                href,title = match.groups()
                items.append({'title': title,'url':href})
    else:
        for match in _RE1.finditer(content):
            datapag = match.groups()[0]
            for match in _RE2.finditer(str(datapag)):
                data =match.groups()[0]
                id = url.split('/')[4]
                real_link = 'http://www.youku.com/show_episode/' + id + '?dt=json&divid=reload_' + data
                real_content = fetch_url(real_link)
                for match in _RE3.finditer(real_content):
                    href,title = match.groups()
                    items.append({'title': title,'url':href})
    dm_maxpage = int(len(items))/100 + 1 if int(len(items))%100 > 0 else 0
    detailpage = (int(index)-1)*100
    if dm_maxpage != index:
        items = items[detailpage:int(detailpage)+100]
    else:
        items = items[detailpage:len(items)]
    return items,dm_maxpage

def get_other_juji_list(url,name):
    items = []
    items.append({'title': name,'url':url})
    return items,1

def playVideo(url):
    mylist = GetHttpData(url)
    foobars = re.compile('<m3u8>(.*?)</m3u8>', re.DOTALL).findall(mylist)
    playlist = xbmc.PlayList(1)
    playlist.clear()
    for i in range(0,len(foobars)):
        title =" 第"+str(i+1)+"/"+str(len(foobars))+"节"
        listitem=xbmcgui.ListItem(title)
        listitem.setInfo(type="Video",infoLabels={"Title":title})
        playlist.add(foobars[i], listitem)
    xbmc.Player().play(playlist)

def searchkey(category_id):
    keyword = ""
    type = ""
    if category_id == "96":
        category_mf = "1"
        keyword = "特殊身份,古惑仔,青春如期,小时代,狄仁杰之神都龙王,不二神探,激战,速度与激情"
        type = "电影"
    elif category_id == "97":
        category_mf = "2"
        keyword = "特种兵之火凤凰,因为爱情有多美,万万没想到,打狗棍,千金归来,法外风云,咱们结婚吧,终极一班3"
        type = "电视剧"
    elif category_id == "85":
        category_mf = "14"
        keyword = "爸爸去哪儿,快乐大本营,running man,康熙来了,晓说,天天向上,非诚勿扰,我们结婚了"
        type = "综艺"
    elif category_id == "100":
        category_mf = "4"
        keyword = "灌篮高手,火影忍者,熊出没,奥特曼,名侦探柯南,海贼王,尸兄,我叫mt"
        type = "动漫"
    kb = Keyboard('','请输入搜索内容',keyword,type)
    kb.doModal()
    if (kb.isConfirmed()):
        keyword = kb.getText()
        if keyword !='':
            searchpage = 1
            searchlist(keyword,category_id,category_mf,searchpage)
        else:
            xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
            xbmcplugin.endOfDirectory(int(sys.argv[1]))
    else:
        xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumbsearch')
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
    
def searchlist(keyword,category_id,category_mf,searchpage):
    search_path = xbmc.getInfoLabel("AppServer.IP")+"/cube/api/resources/search/"+keyword+"?page_size=54"+"&page_no="+str(searchpage)+"&client_id="+str(xbmc.getInfoLabel("client.id"))+"&user_type=1&user_id=0&timestamp=1383555354&security_code=ce30ea919afcc8cf731b5edf8f91ee6c&session_id=dltianwei&category_id="+str(category_mf)+"&app_id=232"
    search_path = eval(repr(search_path).replace("\\x","%"))
    p1 = GetHttpData(search_path)
    data = json.JSONDecoder().decode(p1)
    newses = data["data"]
    app_id = ''
    area_id = ''
    style_id = ''
    if newses != None:
        newses1 = newses["items"]
        maxpage = newses["totalPages"]
        for i in newses1:
            name = i["title"].encode("utf-8")
            resid = i["id"]
            resappepisodes = i["resAppEpisodes"]
            url = i["channelUrl"]
            thumbnail = i["thumbnail"].encode("utf-8")
            listitem=xbmcgui.ListItem(name,thumbnailImage = thumbnail)
            u=sys.argv[0]+'?mode=2&url='+urllib.quote_plus(url)+"&name="+urllib.quote_plus(name)+"&thumbnail="+urllib.quote_plus(thumbnail)+'&category_id='+urllib.quote_plus(category_id)+'&resappepisodes='+urllib.quote_plus(str(resappepisodes))
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True, len(newses1))
        if int(maxpage) > searchpage:
            listitem=xbmcgui.ListItem('[COLOR FF004AFF]更多  ' + str(searchpage) + '/' +str(maxpage) +'[/COLOR]',thumbnailImage=MORE_THUMB)
            listitem.setProperty('next','true')
            u=sys.argv[0] + '?mode=9&mfcachetype=dir_cache_always&searchpage='+str(searchpage+1) +'&app_id='+urllib.quote_plus('0')+'&category_id='+str(category_id)+'&area_id='+str(area_id)+ '&style_id=' + urllib.quote_plus(style_id)+ '&keyword=' + urllib.quote_plus(keyword)+"&view_mode="+urllib.quote_plus('morefunthumb')
            xbmcplugin.addDirectoryItem(int(sys.argv[1]), u, listitem, True)
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
    xbmcplugin.setProperty(int(sys.argv[1]), 'view_mode', 'morefunthumb')
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getareas(category, category_id,medianame):
    areas = []
    if category == "movie":
        areas = movie_areas
    elif category == "tv":
        areas = tv_areas
    elif category == "show":
        areas = show_areas
    elif category == "comic":
        areas = comic_areas
    elif category == "info":
        areas = info_areas
    elif category == "music":
        areas = music_areas
    else:
        areas = void_areas
    for area in areas:
        listitem=xbmcgui.ListItem(area[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(area[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus(area[1])+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getstyles(category, category_id,medianame):
    styles = []
    if category == "movie":
        styles = movie_styles
    elif category == "tv":
        styles = tv_styles
    elif category == "show":
        styles = show_styles
    elif category == "comic":
        styles = comic_styles
    elif category == "info":
        styles = info_styles
    elif category == "education":
        styles = edu_styles
    elif category == "recoder":
        styles = rec_styles
    elif category == "music":
        styles = music_styles
    elif category == "fun":
        styles = fun_styles
    elif category == "sport":
        styles = sport_styles
    elif category == "car":
        styles = car_styles
    elif category == "science":
        styles = science_styles
    elif category == "games":
        styles = games_styles
    elif category == "life":
        styles = life_styles
    elif category == "style":
        styles = style_styles
    elif category == "trip":
        styles = trip_styles
    elif category == "mom_baby":
        styles = mom_baby_styles
    elif category == "jock":
        styles = jock_styles
    elif category == "creation":
        styles = creation_styles
    elif category == "ad":
        styles = void_styles
    for style in styles:
        listitem=xbmcgui.ListItem(style[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(style[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus(style[1])+"&released_on_from="+urllib.quote_plus('0')+"&released_on_to="+urllib.quote_plus('0')+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def getyears(category,category_id,medianame):
    years = []
    if category == "movie" or category == "tv" or category == "show" or category == "comic" or category == "info" or category == "music":
        years = full_years
    else:
        years = void_years
    for year in years:
        listitem=xbmcgui.ListItem(year[0],thumbnailImage="")
        url=sys.argv[0]+"?mode=1&name="+urllib.quote_plus(year[0])+"&category_id="+urllib.quote_plus(category_id)+"&area_id="+urllib.quote_plus('0')+"&style_id="+urllib.quote_plus('0')+"&released_on_from="+urllib.quote_plus(year[1])+"&released_on_to="+urllib.quote_plus(year[2])+"&page_size="+urllib.quote_plus('50')+"&page="+urllib.quote_plus('1') + '&medianame='+urllib.quote_plus(medianame)
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), url, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def display_for_history(params):
    app_id = urllib.unquote_plus(params['app_id']) if 'app_id' in params else ''
    category_id = urllib.unquote_plus(params['category_id']) if 'category_id' in params else ''
    url = urllib.unquote_plus(params['url']) if 'url' in params else ''
    name = urllib.unquote_plus(params['title']) if 'title' in params else ''
    if name == "" or name == None:
        name = urllib.unquote_plus(params['name']) if 'name' in params else ''
    page = urllib.unquote_plus(params['page']) if 'page' in params else ''
    resappepisodes = urllib.unquote_plus(params['resappepisodes']) if 'resappepisodes' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    medianame = urllib.unquote_plus(params['medianame']) if 'medianame' in params else ''
    buildNextLists(app_id,category_id,url,name,thumbnail,page,resappepisodes,medianame)
    
def display_for_favourite(params):
    display_for_history(params)

def update_favourite(params):
    title = urllib.unquote_plus(params['title']) if 'title' in params else ''
    thumbnail = urllib.unquote_plus(params['thumbnail']) if 'thumbnail' in params else ''
    resid = urllib.unquote_plus(params['resid']) if 'resid' in params else ''
    url = urllib.unquote_plus(params['url']) if 'url' in params else ''
    category_id = urllib.unquote_plus(params['category_id']) if 'category_id' in params else ''
    content = fetch_url(url)
    if category_id == "96":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_dianying_from_url(content)
    elif category_id == "97":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_dianshi_from_url(content)
    elif category_id == "85":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_zongyi_from_url(url)
    elif category_id == "100":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_dongman_from_url(content)
    elif category_id == "91":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_zixun_from_url(content)
    elif category_id == "87":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_jiaoyu_from_url(content)
    elif category_id == "84":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_jilupian_from_url(content)
    elif category_id == "95":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_yinyue_from_url(content)
    elif category_id == "86":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_yule_from_url(content)
    elif category_id == "89":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_shishang_from_url(content)
    elif category_id == "88":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_lvyou_from_url(content)
    elif category_id == "92":
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_yuanchuang_from_url(content)
    else:
        resid,actors,stylename,areaname,year,description,resappepisodes_mf = get_detail_other_from_url(content)
    episodesCount = resappepisodes_mf
    
    updateUrl = sys.argv[0]+"?fromtype=updateFavourite&resid="+urllib.quote_plus(str(resid))+"&url="+urllib.quote_plus(url)+"&category_id="+urllib.quote_plus(category_id)
    listitem=xbmcgui.ListItem(title)
    listitem.setProperty('title',title)
    listitem.setProperty('thumb',thumbnail)
    listitem.setProperty('episodesNum',episodesCount)
    listitem.setProperty('updateUrl',updateUrl)
    xbmcplugin.addDirectoryItem(int(sys.argv[1]), updateUrl, listitem, True)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))


def get_params(url = ''):
    param = []
    paramstring = sys.argv[2] if url=='' else url
    if len(paramstring) >= 2:
        params = paramstring
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]
    return param

