#! /usr/bin/env python
# coding=utf-8
import re
import urllib2,json,xbmcaddon,sys,os,os.path
from xbmcswift2 import Plugin, xbmc, xbmcgui
from utils import fetch_url, keyboard
import user
import itvi_play
plugin = Plugin()

__addonid__ = "plugin.video.mfyun"
__addon__ = xbmcaddon.Addon(id=__addonid__)
lib_path = os.path.join(__addon__.getAddonInfo('path'))
sys.path.append (lib_path)

def GetHttpData(url):
    #UserAgent = ''
    req = urllib2.Request(url)
    #req.add_header('User-Agent', UserAgent)
    response = urllib2.urlopen(req)
    httpdata = response.read()
    if response.headers.get('content-encoding', None) == 'gzip':
        httpdata = gzip.GzipFile(fileobj=StringIO.StringIO(httpdata)).read()
    response.close()
    match = re.compile('encodingt=(.+?)"').findall(httpdata)
    if len(match)<=0:
        match = re.compile('meta charset="(.+?)"').findall(httpdata)
    if len(match)>0:
        charset = match[0].lower()
        if (charset != 'utf-8') and (charset != 'utf8'):
            httpdata = unicode(httpdata, charset).encode('utf8')
    return httpdata

def get_album_items_from_url(sourceurl,page,page_size):
    album_url = sourceurl
    limit = int(page_size)
    start = (int(page)-1)*limit
    get_album_list_url = 'http://yun.baidu.com/pcloud/album/getlist?start='+str(start)+'&limit='+str(limit)+'&query_uk=%s'
    album_url = album_url.split('?')
    uk = album_url[-1].replace('&view=album','').replace('uk=','')
    content = fetch_url(get_album_list_url % uk)
    r = json.loads(content)
    album_list = r['album_list']
    count = r['count']
    return (album_list,count)

def get_album_items_from_json(type,page):
    url     = 'http://files.cube.morefun.tv/mfalbums/mfalbums_v1_0/resources-remendapian-all-%s.json'%page
    data    = GetHttpData(url)
    albums  = json.JSONDecoder().decode(data)
    count   = albums['total_count']
    
    album_list  = []
    for item in  albums['resources']:
        albumurl = item['url']
        album_id = albumurl.replace('http://yun.baidu.com/pcloud/album/info?uk=(\s\S)*?&album_id=','')
        album_list.append({ 'title'       : item['name'],
                            'cover_thumb' : item['thumb'],
                            'album_id'    : album_id,
                         })

    return album_list,count
    
def get_album_detail_list(album_id,sourceurl,page,page_size):
    album_url = sourceurl
    limit = int(page_size)
    start = (int(page)-1)*limit
    get_album_detail='http://yun.baidu.com/pcloud/album/listfile?album_id=%s&query_uk=%s&start='+str(start)+'&limit='+str(limit)+'&channel=chunlei&clienttype=0&web=1'
    album_url = album_url.split('?')
    uk = album_url[-1].replace('&view=album','').replace('uk=','')
    content = fetch_url(get_album_detail % (album_id,uk))
    r = json.loads(content)
    detail_list = r['list']
    count = r['count']
    return (detail_list,count)

def play_album_detail(playname,playpath,dlink):
    id = user.get_default_userid()
    if id == None:
        xbmc.executebuiltin("ShowBusyDialog")
        listitem = xbmcgui.ListItem(playname)
        playlist = xbmc.PlayList(1)
        playlist.clear()
        playlist.add(dlink, listitem)
        xbmc.Player().play(playlist)
        xbmc.executebuiltin('HideBusyDialog')
    else:
        properties = {}
        properties['itemType'] = 'baiduyun_album'
        properties['url'] = playpath
        properties['title'] = playname
        player = itvi_play.ItviItemPlayer()
        player.play(properties)