#! /usr/bin/env python
# coding=utf-8
import re
import json,xbmcaddon,sys,os,os.path
from xbmcswift2 import Plugin, xbmc, xbmcgui
from utils import fetch_url, keyboard

plugin = Plugin()
plugin_path = plugin.addon.getAddonInfo('path')
lib_path = os.path.join(plugin_path,'lib')
sys.path[0:0] = [lib_path,
                 os.path.join(lib_path, 'beautifulsoup-3.2.1-py2.7.egg')]
from BeautifulSoup import BeautifulSoup
import itvi_play
import run


__addonid__ = "plugin.video.mfyun"
__addon__ = xbmcaddon.Addon(id=__addonid__)
lib_path = os.path.join(__addon__.getAddonInfo('path'))
sys.path.append (lib_path)
import personal

def get_bd_items_from_url(sourceurl):
    move_list=[]
    content = fetch_url(sourceurl)
    soup = BeautifulSoup(content)
    pagenavi = soup.find("div",{"id":"pagenavi"})
    last_page = 1
    if pagenavi is not None and pagenavi != "":
        a_list = pagenavi.findAll("a")
        if a_list is not None and a_list != "" and len(a_list)>0:
            last_page = a_list[-1]['href'].split("/")[-1]
    ul = soup.find("ul",{"class":"movie_list"})
    if ul is not None and ul != "":
        li_list = ul.findAll("li")
        for li in li_list:
            move={}
            link = li.find('div').find('div').find('a')
            move['title'] = link.find('img')['alt'].encode("utf-8")
            move['img'] = link.find('img')['src'].encode("utf-8")
            link = link['href'].encode("utf-8")
            message = get_bdpan_url(link)
            #没有百度盘收藏地址
            if message == 80000:
                continue
            else:
                move['url']= message
            move_list.append(move)
    return move_list,last_page

def get_bdpan_url(url):
    erron = 80000
    #url='http://v.bdpan.com/post-1030.html'
    content = fetch_url(url)
    soup = BeautifulSoup(content)
    ul = soup.find("ul",{"id":"downlist"})
    if ul is not None and ul !="":
        li = ul.find("li",{"class":"r"})
        if li is not None and li !="":
            real_url = li.find("a")["href"]
            if real_url == "":
                return erron
            else:
                return real_url
        else:
            return erron

def bd_serach_result(keyward,page=1):
    move_list=[]
    search_url = "http://v.bdpan.com/?keyword=" + str(keyward) + "&page=" + str(page)
    content = fetch_url(search_url)
    soup = BeautifulSoup(content)
    pagenavi = soup.find("div",{"id":"pagenavi"})
    last_page = 1
    if pagenavi is not None and pagenavi != "":
        a_list = pagenavi.findAll("a")
        if a_list is not None and a_list != "" and len(a_list)>0:
            last_page = a_list[-1]['href'].split("/")[-1]
            last_page = last_page.split("=")[-1]
    ul = soup.find("ul",{"class":"list"})
    if ul is not None and ul !="":
        li_list = ul.findAll("li")
        for li in li_list:
            mes_info = 0
            move={}
            link = li.find('div').find('div').find('a')
            img = li.find('div').find("div",{"class":"img"})
            con = li.find('div').find("div",{"class":"con"})
            span_list = con.find("span",{"class":"l"})
            for span in span_list:
                if "集" in span:
                    mes_info = 900000
            if mes_info == 900000:
                continue
            move['title'] = con.find('h2').find('a').contents[0].encode("utf-8")
            move['img'] = img.find('img')['src'].encode("utf-8")
            link = link['href'].encode("utf-8")
            message = con.find('h2').find('a')['href'].encode("utf-8")
            message = get_bdpan_url(message)
            #没有百度盘收藏地址
            if message == 80000:
                continue
            else:
                move['url']= message
                move_list.append(move)
        return move_list,last_page


def play_bd_detail(playpath,playname):
    properties = {}
    properties['itemType'] = 'baiduyun_161'
    properties['url'] = playpath
    properties['title'] = playname
    
    folderpath = xbmc.getInfoLabel('container.folderpath')
    pos = folderpath.find('?')
    host = folderpath[0:pos]
    params = run.get_params(folderpath[pos:])
    playname = params['playname'] if 'playname' in params else ''
    playpath = params['playpath'] if 'playpath' in params else ''
    sourcetype = params['sourcetype'] if 'sourcetype' in params else ''
    get_type = params['get_type'] if 'get_type' in params else ''
    get_sourcetype = params['get_sourcetype'] if 'get_sourcetype' in params else ''
    parentPath = host+'?fromtype=history&historytype=bdpan&playname='+playname+'&playpath='+playpath+'&sourcetype='+sourcetype+'&get_type='+get_type+'&get_sourcetype='+get_sourcetype
    properties['parentPath'] = parentPath
    
    player = itvi_play.ItviItemPlayer()
    player.play(properties)