#! /usr/bin/env python
# coding=utf-8
import re
import json,xbmcaddon,sys,os,os.path
from urlparse import urljoin, parse_qs
from urllib import quote_plus,unquote_plus,urlencode
from xbmcswift2 import  Module, Plugin,actions, xbmc, xbmcgui

from utils import fetch_url, create_baidu_url, keyboard, update_plugin_url,refresh

from CaptchaDialog import CaptchaDialog
import itvi_play
import run


plugin = Plugin()
plugin_path = plugin.addon.getAddonInfo('path')

__addonid__ = "plugin.video.mfyun"
__addon__ = xbmcaddon.Addon(id=__addonid__)
lib_path = os.path.join(__addon__.getAddonInfo('path'))
sys.path.append (lib_path)
import personal

title = '161电影网'
m = Module(__name__)
m.storage_path = Plugin().storage_path  # a bug from xbmcswift2
HOST = 'http://m.dy161.com/'
collect_url_1 = 'http://pan.baidu.com/share/transfer?channel=chunlei&clienttype=0&web=1&from=%s&shareid=%s&bdstoken=%s&channel=chunlei&clienttype=0&web=1'
collect_url_2 ="http://pan.baidu.com/mis/dtcount?bdstoken=%s&channel=chunlei&clienttype=0&web=1" 

@m.route('/')
def index():
    return [
        {'label': u'电影频道', 'path': m.url_for('list_movies', cid=0, s=0)},
        {'label': u'动作电影频道', 'path': m.url_for('list_movies', cid=8, s=0)},
        {'label': u'喜剧电影频道', 'path': m.url_for('list_movies', cid=9, s=0)},
        {'label': u'剧情电影频道', 'path': m.url_for('list_movies', cid=12, s=0)},
        {'label': u'恐怖电影频道', 'path': m.url_for('list_movies', cid=13, s=0)},
        {'label': u'[COLOR FFFFFF00]* 搜索 *[/COLOR]',
         'path': m.url_for('search')}]


@m.route('/search/')
def search():
    query = (keyboard(heading=u'请输入搜索内容') or '').strip()
    if query:
        m.plugin.redirect(m.url_for(
            'search_result', keyword=query, s=0))


@m.route('/list_movies/<cid>/<s>')
def list_movies(cid, s):
    if s == '0':
        url = '%sdy.aspx' % HOST if cid == '0' \
            else '%sdy.aspx?cid=%s' % (HOST, cid)
    else:
        url = '%sloadMore.aspx?cid=%s&s=%s' % (HOST, cid, s)
    items = get_items_from_url(url)
    if len(items) == 10:
        items.append({
            'label': '下一页',
            'path': m.url_for('list_movies', cid=cid, s=int(s) + 10)
        })

    return m.plugin.finish(items, view_mode='thumbnail')


@m.route('/play_detail/<page_id>/<playname>/')
def play_detail(page_id,playname):
    url = '%sdetail.aspx?id=%s' % (HOST, page_id)
    content = fetch_url(url)
    #_RE = re.compile(r'<a id="playlink" href="(.+?)"[^>]*>下载播放</a>')
    #match = _RE.search(content)
    ##if match:
    #create_baidu_url_from_bdlink(url)
    ##update_plugin_url(create_baidu_url_from_bdlink(url))
    _RE = re.compile(r'<a id="playlink" href="(.+?)"')
    for match in _RE.finditer(content):
        playlink = str(match.groups()).replace('(',"").replace(')',"").replace(',',"").replace("'","").replace("amp;","")
    properties = {}
    properties['itemType'] = 'baiduyun_161'
    properties['url'] = playlink
    properties['title'] = playname
    
    folderpath = xbmc.getInfoLabel('container.folderpath')
    pos = folderpath.find('?')
    host = folderpath[0:pos]
    params = run.get_params(folderpath[pos:])
    playname = params['playname'] if 'playname' in params else ''
    playpath = params['playpath'] if 'playpath' in params else ''
    sourcetype = params['sourcetype'] if 'sourcetype' in params else ''
    get_type = params['get_type'] if 'get_type' in params else ''
    get_sourcetype = params['get_sourcetype'] if 'get_sourcetype' in params else ''
    parentPath = host+'?fromtype=history&historytype=dy161&playname='+playname+'&playpath='+playpath+'&sourcetype='+sourcetype+'&get_type='+get_type+'&get_sourcetype='+get_sourcetype
    properties['parentPath'] = parentPath
    
    player = itvi_play.ItviItemPlayer()
    player.play(properties)


def get_items_from_url(url):
    content = fetch_url(url)
    _RE = re.compile(
        r'<li>\s*<a href="detail\.aspx\?id=(\d+)"[\s\S]*?'
        '<img src="(.+?)"[\s\S]*?'
        '<h3>(.+?)</h3>[\s\S]*?'
        '<em>(.+?)</em>')
    items = []
    for match in _RE.finditer(content):
        page_id, imgurl, name, grade = match.groups()
        items.append({
            'label': '%s [评分：%s]' % (name, grade),
            'path': m.url_for('play_detail', page_id=page_id),
            'thumbnail': urljoin(HOST, imgurl)
        })

    return items


def get_items_from_url_mf(url):
    content = fetch_url(url)
    _RE = re.compile(
        r'<li>\s*<a href="detail\.aspx\?id=(\d+)"[\s\S]*?'
        '<img src="(.+?)"[\s\S]*?'
        '<h3>(.+?)</h3>[\s\S]*?'
        '<em>(.+?)</em>')
    items = []
    for match in _RE.finditer(content):
        page_id, imgurl, name, grade = match.groups()
        items.append({
            'label': '%s [评分：%s]' % (name, grade),
            'path': page_id,
            'thumbnail': urljoin(HOST, imgurl)
        })

    return items

@m.route('/search_result/<keyword>/<s>')
def search_result(keyword, s):
    if s == '0':
        url = '%ssearch.aspx?kw=%s' % (HOST, quote_plus(keyword, ''))
    else:
        url = '%sloadMoreSearch.aspx?kw=%s&s=%s' % (
            HOST, quote_plus(keyword, ''), s)
    items = get_items_from_url(url)
    if len(items) == 10:
        items.append({
            'label': '下一页',
            'path': m.url_for('search_result', keyword=keyword, s=int(s) + 10)
        })

    return m.plugin.finish(items, view_mode='thumbnail')

def search_result_mf(keyword, s):
    if s == '0':
        url = '%ssearch.aspx?kw=%s' % (HOST, quote_plus(keyword, ''))
    else:
        url = '%sloadMoreSearch.aspx?kw=%s&s=%s' % (
            HOST, quote_plus(keyword, ''), s)
    items = get_items_from_url_mf(url)
#    if len(items) == 10:
#        items.append({
#            'label': '下一页',
#            'path': "plugin://video.mfyun/search_result/" + keyword + '/' + s +"/"
#        })

    return items

def on_verifycode(imgurl, captcha_error=False):
    if captcha_error:
        plugin.notify('验证码不正确，请重新输入', delay=2000, image='DefaultIconInfo.png')
    
    win = CaptchaDialog('captcha.xml', plugin_path, imgurl=imgurl)
    try:
        win.doModal()
        input_text = win.get_text()
        if input_text:
            return input_text
    finally:
        del win


def get_session():
    userid=plugin.get_storage('config').get('current_user')
    userdata = plugin.get_storage('userdata')
    user = userdata.setdefault(userid, {})
    if 'session' in user:
        session = user['session']
        return session

def get_url(self, remote_dir='/', page=1, num=100, order='time', desc=1):
    params = {'dir': '/', 'page': page, 'num': num, 'web': 1}
    if order != 'time':
        params['order'] = order
    if desc != 1:
        params['desc'] = desc
    url = 'http://pan.baidu.com/api/list?' + urlencode(params)
    return url




