#! /usr/bin/env python
# coding=utf-8
import re
import json,xbmcaddon,sys,os,os.path
from xbmcswift2 import Plugin, xbmc, xbmcgui

from utils import fetch_url, keyboard

plugin = Plugin()
plugin_path = plugin.addon.getAddonInfo('path')
lib_path = os.path.join(plugin_path,'lib')
sys.path[0:0] = [lib_path,
                 os.path.join(lib_path, 'poster-0.4-py2.6.egg')]
from BeautifulSoup import BeautifulSoup
import itvi_play
import run

__addonid__ = "plugin.video.mfyun"
__addon__ = xbmcaddon.Addon(id=__addonid__)
lib_path = os.path.join(__addon__.getAddonInfo('path'))
sys.path.append (lib_path)

def get_znds_items_from_url(sourceurl,totalresult,zhineng_page):
    url = "http://yun.znds.com/list-" + sourceurl + ".html?toptype=" + str(sourceurl) + "&totalresult=" + str(totalresult) + "&pageno=" + str(zhineng_page)
    move_list=[]
    host = "http://yun.znds.com%s"
    content = fetch_url(url)
    soup = BeautifulSoup(content)
    pagelistbox = soup.find("div",{"class":"pagelistbox"})
    if pagelistbox:
        totalresult = pagelistbox.find('span').contents[0].split('/')[-1].replace('条记录','').strip()
    ul = soup.find("ul",{"class":"gallery-post-grid holder"})
    if ul is not None and ul != "":
        li_list = ul.findAll("li")
        for li in li_list:
            move={}
            link = li.find('span').find('a')['href'].encode("utf-8")
            title = li.find('span').find('a').contents[0].encode("utf-8")
            img = li.find("a").find('img')['src'].encode("utf-8")
            move['url'] = host % link
            move['img'] = host % img
            move['title']= title
            move_list.append(move)
    return move_list,totalresult
    


def play_znds_detail(playpath,playname,thumb):
    content = fetch_url(playpath)
    soup = BeautifulSoup(content)
    a_list = soup.findAll("a",{"class":"btn btn-inverse pull-left"})
    if len(a_list)>0:
        a_link = a_list[0]['href']
        playurl = playpath
        real_url = playurl + a_link
        #errno = dy161.baidu_url_for_bdlink(real_url)
        properties = {}
        properties['itemType'] = 'baiduyun_161'
        properties['url'] = real_url
        properties['title'] = playname
        properties['sourceType'] = 'znds'
        properties['thumb'] = thumb
        
        folderpath = xbmc.getInfoLabel('container.folderpath')
        pos = folderpath.find('?')
        host = folderpath[0:pos]
        params = run.get_params(folderpath[pos:])
        playname = params['playname'] if 'playname' in params else ''
        playpath = params['playpath'] if 'playpath' in params else ''
        sourcetype = 'znds'
        get_type = params['get_type'] if 'get_type' in params else ''
        get_sourcetype = params['get_sourcetype'] if 'get_sourcetype' in params else ''
        parentPath = host+'?fromtype=history&historytype=znds&playname='+playname+'&playpath='+playpath+'&sourcetype='+sourcetype+'&get_type='+get_type+'&get_sourcetype='+get_sourcetype
        properties['parentPath'] = parentPath
        
        player = itvi_play.ItviItemPlayer()
        errno = player.play(properties)
        if errno == 10000 and len(a_list)>1:
            plugin.notify('正在获取下一个播放地址', delay=2000, image='DefaultIconInfo.png')
            a_link = a_list[1]['href']
            real_url = playurl + a_link
            #errno = dy161.baidu_url_for_bdlink(real_url)
            properties['url'] = real_url
            properties['sourceType'] = ''
            errno = player.play(properties)
        elif errno == 10000 and len(a_list) ==1:
            dialog = xbmcgui.Dialog()
            dialog.ok("提示","当前收藏文件的地址无效。")
            
def znds_search_result(query):
    post_url = 'http://yun.znds.com/if.php'
    items=[]
    totalresult = 0
    host = "http://yun.znds.com%s"
    params={'q':query}
    get_content =fetch_url(post_url,params)
    soup = BeautifulSoup(get_content)
    pagelistbox = soup.find("div",{"class":"pagelistbox"})
    if pagelistbox:
        totalresult = pagelistbox.find('span').contents[0].split('/')[-1].replace('条记录','').strip()
    ul = soup.find("ul",{"class":"gallery-post-grid holder"})
    if ul is not None and ul != "":
        li_list = ul.findAll("li")
        for li in li_list:
            move={}
            link = li.find('span').find('a')['href'].encode("utf-8")
            title = li.find('span').find('a').contents[0].encode("utf-8")
            img = li.find("a").find('img')['src'].encode("utf-8")
            move['path'] = host % link
            move['thumbnail'] = host % img
            move['label']= title
            items.append(move)
    return items,totalresult