#!/usr/bin/python
# -*- coding: utf-8 -*-
import sys
import os
import time
import urllib
import json
from xbmcswift2 import Plugin, xbmc, xbmcgui
from urllib import quote_plus, unquote_plus, urlencode
import urllib2
import re
import xbmcaddon
import itvi_play
import subroutine
import user
import run
import personal

plugin = Plugin()
plugin_path = plugin.addon.getAddonInfo('path')
lib_path = os.path.join(plugin_path, 'lib')
sys.path[0:0] = [lib_path,
                 os.path.join(lib_path, 'poster-0.4-py2.6.egg'),
                 os.path.join(lib_path, 'rsa_x509_pem-0.1.0.egg')]

__addonid__ = "plugin.video.mfyun"
__addon__ = xbmcaddon.Addon(id=__addonid__)
RESOURCES_PATH = os.path.join(__addon__.getAddonInfo('path'), 'media', )
lib_path = os.path.join(__addon__.getAddonInfo('path'), 'lib' ,'modules')
sys.path.append (lib_path)


#获取当前用户的关注
@plugin.route('/myfollows/<userid>/<page>/')
def myfollows_mf(userid, page):
    if userid == 'null':
        return []
    page = int(page)
    api = personal.get_api(userid)
    uk = personal.get_uk(userid)
    follow_list, total_count = api.get_follow_list(uk, 24 * page)
    items = [{
        'label': '[[COLOR FF00FFFF]%s[/COLOR]] ([COLOR FF00FF00]%d[/COLOR]) %s' % (  # noqa
            user['follow_uname'], user['pubshare_count']+user['album_count'], user['intro']),
        'path': 'plugin://video.mfyun/myfollow_show_items_mf/%s' % user['follow_uk'],  # noqa
    } for user in follow_list]
    
    # if 24 * (page + 1) < total_count:
        # items.append({
            # 'label': '[COLOR FFFFFF00]下一页[/COLOR]',
            # 'path': 'plugin://video.mfyun/myfollows/' + userid + '/' + str(int(page) + 1) + '/'
        # })
    return items,total_count

#获取此关注下的资源
@plugin.route('/myfollow_show_items_mf/<follow_uk>/')
def myfollow_show_items_mf(follow_uk):
    if follow_uk == 'null':
        return []
    path = "http://yun.baidu.com/share/home?uk=%s" % follow_uk
    items = myfollow_show_baidupan(follow_uk,"null","null")
    return items

def myfollow_show_baidupan(uk, shareid, fid):
    if shareid == 'null':
        shareid = ''
    if fid == 'null':
        fid = ''
    
    items = []
    share_files = []
    isRoot = None
    if shareid:
        isRoot = False
        try:
            if fid.isdigit():
                share_files = subroutine.parse_baidupan_url(uk, shareid, fid)
            else:
                share_files = subroutine.parse_baidupan_url(uk, shareid, remote_dir=fid)
        except:
            xbmcgui.Dialog().notification('警告', '分享链接不存在或者存在错误', xbmcgui.NOTIFICATION_ERROR)
            return []
    else:
        share_files = subroutine.parse_baidupan_url(uk)
        isRoot = True
    
    for item in share_files:
        if item['type'] == 'file':          #文件
            label = item['name']
            fid   = item['fs_id']
            path  = 'plugin://video.mfyun/play_baidupan/' + str(uk) + '/' + str(item['shareid']) + '/' + str(fid) + '/' + urllib.quote_plus(str(label)) + '/' + urllib.quote_plus(str(item['thumurl'])) + '/'
            filetype = item['filetype']
            if filetype == 'torrent':
                path  = 'plugin://plugin.video.mfyun/list_shared_torrent/' + str(uk) + '/' + str(item['shareid']) + '/' + urllib.quote_plus(item['path'].encode('utf-8')) + '/'
        elif item['type'] == 'folder':      #文件夹
            label = '[COLOR FFFFFF00]%s[/COLOR]' % item['name']
            fid   = item['fs_id']
            if isRoot:
                shareid = str(item['shareid'])
            path  = 'plugin://video.mfyun/myfollow_show_baidupan/' + str(uk) + '/' + shareid + '/' + urllib.quote_plus(str(fid)) + '/' + urllib.quote_plus(str(item['name'])) + '/'
        elif item['type'] == 'album':       #专辑
            label = '[COLOR FFFFFF00]%s[/COLOR]' % item['name']
            url   = 'http://yun.baidu.com/share/home?uk='+str(item['uk'])+'&view=album'
            path  = 'plugin://plugin.video.mfyun/get_album_detail_list/' + urllib.quote_plus(item['album_id']) + '/' +urllib.quote_plus(url)  + '/' +urllib.quote_plus(item['thumurl'])  + '/'
        
        mode = 11 if item['type'] == 'album' else 10
        
        iteminfo ={
            'type'      :  item['type'],
            'label'     :  label,
            'path'      :  path,
            'mode'      :  mode,
            'properties':  subroutine.is_torrent(item['name']) and {'isPlayable': ''} or {},
            'asfolder'  :  item['asfolder'],
            'filetype'  :  item['filetype'],
            }
        if item['type'] == 'file':
            iteminfo['thumbnail'] = item['thumurl']
        
        items.append(iteminfo)
        
                    
    return items

#播放关注的视频
@plugin.route('/play_baidupan/<uk>/<shareid>/<fid>/noresolved/',
         name='play_baidupan_noresolved', options={'noresolved': True})
@plugin.route('/play_baidupan/<uk>/<shareid>/<fid>/')
def play_baidupan(uk, shareid, fid, playname,noresolved=False,thumbnail='',favouriteinfo={}):
    if fid == 'null' or fid == '':
        fid = '1'
    path = "http://yun.baidu.com/share/link?shareid=" + str(shareid) + "&uk=" + str(uk) + "&fid=" + str(fid)
    properties = {}
    properties['itemType'] = 'baiduyun_follow'
    properties['url'] = path
    properties['title'] = playname
    properties['thumb'] = thumbnail
    
    folderpath = xbmc.getInfoLabel('container.folderpath')
    pos = folderpath.find('?')
    host = folderpath[0:pos]
    params = run.get_params(folderpath[pos:])
    playname = params['playname'] if 'playname' in params else ''
    playpath = params['playpath'] if 'playpath' in params else ''
    get_type = params['get_type'] if 'get_type' in params else ''
    get_sourcetype = params['get_sourcetype'] if 'get_sourcetype' in params else ''
    parentPath = host+'?fromtype=history&historytype=myfollow&playname='+playname+'&playpath='+playpath+'&get_type='+get_type+'&get_sourcetype='+get_sourcetype+"&thumbnail="+urllib.quote_plus(thumbnail)
    properties['parentPath'] = parentPath
    
    player = itvi_play.ItviItemPlayer()
    player.play(properties,favouriteinfo)



