#!/usr/bin/python
# -*- coding: utf-8 -*-
import sys
import os
import time
import traceback
import urllib
import json
from pkgutil import iter_modules
from xbmcswift2 import Plugin, actions, xbmc, xbmcgui
from urllib import quote_plus, unquote_plus, urlencode
import urllib2
import re
import xbmcvfs
import xbmcaddon
import itvi_play
import personal
import run

plugin = Plugin()
plugin_path = plugin.addon.getAddonInfo('path')
lib_path = os.path.join(plugin_path, 'resources', 'lib')
sys.path[0:0] = [lib_path,
                 os.path.join(lib_path, 'poster-0.4-py2.6.egg'),
                 os.path.join(lib_path, 'rsa_x509_pem-0.1.0.egg')]

__addonid__ = "plugin.video.mfyun"
__addon__ = xbmcaddon.Addon(id=__addonid__)
RESOURCES_PATH = os.path.join(__addon__.getAddonInfo('path'), 'media')
lib_path = os.path.join(__addon__.getAddonInfo('path'), 'lib')
sys.path.append (lib_path)
import utils
import myplayer
from client_api import ClientAPI, PCSApiError, ClientApiError, TRANSCODE_TYPES
from CaptchaDialog import CaptchaDialog

        
def delete_path_mf(userid, path):
    api = get_api(userid)
    try:
        #plugin.notify('正在删除文件，请稍候...', delay=2000, image='DefaultIconInfo.png')
        api.delete(path)
    except PCSApiError as e:
        utils.show_msg(str(e), '')
    else:
        xbmc.sleep(1000)
        #utils.refresh()
        

@plugin.route('/select_user/')
def select_user():
    config = plugin.get_storage('config')
    users = config.get('users', {})
    if not users:
        return

    userid_list = users.keys()
    userid_list.insert(0, NULL_USER)
    choice = utils.select('请选择活动帐号', userid_list)
    if choice < 0:
        return

    config['current_user'] = userid_list[choice] if choice > 0 else None
    config.sync()
    utils.refresh()
    
def select_user_mf(userid):
    config = plugin.get_storage('config')
    config['current_user'] = userid
    
    config.sync()
    utils.refresh()
    

@plugin.route('/remove_user/<userid>/')
def remove_user(userid):
    if not utils.yesno('注销帐号', '是否注销帐号 %s？' % userid):
        return

    config = plugin.get_storage('config')
    users = config.setdefault('users', {})
    users.pop(userid, None)
    if config.get('current_user') == userid:
        config['current_user'] = None
        HotSourceUser = ['videoshare@qq.com','videoshare001@qq.com','videoshare002@qq.com','videoshare003@qq.com','videoshare004@qq.com','videoshare005@qq.com','videoshare006@qq.com',
                         'videofactory@126.com','seek2man@126.com','wefreecash@163.com','switchfun@163.com','tookpig@163.com']
        for user in users.keys():
            if user not in HotSourceUser:
                config['current_user'] = user
                break
        
    config.sync()

    userdata = plugin.get_storage('userdata')
    userdata.pop(userid, None)
    userdata.sync()

    plugin.notify('帐号已经注销成功', delay=3000, image='DefaultIconInfo.png')
    utils.refresh()
    
    
def remove_user_mf(userid):
    #plugin.notify('正在尝试删除用户信息', delay=3000, image='DefaultIconInfo.png')
    pass
    
#     config = plugin.get_storage('config')
#     users = config.setdefault('users', {})
#     users.pop(userid, None)
#     if config.get('current_user') == userid:
#         config['current_user'] = users.keys()[0] if users else None
#     config.sync()
# 
#     userdata = plugin.get_storage('userdata')
#     userdata.pop(userid, None)
#     userdata.sync()

    #plugin.notify('正常尝试注销重新登录', delay=3000, image='DefaultIconInfo.png')
    #utils.refresh()
    

# @plugin.route('/add_user/')
# def add_user():
#     userid = (utils.keyboard(heading='请输入您的百度云帐号')
#               or '').strip()
#     if not userid:
#         return
# 
#     config = plugin.get_storage('config')
#     users = config.setdefault('users', {})
#     if userid in users:
#         plugin.notify('用户已存在', delay=2000, image='DefaultIconInfo.png')
#         return
# 
#     password = (utils.keyboard(heading='请输入密码', hidden=True)
#                 or '').strip()
#     if not password:
#         returith_publickey()
#     try:
#         login_info = api.try_login(userid, password, on_verifycode)
#     except Exception as e:
#         plugin.log.info(traceback.format_exc())
#         if isinstance(e, ClientApiError):
#             e = e.get_errmsg()
#         plugin.notify('登录失败: %s' % e,delay=2000, image='DefaultIconInfo.png')
#         return
# 
#     if not login_info:
#         return
# 
#     _save_user_info(config, userid, password, login_info, api)
# 
#     plugin.notify('用户添加成功', delay=3000, image='DefaultIconInfo.png')
#     utils.refresh()
    
def add_user_mf(userid,password):

    config = plugin.get_storage('config')
    users = config.setdefault('users', {})
    #不判断是否存在，无论是否存在，都尝试登录
#     if userid in users:
#         plugin.notify('用户已存在', delay=2000, image='DefaultIconInfo.png')
#         return "success"

    api = personal.creaet_api_with_publickey()
    try:
        login_info = api.try_login(userid, password, on_verifycode)
    except Exception as e:
        plugin.log.info(traceback.format_exc())
        emsg = e
        errno = 0
        if isinstance(e, ClientApiError):
            emsg = e.get_errmsg()
            errno = e.get_errno()
        plugin.notify('登录失败: %s' % emsg,delay=3000, image='DefaultIconInfo.png')
        if errno == 2 :
            return "fail"
        if errno == 16 :
            return "fail"
        
        heading = "百度云账号"
        # exist = ""
        # xbmc.executebuiltin('SetWindowData(10156,heading,%s)' %heading)
        # xbmc.executebuiltin('SetWindowData(10156,userid,%s)' %userid)
        # xbmc.executebuiltin('SetWindowData(10156,password,%s)' %password)
        # xbmc.executebuiltin('SetWindowData(10156,exist,%s)' %exist)
        # xbmc.executebuiltin('ActivateWindow(dialogmorefunlogin)')
        dialog = xbmcgui.Dialog()
        if not password :
            password = ""
        ret = dialog.login(heading, str(userid), str(password))
        if ret[0] == '1' and ret[1] and ret[2]:
            run.login(ret[1],ret[2])
        return "fail"

    if not login_info:
        return "cancel"
    else:
        select_user_mf(userid)

    _save_user_info(config, userid, password, login_info, api)

    plugin.notify('用户添加成功', delay=3000, image='DefaultIconInfo.png')
    utils.refresh()
    return "success"


def add_defaultuser(userid,password):
    config = plugin.get_storage('config')
    users = config.setdefault('users', {})
    if userid in users:
        #plugin.notify('用户已存在', delay=2000, image='DefaultIconInfo.png')
        return "success"

    api = personal.creaet_api_with_publickey()
    try:
        login_info = api.try_login(userid, password, on_verifycode)
    except Exception as e:
        plugin.log.info(traceback.format_exc())
        if isinstance(e, ClientApiError):
            e = e.get_errmsg()
        plugin.notify('登录失败: %s' % e,delay=3000, image='DefaultIconInfo.png')
        return "fail"

    if not login_info:
        return "cancel"

    _save_user_info(config, userid, password, login_info, api)

    plugin.notify('用户添加成功', delay=3000, image='DefaultIconInfo.png')
    utils.refresh()
    return "success"

@plugin.route('/relogin/<userid>/')
def relogin(userid):
    config = plugin.get_storage('config')
    users = config['users']

    #old_password = users[userid]
    old_password = ""
    if userid in users:
        old_password = users[userid]
        
    password = (utils.keyboard(old_password, '请输入密码', True) or '').strip()
    if not password:
        return

    api = personal.creaet_api_with_publickey()
    try:
        login_info = api.try_login(userid, password, on_verifycode)
    except Exception as e:
        plugin.log.info(traceback.format_exc())
        if isinstance(e, ClientApiError):
            e = e.get_errmsg()
        plugin.notify('登录失败: %s' % e,delay=3000, image='DefaultIconInfo.png')
        return

    if not login_info:
        return

    _save_user_info(config, userid, password, login_info, api)

    plugin.notify('用户登录成功', delay=3000, image='DefaultIconInfo.png')
    utils.refresh()
    
def relogin_mf(userid,password):
    
    config = plugin.get_storage('config')
    users = config.setdefault('users', {})
    api = personal.creaet_api_with_publickey()
    try:
        login_info = api.try_login(userid, password, on_verifycode)
    except Exception as e:
        plugin.log.info(traceback.format_exc())
        emsg = e
        errno = 0
        if isinstance(e, ClientApiError):
            emsg = e.get_errmsg()
            errno = e.get_errno()
        plugin.notify('登录失败: %s' % emsg,delay=3000, image='DefaultIconInfo.png')
        
        if errno == 2 :
            return "fail"
        if errno == 16 :
            return "fail"
        
        heading = "百度云账号"
        # exist = ""
        # xbmc.executebuiltin('SetWindowData(10156,heading,%s)' %heading)
        # xbmc.executebuiltin('SetWindowData(10156,userid,%s)' %userid)
        # xbmc.executebuiltin('SetWindowData(10156,password,%s)' %password)
        # xbmc.executebuiltin('SetWindowData(10156,exist,%s)' %exist)
        # xbmc.executebuiltin('ActivateWindow(dialogmorefunlogin)')
        dialog = xbmcgui.Dialog()
        if not password :
            password = ""
        ret = dialog.login(heading, str(userid), str(password))
        if ret[0] == '1' and ret[1] and ret[2]:
            run.login(ret[1],ret[2])
        return
    if not login_info:
        return
    else:
        select_user_mf(userid)
    _save_user_info(config, userid, password, login_info, api)
    plugin.notify('用户登录成功', delay=3000, image='DefaultIconInfo.png')
    #utils.refresh()

def get_default_userid():
    return plugin.get_storage('config').get('current_user')

@plugin.route('/clear_cache/')
def clear_cache():
    plugin.clear_function_cache()
    plugin.notify('缓存清除完毕！'.encode('utf-8'),delay=2000, image='DefaultIconInfo.png')


@plugin.route('/users_list/')
def users_list():
    items = []
    config = plugin.get_storage('config')
    users = config.setdefault('users', {})
    for userid in users.keys():
        items.append({
            'label': userid,
                     'path': plugin.url_for('remove_user', userid=userid),
                     'is_playable': True,
                     'properties': {'isPlayable': ''},
            'context_menu': [(
                '[COLOR FFFFFF00]重新登录[/COLOR]',
                actions.background(
                    plugin.url_for('relogin', userid=userid))
            )],
            'replace_context_menu': True
        })

    return items





def on_verifycode(imgurl, captcha_error=False):
    if captcha_error:
        plugin.notify('验证码不正确，请重新输入', delay=2000, image='DefaultIconInfo.png')
#     import time
#     time.sleep(6)
    win = CaptchaDialog('captcha.xml', plugin_path, imgurl=imgurl)
    try:
        win.doModal()
        input_text = win.get_text()
        if input_text:
            return input_text
    finally:
        del win
        

def _save_user_info(config, userid, password, login_info, api):
    
    #plugin.notify('正在保存用户信息', delay=2000, image='DefaultIconInfo.png')
        
    users = config['users']
    users[userid] = password
    if not config.get('current_user'):
        config['current_user'] = userid

    ss = (login_info['bduss'], login_info[
          'uid'], login_info['ptoken'], login_info['stoken'])

    api.set_login_info(ss)

    userdata = plugin.get_storage('userdata')
    userdata[userid] = {'session': ss, 'session_time': time.time()}

    config.sync()
    userdata.sync()

def save_user_info_for_hotsource(userid, password, login_info, select=False):
    config = plugin.get_storage('config')
    users = config.setdefault('users', {})
    users[userid] = password
    if select:
        config['current_user'] = userid

    ss = (login_info['bduss'], login_info[
          'uid'], login_info['ptoken'], login_info['stoken'])

    userdata = plugin.get_storage('userdata')
    userdata[userid] = {'session': ss, 'session_time': time.time()}

    config.sync()
    userdata.sync()