# -*- coding: utf-8 -*-
import os, sys, re
from traceback import print_exc

import xbmc, xbmcgui
from xbmcaddon import Addon
import urllib2, urllib, httplib, time
#import cookielib
if sys.version_info < (2, 7):
    import simplejson
else:
    import json as simplejson

from utils import keyboard


__settings__ = Addon( "script.module.dialog.mflogin" )
__addonDir__ = __settings__.getAddonInfo( "path" )
__language__ = __settings__.getLocalizedString
__profile__  = xbmc.translatePath( __settings__.getAddonInfo('profile') ).decode("utf-8")

XBMC_SKIN  = xbmc.getSkinDir()
SKINS_PATH = os.path.join( __addonDir__, "resources", "skins" )
ADDON_SKIN = ( "default", XBMC_SKIN )[ os.path.exists( os.path.join( SKINS_PATH, XBMC_SKIN ) ) ]
MEDIA_PATH = os.path.join( SKINS_PATH, ADDON_SKIN, "media" )

#cookieFile = __profile__ + 'cookies.baidu'
UserAgent  = 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3'

ACTION_PARENT_DIR     = 9
ACTION_PREVIOUS_MENU  = (10, 92)

CTRL_ID_HEAD = 1
CTRL_ID_USERID = 9001
CTRL_ID_PASSWORD = 9002
CTRL_ID_LOGIN = 110
CTRL_ID_REMOVE = 111
CTRL_ID_CANCEL = 112

class InputWindow(xbmcgui.WindowXMLDialog):
    def __init__( self, *args, **kwargs ):
        self.heading = kwargs.get("heading") or ""
        self.userid = kwargs.get("userid") or ""
        self.password = kwargs.get("password") or ""
        self.remove = kwargs.get("remove") or False
        self.result = ['0']
        self.confirmed = False
        xbmcgui.WindowXMLDialog.__init__(self)

    def onInit(self):
        self.getControl(CTRL_ID_HEAD).setLabel(self.heading)
        self.getControl(CTRL_ID_USERID).setText(self.userid)
        self.getControl(CTRL_ID_PASSWORD).setText(self.password)
        self.getControl(CTRL_ID_REMOVE).setVisible(self.remove)
        self.getControl(CTRL_ID_USERID).setEnabled(not self.remove)
        if not self.remove and not self.userid:
            self.setFocusId(CTRL_ID_USERID)
        elif not self.password:
            self.setFocusId(CTRL_ID_PASSWORD)
        else:
            self.setFocusId(CTRL_ID_LOGIN)
    
    def onFocus( self, controlId ):
        self.controlId = controlId

    def onClick( self, controlID ):
        if controlID == CTRL_ID_USERID:
            old_userid = self.getControl(CTRL_ID_USERID).getText()
            userid = (keyboard(default=old_userid, heading=u'请输入用户名') or '').strip()
            self.getControl(CTRL_ID_USERID).setText(userid)
        elif controlID == CTRL_ID_LOGIN:
            userid = self.getControl(CTRL_ID_USERID).getText()
            password = self.getControl(CTRL_ID_PASSWORD).getText()
            result = ['1']
            result.append(userid)
            result.append(password)
            self.result = result
            self.confirmed = True
            self.close()
        elif controlID == CTRL_ID_REMOVE:
            userid = self.getControl(CTRL_ID_USERID).getText()
            password = self.getControl(CTRL_ID_PASSWORD).getText()
            result = ['2']
            result.append(userid)
            result.append(password)
            self.result = result
            self.confirmed = True
            self.close()
        elif controlID == CTRL_ID_CANCEL:
            userid = self.getControl(CTRL_ID_USERID).getText()
            password = self.getControl(CTRL_ID_PASSWORD).getText()
            result = ['0']
            result.append(userid)
            result.append(password)
            self.result = result
            self.confirmed = False
            self.close()
    
    def onAction(self,action):
        if action.getId() in ACTION_PREVIOUS_MENU:
            self.close()

    def isConfirmed(self):
        return self.confirmed

    def getResult(self):
        return self.result

class MFLogin:
    def __init__( self, heading, userid='', password='', remove=False ):
        self.confirmed = False
        self.heading = heading
        self.userid = userid
        self.password = password
        self.remove = remove
        self.result = []

    def doModal (self):
        self.win = InputWindow("DialogMFLogin.xml", __addonDir__, ADDON_SKIN, heading=self.heading, userid=self.userid, password=self.password, remove=self.remove )
        self.win.doModal()
        self.confirmed = self.win.isConfirmed()
        self.result = self.win.getResult()
        del self.win

    def setHeading(self, heading):
        self.heading = heading
    
    def setUserid(self, userid):
        self.userid = userid
    
    def setPassword(self, password):
        self.password = password
    
    def setRemove(self, remove):
        self.remove = remove

    def isConfirmed(self):
        return self.confirmed

    def getResult(self):
        return self.result
    
def showAndGetInput(heading, userid='', password='', remove=False):
    login_dialog = MFLogin(heading, userid, password, remove)
    xbmc.sleep(1000)
    login_dialog.doModal()
    return login_dialog.getResult()
