# -*- coding: utf-8 -*-
# default.py

import sqlite3
import json
import time
import os
import sys
import urllib, urllib2
import urlparse
import re
import xbmc, xbmcgui, xbmcplugin

FAVOURITE_DB = xbmc.translatePath('special://home/userdata/Database/MyVideos80.db').decode("utf-8")

reload(sys)
sys.setdefaultencoding('utf8')

def GetHttpData(url):
    #UserAgent = ''
    req = urllib2.Request(url)
    #req.add_header('User-Agent', UserAgent)
    response = urllib2.urlopen(req)
    httpdata = response.read()
    if response.headers.get('content-encoding', None) == 'gzip':
        httpdata = gzip.GzipFile(fileobj=StringIO.StringIO(httpdata)).read()
    response.close()
    match = re.compile('encodingt=(.+?)"').findall(httpdata)
    if len(match)<=0:
        match = re.compile('meta charset="(.+?)"').findall(httpdata)
    if len(match)>0:
        charset = match[0].lower()
        if (charset != 'utf-8') and (charset != 'utf8'):
            httpdata = unicode(httpdata, charset).encode('utf8')
    return httpdata


def getFavourites():
    print '[script.module.itvifav] getting favourites ...'
    favouriteItems = []
    ret = True
    try:
        conn = sqlite3.connect(FAVOURITE_DB)
        conn.row_factory = sqlite3.Row
        c = conn.cursor()
        c.execute("select * from userfavourite order by addTime DESC")
        
        for row in c.fetchall():
            item = {}
            item['idItem'] = row['idItem']
            item['itemType'] = row['itemType']
            item['url'] = row['url']
            item['title'] = row['title']
            item['thumb'] = row['thumb']
            item['playable'] = row['playable']
            item['addTime'] = row['addTime']
            item['updateTime'] = row['updateTime']
            item['updateUrl'] = row['updateUrl']
            item['episodesNum'] = row['episodesNum']
            favouriteItems.append(item)
        conn.close()
    except:
        print '[script.module.itvifav] get favourites failed!'
        ret = False
    
    return favouriteItems, ret

def saveToFile(obj, file_name):
    print '[script.module.itvifav] saving %s ...' %file_name
    try:
        file = open(file_name, 'w')
        json.dump(obj, file, indent=2, separators=(',',':'))
        file.close()
    except Exception, e:
        print '[script.module.itvifav] save %s failed!' %file_name
        return False
    return True
        

def exportFavourite(saveFile):
    if not saveFile:
        return
    
    saveFile=unicode(saveFile,'utf8')
        
    if not os.path.isdir(os.path.dirname(saveFile)):
        return
        
    favourites, result = getFavourites()
    if not result:
        dialog = xbmcgui.Dialog()
        dialog.ok('提示', '读取收藏列表时发生错误')
        return
    if not favourites:
        dialog = xbmcgui.Dialog()
        dialog.ok('提示', '收藏列表为空')
        return
        
    if saveToFile(favourites, saveFile):
        dialog = xbmcgui.Dialog()
        fileName = os.path.basename(saveFile)
        dialog.notification('提示', '导出收藏文件%s成功' %fileName, xbmcgui.NOTIFICATION_INFO, 5000)
    else:
        dialog = xbmcgui.Dialog()
        dialog.ok('提示', '将收藏列表写入文件时发生错误')

def loadFavourite(filePath):
    
    filePath=unicode(filePath,'utf8')
    
    if not os.path.isfile(filePath):
        return
    fileName = os.path.basename(filePath)
    favouriteFile = open(filePath)
    strFavourites = ''
    openRet = True
    try:
        strFavourites = favouriteFile.read()
    except:
        openRet = False
    finally:
        favouriteFile.close()
    if not openRet:
        dialog = xbmcgui.Dialog()
        dialog.notification('提示', '读取muf文件失败', xbmcgui.NOTIFICATION_ERROR, 5000)
        xbmcplugin.setProperty(int(sys.argv[1]), 'favouritetype', 'muf')
        xbmcplugin.setProperty(int(sys.argv[1]), 'favouritename', fileName)
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
        return
    
    if not strFavourites:
        dialog = xbmcgui.Dialog()
        dialog.notification('提示', 'muf文件内容为空', xbmcgui.NOTIFICATION_ERROR, 5000)
        xbmcplugin.setProperty(int(sys.argv[1]), 'favouritetype', 'muf')
        xbmcplugin.setProperty(int(sys.argv[1]), 'favouritename', fileName)
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
        return
    
    strFavourites = strFavourites.decode('gbk').encode('utf-8')
    favourites = []
    try:
        favourites = json.JSONDecoder().decode(strFavourites)
    except:
        dialog = xbmcgui.Dialog()
        dialog.ok('提示', 'muf文件格式不正确')
        xbmcplugin.setProperty(int(sys.argv[1]), 'favouritetype', 'muf')
        xbmcplugin.setProperty(int(sys.argv[1]), 'favouritename', fileName)
        xbmcplugin.endOfDirectory(int(sys.argv[1]))
        return
    for favourite in favourites:
        idItem = favourite['idItem'].encode("utf-8") if 'idItem' in favourite and favourite['idItem'] else ''
        itemType = favourite['itemType'].encode("utf-8") if 'itemType' in favourite and favourite['itemType'] else ''
        url = favourite['url'].encode("utf-8") if 'url' in favourite and favourite['url'] else ''
        title = favourite['title'].encode("utf-8") if 'title' in favourite and favourite['title'] else ''
        thumb = favourite['thumb'].encode("utf-8") if 'thumb' in favourite and favourite['thumb'] else ''
        playable = favourite['playable'] if 'playable' in favourite and favourite['playable'] else 0
        addTime = favourite['addTime'] if 'addTime' in favourite and favourite['addTime'] else 0
        updateTime = favourite['updateTime'] if 'updateTime' in favourite and favourite['updateTime'] in favourite else 0
        updateUrl = favourite['updateUrl'].encode("utf-8") if 'updateUrl' in favourite and favourite['updateUrl'] else ''
        episodesNum = favourite['episodesNum'] if 'episodesNum' in favourite and favourite['episodesNum'] else 0
        
        listitem=xbmcgui.ListItem(title,thumbnailImage=thumb)
        listitem.setProperty('idItem', idItem)
        listitem.setProperty('itemType', itemType)
        listitem.setProperty('url', url)
        listitem.setProperty('title', title)
        listitem.setProperty('thumb', thumb)
        listitem.setProperty('playable', str(playable))
        listitem.setProperty('addTime', str(addTime))
        listitem.setProperty('updateTime', str(updateTime))
        listitem.setProperty('updateUrl', updateUrl)
        listitem.setProperty('episodesNum', str(episodesNum))
        xbmcplugin.addDirectoryItem(int(sys.argv[1]), '', listitem, True)
    xbmcplugin.setProperty(int(sys.argv[1]), 'favouritetype', 'muf')
    xbmcplugin.setProperty(int(sys.argv[1]), 'favouritename', fileName)
    xbmcplugin.endOfDirectory(int(sys.argv[1]))

def onClick(url, itemType, title, thumb):
    if not url:
        dialog = xbmcgui.Dialog()
        dialog.ok('提示', '链接地址为空')
        return
    # 磁力链
    if is_magnet(url):
        playpath = 'plugin://plugin.video.mfyun/list_magnet/'+urllib.quote_plus(url)+'/'
        newurl = 'plugin://plugin.video.mfyun/?mode=10&playname='+urllib.quote_plus(title)+'&playpath='+urllib.quote_plus(playpath)
        if xbmc.getCondVisibility('Window.IsVisible(MoreFunVideo)'):
            xbmc.executebuiltin('Container.Update(%s)' %newurl)
        else:
            xbmc.executebuiltin('ActivateWindow(MoreFunVideo,%s,return)' %newurl)
        return
    # 电驴链接
    if is_ed2k(url):
        playpath = 'plugin://plugin.video.mfyun/play_ed2k/'+urllib.quote_plus(url)+'/'
        newurl = 'plugin://plugin.video.mfyun/?mode=10&playname='+urllib.quote_plus(title)+'&playpath='+urllib.quote_plus(playpath)
        xbmc.executebuiltin('RunPlugin(%s)' %newurl)
        return
    parsedUrl = urlparse.urlparse(url)
    netloc = parsedUrl.netloc
    path = parsedUrl.path
    query = parsedUrl.query
    query_splited = urlparse.parse_qs(query, True)
    fragment = parsedUrl.fragment
    # 金山影视资源
    if netloc.find('v.duba.com') != -1:
        category_id = ''
        if path.find('moviedetail') != -1:
            category_id = '1'
        if path.find('tvdetail') != -1:
            category_id = '2'
        if path.find('cartoondetail') != -1:
            category_id = '3'
        if path.find('varietydetail') != -1:
            category_id = '4'
        if not category_id:
            dialog = xbmcgui.Dialog()
            dialog.ok('提示', '暂不支持该资源')
            return
        newurl = 'plugin://plugin.video.mfvod/?mode=2&url='+urllib.quote_plus(url)+"&name="+urllib.quote_plus(title)+"&thumbnail="+urllib.quote_plus(thumb)+'&category_id='+urllib.quote_plus(category_id)+'&resappepisodes='
        if xbmc.getCondVisibility('Window.IsVisible(MoreFunVideo)'):
            xbmc.executebuiltin('Container.Update(%s)' %newurl)
        else:
            xbmc.executebuiltin('ActivateWindow(MoreFunVideo,%s,return)' %newurl)
    # 百度云资源
    elif netloc.find('yun.baidu.com') != -1:
        view = query_splited['view'][0] if 'view' in query_splited and query_splited['view'] else ''
        # 用户分享的所有专辑列表
        if path == '/share/home' and view == 'album':
            playpath = 'plugin://plugin.video.mfyun/get_album_items_from_url/'+urllib.quote_plus(title)+'/'+urllib.quote_plus(url)+'/'
            newurl = 'plugin://plugin.video.mfyun/?mode=11&playname='+urllib.quote_plus(title)+'&playpath='+urllib.quote_plus(playpath)
            if xbmc.getCondVisibility('Window.IsVisible(MoreFunVideo)'):
                xbmc.executebuiltin('Container.Update(%s)' %newurl)
            else:
                xbmc.executebuiltin('ActivateWindow(MoreFunVideo,%s,return)' %newurl)
        # 某专辑详情界面
        elif path == '/pcloud/album/info':
            uk = query_splited['uk'][0] if 'uk' in query_splited and query_splited['uk'] else ''
            album_id = query_splited['album_id'][0] if 'album_id' in query_splited and query_splited['album_id'] else ''
            if uk and album_id:
                album_home_url = 'http://yun.baidu.com/share/home?uk=%s&view=album' %uk
                playpath = 'plugin://plugin.video.mfyun/get_album_detail_list/'+urllib.quote_plus(album_id)+'/'+urllib.quote_plus(album_home_url)+'/'+urllib.quote_plus(thumb)+'/'
                newurl = 'plugin://plugin.video.mfyun/?mode=11&playname='+urllib.quote_plus(title)+'&playpath='+urllib.quote_plus(playpath)
                if xbmc.getCondVisibility('Window.IsVisible(MoreFunVideo)'):
                    xbmc.executebuiltin('Container.Update(%s)' %newurl)
                else:
                    xbmc.executebuiltin('ActivateWindow(MoreFunVideo,%s,return)' %newurl)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('提示', '暂不支持该资源')
        # 专辑内的视频
        elif path == '/pcloud/album/file':
            uk = query_splited['uk'][0] if 'uk' in query_splited and query_splited['uk'] else ''
            album_id = query_splited['album_id'][0] if 'album_id' in query_splited and query_splited['album_id'] else ''
            fsid = query_splited['fsid'][0] if 'fsid' in query_splited and query_splited['fsid'] else ''
            if uk and album_id and fsid:
                playpath = 'plugin://plugin.video.mfyun/play_album_detail/'+urllib.quote_plus(title)+'/'+urllib.quote_plus(url)+'//'+urllib.quote_plus(thumb)+'//'
                newurl = 'plugin://plugin.video.mfyun/?mode=11&playname='+urllib.quote_plus(title)+'&playpath='+urllib.quote_plus(playpath)
                xbmc.executebuiltin('RunPlugin(%s)' %newurl)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('提示', '暂不支持该资源')
        # 用户分享全部文件列表
        elif path == '/share/home' and view == 'share':
            uk = query_splited['uk'][0] if 'uk' in query_splited and query_splited['uk'] else ''
            if uk:
                playpath = 'plugin://video.mfyun/myfollow_show_items_mf/'+urllib.quote_plus(uk)
                newurl = 'plugin://plugin.video.mfyun/?mode=10&playname='+urllib.quote_plus(title)+'&playpath='+urllib.quote_plus(playpath)+'&thumbnail='+urllib.quote_plus(thumb)
                if xbmc.getCondVisibility('Window.IsVisible(MoreFunVideo)'):
                    xbmc.executebuiltin('Container.Update(%s)' %newurl)
                else:
                    xbmc.executebuiltin('ActivateWindow(MoreFunVideo,%s,return)' %newurl)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('提示', '暂不支持该资源')
        # 用户分享根目录下的资源，及子目录
        elif path.find('/s/') != -1:
            uk = ''
            shareid = ''
            fid = ''
            content = GetHttpData(url)
            match = re.search('FileUtils.share_uk="(.+?)"', content)
            if match:
                uk = match.groups()[0]
            match = re.search('FileUtils.share_id="(.+?)"', content)
            if match:
                shareid = match.groups()[0]
            match = re.search('disk.util.ViewShareUtils.fsId="(.+?)"', content)
            if match:
                fid = match.groups()[0]
            
            if uk and shareid:
                if not fid:
                    # 目录类型包括子目录
                    fragment_splited = fragment.split('=')
                    if len(fragment_splited) > 1 and fragment_splited[0] == 'dir/path':
                        fid = fragment_splited[1]
                    playpath = 'plugin://video.mfyun/myfollow_show_baidupan/'+urllib.quote_plus(uk)+'/'+urllib.quote_plus(shareid)+'/'+fid+'/'
                    newurl = 'plugin://plugin.video.mfyun/?mode=10&playname='+urllib.quote_plus(title)+'&playpath='+urllib.quote_plus(playpath)+'&thumbnail='+urllib.quote_plus(thumb)
                    if xbmc.getCondVisibility('Window.IsVisible(MoreFunVideo)'):
                        xbmc.executebuiltin('Container.Update(%s)' %newurl)
                    else:
                        xbmc.executebuiltin('ActivateWindow(MoreFunVideo,%s,return)' %newurl)
                else:
                    path = ''
                    match = re.search(r'\\"path\\":\\"(.+?)\\"', content)
                    if match:
                        path = match.groups()[0].strip('\\').replace('\\\\','\\').decode('unicode_escape').encode('utf-8')
                    # 种子文件
                    if is_torrent(path):
                        playpath = 'plugin://plugin.video.mfyun/list_shared_torrent/'+urllib.quote_plus(uk)+'/'+urllib.quote_plus(shareid)+'/'+urllib.quote_plus(path)+'/'
                        newurl = 'plugin://plugin.video.mfyun/?mode=10&playname='+urllib.quote_plus(title)+'&playpath='+urllib.quote_plus(playpath)+'&thumbnail='+urllib.quote_plus(thumb)
                        if xbmc.getCondVisibility('Window.IsVisible(MoreFunVideo)'):
                            xbmc.executebuiltin('Container.Update(%s)' %newurl)
                        else:
                            xbmc.executebuiltin('ActivateWindow(MoreFunVideo,%s,return)' %newurl)
                    # 视频文件
                    elif is_video(path):
                        playpath = 'plugin://video.mfyun/play_baidupan/'+urllib.quote_plus(uk)+'/'+urllib.quote_plus(shareid)+'/'+urllib.quote_plus(fid)+'/'
                        newurl = 'plugin://plugin.video.mfyun/?mode=10&playname='+urllib.quote_plus(title)+'&playpath='+urllib.quote_plus(playpath)+'&thumbnail='+urllib.quote_plus(thumb)
                        xbmc.executebuiltin('RunPlugin(%s)' %newurl)
                    else:
                        dialog = xbmcgui.Dialog()
                        dialog.ok('提示', '暂不支持该资源')
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('提示', '暂不支持该资源')
        # 用户分享的子目录下的视频文件
        elif path == '/share/link':
            uk = query_splited['uk'][0] if 'uk' in query_splited and query_splited['uk'] else ''
            shareid = query_splited['shareid'][0] if 'shareid' in query_splited and query_splited['shareid'] else ''
            fid = query_splited['fid'][0] if 'fid' in query_splited and query_splited['fid'] else ''
            if uk and shareid and fid:
                playpath = 'plugin://video.mfyun/play_baidupan/'+urllib.quote_plus(uk)+'/'+urllib.quote_plus(shareid)+'/'+urllib.quote_plus(fid)+'/'+urllib.quote_plus(title)+'/'+urllib.quote_plus(thumb)+'/'
                newurl = 'plugin://plugin.video.mfyun/?mode=10&playname='+urllib.quote_plus(title)+'&playpath='+urllib.quote_plus(playpath)+'&thumbnail='+urllib.quote_plus(thumb)
                xbmc.executebuiltin('RunPlugin(%s)' %newurl)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('提示', '暂不支持该资源')
        else:
            dialog = xbmcgui.Dialog()
            dialog.ok('提示', '暂不支持该资源')
    # 百度云个人网盘资源，用于热门资源的几个特定帐号
    elif netloc.find('pan.baidu.com') != -1:
        fragment_splited = fragment.split('*&&*')
        userid = ''
        dir_path = ''
        if len(fragment_splited) > 1:
            userid = fragment_splited[1]
            path_splited = fragment_splited[0].split('=')
            if len(path_splited) > 1 and path_splited[0] == 'dir/path':
                dir_path = path_splited[1] # dir_path is quoted
        # 百度云个人网盘目录
        if path =='/disk/home':
            if userid and dir_path:
                playpath = 'plugin://plugin.video.mfyun/get_hotsource_pan/'+urllib.quote_plus(title)+'/'+urllib.quote_plus(userid)+'/'+dir_path+'/'
                newurl = 'plugin://plugin.video.mfyun/?mode=18&playname='+urllib.quote_plus(title)+'&playpath='+urllib.quote_plus(playpath)+'&thumbnail='+urllib.quote_plus(thumb)
                if xbmc.getCondVisibility('Window.IsVisible(MoreFunVideo)'):
                    xbmc.executebuiltin('Container.Update(%s)' %newurl)
                else:
                    xbmc.executebuiltin('ActivateWindow(MoreFunVideo,%s,return)' %newurl)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('提示', '暂不支持该资源')
        else:
            dialog = xbmcgui.Dialog()
            dialog.ok('提示', '暂不支持该资源')
    else:
        dialog = xbmcgui.Dialog()
        dialog.ok('提示', '暂不支持该资源')

def is_torrent(filename):
    return filename.lower().endswith('.torrent')

def is_video(filename):
    _video_file_exts = [
        '.mkv', '.rmvb', '.rm', '.avi', '.mpg', '.mpeg', '.mp4',
        '.mov', '.3gp', '.asf', '.wmv', '.flv', '.ts']
    filename = filename.lower()
    return any(filename.endswith(ext) for ext in _video_file_exts)

def is_ed2k(url):
    return url.lower().startswith('ed2k://')

def is_magnet(url):
    return url.lower().startswith('magnet:')

def get_params(url = ''):
    param = []
    paramstring = sys.argv[2] if len(sys.argv)>2 else sys.argv[1]
    paramstring = paramstring if url=='' else url
    if len(paramstring) >= 2:
        params = paramstring
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]
    return param

mode = ''
path = ''
url = ''
itemType = ''
title = ''
thumb = ''

params = get_params()
try:
    mode = urllib.unquote_plus(params["mode"])
except:
    pass

try:
    path = urllib.unquote_plus(params["path"])
except:
    pass

try:
    url = urllib.unquote_plus(params["url"])
except:
    pass
try:
    itemType = urllib.unquote_plus(params["itemType"])
except:
    pass
try:
    title = urllib.unquote_plus(params["title"])
except:
    pass
try:
    thumb = urllib.unquote_plus(params["thumb"])
except:
    pass

if mode == 'export':
    exportFavourite(path)
elif mode == 'load':
    loadFavourite(path)
elif mode == 'click':
    onClick(url, itemType, title, thumb)