# -*- coding: utf-8 -*-
import json, urllib, urllib2, re, os, sys, traceback, time
import xbmc, xbmcgui
import xbmcaddon
from xbmcswift2 import Plugin

plugin_itviplay = Plugin(addon_id='script.module.itviplay')
plugin_path = plugin_itviplay.addon.getAddonInfo('path')
lib_path = xbmc.translatePath( os.path.join(plugin_path, 'lib', 'libs') ).decode("utf-8")
sys.path[0:0] = [lib_path,
                 os.path.join(lib_path, 'poster-0.4-py2.6.egg'),
                 os.path.join(lib_path, 'rsa_x509_pem-0.1.0.egg')]
reload(sys)
sys.setdefaultencoding('utf-8')

plugin = Plugin()

import utils, myplayer
from client_api import ClientAPI, PCSApiError, ClientApiError, TRANSCODE_TYPES
from CaptchaDialog import CaptchaDialog
import subroutine


__addon__      = xbmcaddon.Addon()
__language__   = __addon__.getLocalizedString

class ItviItemPlayer:
    def __init__(self):
        self.selectedList={}
        self._api_maps = {}
        self.plugin_mfyun = Plugin(addon_id='plugin.video.mfyun')
        self.collect_url_1 = 'http://pan.baidu.com/share/transfer?channel=chunlei&clienttype=0&web=1&from=%s&shareid=%s&bdstoken=%s&channel=chunlei&clienttype=0&web=1'
    
    def play(self, properties,favouriteinfo={}):
        if 'saveHistory' not in properties:
            properties['saveHistory'] = 'true'
        itemType = properties['itemType'] if 'itemType' in properties else ''
        if itemType == 'morefun':
            return self.playMorefuntvVideo(properties)
        elif itemType.find('baiduyun') != -1:
            return self.playBaiduyunVideo(properties,favouriteinfo)
        
    def SetSelectType(self, source_id,seltype):
        self.selectedList[source_id]=seltype
        
    def GetSelectType(self, source_id):
        if self.selectedList.has_key(source_id):
            return self.selectedList[source_id]
        else:
            return ""
        
    def getDefinitionText(self, seltype):
        if seltype == "nd":
            return "流畅";
        elif seltype == "hd":
            return "高清"
        elif seltype == "sd":
            return "超清"
        elif seltype == "sd2":
            return "超高清"
        elif seltype == "M3U8_AUTO_origin":
            return "原码"
        elif seltype == "M3U8_AUTO_720":
            return "超高清(720)"
        elif seltype == "M3U8_AUTO_480":
            return "超清(480)"
        elif seltype == "M3U8_AUTO_360":
            return "高清(360)"
        elif seltype == "M3U8_AUTO_240":
            return "流畅(240)"
        else:
            return ''

    def getDefinitionType(self, text):
        if text == "流畅":
            return "nd";
        elif text == "高清":
            return "hd"
        elif text == "超清":
            return "sd"
        elif text == "超高清":
            return "sd2"
        elif text == "原码":
            return "M3U8_AUTO_origin"
        elif text == "超高清(720)":
            return "M3U8_AUTO_720"
        elif text == "超清(480)":
            return "M3U8_AUTO_480"
        elif text == "高清(360)":
            return "M3U8_AUTO_360"
        elif text == "流畅(240)":
            return "M3U8_AUTO_240"
        else:
            return ''
        
    def playMorefuntvVideo(self, properties):
        source_id = properties['sourceId'] if 'sourceId' in properties else ''
        url = properties['url'] if 'url' in properties else ''
        #additional_property_dict = properties['additional_property_dict']
        source_kind = properties['sourceKind'] if 'sourceKind' in properties else ''
        item_id = properties['itemId'] if 'itemId' in properties else ''
        spiderName = properties['spiderName'] if 'spiderName' in properties else ''
        videoParam = properties['videoParam'] if 'videoParam' in properties else ''
        name = properties['title'] if 'title' in properties else ''
        thumb = properties['thumb'] if 'thumb' in properties else ''

        selectedRateType = ''
        if xbmc.getCondVisibility('Player.AutoPlayingNext'):
            selectedRateType = xbmc.getInfoLabel('Player.SelectedRateType')
        
        resultstr = xbmc.getRealUrl(int(source_id), url,"AnalysisRealUrlForMorefun","",source_kind,item_id,spiderName,videoParam)
        retlist=resultstr.split("~:")
        if len(retlist) > 2 and retlist[1] != "0" and retlist[2] == "0":
            resultstr = xbmc.getRealUrl(int(source_id), url,"AnalysisRealUrlForMorefun","",source_kind,item_id,spiderName,"<defFormat>m3u8</defFormat>")
        real_list = []
        select_text = ""
        if resultstr:
            retlist=resultstr.split("~:")
            if len(retlist)>2:
                resultstr=retlist[0]
                if retlist[2]=="1":  #canceled by user
                    return
                if retlist[1]!="0":
                    real_list.append("errcode")
                    real_list.append(retlist[1])
                    if xbmc.isSupportWebAnalysis(spiderName,'Android',url):
                        dialog = xbmcgui.Dialog()
                        ret = dialog.yesno("提示","是否进行原网页播放？")
                        if ret:
                            xbmc.executebuiltin('StartAndroidMfActivity("org.morefun.morefuntv","org.morefun.morefunie.MainActivity","","","morefun://morefunie/?params=<pageType>video</pageType><mfurl>%s</mfurl>")' %url)
                    return real_list
            rtjson = json.JSONDecoder().decode(resultstr)
            dtypes = []
            for seltype in ('sd2','sd','hd','nd'):
                if rtjson.has_key(seltype):
                    dtypes.append(self.getDefinitionText(seltype))
                    select_text = self.getDefinitionText(seltype)
            if len(dtypes) > 1 and (self.getDefinitionText(selectedRateType) not in dtypes):
                dialog = xbmcgui.Dialog()
                ret = dialog.select('请选择视频清晰度', dtypes)
                if ret >= 0:
                    select_text = dtypes[ret]
                else:
                    real_list.append("usercancel")
                    return real_list
            elif len(dtypes) == 1:
                select_text = dtypes[0]
            else:
                select_text = self.getDefinitionText(selectedRateType)
            self.SetSelectType(source_id,select_text)
                    
            if rtjson.has_key("callback"):
                resultstr = xbmc.getRealUrl(int(source_id), url,"AnalysisRealUrlItems",self.getDefinitionType(select_text),source_kind,item_id,spiderName,videoParam)
                retlist=resultstr.split("~:")
                if len(retlist)>2:
                    resultstr=retlist[0]
                    if retlist[2]=="1":  #canceled by user
                        return
                    if retlist[1]!="0":
                        real_list.append("errcode")
                        real_list.append(retlist[1])
                        if xbmc.isSupportWebAnalysis(spiderName,'Android',url):
                            dialog = xbmcgui.Dialog()
                            ret = dialog.yesno("提示","是否进行原网页播放？")
                            if ret:
                                xbmc.executebuiltin('StartAndroidMfActivity("org.morefun.morefuntv","org.morefun.morefunie.MainActivity","","","morefun://morefunie/?params=<pageType>video</pageType><mfurl>%s</mfurl>")' %url)
                        return real_list
                rtjson = json.JSONDecoder().decode(resultstr)    
            real_list = rtjson[self.getDefinitionType(select_text)]    
                    
            if rtjson.has_key("video_properties"):
                video_properties=rtjson["video_properties"]
                if video_properties:
                    for key in video_properties.keys():
                        keystr=str(key)
                        if keystr.endswith("_"+self.getDefinitionType(select_text)):
                            keystr=keystr[0:-len(self.getDefinitionType(select_text))-1]
                        #additional_property_dict[keystr]=str(video_properties.get(str(key)))
        playlist = xbmc.PlayList(1)
        playlist.clear()
        for i in range(0,len(real_list)):
            title =name+" 第"+str(i+1)+"/"+str(len(real_list))+"节"
            listitem=xbmcgui.ListItem(title)
            listitem.setInfo(type="Video",infoLabels={"Title":title})
            listitem.setThumbnailImage(thumb)
            listitem.setProperty('itemId',item_id)
            listitem.setProperty('playerRequired',"dvdplayer")
            listitem.setProperty('webUrl',url)
            listitem.setProperty('osdUrl',url)
            listitem.setProperty('spiderName',spiderName)
            listitem.setProperty('selectedRateType',self.getDefinitionType(select_text))
            for (key,value) in properties.items():
                listitem.setProperty(key, str(value))
            playlist.add(real_list[i], listitem)
        xbmc.Player().play(playlist)
    
    def playBaiduyunVideo(self, properties,favouriteinfo={}):
        itemType = properties['itemType'] if 'itemType' in properties else ''
        if itemType == 'baiduyun_album':
            return self.playBaiduyunAlbumVideo(properties)
        elif itemType == 'baiduyun_pan':
            return self.playBaiduyunPanVideo(properties)
        elif itemType == 'baiduyun_161':
            return self.playBaiduyun161Video(properties)
        elif itemType == 'baiduyun_follow':
            return self.playBaiduyun161Video(properties,favouriteinfo)
        elif itemType == 'baiduyun_torrent':
            return self.playBaiduyunTorrentVideo(properties)
        elif itemType == 'baiduyun_magnet':
            return self.playBaiduyunMagnetVideo(properties)
        elif itemType == 'baiduyun_ed2k':
            return self.playBaiduyunED2KVideo(properties)
    
    def playBaiduyunAlbumVideo(self, properties):
        xbmc.executebuiltin("ShowBusyDialog")
        url = properties['url'] if 'url' in properties else ''
        title = properties['title'] if 'title' in properties else ''
        
        subtitle = properties['subtitle'] if 'subtitle' in properties else ''
        
        weburl = url

        selectedRateType = ''
        if xbmc.getCondVisibility('Player.AutoPlayingNext'):
            selectedRateType = xbmc.getInfoLabel('Player.SelectedRateType')

        #title = "猫鼠游戏.White.Collar.S05E01.中英字幕.HDTVrip.1024X576.x264-YYeTs人人影视.mkv"
        #url = "http://yun.baidu.com/pcloud/album/file?album_id=3941012083858215211&uk=3225353827&fsid=386630203"
        album_id=""
        uk=""
        fsid=""
        errno2 = ""
        headers={}
        param_list = url.split("?")[-1].split("&")
        for param in param_list :
            if 'album_id' in param:
                album_id = param.replace("album_id=","")
            if 'uk' in param:
                uk = param.replace("uk=","")
            if 'fsid' in param:
                fsid = param.replace("fsid=","")
        #判断是否登录
        errno=90000
        userid = self.get_default_userid()
        if userid is None or userid == "":
            userid = "videouser@qq.com"
            password = "videouser@qq"
            ret = self.add_defaultuser(userid,password)
            
            if ret != "cancel":
                id = self.get_default_userid()
                if id == None:
                    ret = self.add_defaultuser(userid,password)
                    if ret != "cancel":
                        id = self.get_default_userid()
                        if id == None:
                            heading = "百度云账号"
                            dialog = xbmcgui.Dialog()
                            ret = dialog.login(heading, str(userid), str(password), False)
                            if ret[0] == '1' and ret[1] and ret[2]:
                                self.add_user_mf(ret[1],ret[2])
                            id = self.get_default_userid()
                            if id == None:
                                xbmc.executebuiltin('HideBusyDialog')
                                dialog = xbmcgui.Dialog()
                                dialog.ok("提示","播放时发生错误\n登录百度云帐号失败")
                                return errno
            
        
        session = self.get_session()
        if not session:
            xbmc.executebuiltin('HideBusyDialog')
            utils.show_msg('需要登录百度云帐号方可播放此文件。\n请您在百度云插件中进行登录')
            return
        
        #收藏
        session = str(self.get_session()).split(',')
        bdstoken = session[-1].replace('" u',"").replace("'","").replace(')"]',"").replace(')',"").replace(' ',"").replace('u',"")
        headers['Cookie'] = 'BDUSS='+session[0].replace("(u'","").replace("'","")
        bdstoken = self.get_album_bdstoken(url,headers)
        post_url="http://yun.baidu.com/pcloud/album/transfertask/create?&bdstoken=%s&channel=chunlei&clienttype=0&web=1" % bdstoken
        if album_id !="" and uk!="" and fsid!="":
            fsid_list = '['+fsid+']'
            post_params = {"album_id":album_id,"from_uk":uk,"to_path":"","fsid_list":fsid_list}
            coll_content = utils.fetch_url(post_url,post_params,headers)
            r = json.loads(coll_content)
            if r.has_key('info'):
                info = r['info']
                errno2 = str(info[0]['errno'])
                if errno2 == "-32":
                    # errno2=-32 保存失败，你的空间不足了哟，赶紧购买空间吧
                    xbmc.executebuiltin('HideBusyDialog')
                    dialog = xbmcgui.Dialog()
                    dialog.ok("提示","保存失败，你的空间不足了哟，赶紧购买空间吧。")
                    return errno2
            cookies = headers['Cookie']
            tmp_entries=['fetch_url_failed']
            path1='/'
            for page in range(1,21):
                if page == 1:
                    try_time = 3
                else:
                    try_time = 1
                for counter in range(1,try_time+1):
                    tmp_url = self.get_url(path1,page)
                    content = utils.fetch_url(tmp_url,None,headers)
                    tmp_entries = json.loads(content)['list']
                    if len(tmp_entries)==1 and tmp_entries[0]=='fetch_url_failed':
                        xbmc.executebuiltin('HideBusyDialog')
                        utils.show_msg('播放出错，请重新尝试')
                        return
                    if tmp_entries == []:
                        errno = json.loads(content)['errno']
                        if errno == 0:
                            xbmc.executebuiltin('HideBusyDialog')
                            utils.show_msg('播放时发生未知错误。')
                        else:
                             # 不再尝试登录
#                             useid = self.get_default_userid()
#                             self.relogin_mf(useid)
#                             self.playBaiduyunAlbumVideo(properties)
                             xbmc.executebuiltin('HideBusyDialog')
                             utils.show_msg('播放时发生未知错误。\n重新登录百度云帐号或可解决此问题')
                            
#                        elif errno == 1:
#                            utils.show_msg('您的百度云帐号会话已失效。\n请您在百度云插件中重新登录')
#                        else:
#                            utils.show_msg('播放时发生未知错误。\n重新登录百度云帐号或可解决此问题')
                        return
                    for entry in tmp_entries:
                        filename = entry['server_filename']
                        if filename == title:
                            dlink = entry.get('dlink')
                            path2 = entry.get('path')
                            filename = entry['server_filename']
                            userid = self.get_default_userid()
                            auto_choose_transcode = self.plugin_mfyun.get_setting('auto_choose_transcode', bool)
                            if not auto_choose_transcode and self.getDefinitionText(selectedRateType) not in TRANSCODE_TYPES:
                                choice = utils.select('请选择视频清晰度', TRANSCODE_TYPES)
                                if choice < 0:
                                    self.delete_path_mf(userid, path2)
                                    xbmc.executebuiltin('HideBusyDialog')
                                    return
                                transcode_type = TRANSCODE_TYPES[choice]
                            elif auto_choose_transcode:
                                transcode_type = self.plugin_mfyun.get_setting('transcode_type', str)
                            else:
                                transcode_type = self.getDefinitionText(selectedRateType)
                            if transcode_type == "原码":
                                try:
                                    self.play_stream_mf(userid, entry, headers, filename, weburl, cookies, subtitle, properties)
                                except:
                                    self.delete_path_mf(userid, path2)
                            else:
                                if transcode_type == "超高清(720)":
                                    transcode_type = "M3U8_AUTO_720"
                                elif transcode_type == "超清(480)":
                                    transcode_type = "M3U8_AUTO_480"
                                elif transcode_type == "高清(360)":
                                    transcode_type = "M3U8_AUTO_360"
                                elif transcode_type == "流畅(240)":
                                    transcode_type = "M3U8_AUTO_240"
                                try:
                                    self.play_transcode_video_mf(userid, path2, filename, weburl, cookies, subtitle, transcode_type, properties=properties)
                                except:
                                    self.delete_path_mf(userid, path2)
                            self.delete_path_mf(userid, path2)
                            xbmc.executebuiltin('HideBusyDialog')
                            return
                    if page == 1:
                        time.sleep(0.3)
        xbmc.executebuiltin('HideBusyDialog')
        
    def playBaiduyunPanVideo(self, properties, transcode_type=''):
        url = properties['url'] if 'url' in properties else ''
        title = properties['title'] if 'title' in properties else ''
        weburl = url
        
        if "plugin://plugin.video.mfyun/play_pan_video/" in url:
            url = url.replace('plugin://plugin.video.mfyun/play_pan_video/','')
            urlitems = url.split('/')
            userid = urllib.unquote_plus(urlitems[0])
            serverpath = urllib.unquote_plus(urlitems[1])
            filename = urllib.unquote_plus(urlitems[2])
            subtitle = ''
            if len(urlitems)>3:
                subtitle = urlitems[3]
            self._play_baiduyun_video(userid, serverpath, filename, weburl, subtitle, properties)
            
    
    def playBaiduyun161Video(self, properties,favouriteinfo={}):
        xbmc.executebuiltin("ShowBusyDialog")
        url = properties['url'] if 'url' in properties else ''
        title = properties['title'] if 'title' in properties else ''
        sourceType = properties['sourceType'] if 'sourceType' in properties else ''
        weburl = url

        selectedRateType = ''
        if xbmc.getCondVisibility('Player.AutoPlayingNext'):
            selectedRateType = xbmc.getInfoLabel('Player.SelectedRateType')
        
        headers={}
        userId = self.get_default_userid()
        if not userId:
            userid = "videouser@qq.com"
            password = "videouser@qq"
            ret = self.add_defaultuser(userid,password)
            if ret != "cancel":
                id = self.get_default_userid()
                if id == None:
                    ret = self.add_defaultuser(userid,password)
                    if ret != "cancel":
                        id = self.get_default_userid()
                        if id == None:
                            heading = "百度云账号"
                            dialog = xbmcgui.Dialog()
                            ret = dialog.login(heading, str(userid), str(password), False)
                            if ret[0] == '1' and ret[1] and ret[2]:
                                self.add_user_mf(ret[1],ret[2])
                            id = self.get_default_userid()
                            if id == None:
                                xbmc.executebuiltin('HideBusyDialog')
                                dialog = xbmcgui.Dialog()
                                dialog.ok("提示","播放时发生错误\n登录百度云帐号失败")
                                return
        session = self.get_session()
        if not session:
            xbmc.executebuiltin('HideBusyDialog')
            utils.show_msg('需要登录百度云帐号方可播放此文件。\n请您在百度云插件中进行登录')
            return
            # self.plugin_mfyun.notify('您的百度云帐号会话已失效，请重新登录', delay=3000, image='DefaultIconInfo.png')
            # userId = self.get_default_userid()
            # if not self.relogin(userId):
                # xbmc.executebuiltin('HideBusyDialog')
                # return
            session = self.get_session()
        headers['Cookie'] = 'BDUSS='+session[0]
        play_content = utils.fetch_url(url,None,headers)
        if "share_nofound_des" in play_content:
            errno1 = 10000
            #errno:10000  "当前收藏文件的地址无效"
            xbmc.executebuiltin('HideBusyDialog')
            if sourceType == 'znds':
                return errno1

        cktoken = 'fetch_url_failed'
        _RE = re.compile(
            r'bdstoken="(.+?)"[\s\S]*?'
            'FileUtils.share_uk="(.+?)"[\s\S]*?'
            'FileUtils.share_id="(.+?)"[\s\S]*?'
            'FileUtils.cktoken="(.+?)"[\s\S]*?'
            'fid:"(.+?)"[\s\S]*?'
            'path:"(.+?)"[\s\S]*?'
            'ViewShareUtils.share_ctime="(.+?)"'
            )
           
        for match in _RE.finditer(play_content):
            bdstoken, share_uk, share_id,cktoken, fid, path, share_ctime= match.groups()
            params={
                'bdstoken':bdstoken,
                'share_uk': share_uk,
                'share_id': share_id,
                'cktoken':cktoken, 
                'fid':fid,
                'path': path,
                'share_ctime':share_ctime
            }
        if cktoken == 'fetch_url_failed':
            errno1 = 10000
            #errno:10000  "当前文件不存在"
            if sourceType == 'znds':
                useid = self.get_default_userid()
                self.relogin_mf(useid)
                self.playBaiduyun161Video(properties)
                xbmc.executebuiltin('HideBusyDialog')
                #utils.show_msg('播放时发生未知错误。\n重新登录百度云帐号或可解决此问题')
            xbmc.executebuiltin('HideBusyDialog')
            return errno1
        if not cktoken:
            useid = self.get_default_userid()
            self.relogin_mf(useid)
            self.playBaiduyun161Video(properties)
            xbmc.executebuiltin('HideBusyDialog')
            #utils.show_msg('您的百度云帐号会话已失效。\n请您在百度云插件中重新登录')
            return
            # self.plugin_mfyun.notify('您的百度云帐号会话已失效，请重新登录', delay=3000, image='DefaultIconInfo.png')
            # userId = self.get_default_userid()
            # if not self.relogin(userId):
                # xbmc.executebuiltin('HideBusyDialog')
                # return
            # return self.playBaiduyun161Video(properties)
        
        # 在分享目录中查找字幕文件
        video_name = path.split('/')[-1].rpartition('.')[0]
        subtitle_file = ''
        parent_path = path[0:path.rfind('/')]
        parent_items = subroutine.list_baidu_share(share_id, share_uk, remote_dir=parent_path)
        for parent_item in parent_items:
            item_path = parent_item['path']
            item_filename = parent_item['server_filename']
            if self.is_subtitle(item_filename) and item_filename.startswith(video_name + '.') and '.' not in item_filename[len(video_name) + 1:]:
                subtitle_file = item_path
                break

        cktoken = cktoken.replace("'","").replace("(u","")
        filelist_1 = '[\"'+path.encode('utf-8')+'\"]'
        if subtitle_file:
            filelist_1 = '["'+path.encode('utf-8')+'","'+subtitle_file+'"]'
        params_1 = {"filelist":filelist_1,"path":""}
        post_url_1 = self.collect_url_1%(share_uk,share_id,bdstoken)
        headers['Cookie'] = "BDUSS="+cktoken
        cookies = headers['Cookie']
        coll_content = utils.fetch_url(post_url_1,params_1,headers)
        r = json.loads(coll_content)
        if r.has_key('info'):
            info = r['info']
            errno2 = str(info[0]['errno'])
            if errno2 == "-32":
                # errno2=-32 保存失败，你的空间不足了哟，赶紧购买空间吧
                xbmc.executebuiltin('HideBusyDialog')
                dialog = xbmcgui.Dialog()
                dialog.ok("提示","保存失败，你的空间不足了哟，赶紧购买空间吧。")
                return errno2
        entries = []
        tmp_entries=['fetch_url_failed']
        path1='/'

        # 在个人网盘中查找字幕文件
        subtitle = ''
        subtitle_path = ''
        break_find = False
        for page in range(1,21):
            if page == 1:
                try_time = 3
            else:
                try_time = 1
            for counter in range(1,try_time+1):
                tmp_url = self.get_url(path1,page)
                content = utils.fetch_url(tmp_url,None,headers)
                tmp_entries = json.loads(content)['list']
                if len(tmp_entries)==1 and tmp_entries[0]=='fetch_url_failed':
                    break_find = True
                    break
                if tmp_entries == []:
                    break_find = True
                    break
                for entry in tmp_entries:
                    filename = entry['server_filename']
                    if self.is_subtitle(filename) and filename.startswith(video_name + '.') and '.' not in filename[len(video_name) + 1:]:
                        subtitle = entry.get('dlink')
                        subtitle_path = entry.get('path')
                        break_find = True
                        break
                if break_find:
                    break
                if page == 1:
                    time.sleep(0.3)
            if break_find:
                break

        for page in range(1,21):
            if page == 1:
                try_time = 3
            else:
                try_time = 1
            for counter in range(1,try_time+1):
                tmp_url = self.get_url(path1,page)
                content = utils.fetch_url(tmp_url,None,headers)
                tmp_entries = json.loads(content)['list']
                if len(tmp_entries)==1 and tmp_entries[0]=='fetch_url_failed':
                    xbmc.executebuiltin('HideBusyDialog')
                    utils.show_msg('播放出错，请重新尝试')
                    return
                if tmp_entries == []:
                    errno = json.loads(content)['errno']
                    if errno == 0:
                        xbmc.executebuiltin('HideBusyDialog')
                        utils.show_msg('播放时发生未知错误。')
                    else:
#                         useid = self.get_default_userid()
#                         self.relogin_mf(useid)
#                         self.playBaiduyun161Video(properties)
                        xbmc.executebuiltin('HideBusyDialog')
                        utils.show_msg('播放时发生未知错误。\n重新登录百度云帐号或可解决此问题')
#                    elif errno == 1:
#                        utils.show_msg('您的百度云帐号会话已失效。\n请您在百度云插件中重新登录')
#                    else:
#                        utils.show_msg('播放时发生未知错误。\n重新登录百度云帐号或可解决此问题')
                    return
                for entry in tmp_entries:
                    filename = entry['server_filename']
                    if filename == path.split('/')[-1]:
                        dlink = entry.get('dlink')
                        path2 = entry.get('path')
                        filename = entry['server_filename']
                        userid = self.plugin_mfyun.get_storage('config').get('current_user')
                        auto_choose_transcode = self.plugin_mfyun.get_setting('auto_choose_transcode', bool)
                        if not auto_choose_transcode and self.getDefinitionText(selectedRateType) not in TRANSCODE_TYPES:
                            ext_TRANSCODE_TYPES = TRANSCODE_TYPES[:]
                            if favouriteinfo and compare_client_version(xbmc.getInfoLabel('client.version'), '1.1.0')>=0:
                                checkstr = 'isfavourite(%s)'%favouriteinfo['itemId']
                                isCollected = xbmc.getCondVisibility(checkstr)
                                if not isCollected:
                                    ext_TRANSCODE_TYPES.append('收藏')
                                else:
                                    ext_TRANSCODE_TYPES.append('取消收藏')         
                            choice = utils.select('请选择视频清晰度', ext_TRANSCODE_TYPES)
                            if choice < 0:
                                delete_filelist = [path2,subtitle_path] if subtitle_path else path2
                                self.delete_path_mf(userid, delete_filelist)
                                xbmc.executebuiltin('HideBusyDialog')
                                return
                            transcode_type = ext_TRANSCODE_TYPES[choice]
                        elif auto_choose_transcode:
                            transcode_type = self.plugin_mfyun.get_setting('transcode_type', str)
                        else:
                            transcode_type = self.getDefinitionText(selectedRateType)
                        
                        mofanCode = False
                        if transcode_type == "原码":
                            try:
                                self.play_stream_mf(userid, entry, headers, filename, weburl, cookies, urllib.quote_plus(subtitle), properties)
                            except:
                                delete_filelist = [path2,subtitle_path] if subtitle_path else path2
                                self.delete_path_mf(userid, delete_filelist)
                        elif transcode_type == "超高清(720)":
                            transcode_type = "M3U8_AUTO_720"
                            mofanCode = True
                        elif transcode_type == "超清(480)":
                            transcode_type = "M3U8_AUTO_480"
                            mofanCode = True
                        elif transcode_type == "高清(360)":
                            transcode_type = "M3U8_AUTO_360"
                            mofanCode = True
                        elif transcode_type == "流畅(240)":
                            transcode_type = "M3U8_AUTO_240"
                            mofanCode = True
                        elif transcode_type == "收藏":
                            xbmc.executebuiltin('HideBusyDialog')
                            result = xbmc.addFollowFavourite( 
                                                             favouriteinfo['itemId'],
                                                             favouriteinfo['itemType'],
                                                             favouriteinfo['url'],
                                                             favouriteinfo['title'],
                                                             favouriteinfo['thumb'],
                                                             favouriteinfo['playable']
                                                            )
                            if result:
                                utils.show_msg('收藏成功')
                            return
                        elif transcode_type == "取消收藏":
                            xbmc.executebuiltin('HideBusyDialog')
                            if xbmc.delFollowFavourite(favouriteinfo['itemId']):
                                utils.show_msg('取消成功')                            
                            return
                        #如果为"超高清"、"超清"、"高清"、"流畅"
                        if mofanCode:
                            try:
                                self.play_transcode_video_mf(userid, path2, filename, weburl, cookies, urllib.quote_plus(subtitle), transcode_type, properties=properties)
                            except:
                                delete_filelist = [path2,subtitle_path] if subtitle_path else path2
                                self.delete_path_mf(userid, delete_filelist)
                        delete_filelist = [path2,subtitle_path] if subtitle_path else path2
                        self.delete_path_mf(userid, delete_filelist)
                        xbmc.executebuiltin('HideBusyDialog')
                        return
                if page == 1:
                    time.sleep(0.3)
        xbmc.executebuiltin('HideBusyDialog')
    
    def playBaiduyunTorrentVideo(self, properties, transcode_type = None):
        url = properties['url'] if 'url' in properties else ''
        title = properties['title'] if 'title' in properties else ''
        # 暂时不记录历史
        properties['saveHistory'] = 'false'
        weburl = url

        selectedRateType = ''
        if xbmc.getCondVisibility('Player.AutoPlayingNext'):
            selectedRateType = xbmc.getInfoLabel('Player.SelectedRateType')
        
        if "plugin://plugin.video.mfyun/play_torrent/" in url:
            url = url.replace('plugin://plugin.video.mfyun/play_torrent/','')
            urlitems = url.split('/')
            userid = urllib.unquote_plus(urlitems[0])
            torrent_path = urllib.unquote_plus(urlitems[1])
            filenameandpath = urllib.unquote_plus(urlitems[2])
            idx = urllib.unquote_plus(urlitems[3])
            file_sha1 = urllib.unquote_plus(urlitems[4])
            need_to_delete = ''
            if len(urlitems)>5:
                need_to_delete = urllib.unquote_plus(urlitems[5])
            
            xbmc.executebuiltin("ShowBusyDialog")
            headers={}
            session = self.get_session(userid)
            # 说明该用户没有保存登录信息
            if not session:
                xbmc.executebuiltin('HideBusyDialog')
                if utils.yesno('提示', '需要登录百度云帐号%s方可播放此文件。\n是否现在登录？' %userid):
                    if self.relogin_mf(userid, False):
                        session = self.get_session(userid)
                    # 重新显示BusyDialog
                    xbmc.executebuiltin("ShowBusyDialog")
                else:
                    xbmc.executebuiltin('HideBusyDialog')
                    return
            if not session:
                xbmc.executebuiltin('HideBusyDialog')
                utils.show_msg('登录失败，请到百度云插件中，自行登录')
                return
            headers['Cookie'] = 'BDUSS='+session[0]
            
            tmp_entries=['fetch_url_failed']
            path1 = torrent_path[0:torrent_path.rfind('/')+1] + filenameandpath[0:filenameandpath.rfind('/')+1]
            end_of_list = False
            for page in range(1,21):
                if page == 1:
                    try_time = 3
                else:
                    try_time = 1
                for counter in range(1,try_time+1):
                    tmp_url = self.get_url(path1,page)
                    content = utils.fetch_url(tmp_url,None,headers)
                    tmp_entries = json.loads(content)['list']
                    if len(tmp_entries)==1 and tmp_entries[0]=='fetch_url_failed':
                        xbmc.executebuiltin('HideBusyDialog')
                        utils.show_msg('播放出错，请重新尝试')
                        return
                    if tmp_entries == []:
                        errno = json.loads(content)['errno']
                        if errno == 0 or errno == -9:
                            end_of_list = True
                            break
                        else:
#                             useid = self.get_default_userid()
#                             self.relogin_mf(useid)
#                             self.playBaiduyunTorrentVideo(properties)
                            xbmc.executebuiltin('HideBusyDialog')
                            utils.show_msg('播放时发生未知错误。\n重新登录百度云帐号或可解决此问题')
                        return
                    for entry in tmp_entries:
                        filename = entry['server_filename']
                        if filename == filenameandpath.split('/')[-1]:
                            dlink = entry.get('dlink')
                            path2 = entry.get('path')
                            filename = entry['server_filename']
                            userid = self.plugin_mfyun.get_storage('config').get('current_user')
                            auto_choose_transcode = self.plugin_mfyun.get_setting('auto_choose_transcode', bool)
                            if not auto_choose_transcode and self.getDefinitionText(selectedRateType) not in TRANSCODE_TYPES:
                                choice = utils.select('请选择视频清晰度', TRANSCODE_TYPES)
                                if choice < 0:
                                    if need_to_delete == 'deletetorrent':
                                        self.delete_path_mf(userid, torrent_path)
                                    xbmc.executebuiltin('HideBusyDialog')
                                    return
                                transcode_type = TRANSCODE_TYPES[choice]
                            elif auto_choose_transcode:
                                transcode_type = self.plugin_mfyun.get_setting('transcode_type', str)
                            else:
                                transcode_type = self.getDefinitionText(selectedRateType)
                            if transcode_type == "原码":
                                try:
                                    self.play_stream_mf(userid, entry, headers, filename, weburl, '', "", properties)
                                finally:
                                    if need_to_delete == 'deletetorrent':
                                        self.delete_path_mf(userid, torrent_path)
                            else:
                                if transcode_type == "超高清(720)":
                                    transcode_type = "M3U8_AUTO_720"
                                elif transcode_type == "超清(480)":
                                    transcode_type = "M3U8_AUTO_480"
                                elif transcode_type == "高清(360)":
                                    transcode_type = "M3U8_AUTO_360"
                                elif transcode_type == "流畅(240)":
                                    transcode_type = "M3U8_AUTO_240"
                                try:
                                    self.play_transcode_video_mf(userid, path2, filename, weburl, '', "", transcode_type, properties=properties)
                                finally:
                                    if need_to_delete == 'deletetorrent':
                                        self.delete_path_mf(userid, torrent_path)
                            xbmc.executebuiltin('HideBusyDialog')
                            return
                    if page == 1:
                        time.sleep(0.3)
                if end_of_list:
                    break
            # torrent_path = torrent_path.replace('//', '/')
            # api = self.get_api(userid)
            # ret = api.query_sinfo(torrent_path)
            # file_sha1 = ret['torrent_info']['sha1']
            # file_list = ret['torrent_info']['file_info']
            # selected = []
            # for i in range(0,len(file_list)):
                # file_name = file_list[i]['file_name']
                # if self.is_video(file_name) or self.is_subtitle(file_name):
                    # selected.append(str(i+1))
            # selected_idx = ','.join(selected)
            
            api = self.get_api(userid)
            try:
                ret = api.try_cloud_download(torrent_path, torrent_path[0:torrent_path.rfind('/')+1], file_sha1, idx, self.on_verifycode)
            except PCSApiError as e:
                if e._error_code == 36031:
                    utils.show_msg('该帐号离线下载数可能已超过百度云限制，请切换其他帐号后重试')
                    return
            task_id = ret['task_id']
            
            ret = api.query_task(str(task_id))
            status = ret['task_info'][str(task_id)]['status']
            if status == '0':
                video_filename = ret['task_info'][str(task_id)]['file_list'][0]['file_name']
                serverpath = torrent_path[0:torrent_path.rfind('/')+1] + video_filename
                deletepath = torrent_path[0:torrent_path.rfind('/')+1] + video_filename.split('/')[0]
                filename = video_filename[video_filename.rfind('/')+1:]
                
                try:
                    self._play_baiduyun_video(userid, serverpath, filename, weburl, '', properties)
                finally:
                    self.delete_path_mf(userid, deletepath)
                    if need_to_delete == 'deletetorrent':
                        self.delete_path_mf(userid, torrent_path)
                ret = api.delete_task(str(task_id))
                xbmc.executebuiltin('HideBusyDialog')
            else:
                xbmc.executebuiltin('HideBusyDialog')
                utils.show_msg('该视频暂不支持在线播放')
                ret = api.cancel_task(str(task_id))
                if need_to_delete == 'deletetorrent':
                    self.delete_path_mf(userid, torrent_path)
    
    def playBaiduyunMagnetVideo(self, properties, transcode_type = None):
        url = properties['url'] if 'url' in properties else ''
        title = properties['title'] if 'title' in properties else ''
        # 暂时不记录历史
        properties['saveHistory'] = 'false'
        weburl = url

        selectedRateType = ''
        if xbmc.getCondVisibility('Player.AutoPlayingNext'):
            selectedRateType = xbmc.getInfoLabel('Player.SelectedRateType')
        
        if "plugin://plugin.video.mfyun/play_magnet/" in url:
            url = url.replace('plugin://plugin.video.mfyun/play_magnet/','')
            urlitems = url.split('/')
            userid = urllib.unquote_plus(urlitems[0])
            magnet_url = urllib.unquote_plus(urlitems[1])
            magnet_filename = urllib.unquote_plus(urlitems[2])
            idx = urllib.unquote_plus(urlitems[3])
            save_path = '/MoreFunTV/'
            
            xbmc.executebuiltin("ShowBusyDialog")
            headers={}
            session = self.get_session(userid)
            # 说明该用户没有保存登录信息
            if not session:
                xbmc.executebuiltin('HideBusyDialog')
                if utils.yesno('提示', '需要登录百度云帐号%s方可播放此文件。\n是否现在登录？' %userid):
                    if self.relogin_mf(userid, False):
                        session = self.get_session(userid)
                    # 重新显示BusyDialog
                    xbmc.executebuiltin("ShowBusyDialog")
                else:
                    xbmc.executebuiltin('HideBusyDialog')
                    return
            if not session:
                xbmc.executebuiltin('HideBusyDialog')
                utils.show_msg('登录失败，请到百度云插件中，自行登录')
                return
            headers['Cookie'] = 'BDUSS='+session[0]
            
            tmp_entries=['fetch_url_failed']
            path1 = save_path
            end_of_list = False
            for page in range(1,21):
                if page == 1:
                    try_time = 3
                else:
                    try_time = 1
                for counter in range(1,try_time+1):
                    tmp_url = self.get_url(path1,page)
                    content = utils.fetch_url(tmp_url,None,headers)
                    tmp_entries = json.loads(content)['list']
                    if len(tmp_entries)==1 and tmp_entries[0]=='fetch_url_failed':
                        xbmc.executebuiltin('HideBusyDialog')
                        utils.show_msg('播放出错，请重新尝试')
                        return
                    if tmp_entries == []:
                        errno = json.loads(content)['errno']
                        if errno == 0 or errno == -9:
                            end_of_list = True
                            break
                        else:
#                             useid = self.get_default_userid()
#                             self.relogin_mf(useid)
#                             self.playBaiduyunMagnetVideo(properties)
                            xbmc.executebuiltin('HideBusyDialog')
                            utils.show_msg('播放时发生未知错误。\n重新登录百度云帐号或可解决此问题')
                        return
                    for entry in tmp_entries:
                        filename = entry['server_filename']
                        if filename == magnet_filename:
                            dlink = entry.get('dlink')
                            path2 = entry.get('path')
                            filename = entry['server_filename']
                            userid = self.plugin_mfyun.get_storage('config').get('current_user')
                            auto_choose_transcode = self.plugin_mfyun.get_setting('auto_choose_transcode', bool)
                            if not auto_choose_transcode and self.getDefinitionText(selectedRateType) not in TRANSCODE_TYPES:
                                choice = utils.select('请选择视频清晰度', TRANSCODE_TYPES)
                                if choice < 0:
                                    xbmc.executebuiltin('HideBusyDialog')
                                    return
                                transcode_type = TRANSCODE_TYPES[choice]
                            elif auto_choose_transcode:
                                transcode_type = self.plugin_mfyun.get_setting('transcode_type', str)
                            else:
                                transcode_type = self.getDefinitionText(selectedRateType)
                            if transcode_type == "原码":
                                try:
                                    self.play_stream_mf(userid, entry, headers, filename, weburl, '', "", properties)
                                finally:
                                    pass
                            else:
                                if transcode_type == "超高清(720)":
                                    transcode_type = "M3U8_AUTO_720"
                                elif transcode_type == "超清(480)":
                                    transcode_type = "M3U8_AUTO_480"
                                elif transcode_type == "高清(360)":
                                    transcode_type = "M3U8_AUTO_360"
                                elif transcode_type == "流畅(240)":
                                    transcode_type = "M3U8_AUTO_240"
                                try:
                                    self.play_transcode_video_mf(userid, path2, filename, weburl, '', "", transcode_type, properties=properties)
                                finally:
                                    pass
                            xbmc.executebuiltin('HideBusyDialog')
                            return
                    if page == 1:
                        time.sleep(0.3)
                if end_of_list:
                    break
            
            api = self.get_api(userid)
            try:
                ret = api.try_cloud_download(magnet_url, save_path, '', idx, self.on_verifycode)
            except PCSApiError as e:
                if e._error_code == 36031:
                    utils.show_msg('该帐号离线下载数可能已超过百度云限制，请切换其他帐号后重试')
                    return
            task_id = ret['task_id']
            
            ret = api.query_task(str(task_id))
            status = ret['task_info'][str(task_id)]['status']
            if status == '0':
                video_filename = ret['task_info'][str(task_id)]['file_list'][0]['file_name']
                
                try:
                    self._play_baiduyun_video(userid, save_path+video_filename, video_filename, weburl, '', properties)
                finally:
                    self.delete_path_mf(userid, save_path+video_filename)
                ret = api.delete_task(str(task_id))
                xbmc.executebuiltin('HideBusyDialog')
            else:
                xbmc.executebuiltin('HideBusyDialog')
                utils.show_msg('该视频暂不支持在线播放')
                ret = api.cancel_task(str(task_id))
    
    def playBaiduyunED2KVideo(self, properties, transcode_type = None):
        url = properties['url'] if 'url' in properties else ''
        title = properties['title'] if 'title' in properties else ''
        # 暂时不记录历史
        properties['saveHistory'] = 'false'
        weburl = url

        selectedRateType = ''
        if xbmc.getCondVisibility('Player.AutoPlayingNext'):
            selectedRateType = xbmc.getInfoLabel('Player.SelectedRateType')
        
        if "plugin://plugin.video.mfyun/play_ed2k/" in url:
            url = url.replace('plugin://plugin.video.mfyun/play_ed2k/','')
            urlitems = url.split('/')
            ed2k_url = urllib.unquote_plus(urlitems[0])
            ed2k_splited = ed2k_url.split('|')
            ed2k_type = ed2k_splited[1]
            if ed2k_type != 'file':
                utils.show_msg('播放失败，ed2k链接地址错误')
                return 
            ed2k_filename = urllib.unquote_plus(ed2k_splited[2])
            save_path = '/MoreFunTV/'
            
            xbmc.executebuiltin("ShowBusyDialog")
            headers={}
            userid = self.get_default_userid()
            session = self.get_session(userid)
            # 说明该用户没有保存登录信息
            if not session:
                xbmc.executebuiltin('HideBusyDialog')
                if utils.yesno('提示', '需要登录百度云帐号%s方可播放此文件。\n是否现在登录？' %userid):
                    if self.relogin_mf(userid, False):
                        session = self.get_session(userid)
                    # 重新显示BusyDialog
                    xbmc.executebuiltin("ShowBusyDialog")
                else:
                    xbmc.executebuiltin('HideBusyDialog')
                    return
            if not session:
                xbmc.executebuiltin('HideBusyDialog')
                utils.show_msg('登录失败，请到百度云插件中，自行登录')
                return
            headers['Cookie'] = 'BDUSS='+session[0]
            
            tmp_entries=['fetch_url_failed']
            path1 = save_path
            end_of_list = False
            for page in range(1,21):
                if page == 1:
                    try_time = 3
                else:
                    try_time = 1
                for counter in range(1,try_time+1):
                    tmp_url = self.get_url(path1,page)
                    content = utils.fetch_url(tmp_url,None,headers)
                    tmp_entries = json.loads(content)['list']
                    if len(tmp_entries)==1 and tmp_entries[0]=='fetch_url_failed':
                        xbmc.executebuiltin('HideBusyDialog')
                        utils.show_msg('播放出错，请重新尝试')
                        return
                    if tmp_entries == []:
                        errno = json.loads(content)['errno']
                        if errno == 0 or errno == -9:
                            end_of_list = True
                            break
                        else:
#                             useid = self.get_default_userid()
#                             self.relogin_mf(useid)
#                             self.playBaiduyunED2KVideo(properties)
                            xbmc.executebuiltin('HideBusyDialog')
                            utils.show_msg('播放时发生未知错误。\n重新登录百度云帐号或可解决此问题')
                        return
                    for entry in tmp_entries:
                        filename = entry['server_filename']
                        if filename == ed2k_filename:
                            dlink = entry.get('dlink')
                            path2 = entry.get('path')
                            filename = entry['server_filename']
                            userid = self.plugin_mfyun.get_storage('config').get('current_user')
                            auto_choose_transcode = self.plugin_mfyun.get_setting('auto_choose_transcode', bool)
                            if not auto_choose_transcode and self.getDefinitionText(selectedRateType) not in TRANSCODE_TYPES:
                                choice = utils.select('请选择视频清晰度', TRANSCODE_TYPES)
                                if choice < 0:
                                    xbmc.executebuiltin('HideBusyDialog')
                                    return
                                transcode_type = TRANSCODE_TYPES[choice]
                            elif auto_choose_transcode:
                                transcode_type = self.plugin_mfyun.get_setting('transcode_type', str)
                            else:
                                transcode_type = self.getDefinitionText(selectedRateType)
                            if transcode_type == "原码":
                                try:
                                    self.play_stream_mf(userid, entry, headers, filename, weburl, '', "", properties)
                                finally:
                                    pass
                            else:
                                if transcode_type == "超高清(720)":
                                    transcode_type = "M3U8_AUTO_720"
                                elif transcode_type == "超清(480)":
                                    transcode_type = "M3U8_AUTO_480"
                                elif transcode_type == "高清(360)":
                                    transcode_type = "M3U8_AUTO_360"
                                elif transcode_type == "流畅(240)":
                                    transcode_type = "M3U8_AUTO_240"
                                try:
                                    self.play_transcode_video_mf(userid, path2, filename, weburl, '', "", transcode_type, properties=properties)
                                finally:
                                    pass
                            xbmc.executebuiltin('HideBusyDialog')
                            return
                    if page == 1:
                        time.sleep(0.3)
                if end_of_list:
                    break
            
            api = self.get_api(userid)
            try:
                ret = api.try_cloud_download(ed2k_url, save_path, '', '', self.on_verifycode)
            except PCSApiError as e:
                if e._error_code == 36031:
                    utils.show_msg('该帐号离线下载数可能已超过百度云限制，请切换其他帐号后重试')
                    return
            task_id = ret['task_id']
            
            ret = api.query_task(str(task_id))
            status = ret['task_info'][str(task_id)]['status']
            if status == '0':
                video_filename = ret['task_info'][str(task_id)]['file_list'][0]['file_name']
                try:
                    self._play_baiduyun_video(userid, save_path+video_filename, video_filename, weburl, '', properties)
                finally:
                    self.delete_path_mf(userid, save_path+video_filename)
                ret = api.delete_task(str(task_id))
                xbmc.executebuiltin('HideBusyDialog')
            else:
                xbmc.executebuiltin('HideBusyDialog')
                utils.show_msg('该视频暂不支持在线播放')
                ret = api.cancel_task(str(task_id))
            
    
    def _play_baiduyun_video(self, userid, path, filename, weburl, subtitle, properties, transcode_type = None):
        selectedRateType = ''
        if xbmc.getCondVisibility('Player.AutoPlayingNext'):
            selectedRateType = xbmc.getInfoLabel('Player.SelectedRateType')

        if not transcode_type:
            auto_choose_transcode = self.plugin_mfyun.get_setting('auto_choose_transcode', bool)
            if not auto_choose_transcode and self.getDefinitionText(selectedRateType) not in TRANSCODE_TYPES:
                choice = utils.select('请选择视频清晰度', TRANSCODE_TYPES)
                if choice < 0:
                    xbmc.executebuiltin('HideBusyDialog')
                    return
                transcode_type = TRANSCODE_TYPES[choice]
            elif auto_choose_transcode:
                transcode_type = self.plugin_mfyun.get_setting('transcode_type', str)
            else:
                transcode_type = self.getDefinitionText(selectedRateType)
        if transcode_type == "原码":
            xbmc.executebuiltin("ShowBusyDialog")
            dlink = ''
            headers={}
            session = self.get_session(userid)
            # 说明该用户没有保存登录信息
            if not session:
                xbmc.executebuiltin('HideBusyDialog')
                if utils.yesno('提示', '需要登录百度云帐号%s方可播放此文件。\n是否现在登录？' %userid):
                    if self.relogin_mf(userid, False):
                        session = self.get_session(userid)
                    # 重新显示BusyDialog
                    xbmc.executebuiltin("ShowBusyDialog")
                    
#                         password = ""
#                         if userid == "videouser@qq.com":
#                             password = "videouser@qq"
#                         # password = self.get_baiduyun_password(userid)
#                         if self.add_user_mf(userid,password,False):
#                             session = self.get_session(userid)
#                         # 重新显示BusyDialog
#                         xbmc.executebuiltin("ShowBusyDialog")

                else:
                    xbmc.executebuiltin('HideBusyDialog')
                    return
            if not session:
                xbmc.executebuiltin('HideBusyDialog')
                utils.show_msg('登录失败，请到百度云插件中，自行登录')
                return
            headers['Cookie'] = 'BDUSS='+session[0]
            
            tmp_entries=['fetch_url_failed']
            for page in range(1,21):
                if page == 1:
                    try_time = 3
                else:
                    try_time = 1
                for counter in range(1,try_time+1):
                    tmp_url = self.get_url(path[0:path.rfind('/')],page)
                    content = utils.fetch_url(tmp_url,None,headers)
                    tmp_entries = json.loads(content)['list']
                    if len(tmp_entries)==1 and tmp_entries[0]=='fetch_url_failed':
                        xbmc.executebuiltin('HideBusyDialog')
                        utils.show_msg('播放出错，请重新尝试')
                        return
                    if tmp_entries == []:
                        errno = json.loads(content)['errno']
                        if errno == 0:
                            xbmc.executebuiltin('HideBusyDialog')
                            utils.show_msg('播放时发生未知错误。')
                        else:
                            if self.relogin_mf(userid,False):
                                self._play_baiduyun_video(userid, path, filename, weburl, subtitle, properties, transcode_type)
                                xbmc.executebuiltin('HideBusyDialog')
                            else:
                                # wdy:need this?
                                xbmc.executebuiltin('HideBusyDialog')
                                utils.show_msg('获取登录信息失败，无法播放，请重新尝试')
                        return
                    for entry in tmp_entries:
                        tmp_filename = entry['server_filename']
                        if filename == tmp_filename:
                            # dlink = entry.get('dlink')
                            # break
                    # if dlink:
                            self.play_stream_mf(userid, entry, headers, filename, weburl,"",subtitle,properties)
                            xbmc.executebuiltin('HideBusyDialog')
                            return
                    if page == 1:
                        time.sleep(0.3)
            xbmc.executebuiltin('HideBusyDialog')
        else:
            if transcode_type == "超高清(720)":
                transcode_type = "M3U8_AUTO_720"
            elif transcode_type == "超清(480)":
                transcode_type = "M3U8_AUTO_480"
            elif transcode_type == "高清(360)":
                transcode_type = "M3U8_AUTO_360"
            elif transcode_type == "流畅(240)":
                transcode_type = "M3U8_AUTO_240"
                
            self.play_transcode_video_mf(userid, path, filename, weburl, "", subtitle, transcode_type, properties=properties)
        

    def get_default_userid(self):
        return self.plugin_mfyun.get_storage('config').get('current_user')
    
    def get_baiduyun_password(self, userid = ''):
        if userid == "videouser@qq.com":
            password = "videouser@qq"
            return password
        else :
            try:
                config = self.plugin_mfyun.get_storage('config')
                users = config.setdefault('users', {})
                users = config['users']
                # password = users[userid]
                password = ""
                if userid in users:
                    password = users[userid]
                return password
            except Exception as e:
                self.plugin_mfyun.log.info(traceback.format_exc())
                return ""
            
        
    def get_session(self, userid = ''):
        if not userid:
            userid = self.plugin_mfyun.get_storage('config').get('current_user')
        userdata = self.plugin_mfyun.get_storage('userdata')
        user = userdata.setdefault(userid, {})
        if 'session' in user:
            session = user['session']
        else:
            session = None
        return session
    
    def get_album_bdstoken(self, url,headers):
        bdstoken = ""
        play_content = utils.fetch_url(url,None,headers)
        _RE = re.compile(
            r'FileUtils.bdstoken="(.+?)"'
            )
        for match in _RE.finditer(play_content):
            bdstoken = match.groups()
            params={
                'bdstoken':bdstoken
            }
        if bdstoken is not None and bdstoken !="":
            return bdstoken
    
    def add_user(self, userid = ''):
        userid = (utils.keyboard(userid, heading='请输入您的百度云帐号')
                  or '').strip()
        if not userid:
            return False

        config = self.plugin_mfyun.get_storage('config')
        users = config.setdefault('users', {})
        
        #不判断是否存在，无论是否存在，都尝试登录
#         if userid in users:
#             self.plugin_mfyun.notify('用户已存在', delay=3000, image='DefaultIconInfo.png')
#             return True

        password = (utils.keyboard(heading='请输入密码', hidden=True)
                    or '').strip()
        if not password:
            return False

        api = self.creaet_api_with_publickey()
        login_info = None
        try:
            login_info = api.try_login(userid, password, self.on_verifycode)
        except Exception as e:
            self.plugin_mfyun.log.info(traceback.format_exc())
            if isinstance(e, ClientApiError):
                e = e.get_errmsg()
            self.plugin_mfyun.notify('登录失败: %s' % e,delay=3000, image='DefaultIconInfo.png')
            return False

        if not login_info:
            return False

        self._save_user_info(config, userid, password, login_info, api)

        self.plugin_mfyun.notify('用户添加成功', delay=3000, image='DefaultIconInfo.png')
        utils.refresh()
        return True
    
    def relogin(self, userid):
        config = self.plugin_mfyun.get_storage('config')
        users = config['users']
        # old_password = users[userid]
        old_password = ""
        if userid in users:
            old_password = users[userid]
            
        password = (utils.keyboard(old_password, '请输入密码', True) or '').strip()
        if not password:
            return False

        api = self.creaet_api_with_publickey()
        login_info = None
        try:
            login_info = api.try_login(userid, password, self.on_verifycode)
        except Exception as e:
            self.plugin_mfyun.log.info(traceback.format_exc())
            if isinstance(e, ClientApiError):
                e = e.get_errmsg()
            self.plugin_mfyun.notify('登录失败: %s' % e,delay=3000, image='DefaultIconInfo.png')
            return False

        if not login_info:
            return False

        self._save_user_info(config, userid, password, login_info, api)

        self.plugin_mfyun.notify('用户登录成功', delay=3000, image='DefaultIconInfo.png')
        utils.refresh()
        return True
    
    def add_defaultuser(self,userid,password):
        config = self.plugin_mfyun.get_storage('config')
        users = config.setdefault('users', {})
        if userid in users:
            #plugin.notify('用户已存在', delay=2000, image='DefaultIconInfo.png')
            return "success"

        api = self.creaet_api_with_publickey()
        login_info = None
        try:
            login_info = api.try_login(userid, password, self.on_verifycode)
        except Exception as e:
            self.plugin_mfyun.log.info(traceback.format_exc())
            if isinstance(e, ClientApiError):
                e = e.get_errmsg()
            self.plugin_mfyun.notify('登录失败: %s' % e,delay=2000, image='DefaultIconInfo.png')
            return "fail"

        if not login_info:
            return "cancel"

        self._save_user_info(config, userid, password, login_info, api)
        return "success"
    
    def add_user_mf(self,userid,password,select=True):
        config = self.plugin_mfyun.get_storage('config')
        users = config.setdefault('users', {})
        
        #不判断是否存在，无论是否存在，都尝试登录
#         if userid in users:
#             plugin.notify('用户已存在33', delay=2000, image='DefaultIconInfo.png')
#             return True
#         else:
        api = self.creaet_api_with_publickey()
        login_info = None
        try:
            if not password:
                heading = "百度云账号"
                dialog = xbmcgui.Dialog()
                ret = dialog.login(heading, str(userid), str(password))
                if ret[0] == '1' and ret[1] and ret[2]:
                    password = ret[2]
                    login_info = api.try_login(ret[1], ret[2], self.on_verifycode)
            else:
                login_info = api.try_login(userid, password, self.on_verifycode)
        except Exception as e:
            self.plugin_mfyun.log.info(traceback.format_exc())
            emsg = e
            errno = 0
            if isinstance(e, ClientApiError):
                emsg = e.get_errmsg()
                errno = e.get_errno()
            self.plugin_mfyun.notify('登录失败: %s' % emsg,delay=3000, image='DefaultIconInfo.png')
            
            if errno == 2 :
                return "fail"
            if errno == 16 :
                return "fail"
            
            heading = "百度云账号"
            dialog = xbmcgui.Dialog()
            if not password :
                password = ""
            ret = dialog.login(heading, str(userid), str(password))
            if ret[0] == '1' and ret[1] and ret[2]:
                self.add_user_mf(ret[1],ret[2],select)
            
        if not login_info:
            return False
        elif select:
            self.select_user_mf(userid)
        self._save_user_info(config, userid, password, login_info, api)
        #self.plugin_mfyun.notify('用户添加成功', delay=3000, image='DefaultIconInfo.png')
        return True
        
    
    def remove_user_mf(self,userid):
        
        # self.plugin_mfyun.notify('正在删除用户', delay=3000, image='DefaultIconInfo.png')
        pass
#         config = self.plugin_mfyun.get_storage('config')
#         users = config.setdefault('users', {})
#         users.pop(userid, None)
#         if config.get('current_user') == userid:
#             config['current_user'] = users.keys()[0] if users else None
#         config.sync()
#         userdata = self.plugin_mfyun.get_storage('userdata')
#         userdata.pop(userid, None)
#         userdata.sync()
    
    def relogin_mf(self,userid,select=True):
        login_info = None
        password = None
        api = None
        config = self.plugin_mfyun.get_storage('config')
        users = config.setdefault('users', {})
        try:
            if userid:
                if userid in self._api_maps:
                    self._api_maps.pop(userid)
                config = self.plugin_mfyun.get_storage('config')
                users = config['users']

                self.remove_user_mf(userid)
                # password = users[userid]
                password = ""
                if userid in users:
                    password = users[userid]
                else:
                    heading = "百度云账号"
                    dialog = xbmcgui.Dialog()
                    if not password :
                        password = ""
                    ret = dialog.login(heading, str(userid), str(password))
                    if ret[0] == '1' and ret[1] and ret[2]:
                        userid = ret[1]
                        password = ret[2]
                    else:
                        return False
                    
            api = self.creaet_api_with_publickey()
            login_info = api.try_login(userid, str(password), self.on_verifycode)
        except Exception as e:
            self.plugin_mfyun.log.info(traceback.format_exc())
            emsg = e
            errno = 0
            if isinstance(e, ClientApiError):
                emsg = e.get_errmsg()
                errno = e.get_errno()
            self.plugin_mfyun.notify('登录失败: %s' % emsg,delay=3000, image='DefaultIconInfo.png')
            
            if errno == 2 :
                return "fail"
            if errno == 16 :
                return "fail"
        
            heading = "百度云账号"
            dialog = xbmcgui.Dialog()
            if not password :
                password = ""
            ret = dialog.login(heading, str(userid), str(password))
            if ret[0] == '1' and ret[1] and ret[2]:
                return self.add_user_mf(ret[1],ret[2],select)
            
        if not login_info:
            return False
        elif select:
            self.select_user_mf(userid)
        
        self._save_user_info(config, userid, password, login_info, api)
        return True
        
    def select_user_mf(self,userid):
        config = self.plugin_mfyun.get_storage('config')
        config['current_user'] = userid
        
        config.sync()
        
    
    def on_verifycode(self, imgurl, captcha_error=False):
        if captcha_error:
            self.plugin_mfyun.notify('验证码不正确，请重新输入', delay=3000, image='DefaultIconInfo.png')
#         import time
#         time.sleep(6)
        win = CaptchaDialog('captcha.xml', plugin_path, imgurl=imgurl)
        try:
            win.doModal()
            input_text = win.get_text()
            if input_text:
                return input_text
        finally:
            del win
    
    def _save_user_info(self, config, userid, password, login_info, api):
        users = config['users']
        users[userid] = password
        if not config.get('current_user'):
            config['current_user'] = userid

        ss = (login_info['bduss'], login_info[
              'uid'], login_info['ptoken'], login_info['stoken'])

        api.set_login_info(ss)

        userdata = self.plugin_mfyun.get_storage('userdata')
        userdata[userid] = {'session': ss, 'session_time': time.time()}

        config.sync()
        userdata.sync()
    
    def get_url(self, remote_dir='/', page=1, num=100, order='time', desc=1):
        params = {'dir': remote_dir, 'page': page, 'num': num, 'web': 1}
        if order != 'time':
            params['order'] = order
        if desc != 1:
            params['desc'] = desc
        url = 'http://pan.baidu.com/api/list?' + urllib.urlencode(params)
        return url
        
    def delete_path_mf(self, userid, path):
        api = self.get_api(userid)
        try:
            api.delete(path)
        except PCSApiError as e:
            utils.show_msg(str(e), '')
        else:
            xbmc.sleep(1000)
            
    
    def get_dlink(self, userid, path):
        api = self.get_api(userid)
        info = api.get_filemetas(path)['info']
        return info[0]['dlink']
    
    def play_stream_mf(self, userid, entry, headers, name, weburl, cookies, subtitle="",properties={}):
        
        try:
            md5 = properties['md5']
            filepath = properties['filepath']
        except :
            md5 = ''
            filepath = ''
                    
        if filepath == '':
            filepath = weburl.replace('plugin://plugin.video.mfyun/play_pan_video/','')
            urlitems = filepath.split('/')
            filepath = urllib.unquote_plus(urlitems[1])
        
        if filepath == '':
            url = self.get_download_dlink(userid,entry,headers)
        else:
            url = self.get_dlink(userid,filepath)
        
        thumb = properties['thumb'] if 'thumb' in properties else ''
#         if weburl != "":
#             subtitle = "" #params.get('subtitle')
#         else:
#             url = urllib.unquote_plus(url)
#             name = urllib.unquote_plus(name)
        subtitle = urllib.unquote_plus(subtitle)
        subtitle = subtitle.replace('?subtitle=','')
                
        url += '|User-Agent=Mozilla/5.0%20%28Windows%20NT%206.1%3B%20rv%3A25.0%29%20Gecko/20100101%20Firefox/25.0&Referer=http%3A//pan.baidu.com/disk/home'
        if name is None:
            self.plugin_mfyun.set_resolved_url(url, subtitle)
        elif self.is_torrent(name):
            self.plugin_mfyun.redirect(self.plugin_mfyun.url_for('play_torrent', url=url))
        else:
            xbmc.executebuiltin("ShowBusyDialog")
            listitem = xbmcgui.ListItem(name)
            listitem.setInfo(type="Video", infoLabels={'Title': name})
            listitem.setThumbnailImage(thumb)
            if weburl != "":
                listitem.setProperty('webUrl',weburl)
                cookies = "<cookies>.baidu.com||BDUSS=" + cookies + "</cookies>"
                listitem.setProperty('cookies',cookies)
                listitem.setProperty('apps','baiduyun')
            for (key,value) in properties.items():
                listitem.setProperty(key, str(value))
            listitem.setProperty('selectedRateType', 'M3U8_AUTO_origin')
            #url = urllib.unquote_plus(url)
            # playlist = xbmc.PlayList(1)
            # playlist.clear()
            # playlist.add(url,listitem)
            # xbmc.Player().play(playlist)
            player = myplayer.Player()
            player.play(url, listitem, sublist=subtitle)
            xbmc.executebuiltin('HideBusyDialog')
    
    def get_download_dlink(self,userid,entry,headers):
        fid = entry.get('fs_id')
        fidlist = '[' + str(fid) + ']'
        pan_path = 'http://pan.baidu.com/disk/home'
        pan_content = utils.fetch_url(pan_path,None,headers)
        _RE = re.compile(
                        r'FileUtils.sign1="([\s\S]*?)"[\s\S]*?'
                        'FileUtils.sign3="([\s\S]*?)"[\s\S]*?'
                        'FileUtils.timestamp="([\s\S]*?)"[\s\S]*?'
                        'FileUtils.bdstoken="([\s\S]*?)"[\s\S]*?')
        for match in _RE.finditer(pan_content):
            sign1, sign3, timestamp, bdstoken = match.groups()
        sign_uncode = self.get_sign_uncode(sign3,sign1)
        sign = self.get_sign_decode(sign_uncode)
        data = {
            'sign': sign,
            'timestamp': timestamp,
            'fidlist': fidlist,
            'type': 'dlink'
        }
        dlink_path = 'http://pan.baidu.com/api/download?channel=chunlei&clienttype=0&web=1&bdstoken='+str(bdstoken)
        dlink_content = utils.fetch_url(dlink_path,data,headers)
        dlink = json.loads(dlink_content)['dlink'][0]['dlink']

        redirect_url = utils.redirect_url(dlink,None,headers)
        
        return redirect_url
        
    def get_sign_uncode(self,j,r):
        a=[]
        p=[]
        o=""
        v=len(j)
        for q in range(256):
            a.append(ord(j[q%v]))
            p.append(q)
        u=0
        for q in range(256):
            u=((u+p[q]+a[q])%256)
            t=p[q]
            p[q]=p[u]
            p[u]=t
        i=0
        u=0
        for q in range(len(r)):
            i=(i+1)%256
            u=(u+p[i])%256
            t=p[i]
            p[i]=p[u]
            p[u]=t
            k=p[((p[i]+p[u])%256)]
            o=o+unichr((ord(r[q])^k))
        return o
    
    def get_sign_decode(self,G):
        C = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
        H = len(G)
        A = 0
        B = ""
        while(A<H):
            F = ord(G[A])&255
            A=A+1
            if A == H:
                B = B + C[F>>2]
                B = B + C[(F&3)<<4]
                B = B + "=="
                break
            D = ord(G[A])
            A=A+1
            if A == H:
                B = B + C[F>>2]
                B = B + C[((F&3)<<4)|((D&240)>>4)]
                B = B + C[(D&15)<<2]
                B = B + "="
                break
            E = ord(G[A])
            A=A+1
            B = B + C[F>>2]
            B = B + C[((F&3)<<4)|((D&240)>>4)]
            B = B + C[((D&15)<<2)|((E&192)>>6)]
            B = B + C[E&63]
        return B
    
    def play_transcode_video_mf(self, userid, path, name, weburl, cookies, subtitle="", transcode_type="M3U8_AUTO_480", properties={}):
        thumb = properties['thumb'] if 'thumb' in properties else ''
        userid = urllib.unquote_plus(userid)
        config = self.plugin_mfyun.get_storage('config')
        if userid not in config.get('users'):
            xbmc.executebuiltin('HideBusyDialog')
            # utils.show_msg('需要登录百度云帐号方可播放此文件。\n请您在百度云插件中进行登录')
            if utils.yesno('提示', '需要登录百度云帐号%s方可播放此文件。\n是否现在登录？' %userid):
                if self.relogin_mf(userid, False):
                    # 重新显示BusyDialog
                    xbmc.executebuiltin("ShowBusyDialog")
                else:
                    xbmc.executebuiltin('HideBusyDialog')
                    return
            else:
                xbmc.executebuiltin('HideBusyDialog')
                return
            
        path = urllib.unquote_plus(path)
        name = urllib.unquote_plus(name)
        
#         if weburl != "":
#             subtitle = ""
#         else:
        subtitle = urllib.unquote_plus(subtitle)
        subtitle = subtitle.replace('?subtitle=','')
        
        api = self.get_api(userid)
        xbmc.executebuiltin("ShowBusyDialog")
        dlink = api.get_transcode_url(path, transcode_type)
        try:
            content = utils.fetch_url(dlink)
        except urllib2.HTTPError as e:
            if e.code == 400:
                try:
                    content = utils.fetch_url(dlink)
                except urllib2.HTTPError as e:
                    if e.code == 400:
                        xbmc.executebuiltin('HideBusyDialog')
                        utils.show_msg('您的百度云帐号会话已失效。\n请您在百度云插件中重新登录')
                        return
                # self.plugin_mfyun.notify('您的百度云帐号会话已失效，请重新登录', delay=3000, image='DefaultIconInfo.png')
                # if not self.relogin(userid):
                    # xbmc.executebuiltin('HideBusyDialog')
                    # return
                # if userid in self._api_maps:
                    # self._api_maps.pop(userid)
                # api = self.get_api(userid)
                # dlink = api.get_transcode_url(path, transcode_type)
        listitem = xbmcgui.ListItem(name)
        listitem.setInfo(type="Video", infoLabels={'Title': name})
        listitem.setThumbnailImage(thumb)
        
        listitem.setProperty('mfcontenttype','m3u8')
        
        if weburl != "":
            listitem.setProperty('webUrl',weburl)
            cookies = "<cookies>.baidu.com||BDUSS=" + cookies + "</cookies>"
            listitem.setProperty('cookies',cookies)
            listitem.setProperty('apps','baiduyun')
        for (key,value) in properties.items():
            listitem.setProperty(key, str(value))
        listitem.setProperty('selectedRateType', transcode_type)
#         if weburl != "":
#             playlist = xbmc.PlayList(1)
#             playlist.clear()
#             playlist.add(dlink,listitem)
#             xbmc.Player().play(playlist)
#         else:
#             player = myplayer.Player()
#             player.play(dlink, listitem, sublist=subtitle)
        player = myplayer.Player()
        player.play(dlink, listitem, sublist=subtitle)
        
        xbmc.executebuiltin('HideBusyDialog')

    def get_api(self, userid):
        if userid in self._api_maps:
            return self._api_maps[userid]

        api = self.creaet_api_with_publickey()
        userdata = self.plugin_mfyun.get_storage('userdata')
        user = userdata.setdefault(userid, {})
        if 'session' in user:
            api.set_login_info(user['session'])

        self._api_maps[userid] = api

        return api

    def creaet_api_with_publickey(self):
        api = ClientAPI()
        api.set_public_key(*(self._get_public_key()))
        return api

    def _get_public_key(self):
        from simple_rsa import get_public_key
        cert = ClientAPI().get_cert()[0]
        return get_public_key(cert)

    def is_torrent(self, filename):
        return filename.lower().endswith('.torrent')
    
    def is_video(self, filename):
        _video_file_exts = ['.' + ext for ext in self.plugin_mfyun.get_setting(
            'video_file_exts', str).split(',')]

        filename = filename.lower()
        return any(filename.endswith(ext) for ext in _video_file_exts)


    def is_subtitle(self, filename):
        filename = filename.lower()
        return any(filename.endswith(ext) for ext in (
            '.srt', '.sub', '.ssa', '.smi', '.ass'))


def compare_client_version(srcVer, dstVer):
    srcVerList = srcVer.split('.')
    dstVerList = dstVer.split('.')
    srcVerMain = int(srcVerList[0])
    srcVerSub1 = int(srcVerList[1]) if len(srcVerList)>1 else 0
    srcVerSub2 = int(srcVerList[2]) if len(srcVerList)>2 else 0
    srcVerSub3 = int(srcVerList[3]) if len(srcVerList)>3 else 0
    dstVerMain = int(dstVerList[0])
    dstVerSub1 = int(dstVerList[1]) if len(dstVerList)>1 else 0
    dstVerSub2 = int(dstVerList[2]) if len(dstVerList)>2 else 0
    dstVerSub3 = int(dstVerList[3]) if len(dstVerList)>3 else 0
    
    ret = 0
    if srcVerMain > dstVerMain:
        ret = 1
        return ret
    elif srcVerMain < dstVerMain:
        ret = -1
        return ret
        
    if srcVerSub1 > dstVerSub1:
        ret = 1
        return ret
    elif srcVerSub1 < dstVerSub1:
        ret = -1
        return ret
        
    if srcVerSub2 > dstVerSub2:
        ret = 1
        return ret
    elif srcVerSub2 < dstVerSub2:
        ret = -1
        return ret
        
    if srcVerSub3 > dstVerSub3:
        ret = 1
        return ret
    elif srcVerSub3 < dstVerSub3:
        ret = -1
        return ret
    
    return ret

def get_params(strParams):
    params = {}
    strParams = strParams.strip(' &')
    if strParams:
        pairsofparams = strParams.split('&')
        for param in pairsofparams:
            splitparams = param.split('=')
            params[splitparams[0]] = urllib.unquote_plus(splitparams[1])
    return params

if __name__ == '__main__':
    properties = get_params(sys.argv[1])
    player = ItviItemPlayer()
    player.play(properties)