#!/usr/bin/python
# -*- coding: utf-8 -*-
import time
import xbmc


from xbmcswift2 import Plugin, actions, xbmc, xbmcgui
plugin = Plugin()

class Player(xbmc.Player):

    def play(self, item='', listitem=None, windowed=False, sublist=None):
        self._sublist = sublist
        
        super(Player, self).play(item, listitem, windowed)
            
        
        self._start_time = time.time()
        while True:
            # print self._start_time, time.time()
            if self._stopped or time.time() - self._start_time > 45:
                if self._totalTime == 999999:
                    raise PlaybackFailed(
                        'XBMC silently failed to start playback')
                break
            xbmc.sleep(500)
        # print 'play end'


    def __init__(self):
        self._stopped = False
        self._totalTime = 999999

        xbmc.Player.__init__(self, xbmc.PLAYER_CORE_AUTO)

    def onPlayBackStarted(self):
        self._totalTime = self.getTotalTime()
        self._start_time = time.time()

        # for some m3u8 file can not download completely    
        # duration = xbmc.getInfoLabel("Player.Duration(hh:mm:ss)")
        # plugin.log.debug("wdydebug onPlayBackStarted 111 duration  = " + str(duration))
        #plugin.log.debug("wdydebug onPlayBackStarted 111 _totalTime  = " + str(self._totalTime))
        if (self._totalTime < 30) :
            xbmc.executebuiltin((u'Notification(消息通知,百度云视频会出现时长不正确的情况，重新播放或可解决此问题,6000)'))
            
        sublist = self._sublist
        if sublist:
            if isinstance(sublist, basestring):
                sublist = [sublist]

            for surl in sublist:
                # print '$'*50, surl
                plugin.log.debug("wdydebug onPlayBackStarted surl  = " + str(surl))
                self.setSubtitles(surl)
            self.setSubtitleStream(0)
        else:
           plugin.log.debug("wdydebug onPlayBackStarted 333 dont have any sublist ")
            # self.showSubtitles(False)

    def onPlayBackStopped(self):
        self._stopped = True

    def onPlayBackEnded(self):
        self.onPlayBackStopped()


class PlaybackFailed(Exception):

    '''Raised to indicate that xbmc silently failed to play the stream'''
