#!/usr/bin/python
# -*- coding: utf-8 -*-
import gzip
import urllib2
from urllib import urlencode
try:
    from cStringIO import StringIO
except ImportError:
    from StringIO import StringIO  # noqa

import xbmc as _xbmc
from xbmcswift2 import xbmc, xbmcgui
try:
    from MFChineseKeyboard import Keyboard
except ImportError:
    Keyboard = xbmc.Keyboard  # noqa


def keyboard(default='', heading='', hidden=False):

    if hidden:
        kb = _xbmc.Keyboard(default, heading, hidden)
    else:
        kb = Keyboard(default, heading)
    xbmc.sleep(1000)
    kb.doModal()
    if (kb.isConfirmed()):
        return kb.getText()


def show_msg(msg, title='提示'):
    return xbmcgui.Dialog().ok(title, msg)


def select(title, items_list):
    return xbmcgui.Dialog().select(title, items_list)


def yesno(title, *args):
    return xbmcgui.Dialog().yesno(title, *args)


def refresh():
    xbmc.executebuiltin('Container.Refresh')


def unzip(content):
    return gzip.GzipFile(fileobj=StringIO(
        content), mode='rb').read()

http_proxy = None


def redirect_url(url, data=None, headers={}, timeout=None, proxies=None):
    headers.setdefault(
        'User-Agent', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.22 (KHTML, like Gecko) Chrome/25.0.1364.84 Safari/537.22')  # noqa
    headers.setdefault('Accept-Encoding', 'gzip,deflate')

    if data and isinstance(data, dict):
        data = urlencode(data)

    req = urllib2.Request(url, data, headers)

    # urllib2.urlopen 好用，opener.open没有测试过
    if proxies or http_proxy:
        if not proxies:
            if isinstance(http_proxy, basestring):
                proxies = {'http': http_proxy, 'https': http_proxy}
            else:
                proxies = http_proxy
        proxy_handler = urllib2.ProxyHandler(proxies)
        opener = urllib2.build_opener(proxy_handler)
        r = opener.open(req, timeout=timeout)
    else:
        r = urllib2.urlopen(req, timeout=timeout)

    redirectUrl=r.geturl()

    return redirectUrl

def fetch_url(url, data=None, headers={}, timeout=None, proxies=None):
    headers.setdefault(
        'User-Agent', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.22 (KHTML, like Gecko) Chrome/25.0.1364.84 Safari/537.22')  # noqa
    headers.setdefault('Accept-Encoding', 'gzip,deflate')

    if data and isinstance(data, dict):
        data = urlencode(data)

    req = urllib2.Request(url, data, headers)

    if proxies or http_proxy:
        if not proxies:
            if isinstance(http_proxy, basestring):
                proxies = {'http': http_proxy, 'https': http_proxy}
            else:
                proxies = http_proxy
        proxy_handler = urllib2.ProxyHandler(proxies)
        opener = urllib2.build_opener(proxy_handler)
        r = opener.open(req, timeout=timeout)
    else:
        r = urllib2.urlopen(req, timeout=timeout)

    content = r.read()

    if r.headers.get('content-encoding') == 'gzip':
        content = gzip.GzipFile(fileobj=StringIO(
            content), mode='rb').read()

    return content


def create_baidu_url(uk, shareid=None, fid=None):
    return 'plugin://plugin.video.btfactory/btmanager/baidupan/%s/%s/%s/' % (
        uk, shareid or 'null', fid or 'null')


def update_plugin_url(plugin_url):
    xbmc.executebuiltin('Container.Update(%s)' % plugin_url)
